<?php
/**
* This script displays the results from the script running 'Biplot'
* Analysis using ometer.
* Date: 20 Nov 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);
$prevPageNameUpper = strtoupper($prevPageName);
$title = "DOME : Biplot Results";
include("header.php");
?>




<?php

	getPageSelections($selectionsHash);
	
	//Show Parameters
	$selectionsHash['alpha'] = $_SESSION[$prevPageNameUpper]['alpha'];
	$selectionsHash['Matrix Used'] = $_SESSION[$prevPageNameUpper]['matrixType'];
	
	if (!$_SESSION['IS_REPLICATE_TRACK'])
	{	
		unset($selectionsHash['Fields']);
		$selectionsHash['Field'] = $fields[$_SESSION[$searchGeneKey]['FIELDS'][0]];	
	}
	
	print printPageSelections($selectionsHash);
	
	//Show Biplot
	showBiplot();
	print "\n<br />";
		
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	print "\n</form>";
	
	include ("footer.php");


function showBiplot()
{
	$sid = session_id();
	$plotFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.plt";
	$outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.png";
	$plotFileOmeter = "{$_SESSION['BROWSER_TMP_RELATIVE']}$sid" . '-pca-biplot.plt';;
	if (!file_exists($plotFileOmeter))
	{	$errMsgs[] = "Plot file '$plotFileOmeter' not found.";	}
	
	if (!$plotFileHandle = fopen($plotFile, 'w'))
	{
		echo "Cannot open file ($plotFile)";
		return;
	}
	if ($errMsgs)
	{	
		foreach ($errMsgs as $msg)
		{	printError($msg);	}
		return;
	}	
	
	$contents = "set terminal png
    set nokey
	set output \"{$outputFile}\"
    load \"$plotFileOmeter\"";
	
     // Write $contents to our opened file.
	if (!fwrite($plotFileHandle, $contents))
	{
		printError("Cannot write to file ($plotFile)");
		return;
	}
    
	fclose($plotFileHandle);
	$com = "{$_SESSION['GNUPLOT_DIR']}gnuplot {$plotFile} 2>&1";
	exec($com, $retLines, $retValue);
	if (!$retValue)
	{
		//To prevent Browser from not caching Images.
		$junk = md5(time());
		print "<div class=\"plot-image\"> <img border=\"2\" src=\"{$outputFile}?<?=$junk?>\"></div>";
		system("rm -f $plotFile");
	}
	else
	{ 
		if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	$msg = "GNUPlot command Failed. Command was $com";	}
	  	printError ($msg);  
		
	}
}

?>