<?php

/**
* This is the connection file. All database calls use this connection.
* Just change the connect string to point to a different
* database.
* Date: 2 Sept 2003
* @author Aejaaz Kamal <aekamal@vt.edu>
*/
	require_once ("DB.php");
	require_once ("paramSettings.php");
	/**This is to validate the parameters specified 
	* in the paramSettings.php file AND also connect to the DB.
	*/
    
	validateParameterSettings();
	connectToDB();
	validateReferenceDefaults();
    
	
function validateReferenceDefaults()
{
	global $addReferenceFor;
	if (!$redirect AND !validateReferenceDefault('GENE_REFERENCE', 'GENE_DEFAULT_REFERENCE'))
	{	$redirect = true; $addReferenceFor = 'GENE_REFERENCE';	}
	if (!$redirect AND !validateReferenceDefault('METABOLITE_REFERENCE', 'METABOLITE_DEFAULT_REFERENCE'))
	{	$redirect = true; $addReferenceFor = 'METABOLITE_REFERENCE';	}
	if (!$redirect AND !validateReferenceDefault('PROTEIN_REFERENCE', 'PROTEIN_DEFAULT_REFERENCE'))
	{	$redirect = true; $addReferenceFor = 'PROTEIN_REFERENCE';	}
	
	if ($redirect AND !$_REQUEST['dontRedirect'])
	{
		if (strtoupper($_SESSION['role']) == 'MANAGER')
		{	header("Location: addTable.php?currPageName=REFERENCE&dontRedirect=true"); exit();		}
	}
}
	
function connectToDB()
{
	global $username, $password, $server, $database, $BNetSchemaName, $SpeciesSchemaName;
	$dbh = DB::connect('pgsql://' . "$username:$password" . '@' . "$server/$database") or die("Could not connect to the DB");
    if(DB::isError($dbh)) { print "Could not connect to DB $database on server '$server' as '$username'. "; die( $dbh->getMessage());}
    $_SESSION['dbh'] = $dbh;
    $sth = $_SESSION['dbh']->query("SET search_path TO \"$BNetSchemaName\", \"$SpeciesSchemaName\"");
    if ( DB::isError($sth) ) 
	{	
		print "Error setting search_path to \"$BNetSchemaName\", \"$SpeciesSchemaName\". <br />Please check your SchemaNames in the parameters settings file. (" . $sth->getMessage() . ")";	
		exit();
	}
    
    $_SESSION['dbhBNet'] = $dbh;
}
    

function validateParameterSettings()
{
	validatePath($_SESSION['HTDOCS_DIR'], 'HTDOCS_DIR');
	
	$_SESSION['DOME_INSTALLATION_DIR_FULL'] = "{$_SESSION['HTDOCS_DIR']}{$_SESSION['DOME_INSTALLATION_DIR_RELATIVE_TO_HTDOCS']}";
	validatePath($_SESSION['DOME_INSTALLATION_DIR_FULL'], 'HTDOCS_DIR', 'DOME_INSTALLATION_DIR_RELATIVE_TO_HTDOCS');
	validateFile("{$_SESSION['DOME_INSTALLATION_DIR_FULL']}paramSettings.php", 'HTDOCS_DIR', 'DOME_INSTALLATION_DIR_RELATIVE_TO_HTDOCS');
		
	$_SESSION['BROWSER_TMP_FULL'] = "{$_SESSION['DOME_INSTALLATION_DIR_FULL']}{$_SESSION['BROWSER_TMP_RELATIVE']}";
	validatePath($_SESSION['BROWSER_TMP_FULL'], 'BROWSER_TMP_RELATIVE');
	
	//check if R_HOME environment variable exists
	if ($_SERVER['R_HOME'])
	{	$_SESSION['R_HOME'] = $_SERVER['R_HOME'];	}
	

	//check if BROME_HOME environment variable exists
	if ($_SERVER['BROME_HOME'])
	{	$_SESSION['BROME_HOME'] = $_SERVER['BROME_HOME'];	}
	
	validateReadable($_SESSION['BROWSER_TMP_FULL'], 'BROWSER_TMP_RELATIVE');
	validateWritable($_SESSION['BROWSER_TMP_FULL'], 'BROWSER_TMP_RELATIVE');
	validateExecutable($_SESSION['BROWSER_TMP_FULL'], 'BROWSER_TMP_RELATIVE');
	
	validatePath($_SESSION['GNUPLOT_DIR'], 'GNUPLOT_DIR');
	validatePath($_SESSION['PERL_DIR'], 'PERL_DIR');
	validatePath($_SESSION['R_DIR'], 'R_DIR');
	validatePath($_SESSION['OMETER_DIR'], 'OMETER_DIR');
	validatePath($_SESSION['BROME_HOME'], 'BROME_HOME');
	validatePath($_SESSION['FILE_HOME'], 'FILE_HOME');
	validateWritable($_SESSION['FILE_HOME'], 'FILE_HOME');
	
	
	validateFile("{$_SESSION['GNUPLOT_DIR']}gnuplot", 'GNUPLOT_DIR');
	validateFile("{$_SESSION['PERL_DIR']}perl", 'PERL_DIR');
	validateFile("{$_SESSION['R_DIR']}R", 'R_DIR');
	validateFile("{$_SESSION['OMETER_DIR']}ometer", 'OMETER_DIR');
	validatePath($_SESSION['R_HOME'], 'R_HOME', "", false);
	validatePath($_SESSION['RSPERL_DIR'], 'RSPERL_DIR');
	//Also check the RSPerl installation.
	$tmp = "{$_SESSION['RSPERL_DIR']}share/lib/perl5/site_perl/";
	
	//validatePath($tmp, 'RSPERL_DIR');
	
	//check if PERL5LIB environment variable is set on server. If yes append
	//to that variable.
	if ($_SERVER['PERL5LIB'])
	{	$_SESSION['PERL5LIB'] = "{$_SERVER['PERL5LIB']}:{$_SESSION['RSPERL_DIR']}share/lib/site_perl";	}
	else
	{	$_SESSION['PERL5LIB'] = "{$_SESSION['RSPERL_DIR']}share/lib/site_perl";		}

	if ($_SESSION['errMsgs'])
	{	return false;	}
	
	/*connectToDB();
	validateReferenceDefault($_SESSION['GENE_DEFAULT_REFERENCE'], 'GENE_DEFAULT_REFERENCE');
	validateReferenceDefault($_SESSION['METABOLITE_DEFAULT_REFERENCE'], 'METABOLITE_DEFAULT_REFERENCE');
	validateReferenceDefault($_SESSION['PROTEIN_DEFAULT_REFERENCE'], 'PROTEIN_DEFAULT_REFERENCE');
	*/
	
	
	switch (strtolower($_SESSION['PLOT_TIMES_IN']))
	{
	case 'minutes':
	case 'min':
	case 'mins':
	case 'm':
		$_SESSION['PLOT_TIMES_IN'] = 'min';
		break;
	case 'hours':
	case 'hr':
	case 'hrs':
	case 'h':
		$_SESSION['PLOT_TIMES_IN'] = 'hr';
		break;
	case 'days':
	case 'day':
	case 'd':
		$_SESSION['PLOT_TIMES_IN'] = 'day';
		break;
	case 'weeks':
	case 'week':
	case 'wk':
	case 'w':
		$_SESSION['PLOT_TIMES_IN'] = 'wk';
		break;
	default:
		$_SESSION['errMsgs'][] = "'PLOT_TIMES_IN' not properly set.<br />Kindly specify the units to display the plots in 'minutes', 'hours', 'days' or 'weeks'.";
	}
	
	if ($_SESSION['errMsgs'])
	{	return false;	}
	return true;
	
}


function validatePath(&$path, $varName, $varName2 = "", $endPathWithFrontSlash = true)
{
	$path = trim($path);
	if (strlen($path) == 0)
	{
		$_SESSION['errMsgs'][] = "'$varName' not properly set.<br />Invalid Path.";
		return false;
	}
	$trans = array("\\" => '/');
	$path = strtr($path, $trans);
	$dirs = split('/', $path);
	
	$path = '/';
	$firstDir = true;

	foreach ($dirs as $dir)
	{
		if (strlen(trim($dir)) > 0)
		{	
			if ($firstDir)
			{	$path .= "$dir";	}
			else
			{	$path .= "/$dir";	}
			$firstDir = false;
		}
	}
	if ($path != '/' AND $endPathWithFrontSlash)
	{	$path .= '/';	}
	
	if (file_exists($path))
	{	return true;	}
	else
	{	
		$msg = "'$varName'";	
		if ($varName2)
		{	$msg .= " OR '$varName2'";	}
		$msg .= " not properly set.<br />Invalid Path.";	
		$_SESSION['errMsgs'][] = $msg;
	}
	
	return false;
}

function validateFile($file, $varName, $varName2 = "")
{
	if (file_exists($file))
	{	return true;	}
	else
	{	
		$msg = "'$varName'";	
		if ($varName2)
		{	$msg .= " OR '$varName2'";	}
		$msg .= " not properly set.<br />File Not found.";	
		$_SESSION['errMsgs'][] = $msg;
	}
	return false;
}

function validateReadable(&$path, $varName)
{
	if (is_readable($path))
	{	return true;	}
	else
	{	$_SESSION['errMsgs'][] = "'$varName' not properly set.<br />Directory is not readable.";		}
	return false;
}

function validateWritable(&$path, $varName)
{
	if (is_writable($path))
	{	return true;	}
	else
	{	$_SESSION['errMsgs'][] = "'$varName' not properly set.<br />Directory is not writable.";		}
	return false;
}

function validateExecutable(&$path, $varName)
{
	if (is_executable($path))
	{	return true;	}
	else
	{	$_SESSION['errMsgs'][] = "'$varName' not properly set.<br />Directory is not executable.";		}
	return false;
}


function validateReferenceDefault($varName, $sessionVariableName)
{
	$sql = "SELECT d.\"name\", d.\"value\" FROM \"default\" d, \"reference\" r
		WHERE UPPER(d.\"name\") = '" . strtoupper($varName) . "'" . 
		" AND d.\"value\" = r.\"reference_id\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	$_SESSION['errMsgs'][] = "Error Validating Reference for $varName. " . $sth->getMessage();	return false;	}
	if ($sth->numRows() == 0)
	{	
		switch($varName)
		{
		case 'GENE_REFERENCE':
			$entity = 'genes'; 
			break;
		case 'METABOLITE_REFERENCE':
			$entity = 'metabolites'; 
			break;
		case 'PROTEIN_REFERENCE':
			$entity = 'proteins'; 
			break;
		}
		
		$_SESSION['errMsgs'][] = "Please create a reference to track all new '$entity' for this project.";	
		return false;	
	}
	else
	{	
		$row = $sth->fetchRow();
		$_SESSION[$sessionVariableName] = $row[1];
	}
	return true;
}

?>
