<?php
/**
* This script displays the results from the script running 'R'.
* Date: 28 May 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);

?>

<?php
$prevPageNameUpper = strtoupper($prevPageName);
$title = "DOME : {$_SESSION[$prevPageNameUpper]['title']}";
include("header.php");
?>

<?php

fillForm();

print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";
printControlBar($_SESSION['STEP_NUMBER'], 1);
print "\n</form>";
include ("footer.php");
?>


<?php
function fillForm()
{
	global $prevPageName, $searchGeneKey, $fields;
	$prevPageNameUpper = strtoupper($prevPageName);
	
	$NoOfClusters = $_SESSION[$prevPageNameUpper]['NoOfClusters'];
	$plotsPerLine = $_SESSION[$prevPageNameUpper]['plotsPerLine'];
	$sid = session_id();
	
	getPageSelections($selectionsHash);
	if (!$_SESSION['IS_REPLICATE_TRACK'])
	{	
		unset($selectionsHash['Fields']);
		$selectionsHash['Field'] = $fields[$_SESSION[$searchGeneKey]['FIELDS'][0]];	
	}
	$selectionsHash['Clusters'] = $_SESSION[$prevPageNameUpper]['NoOfClusters'];
	$selectionsHash['Maximum Iterations'] = $_SESSION[$prevPageNameUpper]['maxIterations'];
	
	print printPageSelections($selectionsHash);

	
	$self = $_SERVER[PHP_SELF];
	print "<table><tr><td valign=\"top\">";
	print "\n<br /><a href={$_SESSION['BROWSER_TMP_RELATIVE']}{$sid}_cluster.dat target=\"_blank\">Full Cluster Results</a><br />";
	print "\n<ul>";
	for ($i = 1; $i <=$NoOfClusters; $i++)
	{
		$clusterFile = "{$_SESSION['BROWSER_TMP_FULL']}{$sid}_cluster_$i.dat";
		if (file_exists($clusterFile))
		{	print "\n\t<li><a href={$_SESSION['BROWSER_TMP_RELATIVE']}{$sid}_cluster_$i.dat target=\"_blank\">Cluster $i</a></li>";	}
	}
	print "\n</ul>";
	print "</td><td>";
	
	$plotFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.plt";
	$outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.png";
	$infoFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}_center_info.dat";
	$dataFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}_center.dat";
		
	if (!$lines = file($infoFile))
	{
	     printError ("Cannot open information file ($infoFile)");
	     return;
	}
	
	foreach ($lines as $line)
	{
		$tmp = split("\t", trim($line));
		$plotInfo[$tmp[0]] = $tmp[1];
	}
	
	if (!$plotFileHandle = fopen($plotFile, 'w'))
	{
	     printError("Cannot open plot file ($plotFile)");
	     return;
	}
	
	
	$sizeX = 1 / $plotsPerLine;
	$sizeY = 1 / $plotsPerLine;
	$totSizeX = 1;
	$totSizeY = $sizeY * ceil($NoOfClusters / $plotsPerLine);
	
	
	//$contents = "set title \"K-Means Clustering Plot\"
	$contents = "set yrange [{$plotInfo['min']}:{$plotInfo['max']}]
	set grid
	set terminal png
	set output \"{$outputFile}\";
	set size $totSizeX, $totSizeY
	set multiplot";
	
	$contents .= "\nset size $sizeX, $sizeY";
	$orgY = $totSizeY - $sizeY;
	for ($i = 1; $i <= $NoOfClusters; $i++)
	{
		$orgX = (($i - 1) % $plotsPerLine) * (1 / $plotsPerLine);
		$contents .= "\nset origin $orgX, $orgY";
		if (($i % $plotsPerLine) == 0)
		{	$orgY = $orgY - $sizeY;	}
		if($clusters = $plotInfo[$i])
		{
			$contents .= "\nset xlabel \"#$i, $clusters\"";
		}
		
		$col = $i + 1;
		$contents .= "\n\t\tplot \"$dataFile\" using 1:$col notitle with linespoints";
	}
	$contents .= "\nset nomultiplot";
	
	// Write $contents to our opened file.
	if (!fwrite($plotFileHandle, $contents))
	{
		printError ("Cannot write to plot file ($plotFile)");
		return;
	}
	//echo "Success, wrote ($contents) to file ($plotFile)";
	
	fclose($plotFileHandle);
	$com = "{$_SESSION['GNUPLOT_DIR']}gnuplot {$plotFile} 2>&1";
	exec($com, $retLines,$retValue);
	if (!$retValue)
	{
		//To prevent Browser from not caching Images.
		$junk = md5(time());
		print "<div class=\"plot-image\"> <img border=\"2\" src=\"{$outputFile}?<?=$junk?>\"></div><br />";
		print $legendTable;
		//system("rm -f $plotFile");
		//system("rm -f $dataFile");
		//system("rm -f $infoFile");
	}
	else
	{	
		if ($retLines)
		{
			  foreach ($retLines as $retLine)
			  {	$msg .= "$retLine <br />";	}
		}
		else
		{	$msg = "GNUPlot command Failed. Command was $com <br />";	}
		printError ($msg);  
		//system("chmod 777 $plotFile");
		//system("chmod 777 $dataFile");
		//system("chmod 777 $infoFile");
		//system("chmod 777 $outputFile");
	}
	print "\n</td></tr></table>";
}
?>