<?php
/**
* This script displays the results from the script running 'PCA'
* Analysis using ometer.
* Date: 28 May 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);

$prevPageNameUpper = strtoupper($prevPageName);
$title = "DOME : PCA Results";
include("header.php");
?>

<script language="javascript">
function createWindow(cUrl,cName,cFeatures) {
var xWin = window.open(cUrl,cName,cFeatures)
}
</script>


<?php
$sid = session_id();

if ($_REQUEST['submit'])
{
	processForm($currPageName);
}
else
{
	getPageSelections($selectionsHash);
	
	//Show Parameters
	if ($_SESSION[$prevPageNameUpper]['minVariance'] > 0)
	{	$selectionsHash['Variance Explained'] = "{$_SESSION[$prevPageNameUpper]['minVariance']}%";	}
	if ($_SESSION[$prevPageNameUpper]['minComponents'] > 0)
	{	$selectionsHash['Components'] = $_SESSION[$prevPageNameUpper]['minComponents'];	}
	if (!$_SESSION['IS_REPLICATE_TRACK'])
	{	
		unset($selectionsHash['Fields']);
		$selectionsHash['Field'] = $fields[$_SESSION[$searchGeneKey]['FIELDS'][0]];	
	}
	
	print printPageSelections($selectionsHash);
	
	fillOneValueTable();
	
	print "\n<br />";
	
	//Fill Table
	print "\n<p><label>Results of PCA:</label>";
	print fillTable();
	print "</p>";
	
	//Show links
	print "\n<p><a href={$_SESSION['BROWSER_TMP_RELATIVE']}{$sid}-pca-loadings.dat target=\"_blank\">Loadings</a>";
	print "\n<br /><a href={$_SESSION['BROWSER_TMP_RELATIVE']}{$sid}-pca-proj.dat target=\"_blank\">Data Projection</a></p>";
	
	
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"plot_form\" method=\"post\" action=\"$self\" target=\"_blank\">\n";
	//Fill plot area
	fillPCASelectsAndPlotButtons();
	print "</form>";
	
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	print "\n</form>";
	
	include ("footer.php");
}

?>

<?php
//Fill Functions
function fillOneValueTable()
{
	global $searchGeneKey;
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$annotations = &$_SESSION[$searchGeneKey]['ANNOTATIONS'];
	
	
	if ($_SESSION['IS_REPLICATE_TRACK'])
	{
	
		//headers is a hash with the header name as key and 0 as val.
		//In case there is only one type of value, then instead of a 0 the val is the actual single value.
		//For Example if the field Exp Set contains only one value 'Yeast', than
		//$headers[Exp Set] = "Yeast"
		$headers = array("Exp Set"=>0, "Experiment"=>0, "Sampling Point"=>0, "Identifier"=>0, "Protocol Type"=>0);
		//Master Array has the following keys:
		//$master_array[$ESName][$Experiment][$sp_name][$identifier][$protocol_type][$biologicalReplicate][$technicalReplicate]
	}
	else
	{
		$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Protocol Type"=>0, "Data Type"=>0);
		//Master Array has the following keys:
		//$master_array[$ESName][$EName][$identifier][$protocol_type_name][$field][$label_name]
	
	}
	//Get counts of each keys
	foreach ($headers as $header=>$val)
	{
		if (isset($keys[$header]) AND count($keys[$header]) == 1)
		{	
			$keysForHeader = array_keys($keys[$header]);
			$headers[$header] = $keys[$header][$keysForHeader[0]];	
		}
		$count[$header] = count($keys[$header]);
	}
	
	//Print One Value Table
	foreach ($headers as $header=>$val)
	{
		if ($val)
		{	
			if ($cl == 'light-red')
			{	$cl = 'dark-red';	}
			else
			{	$cl = 'light-red';	}
	
			$OneValueTable .= "\n<tr><th class=\"$cl\">$header</th><td class=\"$cl\">$val</td></tr>";
			if ($header == 'Identifier')
			{	
				if ($annotations)	
				{
					if ($cl == 'light-red')
					{	$cl = 'dark-red';	}
					else
					{	$cl = 'light-red';	}
					$OneValueTable .= "\n<tr><th class=\"$cl\">Annotation</th><td class=\"$cl\">$annotations[$val]</td></tr>";
				}
			}
		}
	}

	if ($OneValueTable)
	{
		print "<table cellspacing='2'><tr><th>Legend:</th></tr>$OneValueTable</table>";
		print "<br />";
	}
}


function fillTable()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$sid = session_id();
	
	$dataFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}-pca-proj.dat";
		
	
	if (file_exists($dataFile))
	{	$lines = file($dataFile);	}
	else
	{
	     printError ("Data projection file ($dataFile) does not exist. Ometer did not produce this output file.");
	     return;
	}
	
	$tableString = "\n<table>";
	$isHeader = true;
	$rowColor = "light-row";
	foreach ($lines as $line)
	{
		$tableString .= "\n\t<tr class=\"$rowColor\">";	
		$values = split("\t", rtrim($line));
		foreach ($values as $value)
		{
			if ($isHeader)
			{	
				$tableString .= "<th>$value</th>";
			}
			else
			{	$tableString .= "<td>$value</td>";	}
		}
		$tableString .= "</tr>";	
		$isHeader = false;	
		if ($rowColor == "light-row")
		{	$rowColor = "dark-row";	}
		else
		{	$rowColor = "light-row";	}
		$i++;
	}
	$tableString .= "\n</table>";
	$_SESSION[$currPageNameUpper]['TOTAL_PCAS'] = $i - 1;
	//exclude one for header.
	return $tableString;
}


function fillPCASelectsAndPlotButtons()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
	print "<fieldset><legend>Plots</legend>";
	print "\n<select name=\"PC1\">";
	for ($i = 1; $i <= $_SESSION[$currPageNameUpper]['TOTAL_PCAS'] - 1; $i++)
	{
		print "\n\t<option>PC$i</option>";
	}
	print "\n</select>";
	print " vs ";
	print "\n<select name=\"PC2\">";
	for ($i = 2; $i <= $_SESSION[$currPageNameUpper]['TOTAL_PCAS']; $i++)
	{
		print "\n\t<option>PC$i</option>";
	}
	print "\n</select>";
	
	print "&nbsp;&nbsp;<input type=\"submit\" name=\"submit\" value=\"Plot\">";
	print "<p><input type=\"submit\" name=\"submit\" value=\"Scree Plot\"></p>";
	print "</fieldset>";
}


//Process Functions
function processForm($currPageName = "")
{
	$sid = session_id();
	$plotFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.plt";
	$outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.png";
	switch($_REQUEST['submit'])
	{
	case 'Plot':
		if (!isset($_REQUEST['PC1']))
		{	$errMsgs[] = "Invalid PC1.";	}
		if (!isset($_REQUEST['PC2']))
		{	$errMsgs[] = "Invalid PC2.";	}
		if ($_REQUEST['PC1'] >= $_REQUEST['PC2'])
		{	$errMsgs[] = "PC1 should be less than PC2.";	}
		
		if ($errMsgs)
		{	
			foreach ($errMsgs as $msg)
			{	printError($msg);	}
			return;
		}
	
		$plotFileOmeter = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}-pca-{$_REQUEST['PC1']}_{$_REQUEST['PC2']}.plt";
		break;
	
	case 'Scree Plot':
		$plotFileOmeter = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}-pca-scree.plt";
		break;
	}
	if (!file_exists($plotFileOmeter))
	{	$errMsgs[] = "Plot file '$plotFileOmeter' not found.";	}
	
	if (!$plotFileHandle = fopen($plotFile, 'w'))
	{
		echo "Cannot open file ($plotFile)";
		return;
	}
	if ($errMsgs)
	{	
		foreach ($errMsgs as $msg)
		{	printError($msg);	}
		return;
	}	
	
	$contents = "set terminal png
    set nokey
	set output \"{$outputFile}\"
    load \"$plotFileOmeter\"";
	
     // Write $contents to our opened file.
	if (!fwrite($plotFileHandle, $contents))
	{
		printError("Cannot write to file ($plotFile)");
		return;
	}
    
	fclose($plotFileHandle);
	$com = "{$_SESSION['GNUPLOT_DIR']}gnuplot {$plotFile} 2>&1";
	exec($com, $retLines, $retValue);
	if (!$retValue)
	{
		//To prevent Browser from not caching Images.
		$junk = md5(time());
		print "<div class=\"plot-image\"> <img border=\"2\" src=\"{$outputFile}?<?=$junk?>\"></div>";
		system("rm -f $plotFile");
	}
	else
	{ 
		if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	$msg = "GNUPlot command Failed. Command was $com";	}
	  	printError ($msg);  
		
	}
}

?>

