<?php
/**
* This script gives the user an interface to add a 
* compound or its derivative while adding data 
* using a new file.
* Date: 16 Aug 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/
include_once("common.php");
include_once("compoundFrame.php");
$title = "Add/Search Compounds";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}

$currPageName = 'ADD_CPD_OR_DER';
$currPageNameUpper = strtoupper($currPageName);
?>
<p>This page is displayed only when there are compounds in your data file that do not exist in the B-NET database.<br><br>On the left is the list of compounds not found in B-NET. Please search for synonyms or possible other names for the compound in B-NET and if you find a match then highlight it and first click on "Set Selected Compound". You would see the selected compound next to "Current Cpd:". Then click on "Add As Compound Synonym".<br><br>If the compound is a derivative (e.g. glucose-TMS), then first try to find the compound (e.g. glucose) in B-NET just like it was described previously. If you find the compound in the list then highlight it and click on "Set Selected Compound". If you do not find the compound then click on "Add As New Compound". You should see the desired compound name next to "Current Cpd:". Then click on "Add As Compound Derivative".<br><br>If the search does not yield any compound that matches the compound of interest, then please click "Add As Compound".<br><br>You will have to follow this procedure for all the compounds in your list, one at a time. When there are no compounds left in the list then all the data will be added into the database.</p>
<?php

if (isset($_REQUEST['notInBNet']))
{	$_SESSION[$currPageNameUpper]['notInBNet'] = $_REQUEST['notInBNet'];	}

if ($_REQUEST['submit'] == 'Search')
{	$_SESSION[$currPageNameUpper]['txtSearch'] = $_REQUEST['txtSearch'];	}
elseif ($_REQUEST['submit'] == 'Add As New Compound')
{	
	if ($_REQUEST['txtSearch'])
	{	
		$_SESSION[$currPageNameUpper]['txtSearch'] = $_REQUEST['txtSearch'];	
		$newCpdID = addAsNewCompound($_SESSION[$currPageNameUpper]['txtSearch']);
		if ($newCpdID)
		{	$_SESSION[$currPageNameUpper]['CpdID'] = $newCpdID;	}
	}
	else
	{	$errMsgs[] = "Please enter the name of the new compound to add.";	}
}
elseif ($_REQUEST['submit'] == 'Set Selected Compound')
{
	if ($_REQUEST['searchResults'] > 0)
	{	$_SESSION[$currPageNameUpper]['CpdID'] = $_REQUEST['searchResults'];	}
	else
	{	$errMsgs[] = "Please Select the compound to set.";	}
}
elseif ($_REQUEST['submit'] == 'Clear Selected Compound')
{	unset($_SESSION[$currPageNameUpper]['CpdID']);	}
elseif ($_REQUEST['submit'] == 'Add As Compound')
{
	$retVal = addAsCompound();
	setCpdsNotFound($_SESSION[$currPageNameUpper]['NOTFOUND'], $errMsgs);
	if ($retVal)
	{	unset($_SESSION[$currPageNameUpper]['notInBNet']);	}
}
elseif ($_REQUEST['submit'] == 'Add As Compound Derivative')
{
	$retVal = addAsCompoundDerivative();
	setCpdsNotFound($_SESSION[$currPageNameUpper]['NOTFOUND'], $errMsgs);
	if ($retVal)
	{
		unset($_SESSION[$currPageNameUpper]['CpdID']);
		unset($_SESSION[$currPageNameUpper]['txtSearch']);
		unset($_SESSION[$currPageNameUpper]['notInBNet']);
	}
}
elseif ($_REQUEST['submit'] == 'Add As Compound Synonym')
{
	$retVal = addAsCompoundSynonym();
	setCpdsNotFound($_SESSION[$currPageNameUpper]['NOTFOUND'], $errMsgs);
	if ($retVal)
	{
		unset($_SESSION[$currPageNameUpper]['CpdID']);
		unset($_SESSION[$currPageNameUpper]['txtSearch']);
		unset($_SESSION[$currPageNameUpper]['notInBNet']);
	}
}
/*elseif ($_REQUEST['submit'] == 'Select File Again')
{
	print "<meta http-equiv=\"refresh\" content=\"0; URL=addData.php?stepno=1:3&technique_id={$_SESSION['ADD_DATA']['technique_id']}\">";
	exit();
}*/
elseif ($_REQUEST['submit'] == 'Main Menu')
{
	unset($_SESSION[$currPageNameUpper]);
	resetAllSessionVariables();
	print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";
	exit();
}

if ($errMsgs)
{
	foreach ($errMsgs as $errMsg)
	{
		printError($errMsg);
	}
}

if ($_SESSION[$currPageNameUpper]['NOTFOUND'][0] == 'ALL COMPOUNDS DONE')
{
	
	$_SESSION['Message'][] = "All Compounds Processed. File Addition complete.";
	//resetAllSessionVariables();
    
	//redirect back!
    print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php\">";
    exit();
}
	
fillForm();
include ("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageNameUpper;
	print "\n<form name=\"searchCpd\" method=\"post\" action=\"{$_SERVER['PHP_SELF']}\" >\n";
	fillNotFoundCompounds();
	fillSearchCpdFrame("Search Compound", $_SESSION[$currPageNameUpper]['CpdID'], $currPageNameUpper, "", true);
	fillAddButtons();
	print "\n<div class=\"controlBar\">";
	//print "\n<p><input type=\"submit\" name=\"submit\" value=\"Select File Again\">";
	print "\n<input type=\"submit\" name=\"submit\" value=\"Main Menu\"></p>";
	print "\n</div>";
	print "\n</form>";
	
}  

function fillNotFoundCompounds()
{
	global $currPageNameUpper;
	print "\n<div class=\"not-found-compounds\">";
	print "<label>Not found in B-Net: </label>";
	print "\n<select name=\"notInBNet[]\" size=\"5\" multiple>";
	
	if (!isset($_SESSION[$currPageNameUpper]['notInBNet']))
	{	$_SESSION[$currPageNameUpper]['notInBNet'][0] = $_SESSION[$currPageNameUpper]['NOTFOUND'][0];	}
	
	//Code for filling cpds not found here
	foreach ($_SESSION[$currPageNameUpper]['NOTFOUND'] as $name)
	{
		print "\n\t<option";
		if (in_array($name, $_SESSION[$currPageNameUpper]['notInBNet']))
		{	print " selected"; 	}
		print ">$name</option>";
	}
	print "\n</select>";
	print "</div>";
}

function fillSearchCpd()
{
	global $currPageNameUpper;
	print "\n<div class=\"search-compound\">";
	print "<fieldset><legend>Search Compound</legend>\n";
	print "\n<label>Currently Selected Compound: </label>";
	if (isset($_SESSION[$currPageNameUpper]['CpdID']))
	{	
		$sql = "SELECT aname FROM allnames 
			WHERE record_id = '{$_SESSION[$currPageNameUpper]['CpdID']}'
			AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			AND UPPER(is_primary) = 'Y'";
		
		$sth = $_SESSION['dbh']->query($sql);
	    if ( DB::isError($sth) ) 
	    {	printError("Could Not retrieve Compound Primary Name."); 	}
	    $row = $sth->fetchrow();
	    print $row[0];	
	    print "\n<input type=\"submit\" name=\"submit\" value=\"Clear Selected Compound\">";
	}
	else
	{	print "Not Set";	}
	
	print "\n<p><input type=\"text\" name=\"txtSearch\" value=\"{$_SESSION[$currPageNameUpper]['txtSearch']}\" size=\"25\">";
	print "<input type=\"submit\" name=\"submit\" value=\"Search\"></p>\n";
	if ($_REQUEST['submit'] == 'Search')
	{
		$compoundName = $_SESSION[$currPageNameUpper]['txtSearch'];
		
		//Converting $compoundName into Database search field form.
		$compoundName = convertToSearchName($compoundName);
		$compoundName = strtoupper($compoundName);
	    
	    if (strlen($compoundName) > 0)
	    {
		    $sql = "SELECT record_id, aname FROM allnames 
				WHERE UPPER(search_name) LIKE '%$compoundName%'
				AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";
			
			$sth = $_SESSION['dbh']->query($sql);
		    if ( DB::isError($sth) ) 
		    {	printError("Could Not Search for Compound Names."); 	}
		        
		    print "\n<select name=\"searchResults\" size=\"10\">";
		    while ($row = $sth->fetchrow())
		    {
		    	print "\n\t<option value=\"$row[0]\">$row[1]</option>";
	    	}
	    	print "\n</select>";
	    	if ($sth->numrows() > 0)
	    	{
		    	print "\n<input type=\"submit\" name=\"submit\" value=\"Set Selected Compound\">";
	    	}
    	}
	}
	print "</fieldset></div>";
	
}
function fillAddButtons()
{
	print "\n<div class=\"add-buttons\">";
	print "\n<p><input type=\"submit\" name=\"submit\" value=\"Add As Compound\">";
	print "\n<input type=\"submit\" name=\"submit\" value=\"Add As Compound Derivative\">";
	print "\n<input type=\"submit\" name=\"submit\" value=\"Add As Compound Synonym\"></p>";
	print "\n</div>";
}

/*==========================================
Request Functions
============================================*/
function addAsNewCompound($compoundName)
{
	global $currPageNameUpper;
	$compoundNameS = convertToSearchName($compoundName);
	$sql = "SELECT \"record_id\", \"aname\" FROM \"allnames\" 
		WHERE UPPER(\"search_name\") like UPPER('%$compoundNameS%')
		AND \"kw_table_id\" = '{$_SESSION['TableID']['COMPOUND']}'";
				
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		printError("Could Not Search for Compound Names. Compound '$compoundName' Not added."); 
		return 0;
	}

	if ($sth->numrows() > 0)
	{
		if ($_SESSION[$currPageNameUpper]['previous_txtSearch'] != $_SESSION[$currPageNameUpper]['txtSearch'])
		{
			$_SESSION[$currPageNameUpper]['previous_txtSearch'] = $_SESSION[$currPageNameUpper]['txtSearch'];
			$row = $sth->fetchrow();
			printMessage("Compound with Primary Name or Synonym '$row[1]' already exists. [ID: $row[0]]. Kindly search for this compound. If you still want to try to add it as a New Primary Name, click 'Add As New Compound' again."); 
			return 0;
		}
		else
		{
			unset($_SESSION[$currPageNameUpper]['previous_txtSearch']);
		}
	}
	$newCpdID = insertNewCompound($compoundName);
	if ($newCpdID)
	{	
		$strMsg = "New Compound '$compoundName' added to the database.";
		printMessage($strMsg);	
	}
	return $newCpdID;
}
function insertNewCompound($compoundName)
{
	//Converting $compoundName into Database search field form.
	$compoundNameD = convertToSearchName($compoundName);
	$compoundNameDUpper = strtoupper($compoundNameD);
	
	$qres = $_SESSION['dbh']->query("BEGIN TRANSACTION");
	if( DB::isError($qres) ) {printError("Error starting new transaction. Compound '$compoundName' Not added. (" . $qres->getMessage() . ")" );  return 0;	}
	
	
	$sql = "SELECT record_id, aname FROM allnames 
		WHERE UPPER(search_name) = '$compoundNameDUpper'
		AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
		AND UPPER(is_primary) = 'Y'";
			
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Could Not Search for Compound Names. Compound '$compoundName' Not added."); 
		$_SESSION['dbh']->query("ROLLBACK");
		return 0;
	}
	if ($sth->numrows() > 0)
	{
		$row = $sth->fetchrow();
		printMessage("Compound with Primary Name '$row[1]' already exists. [ID: $row[0]]"); 
		$_SESSION['dbh']->query("ROLLBACK");
		return 0;
	}
	
	//Now adding the compound to the compound table
	//First getting new cpd_id
	$qres = $_SESSION['dbh']->query("SELECT nextval('cpd_id_seq')");
    if( DB::isError($qres) ){	printError("Error getting new Compound ID. (" . $qres->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0;	}
    $rec = $qres->fetchRow();
    $newCpdID = $rec[0];
    
    //Adding in compound
    $sql = "INSERT INTO compound(cpd_id) 
		VALUES ('$newCpdID')";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		printError("Error adding compound '$compoundName' in compound table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK"); 
		return 0;
	}
	
	//Adding in allnames
	$sql = "INSERT INTO allnames(name_id, aname, kw_table_id, record_id, is_primary, search_name, unikey) 
		VALUES (nextval('allnames_id_seq'), '{$compoundName}', '{$_SESSION['TableID']['COMPOUND']}', '$newCpdID', 'Y', '$compoundNameD', '{$compoundName}')";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error adding Primary Name in allnames table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0;	}

	//Adding in specie_compound table
	$qres = $_SESSION['dbh']->query("SELECT nextval('specie_cpd_id_seq')");
    if( DB::isError($qres) ){	printError("Error getting new Specie-Compound ID. Compound '$compoundName' Not added. (" . $qres->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0; 	}
    $rec = $qres->fetchRow();
    $newSCID = $rec[0];
	
	$sql = "INSERT INTO specie_compound(specie_cpd_id, specie_id, cpd_id) 
		VALUES ('$newSCID', '{$_SESSION['CurrentSpecieID']}', '$newCpdID')";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error adding record in specie_compound table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0;	}
	
	//Adding in evidence table
	$qres = $_SESSION['dbh']->query("SELECT nextval('evidence_id_seq')");
    if( DB::isError($qres) ){	printError("Error getting new Evidence ID. Compound '$compoundName' Not added. (" . $qres->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0; 	}
    $rec = $qres->fetchRow();
    $newEvidenceID = $rec[0];
	
	//==HARD CODING HERE
	
	$sql = "SELECT evidence_code_id FROM evidence_code 
		WHERE upper(technique) = 'MASS SPECTRUM'
		AND upper(evidence_code) = 'IDA'";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error searching for evidence code from 'evidence_code' table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0;	}
	$rec = $sth->fetchRow();
    $EvidenceCodeID = $rec[0];
    
    $sql = "SELECT \"value\" FROM \"default\"
		WHERE UPPER(\"name\") = 'METABOLITE_REFERENCE'";
		
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error searching for reference_id from 'default' table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); return 0;	}
	$rec = $sth->fetchRow();
    $reference_id = $rec[0];
	
    $sql = "INSERT INTO evidence(evidence_id, reference_id, evidence_code_id, record_id, kw_table_id) 
		VALUES ('$newEvidenceID', '$reference_id', '$EvidenceCodeID', '$newSCID', '{$_SESSION['TableID']['SPECIE_COMPOUND']}')";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error adding record in specie_compound table. Compound '$compoundName' Not added. (" . $sth->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); 	return 0;	}
	
	$_SESSION['dbh']->query("COMMIT");
	return $newCpdID;
}
function addAsCompound()
{
	global $errMsgs;
	$isErr = 0;
	if ($_REQUEST['notInBNet'])
	{
		$compoundNames = $_REQUEST['notInBNet'];
	}
	else
	{
		$errMsgs[] = "Please select compound(s) to add.";
		return 0;
	}
	
	foreach ($compoundNames as $compoundName)
	{
		if (strlen($compoundName) == 0)
	    {
		    $errMsgs[] = "Length of Compound Name must be greater than 0.";
		    $isErr = 1;
		    continue;
	    }
		$retVal = insertNewCompound($compoundName);
		if ($retVal)
		{	$successfulCpds[] = "$compoundName";	}
		else
		{	$isErr = 1;	}
	}
	
	if ($successfulCpds)
	{	
		$strMsg = "Following Compounds added successfully:<br />" ;
		$strMsg .=  "\n<ol>";
		foreach ($successfulCpds as $successfulCpd)
		{
			$strMsg .=  "\n\t<li>$successfulCpd</li>";
		}
		$strMsg .=  "\n</ol>";
		printMessage($strMsg);	
	}
	if ($isErr)
	{	return 0;	}
	else
	{	return 1;	}
}

function addAsCompoundDerivative()
{
	global $errMsgs, $currPageNameUpper;
	if ($_REQUEST['notInBNet'])
	{
		$compoundDerNames = $_REQUEST['notInBNet'];
	}
	else
	{
		$errMsgs[] = "Please select Compound Derivative(s) to add.";
		return 0;
	}
	if (!$_SESSION[$currPageNameUpper]['CpdID'])
    {
	    $errMsgs[] = "Please select the compound for this derivative.";
	    return 0;
    }
	
    foreach ($compoundDerNames as $compoundDerName)
	{		
	    if (strlen($compoundDerName) == 0)
	    {
		    $errMsgs[] = "Length of Compound Derviative Name must be greater than 0.";
		    continue;
	    }
		$compoundDerNameUpper = strtoupper($compoundDerName);
		
		$qres = $_SESSION['dbh']->query("BEGIN TRANSACTION");
		if( DB::isError($qres) ) {printError("Error starting new transaction. Compound Derivative '$compoundDerName' Not added. (" . $qres->getMessage() . ")" );  $isErr = 1; continue;}
		
		$sql = "SELECT cpd_derivative_id, name FROM cpd_derivative 
			WHERE UPPER(name) = '$compoundDerNameUpper'";
			
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Could Not Search for Compound Derivative '$compoundDerName'. Compound Derivative '$compoundDerName' Not added."); 
			$_SESSION['dbh']->query("ROLLBACK");
			$isErr = 1;
			continue;	
		}
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchrow();
			printMessage("Compound Derivative with Name '$row[1]' already exists. [ID: $row[0]]"); 
			$_SESSION['dbh']->query("ROLLBACK");
			continue;
		}
		
		//Now adding the compound Derivative to the cmp_derivative table
		//First getting new cpd_derivative_id
		$qres = $_SESSION['dbh']->query("SELECT nextval('cpd_derivative_id_seq')");
	    if( DB::isError($qres) ){	printError("Error getting new Compound Derivative ID. Derivative '$compoundDerName' Not added. (" . $qres->getMessage() . ")"); $_SESSION['dbh']->query("ROLLBACK"); $isErr = 1; continue; 	}
	    $rec = $qres->fetchRow();
	    $newCpdDerID = $rec[0];
		
	    //Adding in cpd_derivative
	    $sql = "INSERT INTO cpd_derivative(cpd_derivative_id, cpd_id, name) 
			VALUES ('$newCpdDerID', '{$_SESSION[$currPageNameUpper]['CpdID']}', '$compoundDerName')";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error adding compound derivative '$compoundDerName' in cpd_derivative table. Compound Derivative '$compoundDerName' Not added. (" . $sth->getMessage() . ")");  $_SESSION['dbh']->query("ROLLBACK"); $isErr = 1; continue; 	}
		
		$_SESSION['dbh']->query("COMMIT");	
		$successfulCpdDers[] = $compoundDerName;
	}
	if ($successfulCpdDers)
	{	
		$strMsg = "Following Compound Derivatives added successfully:<br />";
		$strMsg .=  "\n<ol>";
		foreach ($successfulCpdDers as $successfulCpdDer)
		{
			$strMsg .=  "\n\t<li>$successfulCpdDer</li>";
		}
		$strMsg .=  "\n</ol>";
		printMessage($strMsg);	
	}
	if ($isErr)
	{	return 0;	}
	else
	{	return 1;	}
}

function addAsCompoundSynonym()
{
	global $errMsgs, $currPageNameUpper;
	if ($_REQUEST['notInBNet'])
	{
		$compoundSynonymNames = $_REQUEST['notInBNet'];
	}
	else
	{
		$errMsgs[] = "Please select Compound Synonym(s) to add.";
		return 0;
	}
	if (!$_SESSION[$currPageNameUpper]['CpdID'])
    {
	    $errMsgs[] = "Please select the compound for this synonym.";
	    return 0;
    }
	
	
	foreach ($compoundSynonymNames as $compoundSynonymName)
	{		
		//Converting $compoundName into Database search field form.
		$compoundSynonymNameSN = convertToSearchName($compoundSynonymName);
		if (strlen($compoundSynonymName) == 0)
	    {
		    $errMsgs[] = "Length of Compound Synonym Name must be greater than 0.";
		    continue;
	    }

		$qres = $_SESSION['dbh']->query("BEGIN TRANSACTION");
		if( DB::isError($qres) ) {printError("Error starting new transaction. Synonym '$compoundSynonymName' Not added. (" . $qres->getMessage() . ")" );  $isErr = 1; continue;}
		
	    $sql = "SELECT record_id, aname FROM allnames 
			WHERE UPPER(search_name) = '$compoundSynonymNameSN'
			AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";
			
			
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Could Not Search for Synonyms. Synonym '$compoundSynonymName' Not added."); 
			$_SESSION['dbh']->query("ROLLBACK");
			$isErr = 1;
			continue;	
		}
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchrow();
			printMessage("Synonym with Name '$row[1]' already exists. [CPD_ID: $row[0]]"); 
			$_SESSION['dbh']->query("ROLLBACK");
			continue;
		}
		
		
		//getting unikey for allnames
	    $sql = "SELECT \"unikey\" FROM \"allnames\" 
	    	WHERE \"record_id\" = {$_SESSION[$currPageNameUpper]['CpdID']}
	    	AND \"kw_table_id\" = {$_SESSION['TableID']['COMPOUND']}
	    	AND UPPER(\"is_primary\") = 'Y'";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error getting unique key for Synonym '$compoundSynonymName' in allnames table. Synonym '$compoundSynonymName' Not added. (" . $sth->getMessage() . ")");  
			$_SESSION['dbh']->query("ROLLBACK");
			$isErr = 1;
			continue;	
		}
		if ($sth->numrows() == 0)
		{
			printError("Primary Name not found for the selected compound [CPD_ID: {$_SESSION[$currPageNameUpper]['CpdID']}]. Synonym '$compoundSynonymName' Not added."); 
			$_SESSION['dbh']->query("ROLLBACK");
			$isErr = 1;
			continue;	
		}
		else
		{	
			$row = $sth->fetchrow();	
			$unikey = $_SESSION['dbh']->quote($row[0]);
		}
		
		//Now adding the compound Synonym to the allnames table
		$sql = "INSERT INTO allnames(name_id, aname, kw_table_id, record_id, is_primary, search_name, unikey) 
			VALUES (nextval('allnames_id_seq'), '$compoundSynonymName', '{$_SESSION['TableID']['COMPOUND']}', '{$_SESSION[$currPageNameUpper]['CpdID']}', 'N', '$compoundSynonymNameSN', $unikey)";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error adding Synonym '$compoundSynonymName' in allnames table. Synonym '$compoundSynonymName' Not added. (" . $sth->getMessage() . ")");  
			$_SESSION['dbh']->query("ROLLBACK");
			$isErr = 1;
			continue;	
		}
		$_SESSION['dbh']->query("COMMIT");	
		$successfulCpdSyns[] = $compoundSynonymName;
	}
	
	if ($successfulCpdSyns)
	{	
		$strMsg = "Following Compound Synonyms added successfully:<br />";
		$strMsg .=  "\n<ol>";
		foreach ($successfulCpdSyns as $successfulCpdSyn)
		{
			$strMsg .=  "\n\t<li>$successfulCpdSyn</li>";
		}
		$strMsg .=  "\n</ol>";
		printMessage($strMsg);	
	}
	if ($isErr)
	{	return 0;	}
	else
	{	return 1;	}
}

?>

