<?php
/**
* This script is a Front-End for adding Microarray data directly to the DOME database.
* Date: 13 April 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");
//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
$currPageNameUpper = strtoupper($currPageName);
?>
<script language="javascript" type="text/javascript">
<!--
function validate() {
     maxlength=500;
     if(document.init_form.other_description.value.length>=maxlength) {
          alert('Description must be 500 characters or less');
          document.init_form.other_description.focus();
          return false;
     } else {
          return true;
     }
}
//-->
</script>
<?php
$stepCount = count(split(':', $_SESSION['STEP_NUMBER']));
$title = "Add Microarray Data into the database";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}
?>

<?php
if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
if (isset($_REQUEST['technique_id']))
{
	$_SESSION[$currPageNameUpper]['technique_id'] = $_REQUEST['technique_id'];
}

fillForm();

include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\" onsubmit=\"return validate();\">\n";

	if (!getSampleLabelsFor2Channels(&$sample_label))
	{
		printError("No Sample Label found for Channel $i. Please add Sample Label Metadata.");	
		printControlBar($_SESSION['STEP_NUMBER']);
		print "\n</form>";
		return;	
	}
	
	//This MAX_SIZE is an advisory to the browser. (So that the user does not find
	// that his file is rejected by the php on the server after uploading it).
	print "<p class=\"help-tips\">Add .gpr file (gpr file is generated by GenePix software):</p>";
	print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
	print "<p><label>Data File: </label>";
	print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
	print "</p>";
	
	print "<p class=\"help-tips\">Microarray is a 2-channel experiment. One sample is labeled with Cy3 (green) and the other with Cy5 (red). Please add Meta Data and corresponding tiff file for each.</p>";
	
	print "<table width=\"100%\"><tr>";	//start table
		
	for ($i = 1; $i <= 2; $i++)
	{
		print "<td>";
		printChannel($i, $sample_label[$i]);
		print "</td>";
	}
	print "</tr></table>"; //end table
	
	print "<p class=\"help-tips\">Add information about the microarray experiment. If you do not see an option in one of the drop down menus then you would have to go back and add that information using the main menu before loading the microarray data.</p>";
	
	print "<table width=\"100%\"><tr><td>";	//start table

	//Print Extract.
	$sql = "SELECT \"extract_id\", \"name\" FROM \"extract\" WHERE \"technique_id\" = '{$_SESSION[$currPageNameUpper]['technique_id']}' ORDER BY UPPER(\"name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Extracts. " . $sth->getMessage());	return;	}
	print "<p><label>Extraction Method: </label>";
	print "<select name=\"extract_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['extract_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//Print Array Design
	$sql = "SELECT \"array_batch_id\", \"platform_title\" FROM \"array_batch\" ORDER BY UPPER(\"platform_title\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Array Design. " . $sth->getMessage());	return;	}
	print "\n<p><label>Array Design: </label>";
	print "<select name=\"array_batch_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['array_batch_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	print "</td><td>";	//divide cell
	
	//Print Hybridization Protocol
	$sql = "SELECT \"hybridization_protocol_id\", \"hyb_protocol_name\" FROM \"hybridization_protocol\" ORDER BY UPPER(\"hyb_protocol_name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Hybridization Protocols. " . $sth->getMessage());	return;	}
	print "\n<p><label>Hybridization Protocol: </label>";
	print "<select name=\"hybridization_protocol_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['hybridization_protocol_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//Print Scanning Protocol
	$sql = "SELECT \"scanning_protocol_id\", \"scanning_protocol_name\" FROM \"scanning_protocol\" ORDER BY UPPER(\"scanning_protocol_name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Scanning Protocols. " . $sth->getMessage());	return;	}
	print "\n<p><label>Scanning Protocol: </label>";
	print "<select name=\"scanning_protocol_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['scanning_protocol_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//Print Researchers. 
	$sql = "SELECT \"person_id\", \"person_name\" FROM \"person\" ORDER BY UPPER(\"person_name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Researchers. " . $sth->getMessage());	return;	}
	print "<p><label>Researcher: </label>";
	print "<select name=\"researcher_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['researcher_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
		print "</td></tr>";
		print "\n<tr><td>";
		print "<p class=\"help-tips\">Provide an identifier for this sample. This identifier is used only as an internal reference within a given file. The identifier will not appear on final GEO records.<br />";
		print "\n<label>Identifier: </label><input type=\"text\" name=\"sample_entity\" value=\"{$_SESSION[$currPageNameUpper]['sample_entity']}\" size=\"50\" maxlength=\"100\" /></p>";
		print "<p class=\"help-tips\">Provide a unique title that describes this Sample. We suggest that you use the system [biomaterial]-[condition(s)]-[replicate number], e.g., Muscle_exercised_60min_rep2. This is used for the GEO file.<br />";
		print "\n<label>Unique Title: </label><input type=\"text\" name=\"sample_title\" value=\"{$_SESSION[$currPageNameUpper]['sample_title']}\" size=\"50\" maxlength=\"120\" /></p>";
		print "\n</td><td>";
		print "<p class=\"help-tips\">Include any additional information not provided in the other fields, or paste in broad descriptions that cannot be easily dissected into the other fields.<br />";
		print "\n<label>Description (optional): </label><textarea name=\"other_description\" cols=\"50\" rows=\"4\" >\n";
		print "{$_SESSION[$currPageNameUpper]['other_description']}";
		print "</textarea></p>";
		print "</td></tr></table>"; //end table
		printControlBar($_SESSION['STEP_NUMBER']);

	print "\n</form>";
}

/**============================
* Request Functions
*============================*/
function processForm($currPageName)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);

	$_SESSION[$currPageNameUpper]['channel1'] = $_REQUEST['channel1'];
	$_SESSION[$currPageNameUpper]['channel2'] = $_REQUEST['channel2'];
	$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
	$_SESSION[$currPageNameUpper]['array_batch_id'] = $_REQUEST['array_batch_id'];
	$_SESSION[$currPageNameUpper]['hybridization_protocol_id'] = $_REQUEST['hybridization_protocol_id'];
	$_SESSION[$currPageNameUpper]['scanning_protocol_id'] = $_REQUEST['scanning_protocol_id'];
	$_SESSION[$currPageNameUpper]['researcher_id'] = $_REQUEST['researcher_id'];
	$_SESSION[$currPageNameUpper]['sample_entity'] = $_REQUEST['sample_entity'];
	$_SESSION[$currPageNameUpper]['sample_title'] = $_REQUEST['sample_title'];
	$_SESSION[$currPageNameUpper]['other_description'] = $_REQUEST['other_description'];
	
	//===Hard Coding Here
	$_SESSION[$currPageNameUpper]['channel1']['sample_labeling_id'] = 1;
	$_SESSION[$currPageNameUpper]['channel2']['sample_labeling_id'] = 2;
	if (!$_SESSION[$currPageNameUpper]['technique_id'])
	{	$errMsgs[] = "technique_id not set";	}
	
	$noOfChannels = 2;
	for ($i = 1; $i <= $noOfChannels; $i++)
	{
		$identifier = "channel$i";
		$index1 = "channel{$i}_tiff_file";
		//Validating Channel $i
		if (!$_SESSION[$currPageNameUpper][$identifier]['experiment_set_id'])
		{	$errMsgs[] = "Please Select an Experiment Set for Channel $i.";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['exp_name'])
		{	$errMsgs[] = "Please Select an Experiment for Channel $i.";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['sampling_point_label_id'])
		{	$errMsgs[] = "Please Select a Sampling Point for Channel $i";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['tissue_type_label_id'])
		{	$errMsgs[] = "Please Select a Tissue Type for Channel $i";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['biological_replicate'])
		{	$errMsgs[] = "Please Select the Biological Replicate number for Channel $i.";	}
		if ($_FILES[$index1]['name'] == "")
		{	$errMsgs[] = "Please select the tiff file to upload for Channel $i.";	}
		if (preg_match('/\'/', $_FILES[$index1]['name']))
		{	$errMsgs[] = "Name of the tiff file contains an invalid character for Channel $i.";	}
		
		
		$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
		$uploadfile = $uploaddir . $_FILES[$index1]['name'];
		if (move_uploaded_file($_FILES[$index1]['tmp_name'], $uploadfile)) 
		{
		   //File is valid, and was successfully uploaded
		   $_SESSION[$currPageNameUpper][$identifier]['uploadFile'] = $uploadfile;
		   $_SESSION[$currPageNameUpper][$identifier]['uploadFileName'] = $_FILES[$index1]['name'];
		   system("chmod 644 $uploadfile");
		} 
		else 
		{	$errMsgs[] = "Could not move the uploaded Tiff file $i to the Destination on the server";	}
		
		
	}
	
	//Validating Rest
	if ($_FILES['uploadFile']['name'] == "")
	{	$errMsgs[] = "Please select the file to upload using the browse button.";	}
	if (!$_SESSION[$currPageNameUpper]['extract_id'])
	{	$errMsgs[] = "Please Select extraction method.";	}
	if (!$_SESSION[$currPageNameUpper]['array_batch_id'])
	{	$errMsgs[] = "Please Select Array Design.";	}
	if (!$_SESSION[$currPageNameUpper]['hybridization_protocol_id'])
	{	$errMsgs[] = "Please Select Hybridization Protocol.";	}
	if (!$_SESSION[$currPageNameUpper]['scanning_protocol_id'])
	{	$errMsgs[] = "Please Select Scanning Protocol.";	}
	if (!$_SESSION[$currPageNameUpper]['researcher_id'])
	{	$errMsgs[] = "Please Select the name of the Researcher.";	}
	if (!$_SESSION[$currPageNameUpper]['sample_entity'])
	{	$errMsgs[] = "Please Select Identifier for this sample for GEO.";	}
	if (!$_SESSION[$currPageNameUpper]['sample_title'])
	{	$errMsgs[] = "Please Select Unique Title for GEO.";	}
	
	if ($errMsgs)
	{	return 0;	}
	
	$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
	$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
	
	if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
	{
	   //File is valid, and was successfully uploaded
	   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
	   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
	   system("chmod 644 $uploadfile");
	} 
	else 
	{
		$errMsgs[] = "Could not move the uploaded file to the Destination on the server";
		return 0;
	}
	
	//Now find out sampling_replicate_id from the given info for the channels.
	for ($i = 1; $i <= $noOfChannels; $i++)	
	{
		$index1 = "channel$i";
		$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
					, \"sampling_point\" sp
					, \"experiment\" e
				WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper][$index1]['experiment_set_id']}'
				AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper][$index1]['exp_name']}'
				AND sp.\"experiment_id\" = e.\"experiment_id\"
				AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper][$index1]['sampling_point_label_id']}'
				AND sr.\"sampling_point_id\" = sp.\"sampling_point_id\"
				AND sr.\"replicate\" = '{$_SESSION[$currPageNameUpper][$index1]['biological_replicate']}'";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error retrieving Sampling Replicate for channel $i. " . $sth->getMessage();	return 0;	}
		
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchRow();
			$_SESSION[$currPageNameUpper][$index1]['sampling_replicate_id'] = $row[0];
			//print "Set sampling_replicate_id = {$_SESSION[$currPageNameUpper]['sampling_replicate_id']} ($n)";
		}
		else
		{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided for channel $i";	return 0;}
	}
		
	
	if ($errMsgs)
	{	return 0;	}

	
	$fileParameters['FILEHOME'] = $_SESSION['FILE_HOME'];
	$fileParameters['EXTRACT_ID'] = $_SESSION[$currPageNameUpper]['extract_id'];
	$fileParameters['PERSON_ID'] = $_SESSION[$currPageNameUpper]['researcher_id'];
	$fileParameters['DATA_FILE_NAME'] = $_SESSION[$currPageNameUpper]['uploadFile'];
	$fileParameters['SAMPLE_LABELING_ID_1'] = $_SESSION[$currPageNameUpper]['channel1']['sample_labeling_id'];
	$fileParameters['SAMPLE_LABELING_ID_2'] = $_SESSION[$currPageNameUpper]['channel2']['sample_labeling_id'];
	$fileParameters['SAMPLING_REPLICATE_ID_1'] = $_SESSION[$currPageNameUpper]['channel1']['sampling_replicate_id'];
	$fileParameters['SAMPLING_REPLICATE_ID_2'] = $_SESSION[$currPageNameUpper]['channel2']['sampling_replicate_id'];
	$fileParameters['TISSUE_TYPE_ID_1'] = $_SESSION[$currPageNameUpper]['channel1']['tissue_type_label_id'];
	$fileParameters['TISSUE_TYPE_ID_2'] = $_SESSION[$currPageNameUpper]['channel2']['tissue_type_label_id'];
	$fileParameters['CHANNEL1_FILE_NAME'] = $_SESSION[$currPageNameUpper]['channel1']['uploadFile'];
	$fileParameters['CHANNEL2_FILE_NAME'] = $_SESSION[$currPageNameUpper]['channel2']['uploadFile'];
	$fileParameters['SCANNING_PROTOCOL_ID'] = $_SESSION[$currPageNameUpper]['scanning_protocol_id'];
	$fileParameters['ARRAY_BATCH_ID'] = $_SESSION[$currPageNameUpper]['array_batch_id'];
	$fileParameters['HYBRIDIZATION_PROTOCOL_ID'] = $_SESSION[$currPageNameUpper]['hybridization_protocol_id'];
	$fileParameters['SAMPLE_ENTITY'] = $_SESSION[$currPageNameUpper]['sample_entity'];
	$fileParameters['SAMPLE_TITLE'] = $_SESSION[$currPageNameUpper]['sample_title'];
	$fileParameters['OTHER_DESCRIPTION'] = $_SESSION[$currPageNameUpper]['other_description'];
	
	foreach($fileParameters as $key=>$value)
	{	$data .= "$key=$value\n";	}
	$paramFileName = session_id() . ".param";
	$paramFile = $_SESSION['BROWSER_TMP_FULL'] . $paramFileName;
	writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE'], $paramFileName);
	
	$perlScriptFile = "readDataFromGprFile.pl";

	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$paramFile\" 2>&1;";
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
		//redirect
		print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";
		exit();
	}
	else
	{	
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn: $retString RetValue = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
