<?php
/**
* This script is a Front-End for inserting Proteomics Data
* in the DOME database.
* Date: 16 Nov 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");

$currPageName = 'ADD_PROTEOMICS_DATA';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
if (isset($_REQUEST['technique_id']))
{	$_SESSION[$currPageNameUpper]['technique_id'] = strtoupper($_REQUEST['technique_id']);	}

$title = "Add Proteomics Data";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER' OR strtoupper($_SESSION['role']) == 'EDITOR'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}
?>

<?php


if ($_REQUEST['submit'] == 'Insert Data' AND $_SESSION[$currPageNameUpper]['force_add'] == 0)
{	processForm(0);	}
elseif ($_REQUEST['submit'] == 'Continue')
{	processForm(1);	}
elseif ($_REQUEST['submit'] == 'Cancel')
{	$_SESSION[$currPageNameUpper]['force_add'] = 0;	}
else
{	$_SESSION[$currPageNameUpper]['force_add'] = 0;	}
	

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
fillForm($_SESSION[$currPageNameUpper]['force_add']);
include_once("footer.php");
?>

<?php
//Functions
function fillForm($force_add = 0)
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	if ($force_add)
	{
		print "\n<div class=\"controlBar\">";
		print "\n<input type=\"submit\" name=\"submit\" value=\"Cancel\" /> ";
		print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";
		print "\n</div>";
	}
	else
	{
		print '<p class="help-tips"></p>';
		
		//This MAX_SIZE is an advisory to the browser. (So that the user does not find
		// that his file is rejected by the php on the server after uploading it).
		print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
		print "<p><label>Data File: </label>";
		print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
		print "</p>";
		
		//Raw Data File
		print "<br><p class=\"help-tips\">Please enter the raw data file. If you are unable to provide the raw data file at this time then although you can still proceed with data insertion but remember that you will not be able to retrieve this file using DOME at a later instance. (Note: The filename cannot contain space or single/double quotes. Also you cannot have same file names for more than one sample):</p>";
		print "<p><label>Raw Data File: </label>";
		print '<input name="RawDataFile" size="48" type="file" value="Select File using browse"/>';
		print "</p>";
		
		print "<br><p class=\"help-tips\">Please enter the proper Meta Data information:</p>";
		
		printMetaDataSelections("", $_SESSION[$currPageNameUpper], true, true);
		
		//Print Protocol. 
		$sql = "SELECT p.protocol_id, p.protocol_name FROM protocol p, protocol_type pt
			WHERE p.protocol_type_id = pt.protocol_type_id 
			AND pt.technique_id = '{$_SESSION[$currPageNameUpper]['technique_id']}'
			AND UPPER(pt.method) = 'EXPERIMENTAL'
			ORDER BY protocol_name";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Protocol Type. " . $sth->getMessage());	return;	}
		print "<p><label>Protocol: </label>";
		print "<select name=\"protocol_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['protocol_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		printExtractMethod($_SESSION[$currPageNameUpper]['technique_id']);
		
		//Print Researchers. 
		$sql = "SELECT person_id, person_name FROM person ORDER BY person_name";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Researchers. " . $sth->getMessage());	return;	}
		print "<p><label>Researcher: </label>";
		print "<select name=\"researcher_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['researcher_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
	
		print "<input type=\"submit\" name=\"submit\" value=\"Insert Data\" />";
	}
	print "\n</form>";

}


/**============================
* Request Functions
*============================*/
function processForm($force_add = 0)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	if (!$force_add)
	{
		$_SESSION[$currPageNameUpper]['experiment_set_id'] = $_REQUEST['experiment_set_id'];
		$_SESSION[$currPageNameUpper]['exp_name'] = $_REQUEST['exp_name'];
		$_SESSION[$currPageNameUpper]['sampling_point_label_id'] = $_REQUEST['sampling_point_label_id'];
		$_SESSION[$currPageNameUpper]['tissue_type_label_id'] = $_REQUEST['tissue_type_label_id'];
		$_SESSION[$currPageNameUpper]['biological_replicate'] = $_REQUEST['biological_replicate'];
		$_SESSION[$currPageNameUpper]['technical_replicate'] = $_REQUEST['technical_replicate'];
		$_SESSION[$currPageNameUpper]['protocol_id'] = $_REQUEST['protocol_id'];
		$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
		$_SESSION[$currPageNameUpper]['researcher_id'] = $_REQUEST['researcher_id'];
			
		
		if ($_FILES['uploadFile']['name'] == "")
		{	$errMsgs[] = "Please select the Data File to upload.";	}
			
		if (!$_SESSION[$currPageNameUpper]['experiment_set_id'])
		{	$errMsgs[] = "Please Select an Experiment Set.";	}
		
		if (!$_SESSION[$currPageNameUpper]['exp_name'])
		{	$errMsgs[] = "Please Select an Experiment.";	}
		
		if (!$_SESSION[$currPageNameUpper]['sampling_point_label_id'])
		{	$errMsgs[] = "Please Select a Sampling Point";	}
		
		if (!$_SESSION[$currPageNameUpper]['tissue_type_label_id'])
		{	$errMsgs[] = "Please Select a Tissue Type";	}
		
		if (!$_SESSION[$currPageNameUpper]['biological_replicate'])
		{	$errMsgs[] = "Please Select the biological replicate number.";	}
	
		if (!$_SESSION[$currPageNameUpper]['technical_replicate'])
		{	$errMsgs[] = "Please Select the technical replicate number.";	}
		
		if (!$_SESSION[$currPageNameUpper]['protocol_id'])
		{	$errMsgs[] = "Please Select a Protocol.";	}
		
		if (!$_SESSION[$currPageNameUpper]['extract_id'])
		{	$errMsgs[] = "Please Select an Extraction Method.";	}
		
		if (!$_SESSION[$currPageNameUpper]['researcher_id'])
		{	$errMsgs[] = "Please Select the name of the Researcher.";	}
		
		if (preg_match('/\'/', $_FILES['uploadFile']['name']))
		{
			$errMsgs[] = "Name of the processed file contains an invalid character.";		
		}
		if (preg_match('/\'/', $_FILES['RawDataFile']['name']))
		{
			$errMsgs[] = "Name of the Raw Data file contains an invalid character.";		
		}
	
		
		if ($errMsgs)
		{	return 0;	}
		
		$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
		$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
		if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
		{
		   //File is valid, and was successfully uploaded
		   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
		   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
		   system("chmod 644 $uploadfile");
		} 
		else 
		{
			$errMsgs[] = "Could not move the uploaded file to the Destination on the server";
			return 0;
		}
		
		if ($_FILES['RawDataFile']['name'] == "")
		{
			unset($_SESSION[$currPageNameUpper]['RawDataFile']);
			unset($_SESSION[$currPageNameUpper]['RawDataFileName']);
		}
		else
		{
			$uploadfile = $uploaddir . $_FILES['RawDataFile']['name'];
			if (move_uploaded_file($_FILES['RawDataFile']['tmp_name'], $uploadfile)) 
			{
			   //File is valid, and was successfully uploaded
			   $_SESSION[$currPageNameUpper]['RawDataFile'] = $uploadfile;
			   $_SESSION[$currPageNameUpper]['RawDataFileName'] = $_FILES['RawDataFile']['name'];
			   system("chmod 644 $uploadfile");
			} 
			else 
			{
				$errMsgs[] = "Could not move the Raw Data File to the Destination on the server.";
			}
		}
		
		if ($errMsgs)
		{	return 0;	}
		

		//Now find out sampling_replicate_id from the given info.
		$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
						, \"sampling_point\" sp
						, \"experiment\" e
					WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper]['experiment_set_id']}'
					AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper]['exp_name']}'
					AND sp.\"experiment_id\" = e.\"experiment_id\"
					AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper]['sampling_point_label_id']}'
					AND sr.\"sampling_point_id\" = sp.sampling_point_id
					AND sr.\"replicate\" = '{$_SESSION[$currPageNameUpper]['biological_replicate']}'";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error retrieving Sampling Replicate. " . $sth->getMessage();	
			return 0;
		}
		
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchRow();
			$_SESSION[$currPageNameUpper]['sampling_replicate_id'] = $row[0];
			//print "Set sampling_replicate_id = {$_SESSION[$currPageNameUpper]['sampling_replicate_id']} ($n)";
		}
		else
		{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided";	}
		
	}
	
	$perlScriptFile = "readDataFromProt.pl";
	$data_file = $_SESSION[$currPageNameUpper]['uploadFile'];
	$raw_file = $_SESSION[$currPageNameUpper]['RawDataFile'];
	$file_home = $_SESSION['FILE_HOME'];
	$technique_id = $_SESSION[$currPageNameUpper]['technique_id'];
	$sampling_replicate_id = $_SESSION[$currPageNameUpper]['sampling_replicate_id'];
	$technical_replicate = $_SESSION[$currPageNameUpper]['technical_replicate'];
	$person_id = $_SESSION[$currPageNameUpper]['researcher_id'];
	$extract_id = $_SESSION[$currPageNameUpper]['extract_id'];
	$protocol_id = $_SESSION[$currPageNameUpper]['protocol_id'];
	$tissue_type_label_id = $_SESSION[$currPageNameUpper]['tissue_type_label_id'];

	$force_add = $_SESSION[$currPageNameUpper]['force_add'];

	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$data_file\" \"$raw_file\" \"$file_home\" $technique_id $sampling_replicate_id $technical_replicate $person_id $extract_id $protocol_id $tissue_type_label_id 2>&1;";
	//print $com;
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
	  	$_SESSION[$currPageNameUpper]['force_add'] = 0;
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
		//redirect
		print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";
		exit();
	}
	elseif ($retValue == 99)	//data exists
	{
		$_SESSION[$currPageNameUpper]['force_add'] = 1;
		$_SESSION['Message'][] = $msg;
	}
	else
	{	
		$_SESSION[$currPageNameUpper]['force_add'] = 0;
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn Value = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}

	return 1;
}

?>
