<?php
/**
* This script is a Front-End for adding Metadata for Experiment
* set directly to the DOME database.
* Date: 31 Mar 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");


$currPageName = 'ADD_EXPERIMENT_SET';
?>

<?php
$title = "DOME : Add Experiment Set";
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')	
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php
if ($_REQUEST['submit'])
{	
	processForm();	
	if ($errMsgs)
	{  
		foreach ($errMsgs as $msg)
		{	printError($msg);	}
		fillForm();
	}
	else
	{	
		print "<p><a href=\"intro.php\">Main Menu</a> | <a href=\"metaDataMenu.php\">Meta Data Menu</a></p>";	
	}
}
else
{	
	if ($errMsgs)
	{  
		foreach ($errMsgs as $msg)
		{	printError($msg);	}
	}
	fillForm();	
}

include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	//Print Experiment Sets. 
	print "<p><label>Experiment Set: </label>";
	print "<input type=\"text\" name=\"exp_set_name\" size=\"75\" />";
	print "<input type=\"submit\" name=\"submit\" value=\"Add Experiment Set\" />";
	print "\n</form>";
}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$exp_set_name = $_REQUEST['exp_set_name'];
	if (!trim($exp_set_name))
	{
		$errMsgs[] = "Please enter name of the experiment set.";	
		return 0;			
	}
	
	$exp_set_name = $_SESSION['dbh']->quote($exp_set_name);
	
	$sql = "SELECT \"exp_set_id\", \"exp_set_name\"  FROM \"experiment_set\" 
		WHERE UPPER(\"exp_set_name\") = " . strtoupper($exp_set_name);
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving Experiment Sets. " . $sth->getMessage();	
		return 0;	
	}
	
	if ($sth->numRows() == 0)	
	{
		$sql = "INSERT INTO experiment_set (\"exp_set_id\", \"exp_set_name\") values (nextval('exp_set_id_seq'), $exp_set_name)";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error inserting Experiment Set $exp_set_name. " . $sth->getMessage();	
			return 0;	
		}
		printMessage("Experiment Set $exp_set_name successfully inserted in the database");
	}
	else
	{	
		$errMsgs[] = "Experiment Set named $exp_set_name already exists in the database.";
	}
	
	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
