<?php
/**
* This script prints the menu for the metadata
* Date: 31 Mar 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

//session_start();
include_once("common.php");
?>

<?php
$currPageName = 'ADD_METADATA_MENU';

$title = "DOME : MetaData Menu"; 
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>
<p class="help-tips">This page is only accessible to the Manager of the Database. If you are not the Manager then PLEASE LOGOUT.</p>
<p class="help-tips">You can use these links to add Meta Data.</p>

<div class="left-align">
<p>
 <ul>
   <hr/>
   <p class="help-tips">USE THIS SECTION TO ADD META-DATA FOR THE EXPERIMENT</p>
   <li><a href="addTable.php?currPageName=EXPERIMENT_SET">Add Experiment Set</a></li>
	<p class="help-tips">Please begin by first creating an Experiment Set (Defined as mini-project containing a logical set of experiments. Example of logical sets of experiments could be like time series experiments on control vs. perturbed cells</p>
   <li><a href="addTable.php?currPageName=EXPERIMENT">Add Experiment</a></li>	
   <p class="help-tips">Add experiments for each experiment_set previously defined. Example of an experiment could be a collection of time-series data for a particular cell type.</p>
   <li><a href="addSamplingPoint.php">Add Sampling Point</a></li>
   <p class="help-tips">Add sampling_points for each experiment. For example, if the experiment is a time series experiment, then create sampling_points for each time point in the experiment</p>
   <li><a href="addTable.php?currPageName=TISSUE_TYPE">Add Tissue Type</a></li>
   <p class="help-tips">Add tissue type used in the project</p>
   <li><a href="addTable.php?currPageName=SAMPLING_REPLICATE">Add Sampling Replicate</a></li>
   <p class="help-tips">Add biological replicates for each sampling_point</p>
   <hr/>
   <p class="help-tips">USE THIS SECTION TO ADD INFORMATION ABOUT THE BIOLOGICAL SAMPLE USED IN THE EXPERIMENT</p>
   <li><a href="addTable.php?currPageName=BIOSOURCE_PROPERTIES">Add Biosource Properties</a></li>
   <P class="help-tips">Add details about the biological sample used during the project</p>
   <li><a href="addTable.php?currPageName=BIOMATERIAL_MANIPULATION">Add Biomaterial Manipulation</a></li>
   <p class="help-tips">Add details about how the biological sample was perturbed during the course of the experiment</p>
   <li><a href="addTable.php?currPageName=GROWTH_CONDITIONS">Add Growth Conditions</a></li>
   <p class="help-tips">Add details about the growth conditions for the biological sample used during the project</p>
   <p class=\"li-separator\"></p>
   <hr/>
   <p class="help-tips">USE THIS SECTION TO ADD TRANSCRIPTOMICS SPECIFIC META-DATA</p>
   <li><a href="addTable.php?currPageName=SPOTTED_ARRAY_DESIGN">Add Spotted Array Design</a></li>
   <li><a href="addTable.php?currPageName=AFFYMETRIX_ARRAY_DESIGN">Add Affymetrix Array Design</a></li>
   <li><a href="addTable.php?currPageName=ADD_AFFYMETRIX_ANNOTATION">Add Affymetrix Probe set Annotation</a></li>
   
   <p class="help-tips">Create an array batch for each batch used in the microarray experiments. You need to create this before any microarray data can be added into the database</p>
   <li><a href="addTable.php?currPageName=FEATURE_TYPE">Add Feature Type</a></li>
   <p class="help-tips">Add information about the feature (spot) on the array. This is part of Meta Data for the array and should be added before adding any microarray data into the database</p>
   <li><a href="addTable.php?currPageName=HYBRIDIZATION_PROTOCOL">Add Hybridization Protocol</a></li>
   <p class="help-tips">Add the hybridization protocol that was used for the microarray experiment. This has to be added before adding the microarray data into the database</p>
   <li><a href="addSampleLabeling.php?mode=ADD">Add Sample Label</a></li>
   <p class="help-tips">Add how samples were labeled for microarray experiment (e.g. Cy3 and Cy5 labeling)</p>
   <li><a href="addTable.php?currPageName=SCANNING_PROTOCOL">Add Scanning Protocol</a></li>
   <p class="help-tips">Add scanning protocol used to scan the microarray slide. The protocol should be added before adding any microarray data into the database</p>
   <hr/>
   
	<p class="help-tips">USE THIS SECTION TO ADD PROTEOMICS SPECIFIC META-DATA</p>
	
<?php
	//==Hard Coding Here
	$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" 
		WHERE UPPER(\"technique_name\") = 'PROTEOMICS'";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Techniques. " . $sth->getMessage());	}
	else
	{	
		if ($row = $sth->fetchRow())
		{	print "\n\t<li><a href=\"referenceGelData.php?technique_ids=$row[0]\">Protein Index</a></li>";		}
		else
		{	printError ("No Proteomics entry found in technique table.");	}
	}
?>
	
   <hr/>
   
   <p class="help-tips">OTHER INFORMATION REQUIRED FOR THE DATA</p>
   <li><a href="addTable.php?currPageName=COLUMN">Add Column</a></li>
   <p class="help-tips">Add details about the external database with which to link the data</p>
   <li><a href="addTable.php?currPageName=EXTRACT">Add Extraction Method</a></li>
   <p class="help-tips">Add information about the extraction protocol used. Different extraction methods are used for different techniques and each method should be added separately. These methods should be added before adding the data into the database</p>

   <li><a href="addTable.php?currPageName=PROTOCOL_TYPE">Add Protocol</a></li>
   <p class="help-tips">Add details about the protocol used (either experimental or statistical)</p>
   <li><a href="addTable.php?currPageName=PROTOCOL">Add Statistical Test</a></li>
   <p class="help-tips">Add statistical protocol (e.g. mean or ttest) used for a particular protocol_type</p>
   <li><a href="addTable.php?currPageName=REFERENCE">Add Reference</a></li>
   <p class="help-tips">Add reference information</p>

   <li><a href="addTable.php?currPageName=SOFTWARE">Add Software</a></li>
   <p class="help-tips">Add details of the software used to generate the data in an experiment</p>

   <p class=\"li-separator\"></p>	
   
<li><a href="addTable.php?currPageName=PERSON">Add a Person</a></li>
<p class="help-tips">The Manager can add people to the project using this link</p>
<li><a href="addTable.php?currPageName=TECHNIQUE_ACL">Add Technique Viewable by guest</a></li>	
<p class="help-tips">DOME allows Manager with the authority to allow some/all of the data to be viewable to guests (public). Use this link to control what should and should not be allowed.</p>
 </ul>
</p>
</div>
<?php 
	include("footer.php");
?>
