<?php

/**

* This script is copied from Aejaaz's "addDataMetabolomics.php" and alternated

* for uploading new maps for DOME.

* This script will take the following parameters from user:

* file for image

* file for image component data

* image component names vs. experimental elements names

* image name

* image type

*

* Jan. 24, 2007

* X. Jing Li

* Reversion: March 8, 2007: Start adding kegg pathways to Bnet.

*/



include_once("common.php");

//include_once("compoundFrame.php");

include_once("workFlow.php");

?>



<?php

$currPageName = "ADD_NEW_MAP";

$currPageNameUpper = strtoupper($currPageName);

$title = "Add Pathway/Image to DOME";

include("header.php");

if (!(strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER')) {

  printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");

  exit();

}

?>



<p class="help-tips">You can use this page to populate the metabolic pathways for your project specie or upload your pathways or images of your project. If you want to populate the metabolic pathways already in BNet, you need to select a pathway and create a file contains all element names corresponding to the pathway component names in your project. You can either select existing metabolic pathways or enter your own pathway/image with the coordination file for all known elements, along with a name and select a type foryour image. (Please see the "Help" page for more information and file formats.)</p>

<?php

//var_dump($_SESSION[$currPageNameUpper]);



if ($errMsgs) {

  foreach ($errMsgs as $msg) {

    printError($msg);

  }

  unset($errMsgs);

}

if ($_SESSION['Message']) {  

	foreach ($_SESSION['Message'] as $msg){

    printMessage($msg);

  }

	unset($_SESSION['Message']);

}



if ('Add To BNet' == $_REQUEST['submit']) {

  //print "go to processForm<br />";

  $_SESSION[$currPageNameUpper]['kegg_map_name'] = $_REQUEST['kegg_map_name'];

  $_SESSION[$currPageNameUpper]['is_kegg_map'] = $_REQUEST['is_kegg_map'];

  $_SESSION[$currPageNameUpper]['imageFile'] = $_REQUEST['imageFile'];

  $_SESSION[$currPageNameUpper]['imageInfoFile'] = $_REQUEST['imageInfoFile'];

  $_SESSION[$currPageNameUpper]['namesFile'] = $_REQUEST['namesFile'];

  $_SESSION[$currPageNameUpper]['image_name'] = $_REQUEST['image_name'];

  $_SESSION[$currPageNameUpper]['map_type_id'] = $_REQUEST['map_type_id'];

  processForm($_SESSION[$currPageNameUpper]['force_add']);

  if ($errMsgs) {

    foreach ($errMsgs as $msg) {

      printError($msg);

    }

    unset($errMsgs);

  }

  unset($_SESSION['ADD_MAP_CPD_OR_DER']);

} elseif ( 'Continue' == $_REQUEST['submit']) {

  processForm($_SESSION[$currPageNameUpper]['force_add']);

  if ($errMsgs) {

    foreach ($errMsgs as $msg) {

      printError($msg);

    }

    unset($errMsgs);

  }

  unset($_SESSION['ADD_MAP_CPD_OR_DER']); 

} elseif ('Get Pathway Info' == $_REQUEST['submit']) {

  $_SESSION[$currPageNameUpper]['kegg_map_name'] = $_REQUEST['kegg_map_name'];

 // print "kegg_map_id = $_SESSION[$currPageNameUpper]['kegg_map_id']<br/>";

  getPathwayInfo($_SESSION[$currPageNameUpper]['kegg_map_name']);

  unset($_SESSION['Message']);

  $_SESSION[$currPageNameUpper]['force_add'] = 0;

  exit;

} elseif ('Save as Tab-Delimited Format' == $_REQUEST['submit']) {

  savePathwayInfo($_SESSION[$currPageNameUpper]['kegg_map_name']);

  unset($_SESSION['Message']);

  $_SESSION[$currPageNameUpper]['force_add'] = 0;

  exit;

} elseif ('Cancel' == $_REQUEST['submit']) {

  $_SESSION[$currPageNameUpper]['force_add'] = 0;

} else {

  unset($_SESSION[$currPageNameUpper]);

  $_SESSION[$currPageNameUpper]['force_add'] = 0;

}

fillForm($_SESSION[$currPageNameUpper]['force_add']);



include_once("footer.php");

?>



<?php

//Functions

function fillForm($force_add = 0) {

  global $currPageName;

  $currPageNameUpper = strtoupper($currPageName);



  $self = $_SERVER[PHP_SELF];

  print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";



  if ($force_add) {

    print "\n<div class=\"controlBar\">";

    print "\n<input type=\"submit\" value=\"Cancel\" />";

    print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";

    print "\n</div>";

  } else {

    // This MAX_SIZE is an advisory to the browser. (So that the user does not find

    // that his file is rejected by the php on the server after uploading it).

    print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';



    /* This section is for populate KEGG maps for the specie where the user 

    *  logged in. It will display the names of all map with map_type_id = 2 

    *  which is for metabolic pathways. User can choose one or more names and 

    *  the corresponding names file to populate the map_component table.

    */

    print "<hr/>";

    print "<p><input type=\"radio\" name=\"is_kegg_map\" value=\"Y\" ";

    if ($_SESSION[$currPageNameUpper]['is_kegg_map']) {

      print "checked/>";

    } else {

      print "/> Populate a existing Metabolic Pathway: </p>";

    }



    print '<p class="help-tips">Please choose a metabolic pathway. If you need to get the pathway elements\' names and coordinates, click the "Get Pathway Info" button to download it.</p>';

    $sql = "SELECT \"map_id\", \"map_name\" FROM \"map\" WHERE \"map_type_id\" = 2 AND UPPER(\"map_number\") LIKE 'K_%' order by \"map_id\"";

    $sth = $_SESSION['dbh']->query($sql);

    if (DB::isError($sth)) {

       print Error("Error while retrieving pathway names. " . $sth->getMessage());

       return;

    }

    print '<p><label>Metabolic Pathways: </label>';

    print "<select name=\"kegg_map_name\">";

    while ($row = $sth->fetchrow()) {

      print "\n\t<option value=\"$row[1]\">$row[1]</option>";

      if ($_SESSION[$currPageNameUpper]['kegg_map_name'] == $row[1]) {

        print " selected";

      }

      print ">$row[1]</option>";

    }

    print "\n</select> ";



    // print the button for "Get Pathway Info"

   	print "<input type=\"submit\" name=\"submit\" value=\"Get Pathway Info\" /></p>";



    print "\n<h5> Or </h5> ";

    

    print "<p><input type=\"radio\" name=\"is_kegg_map\" value=\"N\" ";

    if ($_SESSION[$currPageNameUpper]['is_kegg_map']) {

      print "checked/>";

    } else {

      print "/> Populate a user defined Pathway: </p>";

    }

    print "<p class=\"help-tips\"> The following information is for user defined maps. It needs two files, map name and choose a map-type. The first file is the image file. It can be \".gif\", \".png\" or \".jpg/.jpeg\". The second file is the shape and coordinates for all map components. Please note the file names should contain only a-z, A-Z, 0-9 and \"_\". The map name has to ber unique from others. Map-type can be chosen from the drop down list.</p>";



    // Image File

    print '<p class="help-tips">Please enter the Image file:</p>';

    print '<p><label>Image File: </label>';

    print '<input name="imageFile" size="48" type="file" value="Select File using browse"/>';

    print '</p>';



    // Image component info File

    print '<p class="help-tips">Please enter the image component information file:</p>';

    print '<p><label>Image component info File: </label>';

    print '<input name="imageInfoFile" size="48" type="file" value="Select File using browse"/>';

    print '</p>';

/*

    // corresponding names File

    print '<br><p class="help-tips">Please enter the image component name file. This file is for the correspondence of component names on image and the element names used in the experimental data file. Each experimental data elements must corresponding to a unique image component.</p>';

    print '<p><label>Corresponding name File: </label>';

    print '<input name="namesFile" size="48" type="file" value="Select File using browse"/>';

    print '</p>';

*/

    print '<p class="help-tips">Please enter the following information:</p>';

    //printMetaDataSelections("", $_SESSION[$currPageNameUpper], true, true);



    // Print Image Name

    print "<p><label>Pathway/Image Name: </label><input type=\"text\" name=\"image_name\" value=\"{$_SESSION[$currPageNameUpper]['image_name']}\" size=\"40\" />";



    // Print map_type.

    $sql = "SELECT map_type_id, map_type_name from map_type order by map_type_id";

    $sth = $_SESSION['dbh']->query($sql);

      if ( DB::isError($sth) ) {

      printError("Error retrieving map types. " . $sth->getMessage());

      return;

    }



    print "<p><label>Image Type: </label>";

    print "<select name=\"map_type_id\">";

    print "\n\t<option value=\"0\">--Select One--</option>";

    while ($row = $sth->fetchRow()) {

      print "\n\t<option value=\"$row[0]\"";

      if ($_SESSION[$currPageNameUpper]['map_type_id'] == $row[0]) {

        print " selected";

      }

      print ">$row[1]</option>";

    }

    print "\n</select></p>";

    print "\n<hr />";



    // corresponding names File

    print '<br><p class="help-tips">Please enter the image component name file. This file is for the correspondence of component names on image and the element names used in the experimental data file. Each experimental data elements must corresponding to a unique image component.</p>';

    print '<p><label>Corresponding name File: </label>';

    print '<input name="namesFile" size="48" type="file" value="Select File using browse"/>';

    print '</p>';



  	print "\n\n<p><input type=\"submit\" name=\"submit\" value=\"Add To BNet\" /></p>";

  	print "<p><a href=\"./BNetMenu.php\">< Back to BNet Menu</a></p>";

  }

  print "\n</form>";

}



/**============================

* Request Functions

*============================*/

function processForm($force_add = 0) {

  global $errMsgs, $currPageName;

  $currPageNameUpper = strtoupper($currPageName);

  $force_add = $_SESSION[$currPageNameUpper]['force_add'];

  $uploaddir = $_SESSION['BROWSER_TMP_FULL'];

  $errMsgs = "";



  if (!$force_add) {

    // check if the cooresponding name file exist

    if ($_FILES['namesFile']['name'] == "") {

      $errMsgs[] = "Please select the corresponding names file to upload using the browse button.";

    }

    if (preg_match('/\'/', $_FILES['namesFile']['name'])) {

      $errMsgs[] = "Name of the correspondigng names file contains invalid character \"\'\".";

    }

    $uploadfile = $uploaddir . session_id() . "_NEWMAP_" . $_FILES['namesFile']['name'];

    //print "uploadfile = $uploadfile, _FILES['namesFile']['tmp_name'] = " . $_FILES['namesFile']['tmp_name'] . "<br/>";

    $ok = move_uploaded_file($_FILES['namesFile']['tmp_name'], $uploadfile);

    //print "ok = $ok<br/>";

    if ($ok == 1) {

      //File is valid, and was successfully uploaded

      $_SESSION[$currPageNameUpper]['namesFile'] = $uploadfile;

      $_SESSION[$currPageNameUpper]['namesFileName'] = $_FILES['namesFile']['name'];

      system("chmod 644 $uploadfile");

    } else {

      $errMsgs[] = "Could not move the corresponding names File to the Destination on the server.";

    }



    // Check other information. 

    if ($_SESSION[$currPageNameUpper]['is_kegg_map'] == "Y") {

      /* user wants to populate kegg pathway */

      //$map_name = $_SESSION[$currPageNameUpper]['kegg_map_name'];

      $_SESSION[$currPageNameUpper]['map_type_id'] = 2;

    } elseif ($_SESSION[$currPageNameUpper]['is_kegg_map'] == "N") {  

      // user uploads custom map

      if (!$_SESSION[$currPageNameUpper]['image_name']) {

        $errMsgs[] = "Image name is not set.";

      }

  

      if (!$_SESSION[$currPageNameUpper]['map_type_id']){

        $errMsgs[] = "Image type is not set.";

      }



      if ($errMsgs) {

        return 0;

      }



      if ($_FILES['imageFile']['name'] == "") {

        $errMsgs[] = "Please select the image file to upload using the browse button.";

      }

      if ($_FILES['imageInfoFile']['name'] == "") {

        $errMsgs[] = "Please select the image component information file to upload using the browse button.";

      }



      if (preg_match('/\'/', $_FILES['imageFile']['name'])) {

        $errMsgs[] = "Name of the image file contains invalid character \"\'\".";

      }

      if (preg_match('/\'/', $_FILES['imageInfoFile']['name'])) {

        $errMsgs[] = "Name of the image component information file contains invalid character \"\'\".";

      }

      if ($errMsgs) {

        return 0;

      }



      $uploadfile = $uploaddir . session_id() . "_NEWMAP_" . $_FILES['imageFile']['name'];

      if (move_uploaded_file($_FILES['imageFile']['tmp_name'], $uploadfile)) {

        //File is valid, and was successfully uploaded

        $_SESSION[$currPageNameUpper]['imageFile'] = $uploadfile;

        $_SESSION[$currPageNameUpper]['imageFileName'] = $_FILES['imageFile']['name'];

        system("chmod 644 $uploadile");

      } else {

        $errMsgs[] = "Could not move the image file to the Destination on the server";

      }



      $uploadfile = $uploaddir . session_id() . "_NEWMAP_" . $_FILES['imageInfoFile']['name'];

      if (move_uploaded_file($_FILES['imageInfoFile']['tmp_name'], $uploadfile)) {

        //File is valid, and was successfully uploaded

        $_SESSION[$currPageNameUpper]['imageInfoFile'] = $uploadfile;

        $_SESSION[$currPageNameUpper]['imageInfoFileName'] = $_FILES['imageInfoFile']['name'];

        system("chmod 644 $uploadfile");

      } else {

        $errMsgs[] = "Could not move the image component information File to the Destination on the server.";

      }

    }

  }



  $retVal = setMapCpdsNotFound($_SESSION['ADD_MAP_CPD_OR_DER']['NOTFOUND'], $errMsgs);

  //print "<br />retVal = $retVal<br />";

  if ($retVal == 99) {

    $_SESSION[$currPageNameUpper]['force_add'] = 1;

    return 0;

  }

  if ($errMsgs) {

    return 0;

  }



  if ($_SESSION['ADD_MAP_CPD_OR_DER']['NOTFOUND'][0] == 'ALL COMPOUNDS DONE') { 

    //redirect

    print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";

  } else {

    //redirect

    print "<meta http-equiv=\"refresh\" content=\"0; URL=addMapCpdOrDer.php\">";

  }

  exit();

}



function setMapCpdsNotFound(&$notFoundCpdArray, &$errMsgs) {

	global $currPageName;

  $currPageNameUpper = strtoupper($currPageName);

	$imageFile = $_SESSION[$currPageNameUpper]['imageFile'];

	$imageInfoFile = $_SESSION[$currPageNameUpper]['imageInfoFile'];

  $namesFile = $_SESSION[$currPageNameUpper]['namesFile'];

	$outFile = $_SESSION['BROWSER_TMP_RELATIVE'] . session_id() . ".addMaplog";

	$file_home = $_SESSION['BROME_HOME'];

	$isKegg = $_SESSION[$currPageNameUpper]['is_kegg_map'];

  if ($isKegg == "Y") {

    $map_name = $_SESSION[$currPageNameUpper]['kegg_map_name'];

  } else {

	  $map_name = $_SESSION[$currPageNameUpper]['image_name'];

  }

  $map_type_id = $_SESSION[$currPageNameUpper]['map_type_id'];

	$person_id = $_SESSION['person_id'];

  $force_add = $_SESSION[$currPageNameUpper]['force_add'];



	$cmd = "{$_SESSION['PERL_DIR']}perl uploadMapToBnet.pl \"$imageFile\" \"$imageInfoFile\" \"$map_name\" \"$map_type_id\" \"$namesFile\" \"$outFile\" \"$file_home\" $person_id \"$isKegg\" $force_add";

	//print $cmd;

	exec($cmd, $retLines, $retValue);

  //print "retValue = $retValue<br />";

 	if ($retValue == 0)	{	

    $_SESSION[$currPAgeNameUpper]['force_add'] = 0;

    if (!$msg) {

      $msg = "Data Adding Script returned a successful value.";

    }

    $_SESSION['Message'][] = $msg;	

    $notFoundCpdArray[0] = 'ALL COMPOUNDS DONE';

    return $retValue;

  } elseif ($retValue == 99) {

    $_SESSION[$currPageNameUpper]['force_add'] = 1;

	  if (file_exists($outFile)) {

      $contents = file_get_contents($outFile);

      //The use of file is done, so delete it.

      unlink($outFile);

    }	else {

      foreach ($retLines as $retLine) {

        $msg .= "$retLine <br />";

      }

      $errMsgs[] = $msg;

      return 99;

    }



    $lines = split("\n", trim($contents));



		foreach ($lines as $line)	{

			list($type, $val) = split("\t", trim($line));

			//print "<br />type = $type, val = $val";

      $allTypes[$type][] = $val;

    }

 

    if ($allTypes['ERROR']) {

      foreach ($allTypes['ERROR'] as $errmsg) {

        $errMsgs[] = $errmsg;

      }

    }	else {

      $notFoundCpdArray = $allTypes['NOTFOUND'];

    }

  } else { 

    if ($retLines) {

		  foreach ($retLines as $retLine)	{

    	  $msg .= "$retLine <br />";

   	  }

    }

    if (!$msg) {

      $msg = "Command to the script adding data Failed. Command was: <br \>$cmd";

    }

    $errMsgs[] = $msg;  

    return $retValue;

	}

	return $retValue;

}



function getPathwayInfo($map_name) {

  $self = $_SERVER[PHP_SELF];

  print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";



  $sql = "SELECT \"kw_table_id\", \"kw_table\" FROM \"ref_kw_table\"";

  $sth = $_SESSION['dbh']->query($sql);

  if ( DB::isError($sth) ) {

    printError("Error retrieving map info.<br/>sql = $sql<br/> " . $sth->getMessage());

    return;

  }

  while ($row = $sth->fetchrow()) {

    $kw_names[$row[0]] = $row[1];

  }

    

  $sql = "SELECT distinct \"component_name\", \"shape\", \"coordinates\" from \"map_component\" where \"map_id\" in (SELECT \"map_id\" FROM \"map\" WHERE \"map_name\" = '$map_name') order by \"component_name\"";

  $sth = $_SESSION['dbh']->query($sql);

  if ( DB::isError($sth) ) {

    printError("Error retrieving map info.<br/>sql = $sql<br/> " . $sth->getMessage());

    return;

  }

  $msg = "<CENTER><TABLE BORDeR=1><TR><TH>Identifier</TH><TH>Shape</TH><TH>Coordinates</TH></TR>\n";

  while ($row = $sth->fetchrow()) {

      $msg .= "<TR><TD>$row[0]</TD><TD>$row[1]</TD><TD>$row[2]</TD></TR>\n";

  }

  $msg .= "</TABLE>\n";



  print $msg;

  print "\n\n<p><input type=\"submit\" name=\"submit\" value=\"Cancel\" />";

  print "\t<input type=\"submit\" name=\"submit\" value=\"Save as Tab-Delimited Format\" /></p>";

  print "</center>";

  print "\n</form>";

  include_once("footer.php");

}



function savePathwayInfo($map_name) {

  $self = $_SERVER[PHP_SELF];

  print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";



  $sql = "SELECT \"kw_table_id\", \"kw_table\" FROM \"ref_kw_table\"";

  $sth = $_SESSION['dbh']->query($sql);

  if ( DB::isError($sth) ) {

    printError("Error retrieving map info.<br/>sql = $sql<br/> " . $sth->getMessage());

    return;

  }

  while ($row = $sth->fetchrow()) {

    $kw_names[$row[0]] = $row[1];

  }

    

  $sql = "SELECT distinct \"component_name\", \"shape\", \"coordinates\" from \"map_component\" where \"map_id\" in (SELECT \"map_id\" FROM \"map\" WHERE \"map_name\" = '$map_name') order by \"component_name\"";

  $sth = $_SESSION['dbh']->query($sql);

  if ( DB::isError($sth) ) {

    printError("Error retrieving map info.<br/>sql = $sql<br/> " . $sth->getMessage());

    return;

  }

  $msg = "Identifier\tShape\tCoordinates\n";

  while ($row = $sth->fetchrow()) {

      $msg .= "$row[0]\t$row[1]\t$row[2]\n";

  }

  

  $output_file = $_SESSION['BROWSER_TMP_RELATIVE'] . "results.xls";

  if (!$file_handle = fopen($output_file, 'w')) {

    print "Can not open output file. ";

    return 0;

  } 

  if (!fwrite($file_handle, $msg)) {

    print "Can not write to file ($output_file)";

    return 0;

  }

  fclose($file_handle);



  //writeFile($msg, $_SESSION['BROWSER_TMP_RELATIVE'], "results.xls");

  print "<center>";

  print "\n<a href=\"./{$_SESSION['BROWSER_TMP_RELATIVE']}results.xls\">Results in Tab-Delimited Format</a>";

  print "\n\n<p><input type=\"submit\" name=\"submit\" value=\"Back to Add Map\" />";

  print "</center>";

  print "\n</form>";

  include_once("footer.php");

}

?>



