<?php
/**
* This script is a Front-End for adding Metadata for Sample Labeling table
* directly to the DOME database.
* Date: 30 Sept 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
$currPageName = 'SAMPLE_LABELING';
$currPageNameUpper = strtoupper($currPageName);
if ($_REQUEST['mode'])
{	$_SESSION[$currPageNameUpper]['mode'] = $_REQUEST['mode'];	}
else
{	$_SESSION[$currPageNameUpper]['mode'] = 'ADD';	}
?>

<?php
$title = "DOME : Sample Label";
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php
if ($_REQUEST['submit'])
{	processForm();	}
if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

fillForm();
include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	
	//Print Experiment Sets. 
	$sql = "SELECT \"sample_labeling_id\", \"label_used\", \"amount_of_nucleic_acid_labeled\", \"label_incorporation_method\" 
		FROM \"sample_labeling\" ORDER BY \"sample_labeling_id\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Sample Labels. " . $sth->getMessage());	return;	}
	
	print "<table width=\"100%\"><tr>";	//start table
	for ($i = 1; $i <= 2; $i++)
	{
		$identifier = "channel$i";
		print "\n<td>";
		if ($sth->numRows() >= $i)
		{	
			$row = $sth->fetchRow();	
			$_SESSION[$currPageNameUpper][$identifier]['sample_labeling_id'] = $row[0];
			$_SESSION[$currPageNameUpper][$identifier]['label_used'] = $row[1];
			$_SESSION[$currPageNameUpper][$identifier]['amount_of_nucleic_acid_labeled'] = $row[2];
			$_SESSION[$currPageNameUpper][$identifier]['label_incorporation_method'] = $row[3];
		}
		$valuesArray = &$_SESSION[$currPageNameUpper][$identifier];
		print "<fieldset><legend> &nbsp;&nbsp;Channel $i";
		print "&nbsp;&nbsp; </legend>";	
		
		//Print Label Used
		print "<p><label>Label *: </label>";
		$name = $identifier . '[label_used]'; $size = 50; $maxlength = 25; $value = $valuesArray['label_used'];
		print "\n<input type=\"text\" name=\"$name\" size=\"$size\" maxlength=\"$maxlength\" value=\"$value\"/>";
		print "</p>";
		
		//Print amount_of_nucleic_acid_labeled
		print "<p><label>Amount of Nucleic Acid Labeled *: </label>";
		$name = $identifier . '[amount_of_nucleic_acid_labeled]'; $size = 25; $maxlength = 50; $value = $valuesArray['amount_of_nucleic_acid_labeled'];
		print "\n<input type=\"text\" name=\"$name\" size=\"$size\" maxlength=\"$maxlength\" value=\"$value\"/>";
		print "</p>";
		
		//Print label_incorporation_method
		print "<p><label>Label Incorporation Method *: </label>";
		$name = $identifier . '[label_incorporation_method]'; $size = 75; $maxlength = 200; $value = $valuesArray['label_incorporation_method'];
		print "\n<input type=\"text\" name=\"$name\" size=\"$size\" maxlength=\"$maxlength\" value=\"$value\"/>";
		print "</p>";
		
		print "</fieldset>\n</td>";
	}
	
	print "</tr></table>"; //end table
	
	print "<input type=\"submit\" name=\"submit\" value=\"Save Sample Labels\" />";
	print "\n</form>";
	
	if ($_SESSION[$currPageNameUpper]['mode'] == 'ADD')
	{	print "<p><a href=\"./addMetaDataMenu.php\">< Back to Add Metadata Menu</a></p>";	}
	else
	{	print "<p><a href=\"./viewEditMetaDataMenu.php\">< Back to View/Edit Metadata Menu</a></p>";	}
	
}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$_SESSION[$currPageNameUpper]['channel1'] = $_REQUEST['channel1'];
	$_SESSION[$currPageNameUpper]['channel2'] = $_REQUEST['channel2'];
	
	$noOfChannels = 2;
	for ($i = 1; $i <= $noOfChannels; $i++)
	{
		$identifier = "channel$i";
		//Validating Channel $i
		if (!$_SESSION[$currPageNameUpper][$identifier]['label_used'])
		{	$errMsgs[] = "Please Enter the 'Label' for Channel $i.";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['amount_of_nucleic_acid_labeled'])
		{	$errMsgs[] = "Please Enter the 'Amount of Nucleic Acid Labeled' for Channel $i.";	}
		if (!$_SESSION[$currPageNameUpper][$identifier]['label_incorporation_method'])
		{	$errMsgs[] = "Please Enter the 'Label Incorporation Method' for Channel $i";	}
	}
	
	if ($errMsgs)
	{	return 0;	}
	
	//Delete and Insert the new values in sample_labeling in a transaction.
	$sth = $_SESSION['dbh']->query("BEGIN TRANSACTION");
	if ( DB::isError($sth) ) 
	{	$errMsgs[] = "Error Starting a new Transaction. " . $sth->getMessage();	return 0;	}
	
	$sql = "DELETE FROM \"sample_labeling\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	$errMsgs[] = "Error Deleting Sample Labels. " . $sth->getMessage();	$_SESSION['dbh']->query("ROLLBACK"); return 0;	}
	
	for ($i = 1; $i <= $noOfChannels; $i++)
	{
		$identifier = "channel$i";
		$sql = "INSERT INTO \"sample_labeling\" (\"sample_labeling_id\", \"amount_of_nucleic_acid_labeled\", \"label_used\", \"label_incorporation_method\") 
			VALUES('$i', '{$_SESSION[$currPageNameUpper][$identifier]['amount_of_nucleic_acid_labeled']}', 
			'{$_SESSION[$currPageNameUpper][$identifier]['label_used']}', 
			'{$_SESSION[$currPageNameUpper][$identifier]['label_incorporation_method']}')";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error saving sample label for channel $i. " . $sth->getMessage();	$_SESSION['dbh']->query("ROLLBACK"); return 0;	}
	}
	$_SESSION['dbh']->query("COMMIT");
	printMessage("Sample Label values saved.");
	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
