<?php
/**
* This script is a Front-End for adding Metadata for Sampling Replicate
* directly to the DOME database.
* Date: 5 Apr 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
$currPageName = 'ADD_SAMPLING_REPLICATE';
?>

<?php
$title = "DOME : Add Sampling Replicate";
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php
if ($_REQUEST['submit'])
{	processForm();	}
if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

fillForm();
include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	
	//Print Experiment Sets. 
	$sql = "SELECT \"exp_set_id\", \"exp_set_name\"  FROM \"experiment_set\" ORDER BY \"exp_set_name\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Experiment Sets. " . $sth->getMessage());	return;	}
	print "<p><label>Experiment Set *: </label>";
	print "<select name=\"experiment_set_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['experiment_set_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//Print Experiments. 
	$sql = "SELECT DISTINCT \"exp_name\", UPPER(\"exp_name\") FROM \"experiment\" ORDER BY UPPER(\"exp_name\")";
    $sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Experiments. " . $sth->getMessage());	return;	}
	print "<p><label>Experiment *: </label>";
	print "<select name=\"exp_name\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['exp_name'] == $row[0])
		{	print " selected";	}
		print ">$row[0]</option>";
	}
	print "\n</select></p>";
	
	//Print Sampling Points. 
	$sql = "SELECT \"label_id\", \"name\", \"order\" FROM \"label\" 
		WHERE kw_table_id = '{$_SESSION['TableID']['SAMPLING_POINT']}'
		ORDER BY \"order\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Sampling Points. " . $sth->getMessage());	return;	}
	print "<p><label>Sampling Point *: </label>";
	print "<select name=\"sampling_point_label\" size=\"1\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option";
		if ($_SESSION[$currPageNameUpper]['sampling_point_label'] == $row[1])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select>";
	
	
	
	//print Start Time
	print "<p><label>Start Date and Time: </label>";
	print "<input type=\"text\" name=\"start_time\" size=\"40\" value=\"{$_SESSION[$currPageNameUpper]['start_time']}\"/>";
	print "</p>";
	
	//print End Time
	print "<p><label>End Date and Time: </label>";
	print "<input type=\"text\" name=\"end_time\" size=\"40\" value=\"{$_SESSION[$currPageNameUpper]['end_time']}\"/>";
	print "</p>";
	
	//print Replicate
	print "<p><label>Replicate *: </label>";
	print "<input type=\"text\" name=\"replicate\" size=\"4\" value=\"{$_SESSION[$currPageNameUpper]['replicate']}\"/>";
	print "</p>";

		
	print "\n<br /><input type=\"submit\" name=\"submit\" value=\"Add Sampling Replicate\" />";
	print "\n</form>";
	print "<p><a href=\"./addMetaDataMenu.php\">< Back to Add Metadata Menu</a></p>";
}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
		
	$_SESSION[$currPageNameUpper]['experiment_set_id'] = $_REQUEST['experiment_set_id'];
	$_SESSION[$currPageNameUpper]['exp_name'] = $_REQUEST['exp_name'];
	$_SESSION[$currPageNameUpper]['sampling_point_label'] = $_REQUEST['sampling_point_label'];
	$_SESSION[$currPageNameUpper]['start_time'] = trim($_REQUEST['start_time']);
	$_SESSION[$currPageNameUpper]['end_time'] = trim($_REQUEST['end_time']);	
	$_SESSION[$currPageNameUpper]['replicate'] = (int) trim($_REQUEST['replicate']);
	
	if (!$_SESSION[$currPageNameUpper]['experiment_set_id'])
	{	$errMsgs[] = "Please Select an Experiment Set.";	}
	if (!$_SESSION[$currPageNameUpper]['exp_name'])
	{	$errMsgs[] = "Please Select an Experiment.";	}
	if (!$_SESSION[$currPageNameUpper]['sampling_point_label'])
	{	$errMsgs[] = "Please Select a Sampling Point.";	}
	if (!$_SESSION[$currPageNameUpper]['replicate'] OR !is_int($_SESSION[$currPageNameUpper]['replicate']) OR $_SESSION[$currPageNameUpper]['replicate'] < 0)
	{	$errMsgs[] = "Invalid Replicate Number.";	}
	
	if ($errMsgs)
	{	return 0;	}
	
	insertSamplingReplicate($_SESSION[$currPageNameUpper]['experiment_set_id'], $_SESSION[$currPageNameUpper]['exp_name'], $_SESSION[$currPageNameUpper]['sampling_point_label'], $_SESSION[$currPageNameUpper]['start_time'], $_SESSION[$currPageNameUpper]['end_time'], $_SESSION[$currPageNameUpper]['replicate']);
	
	if ($errMsgs)
	{	return 0;	}
	return 1;
}


function insertSamplingReplicate($experiment_set_id, $exp_name, $sp_name, $start_time, $end_time, $replicate)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
	$sp_name = $_SESSION['dbh']->quote($sp_name);
	if ($start_time)
	{	
		$start_time = date("Y-m-d H:i:sO", strtotime(trim($start_time)));
		$start_time = $_SESSION['dbh']->quote($start_time);	
	}
	else
	{	$start_time = "";	}
	
	if ($end_time)
	{	
		$end_time = date("Y-m-d H:i:sO", strtotime(trim($end_time)));
		$end_time = $_SESSION['dbh']->quote($end_time);	
	}
	else
	{	$end_time = "";	}
	
	$exp_name = $_SESSION['dbh']->quote($exp_name);
	$replicate = $_SESSION['dbh']->quote($replicate);
	
	//Check Valid Experiment
	$sql = "SELECT e.\"experiment_id\", es.\"exp_set_name\", e.\"exp_name\" FROM \"experiment_set\" es, \"experiment\" e
		WHERE es.\"exp_set_id\" = $experiment_set_id
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND e.\"exp_name\" = $exp_name";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving Experiments. " . $sth->getMessage();	
		return 0;	
	}
	
	if ($sth->numRows() == 0)	
	{
		$errMsgs[] = "No experiment or experiment_set found in the database for your selections. 
		<br />Please enter experiment before attempting to enter the sampling point";
		return 0;	
	}
	else
	{
		$row = $sth->fetchRow();
		$experiment_id = $row[0];
	}
	//Check in Sampling Point
	$sql = "SELECT sp.\"sampling_point_id\", es.\"exp_set_name\", 
		e.\"exp_name\" FROM \"sampling_point\" sp, 
		\"label\" l, \"experiment\" e, \"experiment_set\" es
		WHERE UPPER(l.\"name\") = " . strtoupper($sp_name) .
		" AND sp.\"label_id\" = l.\"label_id\"
		AND sp.\"experiment_id\" = e.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND sp.\"experiment_id\" = $experiment_id";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving sampling point. " . $sth->getMessage();	
		return 0;	
	}
	if ($sth->numRows() == 0)	
	{
		$row = $sth->fetchRow();
		$errMsgs[] = "No Sampling Point $sp_name for experiment_set '$row[1]' and experiment '$row[2]' found in the database.
			<br />Please create new Sampling Point before attempting to enter the sampling replicate";
		return 0;	
	}
	else
	{
		$row = $sth->fetchRow();
		$sampling_point_id = $row[0];
	}
	
	//Check for Sampling Replicate
	$sql = "SELECT sr.\"sampling_replicate_id\", l.\"name\", es.\"exp_set_name\", 
		e.\"exp_name\" FROM \"sampling_point\" sp, \"sampling_replicate\" sr,
		\"label\" l, \"experiment\" e, \"experiment_set\" es
		WHERE UPPER(l.\"name\") = " . strtoupper($sp_name) .
		" AND sp.\"label_id\" = l.\"label_id\"
		AND sp.\"experiment_id\" = e.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND sp.\"experiment_id\" = $experiment_id
		AND sp.\"sampling_point_id\" = sr.\"sampling_point_id\"
		AND sp.\"sampling_point_id\" = $sampling_point_id
		AND sr.\"replicate\" = $replicate";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error checking for sampling Replicate. " . $sth->getMessage();	
		return 0;	
	}

	if ($sth->numRows() == 0)	
	{
		//Begin Tranx
		$sth = $_SESSION['dbh']->query("BEGIN TRANSACTION");
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error starting transaction. " . $sth->getMessage();	
			return 0;	
		}

		//Insert in Sampling Point
		$sql = "INSERT INTO sampling_replicate (\"sampling_replicate_id\"";
		if ($start_time)
		{			$sql .= ", \"start_time\"";	}
		if ($end_time)
		{			$sql .= ", \"end_time\"";	}
		if ($start_time AND $end_time)
		{			$sql .= ", \"experiment_time\"";	}
		$sql .= ", \"replicate\", \"sampling_point_id\") values (nextval('sampling_replicate_id_seq')";
		if ($start_time)
		{	$sql .= ", $start_time";	}
		if ($end_time)
		{			$sql .= ", $end_time";	}
		if ($start_time AND $end_time)
		{			
			
			$sql .= ", timestamp $end_time - timestamp $start_time";	
		}
		$sql .= ", $replicate, $sampling_point_id)";
		
		$sth = $_SESSION['dbh']->query($sql);
		//print $sql;
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error inserting Sampling Replicate '$replicate' for $sp_name. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		$_SESSION['dbh']->query("COMMIT");
		printMessage("Sampling Replicate '$replicate' for sampling point $sp_name successfully inserted in the database.");
		//unset($_SESSION[$currPageNameUpper]);
	}
	else
	{	
		$row = $sth->fetchRow();
		$errMsgs[] = "Sampling Replicate '$replicate' for Sampling Point '$row[1]' for experiment_set '$row[2]' and experiment '$row[3]' already exists in the database.";
	}

	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
