<?php
/**
* This script is a Front-End for adding Metadata for ANY table
* directly to the DOME database. It uses a data structure called $fieldsInfo.
* $fieldsInfo is an array of an array with each row consisting of 
* name, type, size, maxsize, required. This information is stored in dataForTables.php file.
* Date: 26 Apr 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
if ($_REQUEST['currPageName'])
{	$_SESSION['currPageName'] = $_REQUEST['currPageName'];	}
if (!$_SESSION['currPageName'])
{	printError("currPageName not set.");	}
else
{	$currPageName = $_SESSION['currPageName'];	}
$currPageNameUpper = strtoupper($currPageName);

//Page Operated in EDIT mode - ID should be set in $_SESSION[$currPageNameUpper][$nameOfIDField]
if ($_REQUEST['mode'])
{	$_SESSION[$currPageNameUpper]['mode'] = strtoupper($_REQUEST['mode']);	}
else
{	$_SESSION[$currPageNameUpper]['mode'] = 'ADD';	}

if (isset($_REQUEST['callingPage']))
{	$_SESSION[$currPageNameUpper]['callingPage'] = $_REQUEST['callingPage'];	}
else
{	unset($_SESSION[$currPageNameUpper]['callingPage']);	}

include_once("dataForTables.php");

?>

<?php

include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php

if ($_REQUEST['submit'])
{	processForm();	}

if ($_SESSION['errMsgs'])
{	
	foreach ($_SESSION['errMsgs'] as $msg)
	{	printError($msg);	}
	unset ($_SESSION['errMsgs']);
}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

fillForm();
include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName, $fieldsInfo, $nameOfIDField, $tableLabel, $addReferenceFor;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	
	//handle specific pages here - top.
	if ($currPageNameUpper == 'SAMPLING_REPLICATE')
	{
		//Print Experiment Sets. 
		$sql = "SELECT \"exp_set_id\", \"exp_set_name\"  FROM \"experiment_set\" ORDER BY \"exp_set_name\"";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Experiment Sets. " . $sth->getMessage());	return;	}
		print "<p><label>Experiment Set *: </label>";
		print "<select name=\"experiment_set_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['experiment_set_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		//Print Experiments. 
		$sql = "SELECT DISTINCT \"exp_name\", UPPER(\"exp_name\") FROM \"experiment\" ORDER BY UPPER(\"exp_name\")";
	    $sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Experiments. " . $sth->getMessage());	return;	}
		print "<p><label>Experiment *: </label>";
		print "<select name=\"exp_name\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['exp_name'] == $row[0])
			{	print " selected";	}
			print ">$row[0]</option>";
		}
		print "\n</select></p>";
		
		//Print Sampling Points. 
		$sql = "SELECT \"label_id\", \"name\", \"order\" FROM \"label\" 
			WHERE kw_table_id = '{$_SESSION['TableID']['SAMPLING_POINT']}'
			ORDER BY \"order\"";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Sampling Points. " . $sth->getMessage());	return;	}
		print "<p><label>Sampling Point *: </label>";
		print "<select name=\"sampling_point_label\" size=\"1\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option";
			if ($_SESSION[$currPageNameUpper]['sampling_point_label'] == $row[1])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select>";
	}
	
	foreach($fieldsInfo as $fieldRow)
	{
		$name = $fieldRow['name'];
		$label = $fieldRow['label'];
		$type = $fieldRow['type'];
		$required = $fieldRow['required'];
		$help_tip = $fieldRow['help_tip'];
		$size = $fieldRow['size'];
		$maxlength = $fieldRow['maxlength'];
		
		if ($type != 'hidden')
		{
			print "\n<p>";
			if ($help_tip)
			{	print "\n<span class=\"help-tips\">$help_tip</span><br />\n";	}
			print "<label>$label";
			if ($required)
			{	print " *";	}
			print ": </label>";
		}
		switch ($type)
		{
		case 'id':
			if ($fieldRow['ID_SQL'])
			{
				$sql = $fieldRow['ID_SQL'];
			}
			else
			{
				$table = $fieldRow['table'];
				$IDField = $fieldRow['IDField'];
				$displayField = $fieldRow['displayField'];
				
				$sql = "SELECT \"$IDField\", \"$displayField\" FROM \"$table\" ORDER BY UPPER(\"$displayField\")";
			}

			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	printError("Error while retrieving $name. " . $sth->getMessage());	return;	}
			
			print "<select name=\"$name\" size=\"$size\">";
			if ($size == 1)
			{	print "\n\t<option value=\"0\">--Select One--</option>";	}
			while ($row = $sth->fetchRow()) 
			{
				print "\n\t<option value=\"$row[0]\"";
				if ($_SESSION[$currPageNameUpper][$name] == $row[0])
				{	print " selected";	}
				print ">$row[1]</option>";
			}
			print "\n</select>";
			break;
		case 'multitext':
			$rows = $fieldRow['rows'];
			$cols = $fieldRow['cols'];
			print "<textarea name=\"$name\" rows=\"$rows\" cols=\"$cols\">{$_SESSION[$currPageNameUpper][$name]}</textarea>";
			break;	
		case 'password':
			print "<input type=\"password\" name=\"$name\" size=\"$size\" maxlength=\"$maxlength\" value=\"{$_SESSION[$currPageNameUpper][$name]}\"/>";
			break;
		case 'boolean':
			print "<select name=\"$name\" size=\"$size\">";
			print "\n\t<option value=\"0\">--Select One--</option>";
			//True Option
			print "\n\t<option value=\"TRUE\"";
			if ($_SESSION[$currPageNameUpper][$name] == 't')
			{	print " selected";	}
			print ">True</option>";
			//False Option
			print "\n\t<option value=\"False\"";
			if ($_SESSION[$currPageNameUpper][$name] == 'f')
			{	print " selected";	}
			print ">False</option>";
			print "\n</select>";
			break;
		case 'integer':
		case 'text':
			print "<input type=\"text\" name=\"$name\" size=\"$size\" maxlength=\"$maxlength\" value=\"{$_SESSION[$currPageNameUpper][$name]}\"/>";
			break;
		case 'controlled-vocabulary':
			fillControlledVocabulary($name, $_SESSION[$currPageNameUpper][$name]);
			break;
		case 'hidden':
			//print nothing
			break;
		}
		print "</p>";
	}
	
	//Handle Specific pages here - bottom.
	if ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper OR ('ADD_AFFYMETRIX_ANNOTATION' == $currPageNameUpper AND 'ADD' == $_SESSION[$currPageNameUpper]['mode']))
	{
		//This MAX_SIZE is an advisory to the browser. (So that the user does not find
		// that his file is rejected by the php on the server after uploading it).
		print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
		print "\n<p><label>File *: </label>";
		print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
		print "</p>";
	}
	elseif ('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper AND 'ADD' == $_SESSION[$currPageNameUpper]['mode'])
	{
		//This MAX_SIZE is an advisory to the browser. (So that the user does not find
		// that his file is rejected by the php on the server after uploading it).
		print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
		print "<br /><fieldset>\n<legend>&nbsp;&nbsp;Feature Info&nbsp;&nbsp;</legend>\n";
		print "\n<p><label>GAL File *: </label>";
		print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
		print "</p>";
		
		//printing attachment
		$sql = "SELECT \"feature_type_id\", \"attachment\" FROM \"feature_type\" ORDER BY UPPER(\"attachment\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error while retrieving feature types. " . $sth->getMessage());	return;	}
			
		print "\n<p><label>Attachment *: </label>";
		print "<select name=\"feature_type_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['feature_type_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		//printing external_database
		$sql = "SELECT \"external_database_id\", \"database_name\" FROM \"external_database\" ORDER BY UPPER(\"database_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error while retrieving external database names. " . $sth->getMessage());	return;	}
			
		print "\n<p><label>External Database *: </label>";
		print "<select name=\"external_database_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['external_database_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		print "</fieldset>";
	}

	if ($currPageNameUpper == 'REFERENCE')
	{	print "\n<input type=\"hidden\" name=\"dontRedirect\" value=\"{$_REQUEST['dontRedirect']}\" />";	}
	if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
	{	
		$value = "Submit Changes";	
		print "\n<input type=\"hidden\" name=\"mode\" value=\"EDIT\" />";
	}
	else
	{	$value = "Add $tableLabel";	}
	print "\n\n<p><input type=\"submit\" name=\"submit\" value=\"$value\" /></p>";
	print "\n</form>";
	
	if ($_SESSION[$currPageNameUpper]['mode'] == 'ADD')
	{	
		if ('BNetMenu.php' == $_SESSION[$currPageNameUpper]['callingPage'])
		{	print "<p><a href=\"./{$_SESSION[$currPageNameUpper]['callingPage']}\">< Back to BNet Menu</a></p>";	} 
		else
		{	print "<p><a href=\"./addMetaDataMenu.php\">< Back to Add Metadata Menu</a></p>";	}
	}
	else
	{	
		if ('BNetMenu.php' == $_SESSION[$currPageNameUpper]['callingPage'])
		{	print "<p><a href=\"./{$_SESSION[$currPageNameUpper]['callingPage']}\">< Back to BNet Menu</a></p>";	} 
		else
		{	print "<p><a href=\"./viewEditMetaDataMenu.php\">< Back to View/Edit Metadata Menu</a></p>";	}
	}
}

function fillControlledVocabulary($name, $value, $size = 0)
{
	print "<select name=\"$name\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	switch($name)
	{
	case 'method':
		$optionsArray = array('statistical'=>'Statistical', 'experimental'=>'Experimental');
		break;
	case 'role':
		$optionsArray = array('reader'=>'Reader (Can only view data)', 'editor'=>'Editor (Can Add Experiment Data but no Metadata)', 'manager'=>'Manager (Can add all data)');
		break;
	case 'platform_technology':
		$optionsArray = array('Spotted DNA/cDNA'=>'Spotted DNA/cDNA', 'Spotted Oligonucleotide'=>'Spotted Oligonucleotide');
		break;
	case 'extract_molecule':
		$optionsArray = array('total RNA'=>'total RNA', 'polyA RNA'=>'polyA RNA', 'cytoplasmic RNA'=>'cytoplasmic RNA', 'nuclear RNA'=>'nuclear RNA', 'genomic DNA'=>'genomic DNA', 'protein'=>'protein', 'metabolites'=>'metabolites', 'other'=>'other');
		break;
	}
	foreach ($optionsArray as $key=>$displayName)
	{	
		print "\n\t<option value=\"$key\"";
		if ($key == $value)
		{	print " selected";	}
		print ">$displayName</option>";	
	}
	print "</select>";
}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName, $fieldsInfo, $addReferenceFor;
	$currPageNameUpper = strtoupper($currPageName);
	
	
	//Copy to session Variables
	foreach($fieldsInfo as $fieldRow)
	{
		$name = $fieldRow['name'];
		$_SESSION[$currPageNameUpper][$name] = trim($_REQUEST[$name]);
	}
	
	//Handle specific pages here.
	if ('TISSUE_TYPE' == $currPageNameUpper)
	{	$_SESSION[$currPageNameUpper]['kw_table_id'] = $_SESSION['TableID']['SAMPLE'];	}
	elseif ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper OR ('ADD_AFFYMETRIX_ANNOTATION' == $currPageNameUpper AND 'ADD' == $_SESSION[$currPageNameUpper]['mode']))
	{
		$_SESSION[$currPageNameUpper]['platform_technology'] = 'In Situ Oligonucleotide';
		
		if ('ADD' == $_SESSION[$currPageNameUpper]['mode'])
		{	$tryValidating = true;	}
		elseif ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper AND strlen($_FILES['uploadFile']['name']))
		{	$tryValidating = true;	}
		else
		{	$tryValidating = false;	}
		
		if ($tryValidating)
		{
			if ($_FILES['uploadFile']['name'] == "")
			{	$errMsgs[] = "Please select the file to upload using the browse button.";	}
			
			if (preg_match('/\'/', $_FILES['uploadFile']['name']))
			{	$errMsgs[] = "Name of the upload file contains an invalid character.";	}
	
			$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
			$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
			
			if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
			{
				//File is valid, and was successfully uploaded
			   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
			   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
			   system("chmod 644 $uploadfile");
			} 
			else 
			{	$errMsgs[] = "Could not move the uploaded file to the Destination on the server";	}
		}
		else
		{
			unset($_SESSION[$currPageNameUpper]['uploadFile']);
			unset($_SESSION[$currPageNameUpper]['uploadFileName']);
		}
	}
	elseif ('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper)
	{
		if ('ADD' == $_SESSION[$currPageNameUpper]['mode'])
		{	
			$_SESSION[$currPageNameUpper]['feature_type_id'] = $_REQUEST['feature_type_id'];
			$_SESSION[$currPageNameUpper]['external_database_id'] = $_REQUEST['external_database_id'];

			$tryValidating = true;
		}
		else
		{	$tryValidating = false;	}
		
		if ($tryValidating)
		{
			if (!$_SESSION[$currPageNameUpper]['feature_type_id'])
			{	$errMsgs[] = "Please select an attachment.";	}
			if (!$_SESSION[$currPageNameUpper]['external_database_id'])
			{	$errMsgs[] = "Please select an External Database.";	}
			
			if ($_FILES['uploadFile']['name'] == "")
			{	$errMsgs[] = "Please select the file to upload using the browse button.";	}
			
			if (preg_match('/\'/', $_FILES['uploadFile']['name']))
			{	$errMsgs[] = "Name of the upload file contains an invalid character.";	}
	
			$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
			$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
			
			if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
			{
				//File is valid, and was successfully uploaded
			   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
			   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
			   system("chmod 644 $uploadfile");
			} 
			else 
			{	$errMsgs[] = "Could not move the uploaded file to the Destination on the server";	}
		}
	}
	elseif ('SAMPLING_REPLICATE' == $currPageNameUpper)
	{
		$_SESSION[$currPageNameUpper]['experiment_set_id'] = $_REQUEST['experiment_set_id'];
		$_SESSION[$currPageNameUpper]['exp_name'] = $_REQUEST['exp_name'];
		$_SESSION[$currPageNameUpper]['sampling_point_label'] = $_REQUEST['sampling_point_label'];
		
		if (!$_SESSION[$currPageNameUpper]['experiment_set_id'])
		{	$errMsgs[] = "Please Select an Experiment Set.";	}
		if (!$_SESSION[$currPageNameUpper]['exp_name'])
		{	$errMsgs[] = "Please Select an Experiment.";	}
		if (!$_SESSION[$currPageNameUpper]['sampling_point_label'])
		{	$errMsgs[] = "Please Select a Sampling Point.";	}
		if (!$_SESSION[$currPageNameUpper]['replicate'] OR (strval(intval($_SESSION[$currPageNameUpper]['replicate'])) != $_SESSION[$currPageNameUpper]['replicate']) OR $_SESSION[$currPageNameUpper]['replicate'] <= 0)
		{	$errMsgs[] = "Invalid Replicate Number.";	}
	}
	
	//Validate
	foreach($fieldsInfo as $fieldRow)
	{
		$name = $fieldRow['name'];
		$label = $fieldRow['label'];
		$required = $fieldRow['required'];
		if ($required AND !$_SESSION[$currPageNameUpper][$name])
		{	$errMsgs[] = "Please enter $label.";	}
	}
	if ($errMsgs)
	{	return 0;	}
	
	if($currPageNameUpper == 'SAMPLING_REPLICATE')
	{
		//print "{$_SESSION[$currPageNameUpper]['experiment_set_id']}, {$_SESSION[$currPageNameUpper]['exp_name']}, {$_SESSION[$currPageNameUpper]['sampling_point_label']}, {$_SESSION[$currPageNameUpper]['start_time']}, {$_SESSION[$currPageNameUpper]['end_time']}, {$_SESSION[$currPageNameUpper]['replicate']}";
		insertSamplingReplicate($_SESSION[$currPageNameUpper]['experiment_set_id'], $_SESSION[$currPageNameUpper]['exp_name'], $_SESSION[$currPageNameUpper]['sampling_point_label'], $_SESSION[$currPageNameUpper]);
	}
	else
	{	
		$ret = insertIntoTable($_SESSION[$currPageNameUpper]);
		if ($ret AND $currPageNameUpper == 'REFERENCE' AND $addReferenceFor)
		{	
			unset($_SESSION['errMsgs']);
			validateReferenceDefaults();
			if (count($_SESSION['errMsgs']))
			{	
				print "<br />Redirecting to add more tracking info...<br />";
				print "<meta http-equiv=\"refresh\" content=\"3; URL=addTable.php?currPageName=REFERENCE&dontRedirect=true\">";	
			}
			else
			{	
				printMessage("All Tracking info successfully added.");
				print "<br />Redirecting to Main Menu...<br />";
				print "<meta http-equiv=\"refresh\" content=\"3; URL=intro.php\">";	
			}
			exit();
		}	
	}
	
	if ($errMsgs)
	{	return 0;	}
	return 1;
}


function insertIntoTable($data)
{
	global $errMsgs, $currPageName, $fieldsInfo, $nameOfTable, $nameOfIDField, $nameOfDisplayedField, $uniqueKey, $addReferenceFor;
	$currPageNameUpper = strtoupper($currPageName);
	
	if (count($fieldsInfo))	
	{
		foreach($fieldsInfo as $fieldRow)
		{
			$name = $fieldRow['name'];
			$unquotedData[$name] = $data[$name];
			if ($fieldRow['type'] == 'integer')
			{
				if (strlen($data[$name]) > 0 AND strval(intval($data[$name])) != $data[$name])
				{	$errMsgs[] = "Please enter an integer value for {$fieldRow['label']}.";	return 0;	}
			}
			else
			{	$data[$name] = $_SESSION['dbh']->quote($data[$name]);	}
		}
	
		
		//Check in Table
		$sql = "SELECT \"$nameOfIDField\"";
		if ($nameOfDisplayedField)
		{	$sql .= ", \"$nameOfDisplayedField\"";	}
		else
		{	$sql .= ", \"$nameOfIDField\"";	}
		$sql .= " FROM \"$nameOfTable\"";
			
		foreach($uniqueKey as $value)
		{
			if (!$whereDone)
			{	$sql .= " WHERE";	$whereDone = true;	}
			else
			{	$sql .= " AND";	}
			 $sql .= " UPPER(\"$value\") = " . strtoupper($data[$value]);
		}
		
		if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
		{	$sql .= " AND \"$nameOfIDField\" != {$_SESSION[$currPageNameUpper][$nameOfIDField]}"; 	}
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error retrieving from $nameOfTable. " . $sth->getMessage();	
			return 0;	
		}

	
		if ($sth->numRows() == 0)	
		{
			//Begin Tranx
			$sth = $_SESSION['dbh']->query("BEGIN TRANSACTION");
			if ( DB::isError($sth) ) 
			{	
				$errMsgs[] = "Error starting transaction. " . $sth->getMessage();	
				return 0;	
			}
	
			if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
			{		
				$firstField = true;
				$sql = "UPDATE \"$nameOfTable\" SET";
				foreach($fieldsInfo as $fieldRow)
				{
					$name = $fieldRow['name'];
					if (!$firstField)
					{	$sql .= ",";	}
					else
					{	$firstField = false;	}
					$sql .= " \"$name\" = ";
					if (strtolower($fieldRow['type']) == 'integer')
					{	
						if (strlen($data[$name]) == 0)
						{	$sql .= 'NULL';	}
						else
						{	$sql .= $data[$name];	}
					}
					else
					{	$sql .= $data[$name];	}
				} 
				$sql .= " WHERE \"$nameOfIDField\" = {$_SESSION[$currPageNameUpper][$nameOfIDField]}";	
			}
			else
			{
				//Insert in table		
				$sql = "INSERT INTO \"$nameOfTable\" (\"$nameOfIDField\"";
				foreach($fieldsInfo as $fieldRow)
				{
					$name = $fieldRow['name'];
					if (strlen($data[$name]) > 0)
					{	$sql .= ", \"$name\"";	}
				} 
				$sql .= ") values";
				$sql .= " (nextval('{$nameOfIDField}_seq')";
				
				foreach($fieldsInfo as $fieldRow)
				{	
					$name = $fieldRow['name'];
					if (strlen($data[$name]) > 0)
					{	$sql .= ", $data[$name]";	}
				} 
				$sql .= ")";
			}
			
			//print $sql;
			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	
				$errMsgs[] = "Error inserting $nameOfTable '$data[$nameOfDisplayedField]'. " . $sth->getMessage();	
				$_SESSION['dbh']->query("ROLLBACK");
				return 0;	
			}
		}
		else
		{	
			$row = $sth->fetchRow();
			$errMsgs[] = "$nameOfTable named '$row[1]' (ID: $row[0]) already exists in the database.";
		}
	}
	if ($errMsgs)
	{	return 0;	}
	
	handleSpecificInsertsAndCommit($data, $unquotedData);
	if ($errMsgs)
	{	return 0;	}
	

	if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
	{	
		$msg = "$nameOfTable '$data[$nameOfDisplayedField]' successfully edited in the database.";	
		$_SESSION['Message'][] = $msg;
	}
	else
	{	
		$msg = "$nameOfTable '$data[$nameOfDisplayedField]' successfully inserted in the database.";	
		printMessage($msg);
	}
	
	
	if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
	{
		unset($_SESSION[$currPageNameUpper][$nameOfIDField]);
		print "<meta http-equiv=\"refresh\" content=\"0; URL=viewEditTable.php?currPageName=$currPageNameUpper\">";
		exit();
	}

	if ($errMsgs)
	{	return 0;	}
	return 1;
}

function handleSpecificInsertsAndCommit(&$data, &$unquotedData)
{
	global $errMsgs, $currPageName, $fieldsInfo, $nameOfTable, $nameOfIDField, $nameOfDisplayedField, $uniqueKey, $addReferenceFor;
	$currPageNameUpper = strtoupper($currPageName);
	
	if ($currPageNameUpper == 'REFERENCE' AND strlen($addReferenceFor))
	{
		//get the reference_id of the just inserted reference.
		$sql = "SELECT currval('{$nameOfIDField}_seq')";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error getting current value of ID for $nameOfTable '$data[$nameOfDisplayedField]'. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		$row = $sth->fetchRow();
		$reference_id = $row[0];
		
		//delete from "default" table the reference_id if it exists for $addDefaultFor
		$sql = "DELETE FROM \"default\" WHERE UPPER(\"name\") = '" . strtoupper($addReferenceFor) . "'";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error deleting from table 'default' for '$addReferenceFor'. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		
		//Add into table "default" the reference_id for $addDefaultFor
		$sql = "INSERT INTO \"default\" (\"name\", \"value\") VALUES ('" . strtoupper($addReferenceFor) . "', '$reference_id')";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error inserting reference_id '$reference_id' into table 'default' for '$addReferenceFor'. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		
	}
	elseif ($currPageNameUpper == 'PROTOCOL_TYPE' AND $_SESSION[$currPageNameUpper]['mode'] == 'ADD' AND strtoupper($unquotedData['method']) == 'STATISTICAL')
	{
		$sql = "SELECT currval('{$nameOfIDField}_seq')";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error getting current value of ID for $nameOfTable '$data[$nameOfDisplayedField]'. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		$row = $sth->fetchRow();
		$protocol_type_id = $row[0];
		$sql = "INSERT INTO \"protocol\" (\"protocol_id\",\"protocol_name\", \"protocol_type_id\", \"protocol_desc\" ) 
			VALUES (nextval('protocol_id_seq'), 'Mean', '$protocol_type_id', 'Mean for {$unquotedData['protocol_type_name']}')";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error inserting into protocol for protocol_type '$data[$nameOfDisplayedField]'. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
	}
	
	$_SESSION['dbh']->query("COMMIT");
	
	if (('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper OR 'AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper) AND strlen($_SESSION[$currPageNameUpper]['uploadFile']) == 0)
	{	return;	}
	
	if (('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper OR 'AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper) AND 'ADD' == $_SESSION[$currPageNameUpper]['mode'])
	{
		$sql = "SELECT currval('{$nameOfIDField}_seq')";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error getting currval from Array Design. " . $sth->getMessage();	
			return 0;	
		}
		$row = $sth->fetchRow();
	}
	if ('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper)
	{	
		$perlScriptFile = "insertGeneDataFromGalFile.pl";
		//parameters to perl script
		$gal_file = $_SESSION[$currPageNameUpper]['uploadFile'];
		if ('ADD' == $_SESSION[$currPageNameUpper]['mode'])
		{	$array_batch_id = $row[0];	}
		else
		{	$array_batch_id = $_SESSION[$currPageNameUpper][$nameOfIDField];	}
		$feature_type_id = $_SESSION[$currPageNameUpper]['feature_type_id'];
		$external_database_id = $_SESSION[$currPageNameUpper]['external_database_id'];
		$file_home = $_SESSION['FILE_HOME'];
		$person_id = $_SESSION['person_id'];
		$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$gal_file\" $array_batch_id $feature_type_id $external_database_id \"$file_home\" $person_id 2>&1;";
	}
	elseif ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper)
	{
	
		$perlScriptFile = "insertAffyDesign.pl";
		//parameters to perl script - $input_file, $array_batch_id, $file_home, $person_id
		$input_file = $_SESSION[$currPageNameUpper]['uploadFile'];
		if ('ADD' == $_SESSION[$currPageNameUpper]['mode'])
		{	$array_batch_id = $row[0];	}
		else
		{	$array_batch_id = $_SESSION[$currPageNameUpper][$nameOfIDField];	}

		$file_home = $_SESSION['FILE_HOME'];
		$person_id = $_SESSION['person_id'];
		
		$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$input_file\" $array_batch_id $file_home $person_id 2>&1;";
	}
	elseif ('ADD_AFFYMETRIX_ANNOTATION' == $currPageNameUpper)
	{
		$perlScriptFile = "insertAffyAnnotation.pl";
		//parameters to perl script - $input_file, $array_batch_id, $file_home, $person_id
		$input_file = $_SESSION[$currPageNameUpper]['uploadFile'];
		
		$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$input_file\" 2>&1;";
	}
	if ('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper OR ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper OR 'ADD_AFFYMETRIX_ANNOTATION' == $currPageNameUpper))
	{	
		//print $com;
		$retString = exec($com, $retLines, $retValue);
		
		if ($retLines)
	  	{
			foreach ($retLines as $retLine)
			{	$msg .= "$retLine <br />";	}
	  	}
		if ($retValue == 0)	//success
	  	{	
			if (!$msg)
		  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
		  	printMessage($msg);
		}
		else
		{
		  	if (!$msg)
		  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn Value = $retValue";	}
		  	$errMsgs[] = $msg;
		  	
		  	//RollBack Inserted Array Design ONLY IN ADD MODE
		  	if ('ADD_AFFYMETRIX_ANNOTATION' != $currPageNameUpper AND 'ADD' == $_SESSION[$currPageNameUpper]['mode'])
			{
				$sql = "DELETE FROM \"array_batch\" WHERE array_batch_id = $array_batch_id";
				$sth = $_SESSION['dbh']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$errMsgs[] = "Error Rolling Back Array Design (ID: $array_batch_id). " . $sth->getMessage();	
					return 0;	
				}
			}
		}
	}
}

function insertSamplingReplicate($experiment_set_id, $exp_name, $sp_name, $data)
{
	global $errMsgs, $currPageName, $nameOfIDField;
	$currPageNameUpper = strtoupper($currPageName);
	$start_time = $data['start_time'];
	$end_time = $data['end_time'];
	$replicate = $data['replicate'];
	
	$sp_name = $_SESSION['dbh']->quote($sp_name);
	if ($start_time)
	{	
		$tmp_time = strtotime(trim($start_time));
		
		if ($tmp_time == -1 OR $tmp_time == false)
		{	$errMsgs[] = "Invalid Start Date or Time.";	}
		else
		{
			$start_time = date("Y-m-d H:i:sO", $tmp_time);
			$start_time = $_SESSION['dbh']->quote($start_time);	
		}
		
	}
	else
	{	$start_time = "";	}
	
	if ($end_time)
	{	
		$tmp_time = strtotime(trim($end_time));
		if ($tmp_time == -1 OR $tmp_time == false)
		{	$errMsgs[] = "Invalid End Date or Time.";	}
		else
		{
			$end_time = date("Y-m-d H:i:sO", $tmp_time);
			$end_time = $_SESSION['dbh']->quote($end_time);	
		}
	}
	else
	{	$end_time = "";	}
	
	
	$exp_name = $_SESSION['dbh']->quote($exp_name);
	$replicate = $_SESSION['dbh']->quote($replicate);
	
	if ($errMsgs)
	{	return 0;	}
	
	//Check Valid Experiment
	$sql = "SELECT e.\"experiment_id\", es.\"exp_set_name\", e.\"exp_name\" FROM \"experiment_set\" es, \"experiment\" e
		WHERE es.\"exp_set_id\" = $experiment_set_id
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND e.\"exp_name\" = $exp_name";
		
	//print $sql;
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving Experiments. " . $sth->getMessage();	
		return 0;	
	}
	
	if ($sth->numRows() == 0)	
	{
		$errMsgs[] = "No experiment or experiment_set found in the database for your selections. 
		<br />Please enter experiment before attempting to enter the sampling point";
		return 0;	
	}
	else
	{
		$row = $sth->fetchRow();
		$experiment_id = $row[0];
	}
	//Check in Sampling Point
	$sql = "SELECT sp.\"sampling_point_id\", es.\"exp_set_name\", 
		e.\"exp_name\" FROM \"sampling_point\" sp, 
		\"label\" l, \"experiment\" e, \"experiment_set\" es
		WHERE UPPER(l.\"name\") = " . strtoupper($sp_name) .
		" AND sp.\"label_id\" = l.\"label_id\"
		AND sp.\"experiment_id\" = e.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND sp.\"experiment_id\" = $experiment_id";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving sampling point. " . $sth->getMessage();	
		return 0;	
	}
	if ($sth->numRows() == 0)	
	{
		$errMsgs[] = "No Sampling Point $sp_name for the selected experiment_set and experiment found in the database.";
		return 0;	
	}
	else
	{
		$row = $sth->fetchRow();
		$sampling_point_id = $row[0];
	}
	
	//Check for Sampling Replicate
	$sql = "SELECT sr.\"sampling_replicate_id\", l.\"name\", es.\"exp_set_name\", 
		e.\"exp_name\" FROM \"sampling_point\" sp, \"sampling_replicate\" sr,
		\"label\" l, \"experiment\" e, \"experiment_set\" es
		WHERE UPPER(l.\"name\") = " . strtoupper($sp_name) .
		" AND sp.\"label_id\" = l.\"label_id\"
		AND sp.\"experiment_id\" = e.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND sp.\"experiment_id\" = $experiment_id
		AND sp.\"sampling_point_id\" = sr.\"sampling_point_id\"
		AND sp.\"sampling_point_id\" = $sampling_point_id
		AND sr.\"replicate\" = $replicate";
	
	if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
	{	$sql .= " AND \"$nameOfIDField\" != {$_SESSION[$currPageNameUpper][$nameOfIDField]}"; 	}
		
		//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error checking for sampling Replicate. " . $sth->getMessage();	
		return 0;	
	}

	if ($sth->numRows() == 0)	
	{
		//Begin Tranx
		$sth = $_SESSION['dbh']->query("BEGIN TRANSACTION");
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error starting transaction. " . $sth->getMessage();	
			return 0;	
		}
		if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
		{		
			$firstField = true;
			//Update Sampling Point
			$sql = "UPDATE \"sampling_replicate\" SET";
			if ($start_time)
			{	
				$sql .= " \"start_time\" = $start_time"; 
				$firstField = false;	
			}
			if ($end_time)
			{	
				if (!$firstField)
				{	$sql .= ",";	}	
				$sql .= " \"end_time\" = $end_time"; 
				$firstField = false;	
			}
			if ($start_time AND $end_time)
			{	$sql .= ", \"experiment_time\" = timestamp $end_time - timestamp $start_time";	}
			if ($replicate)
			{	
				if (!$firstField)
				{	$sql .= ",";	}
				$firstField = false;	
				$sql .= " \"replicate\" = $replicate";
			}
			$sql .= ", \"sampling_point_id\" = $sampling_point_id 
				WHERE \"$nameOfIDField\" = {$_SESSION[$currPageNameUpper][$nameOfIDField]}";	
		}
		else
		{
			//Insert in Sampling Point
			$sql = "INSERT INTO sampling_replicate (\"sampling_replicate_id\"";
			if ($start_time)
			{			$sql .= ", \"start_time\"";	}
			if ($end_time)
			{			$sql .= ", \"end_time\"";	}
			if ($start_time AND $end_time)
			{			$sql .= ", \"experiment_time\"";	}
			$sql .= ", \"replicate\", \"sampling_point_id\") values (nextval('sampling_replicate_id_seq')";
			if ($start_time)
			{	$sql .= ", $start_time";	}
			if ($end_time)
			{			$sql .= ", $end_time";	}
			if ($start_time AND $end_time)
			{	$sql .= ", timestamp $end_time - timestamp $start_time";	
			}
			$sql .= ", $replicate, $sampling_point_id)";
		}
			
		$sth = $_SESSION['dbh']->query($sql);
		//print $sql;
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error inserting Sampling Replicate '$replicate' for $sp_name. " . $sth->getMessage();	
			$_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		$_SESSION['dbh']->query("COMMIT");
		if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
		{	
			$msg = "Sampling Replicate '$replicate' for sampling point $sp_name successfully edited in the database.";	
			$_SESSION['Message'][] = $msg;
		}
		else
		{	
			$msg = "Sampling Replicate '$replicate' for sampling point $sp_name successfully inserted in the database.";	
			printMessage($msg);
		}
		
		if ($_SESSION[$currPageNameUpper]['mode'] == 'EDIT' AND $_SESSION[$currPageNameUpper][$nameOfIDField])
		{
			unset($_SESSION[$currPageNameUpper][$nameOfIDField]);
			print "<meta http-equiv=\"refresh\" content=\"0; URL=viewEditTable.php?currPageName=$currPageNameUpper\">";
			exit();
		}
	}
	else
	{	
		$row = $sth->fetchRow();
		$errMsgs[] = "Sampling Replicate '$replicate' for Sampling Point '$row[1]' for experiment_set '$row[2]' and experiment '$row[3]' already exists in the database.";
	}

	if ($errMsgs)
	{	return 0;	}
	return 1;
}


?>
