<?php
/**
* This script is a Front-End for adding BNet Data thru perl scripts
* from a file taken through front-end.
* Date: 10 Apr 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
?>

<?php

if ('allnames' == $_REQUEST['table_name'])
{	
	$table_name_title = 'Synonyms';
	$file_label = 'Synonyms File *:';
	$perlScriptFile = 'insertBnetSynonyms.pl';
	$currPageName = 'ADD_SYNONYMS_TO_BNET_FROM_FILE';
}
elseif ('external_links' == $_REQUEST['table_name'])
{	
	$table_name_title = 'External Links';	
	$file_label = 'External Links File *:';
	$perlScriptFile = 'insertBnetExternalLinks.pl';
	$currPageName = 'ADD_EXT_LINKS_TO_BNET_FROM_FILE';
}
else
{	$errMsgs[] = 'table_name not passed.';	}

$currPageNameUpper = strtoupper($currPageName);
if (isset($_REQUEST['table_name']))
{	$_SESSION[$currPageNameUpper]['table_name'] = $_REQUEST['table_name'];	}

$title = "DOME : BNet : Add $table_name_title";
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
	
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
if ('Add To BNet' == $_REQUEST['submit'])
{	processForm();	}

if ($_SESSION['errMsgs'])
{	
	foreach ($_SESSION['errMsgs'] as $msg)
	{	printError($msg);	}
	unset ($_SESSION['errMsgs']);
}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

fillForm();

include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName, $file_label;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	//Print File to upload
	print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
	print "\n<p><label>$file_label</label>";
	print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
	print "</p>";
	
	//printing kw_table_id
	$sql = "SELECT \"kw_table_id\", \"kw_table\" FROM \"ref_kw_table\" 
		WHERE \"in_bnet\"
		ORDER BY UPPER(\"kw_table\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error while retrieving ref_kw_table names. " . $sth->getMessage());	return;	}
		
	print "\n<p><label>Table *: </label>";
	print "<select name=\"kw_table_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['kw_table_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	if ('allnames' == $_SESSION[$currPageNameUpper]['table_name'])
	{
		print "\n<p><input type=\"checkbox\" name=\"is_annotation\"";
		if ($_SESSION[$currPageNameUpper]['is_annotation'])
		{	print " checked";	}
		print ">Synonyms are Annotations</input>";
	}
	
	print "\n<input type=\"hidden\" name=\"table_name\" value=\"{$_SESSION[$currPageNameUpper]['table_name']}\" />";
	print "\n\n<p><input type=\"submit\" name=\"submit\" value=\"Add To BNet\" /></p>";
	print "<p><a href=\"./BNetMenu.php\">< Back to BNet Menu</a></p>";
	print "\n</form>";
	
}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName, $perlScriptFile;
	$currPageNameUpper = strtoupper($currPageName);
	
	$_SESSION[$currPageNameUpper]['kw_table_id'] = $_REQUEST['kw_table_id'];
	$_SESSION[$currPageNameUpper]['is_annotation'] = $_REQUEST['is_annotation'];
	
	if (!$_SESSION[$currPageNameUpper]['kw_table_id'])
	{	$errMsgs[] = "Please Select a Table.";	}
	
	if ($_FILES['uploadFile']['name'] == "")
	{	$errMsgs[] = "Please select the file to upload using the browse button.";	}
	
	if (preg_match('/\'/', $_FILES['uploadFile']['name']))
	{	$errMsgs[] = "Name of the upload file contains an invalid character.";	}

	$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
	$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
	
	if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
	{
		//File is valid, and was successfully uploaded
	   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
	   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
	   system("chmod 644 $uploadfile");
	} 
	else 
	{	$errMsgs[] = "Could not move the uploaded file to the Destination on the server";	}


	if ($errMsgs)
	{	return 0;	}

	
	$inputFile = $_SESSION[$currPageNameUpper]['uploadFile'];
	$kw_table_id = $_SESSION[$currPageNameUpper]['kw_table_id'];
	if ('allnames' == $_SESSION[$currPageNameUpper]['table_name'])
	{
		if ($_SESSION[$currPageNameUpper]['is_annotation'])
		{	$is_primary = 'A';	}
		else
		{	$is_primary = 'N';	}
		$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$inputFile\" $kw_table_id $is_primary 2>&1;";
	}
	else
	{	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$inputFile\" $kw_table_id 2>&1;";	}
	//print $com;
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
		//redirect
		print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";
		exit();
	}
	else
	{	
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn: $retString RetValue = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
