#!/usr/local/bin/perl

########################################################################
# batchrun_readDataFromMetabolite
# ($indir, $file_home, $exp_set_id, $tissue_type_label_id, $protocol_id, 
#  $extract_id, $data_file_type, $raw_file_type, $reference, $person_id)
# $indir = /array2/xingjing/metabolites/GCMS
#     -- MJ/Polar/,
#     -- MJ/Lipid,
#     -- YE/Polar/,
#     -- YE/Lipid,
#     -- UV/Polar/,
#     -- UV/Lipid,
#     -- MIX/Polar/,
#     -- MIX/Lipid,
# $file_home = /array2/xingjing/metabolites/upload/,
# $exp_set_id = 1,  1 for MeJa, 2 for Yeast, 3 for UV, 4 for Mixed
# $tissue_type_label_id = 23,
# $protocol_id = 1 -- Non-Polar, 70 -- Polar
# $extract_id = 2 -- Non-polar GC/MS, 3 -- Polar GC/MS
# $data_file_type = ".txt",
# $raw_file_type = ".cdf",
# $reference = "Ribitol" -- Polar, "Docasanol TMS" -- Non-polar GC/MS,
# $person_id = 19 -- Corey Broeckling
#
# X. Jing Li
# Nov. 8, 2005
##############################################################################

#== MeJa - Polar 
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/MJ/Polar/" "/array1/dome-mt/" 1 23 70 3 ".txt" ".cdf" "Ribitol" 19 > /array2/xingjing/metabolites/upload/MeJa_Polar.log';
print "$cmd\n";
system $cmd;

#== MeJa - Lipid 
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/MJ/Lipid/" "/array1/dome-mt/" 1 23 1 2 ".txt" ".cdf" "Docosanol\ TMS" 19 > /array2/xingjing/metabolites/upload/MeJa_Lipid.log';
print "$cmd\n";
system $cmd;


#== Yeast - Polar
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/YE/Polar/" "/array1/dome-mt/" 2 23 70 3 ".txt" ".cdf" "Ribitol" 19> /array2/xingjing/metabolites/upload/Yeast_Polar.log';
print "$cmd\n";
system $cmd;

#== Yeast - Lipid*/
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/YE/Lipid/" "/array1/dome-mt/" 2 23 1 2 ".txt" ".cdf" "Docosanol\ TMS" 19 > /array2/xingjing/metabolites/upload/Yeast_Lipid.log';
print "$cmd\n";
system $cmd;

#== UV - Polar
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/UV/Polar/" "/array1/dome-mt/" 3 23 70 3 ".txt" ".cdf" "Ribitol" 19 > /array2/xingjing/metabolites/upload/UV_Polar.log';
print "$cmd\n";
system $cmd;

#== UV - Lipid 
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/UV/Lipid/" "/array1/dome-mt/" 3 23 1 2 ".txt" ".cdf" "Docosanol\ TMS" 19 > /array2/xingjing/metabolites/upload/UV_Lipid.log';
print "$cmd\n";
system $cmd;


#== Mixed - Polar
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/MIX/Polar/" "/array1/dome-mt/" 4 23 70 3 ".txt" ".CDF" "Ribitol" 19 > /array2/xingjing/metabolites/upload/Mixed_Polar.log';
print "$cmd\n";
system $cmd;

#== Mixed - Lipid
$cmd = 'perl batchrun_readDataFromMetabolite.pl "/array2/xingjing/metabolites/GCMS/MIX/Lipid/" "/array1/dome-mt/" 4 23 1 2 ".txt" ".CDF" "Docosanol\ TMS" 19 > /array2/xingjing/metabolites/upload/Mixed_Lipid.log';
print "$cmd\n";
system $cmd;

exit;
