#!/usr/local/bin/perl

########################################################################
# batchrun_getMeanStdevForMetaboliteBySPID.pl
# ($exp_set_id, $protocol_type_id, $tissue_type_label_id, $extract_id)
# $exp_set_id = 
#    1 -- MJ,
#    2 -- YE,
#    3 -- UV,
#    4 -- MIX,
# $protocol_type_id:
#   43 -- Normalized by Internal Reference -- non-polar GC/MS
#   44 -- Normalized by Internal Reference -- polar GC/MS
# $tissue_type_label_id = 23,
# $extract_id = 2 -- Non-polar GC/MS, 3 -- Polar GC/MS
#
# X. Jing Li
# Nov. 8, 2005
##############################################################################

#== MeJa - Polar
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 1 44 23 3 > /array2/xingjing/metabolites/upload/MeJa_Polar_meanStdev.log';
#print "$cmd\n";
#system $cmd;
#== MeJa - Lipid 
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 1 43 23 2 > /array2/xingjing/metabolites/upload/MeJa_Lipid_meanStdev.log';
#print "$cmd\n";
#system $cmd;

#== Yeast - Polar
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 2 44 23 3 > /array2/xingjing/metabolites/upload/Yeast_Polar_meanStdev.log';
#print "$cmd\n";
#system $cmd;
#== Yeast - Lipid*/
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 2 43 23 2 > /array2/xingjing/metabolites/upload/Yeast_Lipid_meanStdev.log';
#print "$cmd\n";
#system $cmd;

#== UV - Polar
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 3 44 23 3 > /array2/xingjing/metabolites/upload/UV_Polar_meanStdev.log';
#print "$cmd\n";
#system $cmd;
#== UV - Lipid 
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 3 43 23 2 > /array2/xingjing/metabolites/upload/UV_Lipid_meanStdev.log';
#print "$cmd\n";
#system $cmd;

#== Mixed - Polar
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 4 44 23 3 > /array2/xingjing/metabolites/upload/Mixed_Polar_meanStdev.log';
#print "$cmd\n";
#system $cmd;
#== Mixed - Lipid
$cmd = 'perl batchrun_getMeanStdevForMetaboliteBySPIDs.pl 4 43 23 2 > /array2/xingjing/metabolites/upload/Mixed_Lipid_meanStdev.log';
#print "$cmd\n";
#system $cmd;

# interface for batchrun_getRatioPvaluesBySPIDS.pl:
# $exp_id_e, $exp_id_c, $tissue_type_label_id_e, $tissue_type_label_id_c, $extract_id, $ptid
@elicited_ids = (1, 3, 5,     # MeJa elicitors
                 8, 9, 11,    # Yeast elicitors
                 13, 15, 17,  # UV elicitors
                 20, 22, 23   # Mixed elicitors
                 );
@control_ids = (2, 4, 6,      # MeJa control
                7, 10, 12,    # Yeast controls
                14,16, 18,    # UV controls
                21, 19, 24    # Mixed controls
                );

#== non-polar: extract_id = 2, protocol_type_id = 43
$ptid = 43;
for($i=0; $i<@elicited_ids; $i++) {
    $e_id = $elicited_ids[$i];
    $c_id = $control_ids[$i];
    $cmd = "perl batchrun_getRatioPvaluesBySPIDS.pl $e_id $c_id 23 23 2 $ptid > /array2/xingjing/metabolites/upload/ratio_E" . $e_id . "_C" . $c_id . "_PTID" . $ptid . ".log";
    print "$cmd\n";
    system $cmd;
}
#== Polar: extract_id = 3, protocol_type_id = 44
$ptid = 44;
for($i=0; $i<@elicited_ids; $i++) {
    $e_id = $elicited_ids[$i];
    $c_id = $control_ids[$i];
    $cmd = "perl batchrun_getRatioPvaluesBySPIDS.pl $e_id $c_id 23 23 3 $ptid > /array2/xingjing/metabolites/upload/ratio_E" . $e_id . "_C" . $c_id . "_PTID" . $ptid . ".log";
    print "$cmd\n";
    system $cmd;
}

exit;
