#!/usr/local/bin/perl



use DBI;

use DOMELIB;

use strict "vars";



my($exp_set_id, $extract_id, $ptid, $tissue_type_label_id, $force_add,

   $database, $username, $password, $bnet_DB, $specieDB, $dbh, $sth, $rc, $sql,

   $spid, @spids, $cmd, $ok);

($exp_set_id, $ptid, $tissue_type_label_id, $extract_id) = @ARGV;

$force_add = 0;



#== connect to the database:

($database, $username, $password, $bnet_DB, $specieDB) = database_login2();

$dbh = DBI->connect($database,$username,$password) or die "Can't connect to $database:$DBI::errstr.";

$sql = "set search_path to \"$specieDB\"";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";





#== get all spids for experiment_set:

$sql = "select sampling_point_id from sampling_point where experiment_id in (select experiment_id from experiment where exp_set_id = $exp_set_id) order by sampling_point_id";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

while ($spid = $sth->fetchrow()) {

    push @spids, $spid;

}

$sth->finish;

$dbh->disconnect;



#== do one spid at once:

foreach $spid (@spids) {

    $cmd = "perl getMeanStdevForMetaboliteBySPID.pl $spid $ptid $extract_id $tissue_type_label_id $force_add";

    print "$cmd\n";

    $ok = system $cmd;

#    print "$ok\n";

}



exit;





