#!/usr/local/bin/perl



use DBI;

use DOMELIB;

use strict "vars";



my($exp_set_ids, $extract_id, @protocol_type_ids, $ptid, $tissue_type_label_id,

   $force_add,

   $database, $username, $password, $bnet_DB, $specieDB, $dbh, $sth, $rc, $sql,

   $spid, @spids, $cmd, $ok);



$exp_set_ids = "(1, 2, 3, 4)";

$extract_id = 1;

@protocol_type_ids = (33, 34);

$tissue_type_label_id = 23;

$force_add = 0;



#== connect to the database:

($database, $username, $password, $bnet_DB, $specieDB) = database_login2();

$dbh = DBI->connect($database,$username,$password) or die "Can't connect to $database:$DBI::errstr.";

$sql = "set search_path to \"$specieDB\"";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";





#== get all spids for experiment_set:

$sql = "select sampling_point_id from sampling_point where experiment_id in (select experiment_id from experiment where exp_set_id in $exp_set_ids) order by sampling_point_id";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

while ($spid = $sth->fetchrow()) {

    push @spids, $spid;

}

$sth->finish;

$dbh->disconnect;



#== do one spid at once:

foreach $ptid (@protocol_type_ids) {

    foreach $spid (@spids) {

        $cmd = "perl getMeanStdevForMicroarrayBySPID.pl $spid $ptid $extract_id $tissue_type_label_id $force_add";

        $ok = system $cmd;

        print "$cmd\nok=$ok\n///\n";

    }

}



exit;





