#!/usr/local/bin/perl

use DBI;
use DOMELIB;
use strict "vars";

my ($database, $username, $password, $bnet_DB, $specieDB, $dbh, $sth, $rc, $sql,
    $exp_set_id, $exp_id_e, $exp_id_c, $extract_id, $ptid, 
    $tissue_type_label_id_e, $tissue_type_label_id_c, $spid, $label_id, 
    $spid_e, $spid_c, $ref_spids_elicit, $ref_spids_control, %spids_elicit, 
    %spids_control, $cmd);
($exp_id_e, $exp_id_c, $tissue_type_label_id_e, $tissue_type_label_id_c, $extract_id, $ptid) = @ARGV;

#== connect to the database:
($database, $username, $password, $bnet_DB, $specieDB) = database_login2();
$dbh = DBI->connect($database,$username,$password) or die "Can't connect to $database:$DBI::errstr.";
$sql = "set search_path to \"$specieDB\"";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

#== get all sampling_point_ids:
$ref_spids_elicit = {};
$ref_spids_control = {};
%spids_elicit = %$ref_spids_elicit;
%spids_control = %$ref_spids_control;
$sql = "select sampling_point_id, label_id from sampling_point where experiment_id = $exp_id_e";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
while (($spid, $label_id) = $sth->fetchrow()) {
    $spids_elicit{$label_id} = $spid;
}
$sql = "select sampling_point_id, label_id from sampling_point where experiment_id = $exp_id_c";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
while (($spid, $label_id) = $sth->fetchrow()) {
    $spids_control{$label_id} = $spid;
}
$sth->finish;
$dbh->disconnect;

#== calculate the ratio and pvalue for each pair of sampling_point_ids:
#    foreach $ptid (@protocol_type_ids) {
#        foreach $label_id (sort {$a <=> $b} keys %spids_elicit) {
#            $spid_e = $spids_elicit{$label_id};
#            $spid_c = $spids_control{$label_id};
#            $cmd = "perl getRatioPvalueBySPIDs.pl $spid_e $spid_c $ptid $extract_id $tissue_type_label_id_e $tissue_type_label_id_c 0";
#            print $cmd . "\n";
#            system $cmd;
#        }
#    }
    
#== calculate all time points vs 0 min for both elicited and control:
for ($label_id=2; $label_id < 22; $label_id++) {
    $spid_e = $spids_elicit{$label_id};
    $spid_c = $spids_elicit{1};
    if ($spid_e ne "" && $spid_c ne "") {
        $cmd = "perl getRatioPvalueBySPIDs.pl $spid_e $spid_c $ptid $extract_id $tissue_type_label_id_e $tissue_type_label_id_c 0";
#        print $cmd . "\n";
        system $cmd;
    }
}
for ($label_id=1; $label_id < 22; $label_id++) {
    $spid_e = $spids_elicit{$label_id};
    $spid_c = $spids_control{$label_id};
    if ($spid_e ne "" && $spid_c ne "") {
        $cmd = "perl getRatioPvalueBySPIDs.pl $spid_e $spid_c $ptid $extract_id $tissue_type_label_id_e $tissue_type_label_id_c 0";
#        print $cmd . "\n";
        system $cmd;
    }
}

exit;
