#!/usr/local/bin/perl

use DBI;
use DOMELIB;
use strict "vars";

###############################################################################
# $indir -- the full directory path for the data and raw_files. They should be 
#           in the same dirand the raw_data_file and proc_data_file should have 
#           the same name;
# $file_home -- the file location of the files;
# $exp_set_id -- the experiment_set id;
# $type -- polar or non-polar;
# tissue_type_label_id --
# protocol_id -- the experimental protocol_id;
# $extract_id -- 
# $data_file_type -- the file type for processed data;
# $raw_file_type -- the file type for raw data file;
# $reference -- the reference metabolite for this set of data;
# #person_id -- the researcher name;
#
# Author: X. Jing Li
# Date: November 7, 2005
#==============================================================================

my ($indir, $file_home, $exp_set_id, $tissue_type_label_id, $protocol_id, $extract_id, $data_file_type, $raw_file_type, $reference, $person_id) = @ARGV;

my ($database, $username, $password, $bnet_DB, $specieDB, $dbh, $sth, $rc, $sql,
    @data_files, $data_file, $f_name, $raw_file, $es, $e, $time, $type, $bio_repl,
    $tech_repl, $phase, $t_number, $t_unit, $exp_id, $label_id, $srid, $raw_data,
    $technique_id, $cmd, $out_file, $ok
    );

#== connect to the database:
($database, $username, $password, $bnet_DB, $specieDB) = database_login2();
$dbh = DBI->connect($database,$username,$password) or die "Can't connect to $database:$DBI::errstr.";
$sql = "set search_path to \"$specieDB\"";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

print "Starting time: " . TimeStamp() . "\n";
#== open the dir for all files:
#opendir(DIR,$indir) or die "$indir does not exist or I can't open $indir\n";
#@files = readdir(DIR);
#close DIR;
@data_files = getFilesInDir($indir, $data_file_type);
foreach $data_file (@data_files) {
    $f_name = $data_file;
    $f_name =~ s/$data_file_type//g;
    $raw_file = $f_name . $raw_file_type;
    ($es, $e, $time, $type, $bio_repl, $tech_repl, $phase) = split "_", $f_name;

    #== get the exp_id:  DOME
    if ($es eq "MJ" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 1; }
    elsif ($es eq "MJ" && $e eq "MJ" && $type eq "Control") { $exp_id = 2; }
    elsif ($es eq "MJ" && $e eq "YE" && $type eq "Elicited") { $exp_id = 3; }
    elsif ($es eq "MJ" && $e eq "YE" && $type eq "Control") { $exp_id = 4; }
    elsif ($es eq "MJ" && $e eq "UV" && $type eq "Elicited") { $exp_id = 5; }
    elsif ($es eq "MJ" && $e eq "UV" && $type eq "Control") { $exp_id = 6; }

    elsif ($es eq "YE" && $e eq "YE" && $type eq "Elicited") { $exp_id = 7; }
    elsif ($es eq "YE" && $e eq "YE" && $type eq "Control") { $exp_id = 8; }
    elsif ($es eq "YE" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 9; }
    elsif ($es eq "YE" && $e eq "MJ" && $type eq "Control") { $exp_id = 10; }
    elsif ($es eq "YE" && $e eq "UV" && $type eq "Elicited") { $exp_id = 11; }
    elsif ($es eq "YE" && $e eq "UV" && $type eq "Control") { $exp_id = 12; }

    elsif ($es eq "UV" && $e eq "UV" && $type eq "Elicited") { $exp_id = 13; }
    elsif ($es eq "UV" && $e eq "UV" && $type eq "Control") { $exp_id = 14; }
    elsif ($es eq "UV" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 15; }
    elsif ($es eq "UV" && $e eq "MJ" && $type eq "Control") { $exp_id = 16; }
    elsif ($es eq "UV" && $e eq "YE" && $type eq "Elicited") { $exp_id = 17; }
    elsif ($es eq "UV" && $e eq "YE" && $type eq "Control") { $exp_id = 18; }

    elsif ($es eq "MIX" && $e eq "MJ" && $type eq "Control") { $exp_id = 19; }
    elsif ($es eq "MIX" && $e eq "YE" && $type eq "Elicited") { $exp_id = 20; }
    elsif ($es eq "MIX" && $e eq "YE" && $type eq "Control") { $exp_id = 21; }
    elsif ($es eq "MIX" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 22; }
    elsif ($es eq "MIX" && $e eq "UV" && $type eq "Elicited") { $exp_id = 23; }
    elsif ($es eq "MIX" && $e eq "UV" && $type eq "Control") { $exp_id = 24; }
    else {
        print "Unknonw type of data file.$data_file.\n";
        next;
    }

    #== DOME_PRAC
#    if    ($es eq "MJ" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 7; }
#    elsif ($es eq "MJ" && $e eq "MJ" && $type eq "Control") { $exp_id = 8; }
#    elsif ($es eq "MJ" && $e eq "YE" && $type eq "Elicited") { $exp_id = 9; }
#    elsif ($es eq "MJ" && $e eq "YE" && $type eq "Control") { $exp_id = 10; }
#    elsif ($es eq "MJ" && $e eq "UV" && $type eq "Elicited") { $exp_id = 11; } 
#    elsif ($es eq "MJ" && $e eq "UV" && $type eq "Control") { $exp_id =12; }

#    elsif ($es eq "YE" && $e eq "YE" && $type eq "Elicited") { $exp_id = 1; }
#    elsif ($es eq "YE" && $e eq "YE" && $type eq "Control") { $exp_id = 2; }
#    elsif ($es eq "YE" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 3; }
 #   elsif ($es eq "YE" && $e eq "MJ" && $type eq "Control") { $exp_id = 4; }
#    elsif ($es eq "YE" && $e eq "UV" && $type eq "Elicited") { $exp_id = 5; }
#    elsif ($es eq "YE" && $e eq "UV" && $type eq "Control") { $exp_id = 6; }

#    elsif ($es eq "UV" && $e eq "UV" && $type eq "Elicited") { $exp_id = 13; }
#    elsif ($es eq "UV" && $e eq "UV" && $type eq "Control") { $exp_id = 14; }
#    elsif ($es eq "UV" && $e eq "YE" && $type eq "Elicited") { $exp_id = 15; }
#    elsif ($es eq "UV" && $e eq "YE" && $type eq "Control") { $exp_id = 16; }
#    elsif ($es eq "UV" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 17; }
#    elsif ($es eq "UV" && $e eq "MJ" && $type eq "Control") { $exp_id = 18; }

#    elsif ($es eq "MIX" && $e eq "YE" && $type eq "Elicited") { $exp_id = 19; }
#    elsif ($es eq "MIX" && $e eq "YE" && $type eq "Control") { $exp_id = 20; }
#    elsif ($es eq "MIX" && $e eq "MJ" && $type eq "Elicited") { $exp_id = 21; }
#    elsif ($es eq "MIX" && $e eq "MJ" && $type eq "Control") { $exp_id = 22; }
#    elsif ($es eq "MIX" && $e eq "UV" && $type eq "Elicited") { $exp_id = 23; }
#    elsif ($es eq "MIX" && $e eq "UV" && $type eq "Control") { $exp_id = 24; }
#    else {
#        print "Unknonw type of data file.$data_file.\n";
#        next;
#    }

    #== get the label_id:
    $time =~ /(\d+)(M|H)/;
    $t_number = $1;
    $t_unit = $2;
#    print "time = $time, t_number = $t_number, t_unit = $t_unit, ";
    if ($t_unit eq "M") {$t_unit = " min";}
    elsif ($t_unit eq "H") {$t_unit = " h";}
    $time = $t_number . $t_unit;
#    print "new_time = $time\n";
    $sql = "select \"label_id\" from \"label\" where \"name\" = '$time'";
    $sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
    $rc = $sth->execute or die "Can't execute: $DBI::errstr.";
    $label_id = $sth->fetchrow();

    #== get technique_id:
    $sql = "select technique_id from extract where extract_id = $extract_id";
    $sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
    $rc = $sth->execute or die "Can't execute: $DBI::errstr.";
    $technique_id = $sth->fetchrow();

    #== get the sampling_replicate_id:
    $sql = "select sampling_replicate_id from sampling_replicate where replicate = $bio_repl and sampling_point_id in (select sampling_point_id from sampling_point where experiment_id = $exp_id and label_id = $label_id)";
    $sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
    $rc = $sth->execute or die "Can't execute: $DBI::errstr.";
    $srid = $sth->fetchrow();

    $raw_data = $indir . $raw_file;
    if (!(-e $raw_data) ) {
        $raw_data = "\"\"";
    }

    #== call the script for insert metabolite data:
    $out_file = "/export/home/xingjing/data/dome/temp/GCMS_upload/$f_name.log";
#    print "indir = $indir, data_file = $data_file, raw_data = $raw_data, out_file = $out_file, file_home = $file_home, technique_id = $technique_id, srid = $srid, tech_repl = $tech_repl, person_id = $person_id, extract_id = $extract_id, protocol_id = $protocol_id, ttlid = $tissue_type_label_id, reference = $reference\n";
    $cmd = "perl readDataFromMetabolite.pl " . $indir . $data_file 
        . " $raw_data $out_file "
        . "$file_home $technique_id $srid $tech_repl $person_id $extract_id $protocol_id $tissue_type_label_id $reference";
#    print "$cmd\n";
    $ok = system $cmd;
    #print "ok = $ok for $data_file and $raw_data\n";
}
print "Ending time: " . TimeStamp() . ".\n";
$sth->finish;
$dbh->disconnect;
exit;

###########################################################################
# subroutine: getGprFilesInDir($dir):
#    this subroutine checks the given directory. Get all folder names and 
# put them in array @folders.
#
# parameters in: $dir --- the directory name which needs to be checked,
# parameter out: $ref_folders --- reference for the @folders.
#
###########################################################################
sub getFilesInDir {
    my ($dir, $type) = @_;
    my ($ref_folders, @folders, @files, $file, $filename);

    $ref_folders = ();
    @folders = @$ref_folders;
    opendir(DIR,$dir) or die "$dir does not exist or I can't open $dir\n";
    @files = readdir(DIR);
    foreach $file (@files){
        #print "file = $file\n ";
        if ($file ne '.' && $file ne ".." && $file =~ /$type/i) {
            push (@folders, $file);
        }
    }
    return @folders;
}
