<?php
function fillSearchCpdFrame($legendLabel, &$sessionVarToSet, $pageKey, $appendStrForVariables = "", $addAsNewCompound = false)
{
	print "\n<div class=\"search-compound{$appendStrForVariables}\">";
	print "<fieldset><legend>$legendLabel</legend>\n";
	print "\n<label>Current Cpd: </label>";
	
	if (isset($sessionVarToSet))
	{	
		$sql = "SELECT aname FROM allnames 
			WHERE record_id = '{$sessionVarToSet}'
			AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			ORDER BY UPPER(is_primary) DESC";
		
		$sth = $_SESSION['dbh']->query($sql);
	    if ( DB::isError($sth) ) 
	    {	printError("Could Not retrieve Compound Primary Name."); 	}
	    $row = $sth->fetchrow();
	    print $row[0];	
	    print "\n<input type=\"submit\" name=\"submit{$appendStrForVariables}\" value=\"Clear Selected Compound\">";
	    print "\n <br />";
		print "<label>Synonyms: </label>\n";
		if ($sth->numrows() > 1)
	    {
		    print "<ul>";
		    while($row = $sth->fetchrow())
		    {
		    	print "<li>$row[0]</li>";
	    	}
		    print "</ul>";
	    }
	    else
	    {	print "None";	}
	}
	else
	{	print "Not Set";	}
	
	print "\n<p><input type=\"text\" name=\"txtSearch{$appendStrForVariables}\" value=\"{$_SESSION[$pageKey]["txtSearch{$appendStrForVariables}"]}\" size=\"25\">";
	print "\n<input type=\"submit\" name=\"submit{$appendStrForVariables}\" value=\"Search\">";
	if ($addAsNewCompound)
	{	print "\n OR <input type=\"submit\" name=\"submit{$appendStrForVariables}\" value=\"Add As New Compound\">";	}
	print "</p>\n";
	
	if ($_REQUEST["submit{$appendStrForVariables}"] == 'Search')
	{
		$compoundName = $_SESSION[$pageKey]["txtSearch{$appendStrForVariables}"];
		//Converting $compoundName into Database search field form.
		$compoundName = convertToSearchName($compoundName);
		$compoundName = strtoupper($compoundName);

		if (strlen($compoundName) > 0)
	    {
		    $sql = "SELECT record_id, aname FROM allnames 
				WHERE UPPER(search_name) LIKE '%$compoundName%'
				AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";
			
			$sth = $_SESSION['dbh']->query($sql);
		    if ( DB::isError($sth) ) 
		    {	printError("Could Not Search for Compound Names."); 	}
		        
		    print "\n<select name=\"searchResults{$appendStrForVariables}\" size=\"8\">";
		    while ($row = $sth->fetchrow())
		    {
		    	print "\n\t<option value=\"$row[0]\">$row[1] [{$row[0]}]</option>";
	    	}
	    	print "\n</select>";
	    	if ($sth->numrows() > 0)
	    	{
		    	print "\n<br /><input type=\"submit\" name=\"submit{$appendStrForVariables}\" value=\"Set Selected Compound\">";
	    	}
    	}
	}
	print "</fieldset></div>";
}


function setCpdsNotFound(&$notFoundCpdArray, &$errMsgs)
{
	$addDataMetabolomicsPageName = 'ADD_DATA_METABOLOMICS';
	$proc_data_file = $_SESSION[$addDataMetabolomicsPageName]['uploadFile'];
	$cdf_file = $_SESSION[$addDataMetabolomicsPageName]['RawDataFile'];
	$outFile = $_SESSION['BROWSER_TMP_RELATIVE'] . session_id() . ".addlog";
	$file_home = $_SESSION['FILE_HOME'];
	$technique_id = $_SESSION[$addDataMetabolomicsPageName]['technique_id'];
	$srid = $_SESSION[$addDataMetabolomicsPageName]['sampling_replicate_id'];
	$tech_repl = $_SESSION[$addDataMetabolomicsPageName]['technical_replicate'];
	$person_id = $_SESSION[$addDataMetabolomicsPageName]['researcher_id'];
	$extract_id = $_SESSION[$addDataMetabolomicsPageName]['extract_id'];
	$exp_prot_id = $_SESSION[$addDataMetabolomicsPageName]['protocol_id'];
	$stat_ptid = $_SESSION[$addDataMetabolomicsPageName]['protocol_type_id'];
	$tissue_type_label_id = $_SESSION[$addDataMetabolomicsPageName]['tissue_type_label_id'];
	$reference = $_SESSION[$addDataMetabolomicsPageName]['reference_cpd'];
	if ($_SESSION[$addDataMetabolomicsPageName]['normalize_data'])
	{	$norm = 'Y';	} else {	$norm = 'N';	}

	$cmd = "{$_SESSION['PERL_DIR']}perl readDataFromMetabolite.pl \"$proc_data_file\" \"$cdf_file\" \"$outFile\" \"$file_home\" $technique_id $srid $tech_repl $person_id $extract_id $exp_prot_id $stat_ptid $tissue_type_label_id \"$reference\" $norm 2>&1";
	//print $cmd;
	exec($cmd, $retLines, $retValue);
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
  	if ($retValue == 0)
	{	
		if (!$msg)
		{	$msg = "Data Adding Script returned a successful value.";	}
		$_SESSION['Message'][] = $msg;	
		$notFoundCpdArray[0] = 'ALL COMPOUNDS DONE';
		return $retValue;
	}
	elseif ($retValue == 99)
	{
	  	if (file_exists($outFile))
	  	{
			$contents = file_get_contents($outFile);
			//The use of file is done, so delete it.
			unlink($outFile);
		}
		else
		{
			$errMsgs[] = "Output file containing 'Not Found' compound(s) not found.";
			return 0;
		}
		
		$lines = split("\n", trim($contents));
		
		foreach ($lines as $line)
		{
			list($type, $val) = split("\t", trim($line));
			//print "<br />type = $type, val = $val";
			$allTypes[$type][] = $val;
		}
	
	  	if ($allTypes['ERROR'])
	  	{
		  	foreach ($allTypes['ERROR'] as $errmsg)
		  	{
			  	$errMsgs[] = $errmsg;
		  	}
	  	}
		else
		{	$notFoundCpdArray = $allTypes['NOTFOUND']; 	}
	}
  	else 
  	{ 
	  	if (!$msg)
	  	{	$msg = "Command to the script adding data Failed. Command was: <br \>$cmd";	}
	  	$errMsgs[] = $msg;  
	  	return $retValue;
	}

	return $retValue;
}
?>