<?php

$currPageNameUpper = strtoupper($currPageName);
switch($currPageNameUpper)
{
case 'AFFYMETRIX_ARRAY_DESIGN':
	//This table treated specially. Look for additional code in addTable.php and viewEditTable.php
	$title = "DOME : Affymetrix Array Design";
	//array of hash. Each hash corresponds to information about one field in this table.
	//type can be an id as well and it can contain an sql statement too under the key 'sql'
	//for example 'sql'='SELECT "id" as 'id_field', "name" AS "display_field" FROM "table" ORDER BY "display_field"'
	$fieldsInfo = array(
	array('name'=>'platform_title', 'label'=>'Platform Title', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50, 'help_tip'=> '')
	, array('name'=>'platform_distribution', 'label'=>'Distribution', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_dimension', 'label'=>'Dimension', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_technology', 'label'=>'Technology', 'type'=>'hidden')
	, array('name'=>'platform_organism', 'label'=>'Organism(s)', 'type'=>'text', 'size'=>100, 'maxlength'=>200)
	, array('name'=>'platform_manufacturer', 'label'=>'Manufacturer', 'type'=>'text', 'size'=>100, 'maxlength'=>200)
	, array('name'=>'platform_manufacture_protocol', 'label'=>'Manufacture Protocol', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_catalog_number', 'label'=>'Catalog Number(s)', 'type'=>'text', 'size'=>75, 'maxlength'=>100)
	, array('name'=>'platform_web_link', 'label'=>'Web Link(s)', 'type'=>'text', 'size'=>75, 'maxlength'=>100)
	, array('name'=>'platform_support', 'label'=>'Support', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_coating', 'label'=>'Coating', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_description', 'label'=>'Description(s)', 'type'=>'text', 'size'=>125, 'maxlength'=>250)
	, array('name'=>'platform_contributor', 'label'=>'Contributor(s)', 'type'=>'text', 'size'=>150, 'maxlength'=>500)
	, array('name'=>'platform_pubmed_id', 'label'=>'Pubmed ID(s)', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_geo_accession', 'label'=>'GEO Accession', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	);
	$tableLabel = "Affymetrix Array Design";
	
	$nameOfTable = "array_batch";	//required
	$nameOfIDField = "array_batch_id";	//required
	$nameOfDisplayedField = "platform_title";	//optional
	$uniqueKey = array("platform_title");	//Can be an array with no elements.
	$sortField = "UPPER(\"platform_title\")";	
		//optional, can be an ID field. If not given defaults to $nameOfDisplayedField and even if $nameOfDisplayedField is not there to $nameOfIDField.
	break;	
case 'ADD_AFFYMETRIX_ANNOTATION':
	//This table treated specially. Look for additional code in addTable.php and viewEditTable.php
	$title = "DOME : Affymetrix Probe set Annotation";
	//array of hash. Each hash corresponds to information about one field in this table.
	//type can be an id as well and it can contain an sql statement too under the key 'sql'
	//for example 'sql'='SELECT "id" as 'id_field', "name" AS "display_field" FROM "table" ORDER BY "display_field"'
	$fieldsInfo = array();
	$tableLabel = "Affymetrix Probe set Annotation";
	$uniqueKey = array();	//Can be an array with no elements.
	break;	

case 'BIOMATERIAL_MANIPULATION':
	$title = "DOME : Biomaterial Manipulation";
	$fieldsInfo = array(
	array('name'=>'biomaterial_manipulation_name', 'label'=>'Name', 'required'=>true, 'type'=>'text', 'size'=>25, 'maxlength'=>25)
	, array('name'=>'growth_conditions_id', 'label'=>'Growth Conditions', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'growth_conditions', 'IDField'=>'growth_conditions_id', 'displayField'=>'growth_condition_name')
	, array('name'=>'invivo_treatment', 'label'=>'Invivo Treatment', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'invitro_treatment', 'label'=>'Invitro Treatment', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'treatment_type', 'label'=>'Treatment Type', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'compound', 'label'=>'Compound', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'separation_technique', 'label'=>'Separation Technique', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'biosource_properties_id', 'label'=>'Biosource Properties', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'biosource_properties', 'IDField'=>'biosource_properties_id', 'displayField'=>'biosource_properties_name')
	);
	$tableLabel = "Biomaterial Manipulation";
	
	$nameOfTable = "biomaterial_manipulation";	//required
	$nameOfIDField = "biomaterial_manipulation_id";	//required
	$nameOfDisplayedField = "biomaterial_manipulation_name";	//optional
	$uniqueKey = array("biomaterial_manipulation_name");	//Can be an array with no elements.
	$sortField = "UPPER(\"biomaterial_manipulation_name\")";	
		//optional, can be an ID field. If not given defaults to $nameOfDisplayedField and even if $nameOfDisplayedField is not there to $nameOfIDField.
	break;	

case 'BIOSOURCE_PROPERTIES':
	$title = "DOME : Biosource Properties";
	$fieldsInfo = array(
	array('name'=>'biosource_properties_name', 'label'=>'Name', 'required'=>true, 'type'=>'text', 'size'=>25, 'maxlength'=>25)
	, array('name'=>'organism', 'label'=>'Organism', 'type'=>'text', 'size'=>50)
	, array('name'=>'contact_details_for_sample', 'label'=>'Contact Details for Sample', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'cell_type', 'label'=>'Cell Type', 'type'=>'text', 'size'=>50)
	, array('name'=>'sex', 'label'=>'Sex', 'type'=>'text', 'size'=>2)
	, array('name'=>'age', 'label'=>'Age', 'type'=>'text', 'size'=>3)
	, array('name'=>'developmental_stage', 'label'=>'Developmental Stage', 'type'=>'text', 'size'=>50)
	, array('name'=>'organism_part', 'label'=>'Organism Part', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'strain_or_line', 'label'=>'Strain or Line', 'type'=>'text', 'size'=>50)
	, array('name'=>'genetic_variation', 'label'=>'Genetic Variation', 'type'=>'text', 'size'=>50)
	, array('name'=>'individual_number', 'label'=>'Individual Number', 'type'=>'text', 'size'=>50)
	, array('name'=>'individual_genetic_charactersti', 'label'=>'Individual Genetic Characteristics', 'type'=>'text', 'size'=>50)
	, array('name'=>'disease_state', 'label'=>'Disease State', 'type'=>'text', 'size'=>50)
	, array('name'=>'targeted_cell_type', 'label'=>'Targeted Cell Type', 'type'=>'text', 'size'=>50)
	, array('name'=>'cell_line', 'label'=>'Cell Line', 'type'=>'text', 'size'=>50)
	);
	$tableLabel = "Biosource Properties";
	
	$nameOfTable = "biosource_properties";	//required
	$nameOfIDField = "biosource_properties_id";	//required
	$nameOfDisplayedField = "biosource_properties_name";	//optional
	$uniqueKey = array("biosource_properties_name");	//Can be an array with no elements.
	$sortField = "UPPER(\"biosource_properties_name\")";	
		//optional, can be an ID field. If not given defaults to $nameOfDisplayedField and even if $nameOfDisplayedField is not there to $nameOfIDField.
	break;	
		
case 'COLUMN':
	$title = "DOME : Column";
	$fieldsInfo = array(
	array('name'=>'column_name', 'label'=>'Column Name', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'manufacturer', 'label'=>'Manufacturer', 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'batch_number', 'label'=>'Batch Number', 'type'=>'text', 'size'=>10, 'maxlength'=>100)
		);
	$tableLabel = "Column";
	
	$nameOfTable = "column";
	$nameOfIDField = "column_id";
	$nameOfDisplayedField = "column_name";
	$uniqueKey = array("column_name");
	break;
	
case 'EXPERIMENT_SET':
	$title = "DOME : Experiment Set";
	$fieldsInfo = array(
		array('name'=>'exp_set_name', 'label'=>'Experiment Set Name', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50)
		, array('name'=>'public_access', 'label'=>'Guest Access', 'required'=>true, 'type'=>'boolean')
	);
	$tableLabel = "Experiment Set";
	
	$nameOfTable = "experiment_set";
	$nameOfIDField = "exp_set_id";
	$nameOfDisplayedField = "exp_set_name";
	$uniqueKey = array("exp_set_name");
	break;
	
case 'EXPERIMENT':
	$title = "DOME : Experiment";
	$fieldsInfo = array(
	array('name'=>'exp_set_id', 'label'=>'Experiment Set', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'experiment_set', 'IDField'=>'exp_set_id', 'displayField'=>'exp_set_name')
		, array('name'=>'exp_name', 'label'=>'Experiment Name', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50)
		, array('name'=>'biomaterial_manipulation_id', 'label'=>'Biomaterial Manipulation', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'biomaterial_manipulation', 'IDField'=>'biomaterial_manipulation_id', 'displayField'=>'biomaterial_manipulation_name')
	);
	$tableLabel = "Experiment";
	
	$nameOfTable = "experiment";
	$nameOfIDField = "experiment_id";
	$nameOfDisplayedField = "exp_name";
	$uniqueKey = array("exp_name", "exp_set_id");
	$sortField = "\"experiment_set\".\"exp_set_id\"";
	break;

case 'EXTERNAL_DATABASE':
	$title = "DOME : External Database";
	$fieldsInfo = array(
	array('name'=>'database_name', 'label'=>'Database Name', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>255)
	, array('name'=>'full_db_name', 'label'=>'Full Database Name', 'type'=>'text', 'size'=>100, 'maxlength'=>255)
	, array('name'=>'url', 'label'=>'URL', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>255)
		);
	$tableLabel = "External Database";
	
	$nameOfTable = "external_database";
	$nameOfIDField = "external_database_id";
	$nameOfDisplayedField = "database_name";
	$uniqueKey = array("database_name");
	break;	
	
case 'EXTRACT':
	$title = "DOME : Extraction Method";
	$fieldsInfo = array(
	array('name'=>'technique_id', 'label'=>'Technique', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'technique', 'IDField'=>'technique_id', 'displayField'=>'technique_name')
	, array('name'=>'extraction_method', 'label'=>'Extraction Method', 'type'=>'multitext', 'rows'=>5, 'cols'=>50)
	, array('name'=>'name', 'label'=>'Name', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'extract_molecule', 'label'=>'Extract Molecule', 'required'=>true, 'type'=>'controlled-vocabulary')
				);
	$tableLabel = "Extraction Method";
	
	$nameOfTable = "extract";
	$nameOfIDField = "extract_id";
	$nameOfDisplayedField = "name";
	$uniqueKey = array("name");
	break;

case 'FEATURE_TYPE':
	$title = "DOME : Feature Type";
	$fieldsInfo = array(
	array('name'=>'element_dimensions', 'label'=>'Element Dimensions', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'attachment', 'label'=>'Attachment', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50)
				);
	$tableLabel = "Feature Type";
	
	$nameOfTable = "feature_type";
	$nameOfIDField = "feature_type_id";
	$nameOfDisplayedField = "attachment";
	$uniqueKey = array("attachment");
	break;
	
case 'GROWTH_CONDITIONS':
	$title = "DOME : Growth Conditions";
	$fieldsInfo = array(
	array('name'=>'growth_condition_name', 'label'=>'Name', 'required'=>true, 'type'=>'text', 'size'=>25, 'maxlength'=>250)
	, array('name'=>'atmosphere', 'label'=>'Atmosphere', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'contaminant_organism', 'label'=>'Contaminant Organism', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'density_range', 'label'=>'Density Range', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'generations', 'label'=>'Generations', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'host', 'label'=>'Host', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'humidity', 'label'=>'Humidity', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'light', 'label'=>'Light', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'medium', 'label'=>'Medium', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	, array('name'=>'nutrients', 'label'=>'Nutrients', 'type'=>'text', 'size'=>100, 'maxlength'=>250)
	, array('name'=>'temperature', 'label'=>'Temperature', 'type'=>'text', 'size'=>50, 'maxlength'=>250)
	);
	$tableLabel = "Growth Conditions";
	
	$nameOfTable = "growth_conditions";	//required
	$nameOfIDField = "growth_conditions_id";	//required
	$nameOfDisplayedField = "growth_condition_name";	//optional
	$uniqueKey = array("growth_condition_name");	//Can be an array with no elements.
	$sortField = "UPPER(\"growth_condition_name\")";	
		//optional, can be an ID field. If not given defaults to $nameOfDisplayedField and even if $nameOfDisplayedField is not there to $nameOfIDField.
	break;	
	
case 'HYBRIDIZATION_PROTOCOL':
	$title = "DOME : Hybridization Protocol";
	$fieldsInfo = array(
	array('name'=>'hybridization_chamber_type', 'label'=>'Hybridization Chamber Type', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'quantity_of_the_labelled_extrac', 'label'=>'Quantity of the Labelled Extract', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'duration', 'label'=>'Duration', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'hybridization_volume', 'label'=>'Hybridization Volume', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'temperature', 'label'=>'Temperature', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'full_protocol_description', 'label'=>'Full Protocol Description', 'type'=>'multitext', 'rows'=>5, 'cols'=>50)
	, array('name'=>'hyb_protocol_name', 'label'=>'Hybridization Protocol Name', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50)
				);
	$tableLabel = "Hybridization Protocol";
	
	$nameOfTable = "hybridization_protocol";
	$nameOfIDField = "hybridization_protocol_id";
	$nameOfDisplayedField = "hyb_protocol_name";
	$uniqueKey = array("hyb_protocol_name");
	break;

case 'PERSON':
	$title = "DOME : Person";
	$fieldsInfo = array(
	array('name'=>'person_name', 'label'=>'Name', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'email', 'label'=>'Email', 'type'=>'text', 'size'=>40, 'maxlength'=>40)
	, array('name'=>'phone', 'label'=>'Phone', 'type'=>'text', 'size'=>20, 'maxlength'=>20)
	, array('name'=>'url', 'label'=>'URL', 'type'=>'text', 'size'=>80, 'maxlength'=>80)
	, array('name'=>'position', 'label'=>'Position', 'type'=>'text', 'size'=>40, 'maxlength'=>40)
	, array('name'=>'group', 'label'=>'Group', 'type'=>'text', 'size'=>20, 'maxlength'=>20)
	, array('name'=>'role', 'label'=>'Role', 'required'=>true, 'type'=>'controlled-vocabulary')
	, array('name'=>'affiliation', 'label'=>'Affiliation', 'type'=>'text', 'size'=>40, 'maxlength'=>40)
	, array('name'=>'login', 'label'=>'Login', 'required'=>true, 'type'=>'text', 'size'=>20, 'maxlength'=>20)
	, array('name'=>'passwd', 'label'=>'Password', 'required'=>true, 'type'=>'password', 'size'=>20, 'maxlength'=>20)
				);
	$tableLabel = "Person";
	
	$nameOfTable = "person";
	$nameOfIDField = "person_id";
	$nameOfDisplayedField = "person_name";
	$uniqueKey = array("person_name");
	break;

case 'PROTOCOL':
	$title = "DOME : Statistical Test";
	$fieldsInfo = array(
	array('name'=>'protocol_name', 'label'=>'Statistical Test', 'required'=>true, 'type'=>'text', 'size'=>75, 'maxlength'=>250)
	, array('name'=>'protocol_desc', 'label'=>'Description', 'type'=>'multitext', 'rows'=>2, 'cols'=>80)
	, array('name'=>'protocol_type_id', 'label'=>'Protocol', 'required'=>true, 'type'=>'id', 'size'=>10, 'table'=>'protocol_type', 'IDField'=>'protocol_type_id', 'displayField'=>'protocol_type_name')
	);
	$tableLabel = "Statistical Test";
	
	$nameOfTable = "protocol";
	$nameOfIDField = "protocol_id";
	$nameOfDisplayedField = "protocol_name";
	$uniqueKey = array("protocol_name", "protocol_type_id");
	$sortField = "\"protocol_type\".\"protocol_type_id\"";
	break;
	
case 'PROTOCOL_TYPE':
	$title = "DOME : Protocol";
	$fieldsInfo = array(
	array('name'=>'protocol_type_name', 'label'=>'Protocol', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>150)
	, array('name'=>'protocol_type_desc', 'label'=>'Description', 'type'=>'text', 'size'=>150, 'maxlength'=>250)
	, array('name'=>'method', 'label'=>'Method', 'required'=>true, 'type'=>'controlled-vocabulary')
	, array('name'=>'technique_id', 'label'=>'Technique', 'required'=>true, 'type'=>'id', 'size'=>6, 'table'=>'technique', 'IDField'=>'technique_id', 'displayField'=>'technique_name')
	);
	$tableLabel = "Protocol";
	
	$nameOfTable = "protocol_type";
	$nameOfIDField = "protocol_type_id";
	$nameOfDisplayedField = "protocol_type_name";
	$uniqueKey = array("protocol_type_name");
	$sortField = "\"technique\".\"technique_id\"";
	break;
	
case 'REFERENCE':
	$title = "DOME : Reference";
	$fieldsInfo = array(
	array('name'=>'authors', 'label'=>'Authors', 'type'=>'text', 'size'=>75, 'maxlength'=>250)
	, array('name'=>'year', 'label'=>'Year', 'type'=>'integer', 'size'=>4, 'maxlength'=>4)
	, array('name'=>'title', 'label'=>'Title', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>500)
	, array('name'=>'locator', 'label'=>'Locator', 'required'=>true, 'type'=>'text', 'size'=>75, 'maxlength'=>250)
	, array('name'=>'pubmed_accession', 'label'=>'Pubmed Accession', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	);
	$tableLabel = "Reference";
	
	$nameOfTable = "reference";
	$nameOfIDField = "reference_id";
	$nameOfDisplayedField = "title";
	$uniqueKey = array("locator");
	$sortField = "UPPER(\"reference\".\"authors\")";
	break;
	
case 'ADD_SAMPLING_POINT':
	//This table treated specially. Look for additional code in addTable.php and viewEditTable.php
	$title = "DOME : Sampling Point";
	$fieldsInfo = array();
	$tableLabel = "Sampling Point";
	
	$nameOfTable = "sampling_point";
	$nameOfIDField = "sampling_point_id";
	$nameOfDisplayedField = "";
	$uniqueKey = array("experiment_id", "label_id");
	$sortField = "UPPER(\"experiment_set\".\"exp_set_name\"), UPPER(\"experiment\".\"exp_name\"), \"label\".\"order\"";
	break;
	
case 'SAMPLE_LABELING':
	$title = "DOME : Sample Label";
	$fieldsInfo = array(
	array('name'=>'amount_of_nucleic_acid_labeled', 'label'=>'Amount of Nucleic Acid Labeled', 'type'=>'text', 'size'=>25, 'maxlength'=>50)
	, array('name'=>'label_used', 'label'=>'Label Used', 'required'=>true, 'type'=>'text', 'size'=>25, 'maxlength'=>50)
	, array('name'=>'label_incorporation_method', 'label'=>'Label Incorporation Method', 'type'=>'text', 'size'=>100, 'maxlength'=>200)
		);
	$tableLabel = "Sample Label";
	
	$nameOfTable = "sample_labeling";
	$nameOfIDField = "sample_labeling_id";
	$nameOfDisplayedField = "label_used";
	$uniqueKey = array("label_used");
	break;
	
case 'SAMPLING_REPLICATE':
	//This table treated specially. Look for additional code in addTable.php and viewEditTable.php
	$title = "DOME : Sampling Replicate";
	$fieldsInfo = array(
	array('name'=>'start_time', 'label'=>'Start Date and Time', 'type'=>'text', 'size'=>40, 'maxlength'=>50)
	, array('name'=>'end_time', 'label'=>'End Date and Time', 'type'=>'text', 'size'=>40, 'maxlength'=>50)
	, array('name'=>'replicate', 'label'=>'Replicate', 'required'=>true, 'type'=>'text', 'size'=>3, 'maxlength'=>3)
				);
	$tableLabel = "Sampling Replicate";
	
	$nameOfTable = "sampling_replicate";
	$nameOfIDField = "sampling_replicate_id";
	$nameOfDisplayedField = "";
	$uniqueKey = array("sampling_point_id", "replicate");
	$sortField = "UPPER(\"experiment_set\".\"exp_set_name\"), UPPER(\"experiment\".\"exp_name\"), \"label\".\"order\", \"sampling_replicate\".\"replicate\"";
	break;
	
case 'SCANNING_PROTOCOL':
	$title = "DOME : Scanning Protocol";
	$fieldsInfo = array(
	array('name'=>'scanner_type', 'label'=>'Scanner Type', 'type'=>'text', 'size'=>50, 'maxlength'=>500)
	, array('name'=>'scanning_software', 'label'=>'Scanning Software', 'type'=>'text', 'size'=>50, 'maxlength'=>500)
	, array('name'=>'full_protocol_description', 'label'=>'Full Protocol Description', 'type'=>'text', 'size'=>200, 'maxlength'=>1000)
	, array('name'=>'scanning_protocol_name', 'label'=>'Scanning Protocol Name', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>500)
				);
	$tableLabel = "Scanning Protocol";
	
	$nameOfTable = "scanning_protocol";
	$nameOfIDField = "scanning_protocol_id";
	$nameOfDisplayedField = "scanning_protocol_name";
	$uniqueKey = array("scanning_protocol_name");
	break;
	
case 'SOFTWARE':
	$title = "DOME : Software";
	$fieldsInfo = array(
	array('name'=>'software_name', 'label'=>'Software Name', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'software_vendor', 'label'=>'Software Vendor', 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'software_version', 'label'=>'Software Version', 'type'=>'text', 'size'=>10, 'maxlength'=>100)
		);
	$tableLabel = "Software";
	
	$nameOfTable = "software";
	$nameOfIDField = "software_id";
	$nameOfDisplayedField = "software_name";
	$uniqueKey = array("software_name", "software_version");
	break;
	
case 'SPOTTED_ARRAY_DESIGN':
	//This table treated specially. Look for additional code in addTable.php and viewEditTable.php
	$title = "DOME : Spotted Array Design";
	//array of hash. Each hash corresponds to information about one field in this table.
	//type can be an id as well and it can contain an sql statement too under the key 'sql'
	//for example 'sql'='SELECT "id" as 'id_field', "name" AS "display_field" FROM "table" ORDER BY "display_field"'
	$fieldsInfo = array(
	array('name'=>'platform_title', 'label'=>'Platform Title', 'required'=>true, 'type'=>'text', 'size'=>50, 'maxlength'=>50, 'help_tip'=> '')
	, array('name'=>'platform_distribution', 'label'=>'Distribution', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_dimension', 'label'=>'Dimension', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_technology', 'label'=>'Technology', 'required'=>true, 'type'=>'controlled-vocabulary')
	, array('name'=>'platform_organism', 'label'=>'Organism(s)', 'type'=>'text', 'size'=>100, 'maxlength'=>200)
	, array('name'=>'platform_manufacturer', 'label'=>'Manufacturer', 'type'=>'text', 'size'=>100, 'maxlength'=>200)
	, array('name'=>'platform_manufacture_protocol', 'label'=>'Manufacture Protocol', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_catalog_number', 'label'=>'Catalog Number(s)', 'type'=>'text', 'size'=>75, 'maxlength'=>100)
	, array('name'=>'platform_web_link', 'label'=>'Web Link(s)', 'type'=>'text', 'size'=>75, 'maxlength'=>100)
	, array('name'=>'platform_support', 'label'=>'Support', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_coating', 'label'=>'Coating', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_description', 'label'=>'Description(s)', 'type'=>'text', 'size'=>125, 'maxlength'=>250)
	, array('name'=>'platform_contributor', 'label'=>'Contributor(s)', 'type'=>'text', 'size'=>150, 'maxlength'=>500)
	, array('name'=>'platform_pubmed_id', 'label'=>'Pubmed ID(s)', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	, array('name'=>'platform_geo_accession', 'label'=>'GEO Accession', 'type'=>'text', 'size'=>50, 'maxlength'=>50)
	);
	$tableLabel = "Spotted Array Design";
	
	$nameOfTable = "array_batch";	//required
	$nameOfIDField = "array_batch_id";	//required
	$nameOfDisplayedField = "platform_title";	//optional
	$uniqueKey = array("platform_title");	//Can be an array with no elements.
	$sortField = "UPPER(\"platform_title\")";	
		//optional, can be an ID field. If not given defaults to $nameOfDisplayedField and even if $nameOfDisplayedField is not there to $nameOfIDField.
	break;


case 'TECHNIQUE_ACL':
	$title = "DOME : Guest Display Techniques";
	
	$fieldsInfo = array(
	array('name'=>'exp_set_id', 'label'=>'Experiment Set', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'experiment_set', 'IDField'=>'exp_set_id', 'displayField'=>'exp_set_name')
	, array('name'=>'technique_id', 'label'=>'Technique', 'required'=>true, 'type'=>'id', 'size'=>1, 'table'=>'technique', 'IDField'=>'technique_id', 'displayField'=>'technique_name')
	);
	
	$tableLabel = "Guest Display Techniques";
	
	$nameOfTable = "technique_acl";
	$nameOfIDField = "technique_acl_id";
	$nameOfDisplayedField = "";
	$uniqueKey = array("exp_set_id", "technique_id");
	
	break;
	
		
case 'TISSUE_TYPE':
	$title = "DOME : Tissue Type";
	$fieldsInfo = array(
	array('name'=>'kw_table_id', 'label'=>'kw_table_id', 'type'=>'hidden')
	, array('name'=>'name', 'label'=>'Tissue Type', 'required'=>true, 'type'=>'text', 'size'=>100, 'maxlength'=>100)
	, array('name'=>'order', 'label'=>'Order', 'type'=>'integer', 'size'=>3, 'maxlength'=>3)
	);
	$tableLabel = "Tissue Type";
	
	$nameOfTable = "label";
	$nameOfIDField = "label_id";
	$nameOfDisplayedField = "name";
	$uniqueKey = array("kw_table_id", "name");
	break;

}
?>