<?php
/**
* This script is a Front-End for deleting Affy data from the DOME database.
* Date: 30 Jun 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

$currPageName = 'DELETE_DATA_AFFY';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
$title = "Delete Affymetrix Data from the database";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER'))
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php
if (isset($_REQUEST['technique_id']))
{
	$currPageNameUpper = strtoupper($currPageName);
	$_SESSION[$currPageNameUpper]['technique_id'] = $_REQUEST['technique_id'];
}

if ('Delete' == $_REQUEST['submit'] OR 'Continue' == $_REQUEST['submit'] )
{	processForm($_SESSION[$currPageNameUpper]['force_delete']);	}
elseif('Cancel' == $_REQUEST['submit'])
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}
else
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
	
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}

fillForm($_SESSION[$currPageNameUpper]['force_delete']);

include_once("footer.php");
?>

<?php
//Functions
function fillForm($force_delete = 0)
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	
	if ($force_delete)
	{
		print "\n<div class=\"controlBar\">";
		print "\n<input type=\"submit\" name=\"submit\" value=\"Cancel\" /> ";
		print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";
		print "\n</div>";
	}
	else
	{
		
		print "<p class=\"help-tips\">Affymetrix is a 1-channel experiment.</p>";
		
		print "<table width=\"100%\"><tr><td>";	//start table
		//Print Channel 1 Selections
		printChannel(1, '', '', true);
				
		print "</td></tr></table>"; //end table
		
		print "<p class=\"help-tips\">Add information about the affymetrix experiment. If you do not see an option in one of the drop down menus then you would have to go back and add that information using the main menu before loading the affymetrix data.</p>";
		
		print "<table width=\"100%\"><tr><td>";	//start table
	
		//Print Extract.
		$sql = "SELECT \"extract_id\", \"name\" FROM \"extract\" WHERE \"technique_id\" = '{$_SESSION[$currPageNameUpper]['technique_id']}' ORDER BY UPPER(\"name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Extracts. " . $sth->getMessage());	return;	}
		print "<p><label>Extraction Method: </label>";
		print "<select name=\"extract_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['extract_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		
		print "</td><td>";	//divide cell
		
		//Print Hybridization Protocol
		$sql = "SELECT \"hybridization_protocol_id\", \"hyb_protocol_name\" FROM \"hybridization_protocol\" ORDER BY UPPER(\"hyb_protocol_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Hybridization Protocols. " . $sth->getMessage());	return;	}
		print "\n<p><label>Hybridization Protocol: </label>";
		print "<select name=\"hybridization_protocol_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['hybridization_protocol_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		//Print Scanning Protocol
		$sql = "SELECT \"scanning_protocol_id\", \"scanning_protocol_name\" FROM \"scanning_protocol\" ORDER BY UPPER(\"scanning_protocol_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Scanning Protocols. " . $sth->getMessage());	return;	}
		print "\n<p><label>Scanning Protocol: </label>";
		print "<select name=\"scanning_protocol_id\">";
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['scanning_protocol_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		print "</td></tr></table>"; //end table
		print "<input type=\"submit\" name=\"submit\" value=\"Delete\" />";
		print "\n<p><a href=\"deleteDataMenu.php\"><- Back to Delete Data Menu</a></p>";
	}
	print "\n</form>";
	
}

/**============================
* Request Functions
*============================*/
function processForm($force_delete = 0)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	if (!$force_delete)
	{
		$_SESSION[$currPageNameUpper]['channel1'] = $_REQUEST['channel1'];
		$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
		$_SESSION[$currPageNameUpper]['hybridization_protocol_id'] = $_REQUEST['hybridization_protocol_id'];
		$_SESSION[$currPageNameUpper]['scanning_protocol_id'] = $_REQUEST['scanning_protocol_id'];
		
		if (!$_SESSION[$currPageNameUpper]['technique_id'])
		{	$errMsgs[] = "technique_id not set";	}
		
		$noOfChannels = 1;
		for ($i = 1; $i <= $noOfChannels; $i++)
		{
			$identifier = "channel$i";
			//Validating Channel $i
			if (!$_SESSION[$currPageNameUpper][$identifier]['experiment_set_id'])
			{	$errMsgs[] = "Please Select an Experiment Set for Channel $i.";	}
			if (!$_SESSION[$currPageNameUpper][$identifier]['exp_name'])
			{	$errMsgs[] = "Please Select an Experiment for Channel $i.";	}
			if (!$_SESSION[$currPageNameUpper][$identifier]['sampling_point_label_id'])
			{	$errMsgs[] = "Please Select a Sampling Point for Channel $i";	}
			if (!$_SESSION[$currPageNameUpper][$identifier]['tissue_type_label_id'])
			{	$errMsgs[] = "Please Select a Tissue Type for Channel $i";	}
			if (!$_SESSION[$currPageNameUpper][$identifier]['biological_replicate'])
			{	$errMsgs[] = "Please Select the Biological Replicate number for Channel $i.";	}
			if (!$_SESSION[$currPageNameUpper][$identifier]['technical_replicate'] OR strval(intval($_SESSION[$currPageNameUpper][$identifier]['technical_replicate'])) != $_SESSION[$currPageNameUpper][$identifier]['technical_replicate'])
			{	$errMsgs[] = "Please enter correct Technical Replicate for Channel $i.";	}

		}
		
		//Validating Rest
		if (!$_SESSION[$currPageNameUpper]['extract_id'])
		{	$errMsgs[] = "Please Select extraction method.";	}
		if (!$_SESSION[$currPageNameUpper]['hybridization_protocol_id'])
		{	$errMsgs[] = "Please Select Hybridization Protocol.";	}
		if (!$_SESSION[$currPageNameUpper]['scanning_protocol_id'])
		{	$errMsgs[] = "Please Select Scanning Protocol.";	}
		
		if ($errMsgs)
		{	return 0;	}
		
		
		//Now find out sampling_replicate_id from the given info for the channels.
		for ($i = 1; $i <= $noOfChannels; $i++)	
		{
			$index1 = "channel$i";
			$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
						, \"sampling_point\" sp
						, \"experiment\" e
					WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper][$index1]['experiment_set_id']}'
					AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper][$index1]['exp_name']}'
					AND sp.\"experiment_id\" = e.\"experiment_id\"
					AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper][$index1]['sampling_point_label_id']}'
					AND sr.\"sampling_point_id\" = sp.\"sampling_point_id\"
					AND sr.\"replicate\" = '{$_SESSION[$currPageNameUpper][$index1]['biological_replicate']}'";
			//print $sql;
			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	$errMsgs[] = "Error retrieving Sampling Replicate for channel $i. " . $sth->getMessage();	return 0;	}
			
			if ($sth->numrows() > 0)
			{
				$row = $sth->fetchRow();
				$_SESSION[$currPageNameUpper][$index1]['sampling_replicate_id'] = $row[0];
				//print "Set sampling_replicate_id = {$_SESSION[$currPageNameUpper]['sampling_replicate_id']} ($n)";
			}
			else
			{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided for channel $i";	return 0;}
		}
			
		
		if ($errMsgs)
		{	return 0;	}
	}
	
	$perlScriptFile = "deleteDataForAffy.pl";
	$sr_id = $_SESSION[$currPageNameUpper]['channel1']['sampling_replicate_id'];
	$tissue_type_label_id = $_SESSION[$currPageNameUpper]['channel1']['tissue_type_label_id'];
	$technical_replicate = $_SESSION[$currPageNameUpper]['channel1']['technical_replicate'];
	$extract_id = $_SESSION[$currPageNameUpper]['extract_id'];
	$hybridization_pt_id = $_SESSION[$currPageNameUpper]['hybridization_protocol_id'];
	$scanning_pt_id = $_SESSION[$currPageNameUpper]['scanning_protocol_id'];

	$force_delete = $_SESSION[$currPageNameUpper]['force_delete'];
		
	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile $sr_id $tissue_type_label_id $technical_replicate $extract_id $hybridization_pt_id $scanning_pt_id $force_delete 2>&1;";
	//print $com;
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
	  	$_SESSION[$currPageNameUpper]['force_delete'] = 0;
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
	}
	elseif ($retValue == 99)	//data exists
	{
		$_SESSION[$currPageNameUpper]['force_delete'] = 1;
		$_SESSION['Message'][] = $msg;
		return 0;
	}
	else
	{	
		$_SESSION[$currPageNameUpper]['force_delete'] = 0;
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn: $retString RetValue = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
