<?php
/**
* This script prints the menu for the metadata
* Date: 30 Jun 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

//session_start();
include_once("common.php");
?>

<?php

$currPageName = 'DELETE_METADATA_MENU';
$title = "DOME : Delete Data Menu"; 
include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>
<p class="help-tips">This page is only accessible to the Manager of the Database. If you are not the Manager then PLEASE LOGOUT.</p>
<p class="help-tips">You can use these links delete data.</p>
<div class="left-align">

<?php
		print '<p><ul>';
		
		//Print Techniques.
		$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" ORDER BY UPPER(\"technique_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Techniques. " . $sth->getMessage());	return;	}
	
		while ($row = $sth->fetchRow()) 
		{
			//==Hard Coding Here
			switch(strtoupper($row[1]))
			{
			case 'AFFYMETRIX':
				$redirectFile = "deleteDataAffy.php";
				$technique_type = "Transcriptomics";
				break;
			case 'CE/MS':
				$redirectFile = "deleteDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'CE/LIF':
				$redirectFile = "deleteDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'GC/MS':
				$redirectFile = "deleteDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'LC/MS':
				$redirectFile = "deleteDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'MICROARRAY':
				$redirectFile = "deleteDataMicroarray.php";
				$technique_type = "Transcriptomics";
				break;
			case 'PROTEOMICS':
				$redirectFile = "deleteDataProteomics.php";
				$technique_type = "Proteomics";
				break;
			default:
				$stepno = "";
				break;
			}
			
			if ('Proteomics' == $technique_type)
			{	$deleteDataLinksArray[$technique_type][] = "<a href=\"$redirectFile?technique_id=$row[0]\">2D-PAGE</a>";	}
			else
			{	$deleteDataLinksArray[$technique_type][] = "\n<a href=\"$redirectFile?technique_id=$row[0]\">$row[1]</a>";	}
			
		}
		foreach ($deleteDataLinksArray as $technique_type=>$links)
		{
			print "<li>$technique_type: ";
			$firstDone = false;
			foreach ($links as $link)
			{
				if (!$firstDone)
				{	print $link; $firstDone = true;	}
				else
				{	print ", $link";	}
			}
			print "</li>";
		}
		
		print '</ul></p>';
		print '<hr />';
		print '<p>Processed Data: <br />';
		print "<ul>\n<li>Normalized Data: <a href=\"deleteNormalized1Channel.php\">1-Channel</a>, 
			<a href=\"deleteNormalized2Channel.php\">2-Channel by Reference Design</a></li>";
		
		//Mean and Std Dev Links
		print '<li><a href="deleteStatisticalSummary.php">Statistical Summary Data</a></li>';

		//Compare Data Links
		print '<li><a href="deleteCompared.php">Compared Data</a></li>';	
		print "</ul></p>";
?>

</div>
<?php 
	include("footer.php");
?>

