<?php
/**
* This script is a Front-End for deleting Proteomics Data.
* in the DOME database.
* Date: 30 Jun 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");

$currPageName = 'DELETE_DATA_PROTEOMICS';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
if (isset($_REQUEST['technique_id']))
{	$_SESSION[$currPageNameUpper]['technique_id'] = strtoupper($_REQUEST['technique_id']);	}

$title = "Delete Proteomics Data";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER'))
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php

if ('Delete' == $_REQUEST['submit'] OR 'Continue' == $_REQUEST['submit'] )
{	processForm($_SESSION[$currPageNameUpper]['force_delete']);	}
elseif ($_REQUEST['submit'] == 'Cancel')
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}
else
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
	
fillForm($_SESSION[$currPageNameUpper]['force_delete']);
include_once("footer.php");
?>

<?php
//Functions
function fillForm($force_delete = 0)
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	if ($force_delete)
	{
		print "\n<div class=\"controlBar\">";
		print "\n<input type=\"submit\" name=\"submit\" value=\"Cancel\" /> ";
		print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";
		print "\n</div>";
	}
	else
	{
		print "<br><p class=\"help-tips\">Please enter the proper Meta Data information:</p>";
		
		printMetaDataSelections("", $_SESSION[$currPageNameUpper], true, true);
		
		printExtractMethod($_SESSION[$currPageNameUpper]['technique_id']);
		
		print "<input type=\"submit\" name=\"submit\" value=\"Delete\" />";
		print "\n<p><a href=\"deleteDataMenu.php\"><- Back to Delete Data Menu</a></p>";
	}
	print "\n</form>";

}


/**============================
* Request Functions
*============================*/
function processForm($force_delete = 0)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	if (!$force_delete)
	{
		$_SESSION[$currPageNameUpper]['experiment_set_id'] = $_REQUEST['experiment_set_id'];
		$_SESSION[$currPageNameUpper]['exp_name'] = $_REQUEST['exp_name'];
		$_SESSION[$currPageNameUpper]['sampling_point_label_id'] = $_REQUEST['sampling_point_label_id'];
		$_SESSION[$currPageNameUpper]['tissue_type_label_id'] = $_REQUEST['tissue_type_label_id'];
		$_SESSION[$currPageNameUpper]['biological_replicate'] = $_REQUEST['biological_replicate'];
		$_SESSION[$currPageNameUpper]['technical_replicate'] = $_REQUEST['technical_replicate'];
		$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
					
		if (!$_SESSION[$currPageNameUpper]['experiment_set_id'])
		{	$errMsgs[] = "Please Select an Experiment Set.";	}
		
		if (!$_SESSION[$currPageNameUpper]['exp_name'])
		{	$errMsgs[] = "Please Select an Experiment.";	}
		
		if (!$_SESSION[$currPageNameUpper]['sampling_point_label_id'])
		{	$errMsgs[] = "Please Select a Sampling Point";	}
		
		if (!$_SESSION[$currPageNameUpper]['tissue_type_label_id'])
		{	$errMsgs[] = "Please Select a Tissue Type";	}
		
		if (!$_SESSION[$currPageNameUpper]['biological_replicate'])
		{	$errMsgs[] = "Please Select the biological replicate number.";	}
	
		if (!$_SESSION[$currPageNameUpper]['technical_replicate'])
		{	$errMsgs[] = "Please Select the technical replicate number.";	}
		
		if (!$_SESSION[$currPageNameUpper]['extract_id'])
		{	$errMsgs[] = "Please Select an Extraction Method.";	}
		
		if ($errMsgs)
		{	return 0;	}
		

		//Now find out sampling_replicate_id from the given info.
		$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
						, \"sampling_point\" sp
						, \"experiment\" e
					WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper]['experiment_set_id']}'
					AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper]['exp_name']}'
					AND sp.\"experiment_id\" = e.\"experiment_id\"
					AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper]['sampling_point_label_id']}'
					AND sr.\"sampling_point_id\" = sp.sampling_point_id
					AND sr.\"replicate\" = '{$_SESSION[$currPageNameUpper]['biological_replicate']}'";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error retrieving Sampling Replicate. " . $sth->getMessage();	
			return 0;
		}
		
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchRow();
			$_SESSION[$currPageNameUpper]['sampling_replicate_id'] = $row[0];
			//print "Set sampling_replicate_id = {$_SESSION[$currPageNameUpper]['sampling_replicate_id']} ($n)";
		}
		else
		{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided";	}
		
	}
	
	$perlScriptFile = "deleteDataForProteomics.pl";
	$srid = $_SESSION[$currPageNameUpper]['sampling_replicate_id'];
	$ttlid = $_SESSION[$currPageNameUpper]['tissue_type_label_id'];
	$tech_repl = $_SESSION[$currPageNameUpper]['technical_replicate'];
	$extract_id = $_SESSION[$currPageNameUpper]['extract_id'];
	
	$force_delete = $_SESSION[$currPageNameUpper]['force_delete'];

	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile $srid $ttlid $tech_repl $extract_id $force_delete 2>&1;";
	//print $com;
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
	  	$_SESSION[$currPageNameUpper]['force_delete'] = 0;
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
	}
	elseif ($retValue == 99)	//data exists
	{
		$_SESSION[$currPageNameUpper]['force_delete'] = 1;
		$_SESSION['Message'][] = $msg;
	}
	else
	{	
		$_SESSION[$currPageNameUpper]['force_delete'] = 0;
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn Value = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}

	return 1;
}

?>
