<?php

function deleteActivity($identifier, $unique = "")
{
	$rec = split(':', $unique);
	$EC = $rec[0];
	$protein_pn = $rec[1];
	
	if (is_numeric($identifier))
	{	$event_id = $identifier;	}
	else
	{
		$event_id = getEntityID('EVENT', $identifier);
		if ($event_id == 'ERROR')
		{	return 'ERROR';		}
	}
	
	if ($EC)
	{
		if (is_numeric($EC))
		{	$ec_id = $EC;	}
		else
		{
			$ec_id = getEntityID('EC', $EC);
			if ($ec_id == 'ERROR')
			{	return 'ERROR';		}
		}
	}
	
	if ($protein_pn)
	{
		if (is_numeric($protein_pn))
		{	$protein_id = $protein_pn;	}
		else
		{
			$protein_id = getEntityID('PROTEIN', $protein_pn);
			if ($protein_id == 'ERROR')
			{	return 'ERROR';		}
		}
	}
	    
	$sql = "SELECT activity_id FROM activity a, event_ec eec";
	if ($protein_id)
	{
		$sql .= ", protein_state ps";
	}
	$sql .= " WHERE eec.event_id = '$event_id' 
		AND a.event_ec_id = eec.event_ec_id";
	if ($ec_id)
	{
		$sql .= " AND eec.ec_id = '$ec_id'";
	}
	if ($protein_id)
	{	$sql .= " AND a.protein_state_id = ps.protein_state_id AND ps.protein_id = '$protein_id'";   }
	
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error selecting from 'activity' table for event '$identifier' (query = $sql)(ec = $ec) ( protid = $protein_id). (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	while ($row = $sth->fetchRow())
	{
		$sql = "DELETE FROM activity WHERE activity_id = $row[0]";
		$sthA = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sthA) ) 
		{	
			$_SESSION['errMsgs'][] = "Error deleting from 'activity' table for event '$identifier'.(act = $row[0]) (event = $event_id) (query = $sql)(ec = $ec) ( protid = $protein_id)(" . $sthA->getMessage() . ")"; 	
			return 'ERROR';
		}
		$status = deleteRest('ACTIVITY', $row[0]);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
	}
	return 'PROCESSED';	
}

function deleteActivityByEC($identifier)
{
	if (is_numeric($identifier))
	{	$ec_id = $identifier;	}
	else
	{
		$ec_id = getEntityID('EC', $identifier);
		if ($ec_id == 'ERROR')
		{	return 'ERROR';		}
	}
	
    
	$sql = "SELECT activity_id FROM activity WHERE ec_id = '$ec_id'";
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error selecting from 'activity' table for event '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	while ($row = $sth->fetchRow())
	{
		$sql = "DELETE FROM activity WHERE activity_id = '$row[0]'";
		$sthA = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sthA) ) 
		{	
			$_SESSION['errMsgs'][] = "Error deleting from 'activity' table for ec '$identifier' and activity_id '$row[0]'. (" . $sthA->getMessage() . ")"; 	
			return 'ERROR';
		}
		$status = deleteRest('ACTIVITY', $row[0]);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
	}
	return 'PROCESSED';	
}

function deleteAllNames($group, $identifier, $aname)
{
	if (strtoupper($identifier) == strtoupper($aname))
	{
		$_SESSION['errMsgs'][] = "Name '$aname' provided for deletion in AllNames is same as its identifier name. Cannot delete a primary name.";
		return 'ERROR';
	}
	$record_id = getEntityID($group, $identifier);
	if ($record_id == 'ERROR')
	{	return 'ERROR';		}
		
	//Deleting AllNames
	$sql = "DELETE FROM allnames WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(aname) = UPPER(" . $_SESSION['dbhBNet']->quote($aname) . ")";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'allnames' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	return 'PROCESSED';
}

function deleteComplex($identifier)
{
	//Deleting from complex
	if (is_numeric($identifier))
	{	$complex_id = $identifier;	}
	else
	{
		$complex_id = getEntityID('COMPLEX', $identifier);
		if ($complex_id == 'ERROR')
		{	return 'ERROR';		}
	}
	
	//Delete complex members
	$status = deleteComplexMember($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	
	$sql = "DELETE FROM complex WHERE complex_id = '$complex_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'COMPLEX' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('COMPLEX', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	return 'PROCESSED';
}

function deleteComplexMember($identifier, $unique = "")
{
	//get complex_id
	if (is_numeric($identifier))
	{	$complex_id = $identifier;	}
	else
	{
		$complex_id = getEntityID('COMPLEX', $identifier);
		if ($complex_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Delete Complex Members
	$sql = "DELETE FROM complex_member WHERE complex_id = '$complex_id'";
	if ($unique)
	{	
		$rec = split(':', $unique);
		$record_id = getEntityID($rec[0], $rec[1]);
		if ($record_id == 'ERROR')
		{	return 'ERROR';		}
		
		$sql .= " AND kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'
			AND record_id = '$record_id'";
	}
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from complex_member table for complex '$identifier:$unique'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteCompound($identifier)
{
	if (is_numeric($identifier))
	{	$cpd_id = $identifier;	}
	else
	{
		$cpd_id = getEntityID('COMPOUND', $identifier);
		if ($cpd_id == 'ERROR')
		{	return 'ERROR';		}
	}

	//Deleting from compound
	$status = deleteCompoundDer($identifier);
	if ($status == 'ERROR')
	{
		printError("Error deleting Compound Derivative... Rolling Back (" . $qres->getMessage() . ")" );
		return 'ERROR';		
	}

	//Deleting Evidences to specie_compound
	$sql = "SELECT specie_cpd_id FROM specie_compound 
		WHERE cpd_id = '$cpd_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error looking in 'specie_compound' table for compound '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	while ($row = $sth->fetchRow())
	{
		$sql = "DELETE FROM evidence WHERE record_id = '$row[0]' AND kw_table_id = '{$_SESSION['TableID']['SPECIE_COMPOUND']}'";
		$sthR = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sthR) ) 
		{	
			$_SESSION['errMsgs'][] = "Error deleting from 'EVIDENCE' table for COMPOUND with identifier '$identifier'. (" . $sthR->getMessage() . ")"; 	
			return 'ERROR';
		}
	}

	$status = deleteSpecieCompound($identifier);
	if ($status == 'ERROR')
	{	
		return 'ERROR';		
	}
	
	//Deleting Events
	$sql = "SELECT DISTINCT event_id FROM event_component 
		WHERE kw_table_id = '{$_SESSION['TableID']['COMPOUND']}' 
		AND record_id = '$cpd_id' AND event_id > 0";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error selecting from 'event_component' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	while($row = $sth->fetchrow())
	{
		deleteEvent($row[0]);
		if ($status == 'ERROR')
		{	
			return 'ERROR';		
		}
	}
	
	//Delete the compound
	$sql = "DELETE FROM compound WHERE cpd_id = '$cpd_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'COMPOUND' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('COMPOUND', $identifier);
	if ($status == 'ERROR')
	{	
		return 'ERROR';		
	}
	
	return 'PROCESSED';
}

function deleteCompoundDer($identifier, $derName = "")
{
	if (is_numeric($identifier))
	{	$cpd_id = $identifier;	}
	else
	{
		$cpd_id = getEntityID('COMPOUND', $identifier);
		if ($cpd_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Deleting from cpd_derivative
    $sql = "DELETE FROM cpd_derivative WHERE cpd_id = '$cpd_id'";
    if ($derName)
    {	$sql .= " AND UPPER(name) = UPPER('$derName')";	}
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'cpd_derivative' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteEC($identifier)
{
	if (is_numeric($identifier))
	{	$ec_id = $identifier;	}
	else
	{
		$ec_id = getEntityID('EC', $identifier);
		if ($ec_id == 'ERROR')
		{	return 'ERROR';		}
	}
		
	//Deleting from event_ec
	$sql = "DELETE FROM event_ec WHERE ec_id = '$ec_id'";
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'event_ec' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	
	//Deleting from activity
	$status = deleteActivityByEC($ec_id);	
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	$sql = "DELETE FROM ec WHERE ec_id = '$ec_id'";
    
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'ec' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	
	$status = deleteRest('EC', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	return 'PROCESSED';	
}

function deleteEvent($identifier)
{
	//Deleting from event
	if (is_numeric($identifier))
	{	$event_id = $identifier;	}
	else
	{
		$event_id = getEntityID('EVENT', $identifier);
		if ($event_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Delete Event Components
	$status = deleteEventComponent($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	$status = deleteEventEC($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	$status = deleteActivity($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
    
	$sql = "DELETE FROM event WHERE event_id = '$event_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		print $sql;
		$_SESSION['errMsgs'][] = "Error deleting from 'EVENT' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('EVENT', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	return 'PROCESSED';
}

function deleteEventComponent($identifier, $unique = "")
{
	//get from event_id
	if (is_numeric($identifier))
	{	$event_id = $identifier;	}
	else
	{
		$event_id = getEntityID('EVENT', $identifier);
		if ($event_id == 'ERROR')
		{	return 'ERROR';		}
	}
		
	//Delete Event Components
	$sql = "DELETE FROM event_component WHERE event_id = '$event_id'";
	if ($unique)
	{	
		$rec = split(':', $unique);
		$record_id = getEntityID($rec[0], $rec[1]);
		if ($record_id == 'ERROR')
		{	return 'ERROR';		}
		
		$sql .= " AND kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'
			AND record_id = '$record_id'
			AND UPPER(is_substrate) = '$rec[2]'";	
	}
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from event_component table for event '$identifier:$unique'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteEventEC($identifier, $EC = "")
{
	//Deleting from event_ec
	if (is_numeric($identifier))
	{	$event_id = $identifier;	}
	else
	{
		$event_id = getEntityID('EVENT', $identifier);
		if ($event_id == 'ERROR')
		{	return 'ERROR';		}
	}
	if ($EC)
	{	
		$sql = "SELECT ec_id FROM EC WHERE ec = '$EC'";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error getting EC from 'ec' table for '$EC'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}
		if ($sth->numRows() > 0)
		{	
			$row = $sth->fetchRow();
			$ec_id = $row[0];	
		}
	}

    $sql = "DELETE FROM event_ec WHERE event_id = '$event_id'";
    if ($ec_id)
    {
	    $sql .= " AND ec_id = '$ec_id'";
    }
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'event_ec' table for event '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';	
}

function deleteEventType($identifier)
{
	//Deleting from event_type
	$sql = "DELETE FROM event_type WHERE event_type_name = '$identifier'";
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'event_type' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}


function deleteEvidence($group, $identifier, $unique)
{
	$record_id = getEntityID($group, $identifier);
	if ($record_id == 'ERROR')
	{	return 'ERROR';		}
		
	
	$records = split('::', $unique);
	$locator = $records[0];
	$ECRecord = split(':', $records[1]);
		
	$sql = "SELECT evidence_id FROM evidence ev, 
		evidence_code ec, reference ref
		WHERE UPPER(ref.locator) = UPPER('$locator')
		AND UPPER(ec.evidence_code) = UPPER('$ECRecord[0]')
		AND ec.kw_table_id = '{$_SESSION['TableID'][$ECRecord[1]]}'
		AND UPPER(ec.technique) = UPPER('$ECRecord[2]')
		AND UPPER(ec.strength) = UPPER('$ECRecord[3]')
		AND ev.reference_id = ref.reference_id
		AND ev.evidence_code_id = ec.evidence_code_id
		AND ev.record_id = '$record_id' 
		AND ev.kw_table_id = '{$_SESSION['TableID'][$group]}'";
		

	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error retrieving Evidence Code information while deleting Evidence for '$identifier' with unique code '$unique'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	if ($sth->numrows() > 0)
	{
		$row = $sth->fetchRow();
		//Deleting Evidence
		$sql = "DELETE FROM evidence WHERE evidence_id = '$row[0]'";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error deleting from 'evidence' table for group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}	
	}
	return 'PROCESSED';
}

function deleteEvidenceCode($identifier)
{
	$ECRecord = split(':', $identifier);
	//Deleting from evidence code
	$sql = "DELETE FROM evidence_code WHERE 
		evidence_code = '$ECRecord[0]'
		AND kw_table_id = '{$_SESSION['TableID'][$ECRecord[1]]}'
		AND technique = '$ECRecord[2]'
		AND strength = '$ECRecord[3]'";
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'evidence_code' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteExternalDatabase($identifier)
{
	//Deleting from external database
	$sql = "DELETE FROM exteranal_database WHERE full_db_name = '$identifier'";
		
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'exteranal_database' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteExternalLinks($group, $identifier, $full_db_name)
{
	$record_id = getEntityID($group, $identifier);
	if ($record_id == 'ERROR')
	{	return 'ERROR';		}
		
	//Deleting ExternalLinks
	$sql = "DELETE FROM external_links WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(full_db_name) = UPPER('$full_db_name')";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'external_links' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	return 'PROCESSED';
}

function deleteGene($identifier)
{
	if (is_numeric($identifier))
	{	$gene_id = $identifier;	}
	else
	{
		$gene_id = getEntityID('GENE', $identifier);
		if ($gene_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Deleting from gene
	$sql = "SELECT an.aname FROM mrna m, allnames an WHERE m.gene_id = '$gene_id'
		AND an.record_id = m.mrna_id
		AND an.kw_table_id = '{$_SESSION['TableID']['MRNA']}'
		AND UPPER(an.is_primary) = 'Y'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error getting mrna_id from mrna table while deleting GENE '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	
	while ($row = $sth->fetchRow())
	{
		$status = deleteMrna($row[0]);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
	}
	
    $sql = "DELETE FROM gene WHERE gene_id = '$gene_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'GENE' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('GENE', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	return 'PROCESSED';
}

function deleteLocation($identifier)
{
	//Deleting from location
	$sql = "DELETE FROM location WHERE location_name = '$identifier'";
		
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'location' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteReference($identifier)
{
	//Deleting from reference
	$sql = "DELETE FROM reference WHERE locator = '$identifier'";
		
    $sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'reference' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';
}

function deleteRest($group, $identifier)
{
	if (is_numeric($identifier))
	{	$record_id = $identifier;	}
	else
	{
		$record_id = getEntityID($group, $identifier);
		if ($record_id == 'ERROR')
		{	return 'ERROR';		}
	}
		
	//Deleting Evidences
	$sql = "DELETE FROM evidence WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'evidence' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	
	//Deleting External Links
	$sql = "DELETE FROM external_links WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'external_links' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}

	//Deleting Synonyms
	$sql = "DELETE FROM allnames WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}' AND UPPER(is_primary) = 'N'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'allnames' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	
	//Deleting Primary Name - Delete Last!
	$sql = "DELETE FROM allnames WHERE record_id = '$record_id' AND kw_table_id = '{$_SESSION['TableID'][$group]}' AND UPPER(is_primary) = 'Y'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'allnames' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}	
	return 'PROCESSED';
}

function deleteMrna($identifier)
{
	if (is_numeric($identifier))
	{	$mrna_id = $identifier;	}
	else
	{
		$mrna_id = getEntityID('MRNA', $identifier);
		if ($mrna_id == 'ERROR')
		{	return 'ERROR';		}
	}
		
	$sql = "DELETE FROM mrna WHERE mrna_id = '$mrna_id'";
    //print $sql;
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'mrna' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	
	$status = deleteRest('MRNA', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	return 'PROCESSED';	
}

function deleteProtein($identifier)
{
	//Deleting from protein
	if (is_numeric($identifier))
	{	$protein_id = $identifier;	}
	else
	{
		$protein_id = getEntityID('PROTEIN', $identifier);
		if ($protein_id == 'ERROR')
		{	return 'ERROR';		}
	}
	
	$sql = "SELECT mrna_id FROM mrna WHERE protein_id = $protein_id";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error getting mrna from 'mrna' table for protein '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	while ($row = $sth->fetchRow())
	{	
		$mrna_id = $row[0];
		
		$status = deleteMrna($mrna_id);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
	}
	
	$status = deleteProteinEC($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	$status = deleteProteinState($identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
    $sql = "DELETE FROM protein WHERE protein_id = '$protein_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'PROTEIN' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('PROTEIN', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	return 'PROCESSED';
}

function deleteProteinEC($identifier, $EC = "")
{
	if (is_numeric($identifier))
	{	$protein_id = $identifier;	}
	else
	{
		$protein_id = getEntityID('PROTEIN', $identifier);
		if ($protein_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Deleting from protein_ec
	if ($EC)
	{	
		$sql = "SELECT ec_id FROM EC WHERE ec = '$EC'";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error getting EC from 'ec' table for '$EC'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}
		if ($sth->numRows() > 0)
		{	
			$row = $sth->fetchRow();
			$ec_id = $row[0];	
		}
	}
    
	$sql = "DELETE FROM protein_ec WHERE protein_id = '$protein_id'";
    if ($ec_id)
    {
	    $sql .= " AND ec_id = '$ec_id'";
    }
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'protein_ec' table for protein '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';	
}

function deleteProteinState($identifier, $state = "")
{
	if (is_numeric($identifier))
	{	$protein_id = $identifier;	}
	else
	{
		$protein_id = getEntityID('PROTEIN', $identifier);
		if ($protein_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Deleting from protein_state
	if ($state)
	{	
		$sql = "SELECT \"state_id\" FROM \"state\" WHERE \"type\" = '$state'";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error getting state_id from 'state' table for '$state'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}
		if ($sth->numRows() > 0)
		{	
			$row = $sth->fetchRow();
			$state_id = $row[0];	
		}
	}
    
	$sql = "SELECT protein_state_id FROM protein_state WHERE protein_id = '$protein_id'";
    if ($state_id)
    {
	    $sql .= " AND state_id = '$state_id'";
    }
	$sthA = $_SESSION['dbhBNet']->query($sql);
	if (DB::isError($sthA)) 
	{	
		$_SESSION['errMsgs'][] = "Error getting from 'protein_state' table for protein '$identifier'. (" . $sthA->getMessage() . ")"; 	
		return 'ERROR';
	}
	while ($row = $sthA->fetchRow())
	{
		$protein_state_id = $row[0];
		$status = deleteProteinStateLocation($protein_state_id);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
		
		$status = deleteRest('PROTEIN_STATE', $protein_state_id);
		if ($status == 'ERROR')
		{	return 'ERROR';		}
		
		$sql = "DELETE FROM protein_state WHERE protein_state_id = '$protein_state_id'";
	   	$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error deleting from 'protein_state' table for protein_state_id  '$protein_state_id'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}
	}
	return 'PROCESSED';	
}

function deleteProteinStateLocation($identifier, $location = "")
{
	if (is_numeric($identifier))
	{	$protein_state_id = $identifier;	}
	else
	{
		$protein_state_id = getEntityID('PROTEIN_STATE', $identifier);
		if ($protein_id == 'ERROR')
		{	return 'ERROR';		}
	}
	//Deleting from protein_state_location
	if ($location)
	{	
		$sql = "SELECT location_id FROM location WHERE location_name = '$location'";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error getting location_name from 'location' table for '$location'. (" . $sth->getMessage() . ")"; 	
			return 'ERROR';
		}
		if ($sth->numRows() > 0)
		{	
			$row = $sth->fetchRow();
			$location_id = $row[0];	
		}
	}
    
	$sql = "DELETE FROM protein_state_location WHERE protein_state_id = '$protein_state_id'";
    if ($location_id)
    {
	    $sql .= " AND location_id = '$location_id'";
    }
    
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'protein_state_location' table for protein_state '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';	
}

function deleteSpecieCompound($identifier, $SpName = "")
{
	if (is_numeric($identifier))
	{	$cpd_id = $identifier;	}
	else
	{
		$cpd_id = getEntityID('COMPOUND', $identifier);
		if ($cpd_id == 'ERROR')
		{	return 'ERROR';		}
	}
	
	//Deleting from specie_compound
	if ($SpName)
	{	
		$specie_id = getEntityID('SPECIES', $SpName);	
		if ($specie_id == 'ERROR')
		{	return 'ERROR';		}
	}

    $sql = "DELETE FROM specie_compound WHERE cpd_id = '$cpd_id'";
    if ($specie_id)
    {
	    $sql .= " AND specie_id = '$specie_id'";
    }
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'specie_compound' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	return 'PROCESSED';	
}

function deleteSpecies($identifier)
{
	if (is_numeric($identifier))
	{	$specie_id = $identifier;	}
	else
	{
		$specie_id = getEntityID('SPECIES', $identifier);
		if ($specie_id == 'ERROR')
		{	return 'ERROR';		}
	}

	//Delete the compound
	$sql = "DELETE FROM species WHERE specie_id = '$specie_id'";
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error deleting from 'Species' table for '$identifier'. (" . $sth->getMessage() . ")"; 	
		return 'ERROR';
	}
	$status = deleteRest('SPECIES', $identifier);
	if ($status == 'ERROR')
	{	return 'ERROR';		}
	
	return 'PROCESSED';
}
?>