<?php
/**
* This script is a Front-End for deleting calculated Mean and
* standard deviation for data in DOME.
* Date: 10 July 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");

$currPageName = 'DELETE_STATISTICAL_SUMMARY';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
$title = "Delete Statisctical Summary";

include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>

<?php

if ('Delete' == $_REQUEST['submit'] OR 'Continue' == $_REQUEST['submit'] )
{	processForm($_SESSION[$currPageNameUpper]['force_delete']);	}
elseif ($_REQUEST['submit'] == 'Cancel')
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}
else
{	$_SESSION[$currPageNameUpper]['force_delete'] = 0;	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
	
fillForm($_SESSION[$currPageNameUpper]['force_delete']);
include_once("footer.php");
?>

<?php
//Functions
function fillForm($force_delete = 0)
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	if ($force_delete)
	{
		print "\n<div class=\"controlBar\">";
		print "\n<input type=\"submit\" name=\"submit\" value=\"Cancel\" /> ";
		print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";
		print "\n</div>";
	}
	else
	{
		print '<p class="help-tips"></p>';
		printMetaDataSelections("", $_SESSION[$currPageNameUpper], false);
		
		//Print Normalization Method
		$sql = "SELECT \"protocol_type_id\", \"protocol_type_name\" FROM \"protocol_type\" pt, \"technique\" t 
				WHERE UPPER(pt.\"method\") = 'STATISTICAL' 
				AND pt.\"technique_id\" = t.\"technique_id\"
				ORDER BY UPPER(\"protocol_type_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Protocol Type. " . $sth->getMessage());	return;	}
		print "\n<p><label>Normalization Method: </label>";
		print "<select name=\"protocol_type_id\">";
		
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['protocol_type_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		printExtractMethod();
		
		print "<input type=\"submit\" name=\"submit\" value=\"Delete\" />";
		print "\n<p><a href=\"deleteDataMenu.php\"><- Back to Delete Data Menu</a></p>";
	}
	print "\n</form>";

}


/**============================
* Request Functions
*============================*/
function processForm($force_delete = 0)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	if (!$force_delete)
	{
		$_SESSION[$currPageNameUpper]['experiment_set_id'] = $_REQUEST['experiment_set_id'];
		$_SESSION[$currPageNameUpper]['exp_name'] = $_REQUEST['exp_name'];
		$_SESSION[$currPageNameUpper]['sampling_point_label_id'] = $_REQUEST['sampling_point_label_id'];
		$_SESSION[$currPageNameUpper]['tissue_type_label_id'] = $_REQUEST['tissue_type_label_id'];
		$_SESSION[$currPageNameUpper]['protocol_type_id'] = $_REQUEST['protocol_type_id'];
		$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
			
		
		if (!$_SESSION[$currPageNameUpper]['experiment_set_id'])
		{	$errMsgs[] = "Please Select an Experiment Set.";	}
		
		if (!$_SESSION[$currPageNameUpper]['exp_name'])
		{	$errMsgs[] = "Please Select an Experiment.";	}
		
		if (!$_SESSION[$currPageNameUpper]['sampling_point_label_id'])
		{	$errMsgs[] = "Please Select a Sampling Point";	}
		
		if (!$_SESSION[$currPageNameUpper]['tissue_type_label_id'])
		{	$errMsgs[] = "Please Select a Tissue Type";	}
		
		if (!$_SESSION[$currPageNameUpper]['protocol_type_id'])
		{	$errMsgs[] = "Please Select a Normalization Method.";	}
		
		if (!$_SESSION[$currPageNameUpper]['extract_id'])
		{	$errMsgs[] = "Please Select an Extraction Method.";	}
		
		if ($errMsgs)
		{	return 0;	}
		
		//Find Sampling Point ID
		$sql = 	"SELECT sp.\"sampling_point_id\" FROM 
			\"sampling_point\" sp, \"experiment\" e
			WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper]['experiment_set_id']}'
			AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper]['exp_name']}'
			AND sp.\"experiment_id\" = e.\"experiment_id\"
			AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper]['sampling_point_label_id']}'";
				
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error retrieving sampling_point_id. " . $sth->getMessage();	return 0;	}
		
		if ($sth->numrows() > 0)
		{
			$row = $sth->fetchRow();
			$_SESSION[$currPageNameUpper]['sampling_point_id'] = $row[0];
		}
		else
		{	$errMsgs[] = "Sampling Point not found in the database for the selections.";	}
		
		
		if ($errMsgs)
		{	return 0;	}
	}
		
	
	$perlScriptFile = "deleteDataFromSpSummary.pl";

	
	$sampling_point_id = $_SESSION[$currPageNameUpper]['sampling_point_id'];
	$protocol_type_id = $_SESSION[$currPageNameUpper]['protocol_type_id'];
	$tissue_type_label_id = $_SESSION[$currPageNameUpper]['tissue_type_label_id'];
	$extract_id = $_SESSION[$currPageNameUpper]['extract_id'];
	$force_delete = $_SESSION[$currPageNameUpper]['force_delete'];

	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile $sampling_point_id $tissue_type_label_id $extract_id $protocol_type_id $force_delete 2>&1;";
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
	  	$_SESSION[$currPageNameUpper]['force_delete'] = 0;
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
	}
	elseif ($retValue == 99)	//data exists
	{
		$_SESSION[$currPageNameUpper]['force_delete'] = 1;
		$_SESSION['Message'][] = $msg;
	}
	else
	{	
		$_SESSION[$currPageNameUpper]['force_delete'] = 0;
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn Value = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}

	return 1;
}

?>
