<?php
/**
* This script gets the parameters for the Biplot
* Algorithm and passes it ometer software written by Pedro.
* Date: 20 Nov 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
?>

<?php
$title = "DOME : Biplot Parameters";
include("header.php");
$currPageNameUpper = strtoupper($currPageName);
?>


<?php
if ($errMsgs)
{	
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
print printPageSelections();
$self = $_SERVER[PHP_SELF];
print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";

if (isset($_SESSION[$currPageNameUpper]['alpha']))
{	$defaultAlpha = $_SESSION[$currPageNameUpper]['alpha'];	}
else
{	$defaultAlpha = 0.5;	}

if (!isset($_SESSION[$currPageNameUpper]['matrixType']))
{	$_SESSION[$currPageNameUpper]['matrixType'] = 'Covariance';	}

print "<p><label>Alpha: </label><input type=\"text\" size=\"4\" name=\"alpha\" value=\"$defaultAlpha\" /></p>";

print "<p><fieldset><legend><b>&nbsp;&nbsp;Use&nbsp;&nbsp;</b></legend>";
print "<input type=\"radio\" name=\"matrixType\" value=\"Covariance\"";
if ('Covariance' == $_SESSION[$currPageNameUpper]['matrixType'])
{	print " \"checked\"";	}
print "> Covariance Matrix<br />";
print "<p><input type=\"radio\" name=\"matrixType\" value=\"Correllation\"";
if ('Correllation' == $_SESSION[$currPageNameUpper]['matrixType'])
{	print " \"checked\"";	}
print "> Correllation Matrix<br />";
print "</fieldset></p>";


printControlBar($_SESSION['STEP_NUMBER'], 1);
print "\n</form>";

include ("footer.php");
?>


<?php
function processForm($currPageName = "")
{
	global $errMsgs;
	$currPageNameUpper = strtoupper($currPageName);
	
	$_SESSION[$currPageNameUpper]['alpha'] = $_REQUEST['alpha'];
	$_SESSION[$currPageNameUpper]['matrixType'] = $_REQUEST['matrixType'];
			
	//Validations
	if (!($_SESSION[$currPageNameUpper]['alpha'] >= 0 && $_SESSION[$currPageNameUpper]['alpha'] <= 1))
	{	$errMsgs[] = "'Alpha' should be greater than or equal to 0 and less than or equal to 1.";	}
	
	if ($errMsgs)
	{	return 0;	}
		
	  	
	$sid = session_id();
	$dataFile = "{$_SESSION['BROWSER_TMP_FULL']}$sid.dat";
	$executableFile = "{$_SESSION['OMETER_DIR']}ometer";
	$outputFileNameBase = "{$_SESSION['BROWSER_TMP_RELATIVE']}$sid";
	$biplotPlotFile = $outputFileNameBase . '-pca-biplot.plt';
	if (file_exists($outputFile))
  	{	unlink ($outputFile);	}
	
	$com = "export PATH; PATH=\$PATH:{$_SESSION['OMETER_DIR']}; $executableFile -o $outputFileNameBase --m=pca --biplot-dim=2 --biplot-alpha={$_SESSION[$currPageNameUpper]['alpha']}";
	if ('Covariance' == $_SESSION[$currPageNameUpper]['matrixType'])
	{	$com .= " --samples-center";	}
	else
	{	$com .= " --samples-z";	}
	$com .= " $dataFile 2>&1";
	
	$retString = exec($com, $retLines);
	//$retString = exec("ls -al", $retLines);
	if (!file_exists($biplotPlotFile))
  	{	
	  	if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	
		  	$msg = "ometer output file not found. Command was \"$com\"<br />
	  		Return: <br />
	  		(RetValue = $retValue)";	
	  	}

	  	$errMsgs[] = $msg;
	}
  	
	if ($errMsgs)
	{	return 0;	}
	else
  	{  	return 1;	}
}
?>
