<?php
/**
* This script plots the results using the GNUPlot program
* for DOME.
* Date: 24 Feb 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);

?>

<?php
$currPageNameUpper = strtoupper($currPageName);  
  if (!isset($_SESSION[$currPageNameUpper]['PLOT_TITLE']))
  {
    printError("Plot Titles Session Variable not set");
    include ("footer.php");
    exit();
  }
  
  //Save Request variables
  $_SESSION['ToRemember'][$currPageNameUpper]['data_style'] = $_REQUEST['data_style'];
  $_SESSION['ToRemember'][$currPageNameUpper]['gridOn'] = $_REQUEST['gridOn'];
  if (!isset($_SESSION['ToRemember'][$currPageNameUpper]['data_style']))
  {	
	if ($_SESSION['IS_REPLICATE_TRACK'])
	{  $_SESSION['ToRemember'][$currPageNameUpper]['data_style'] = 'points';	}
	else
	{  $_SESSION['ToRemember'][$currPageNameUpper]['data_style'] = 'linespoints';	}
  }
  
  
  $plotTitles = split(':', $_SESSION[$currPageNameUpper]['PLOT_TITLE']);
  if ($_SESSION['IS_REPLICATE_TRACK'])
  {
	  $plotField = "Intensity";
	  $annotations = &$_SESSION[$searchGeneKey]['ANNOTATIONS'];
  }
  else
  {
	  $annotations = &$_SESSION[$searchGeneKey]['ANNOTATIONS'];
	  if (!isset($_SESSION[$searchGeneKey]['FIELDS'][0]))
	  {
	    printError("Plot Field Session Variable not set");
	    include ("footer.php");
	    exit();
	  }
	  $plotField = $fields[$_SESSION[$searchGeneKey]['FIELDS'][0]];
  }
  
  $title = "DOME : Plot - $plotField vs $plotTitles[0]";
  include("header.php");
?>

<?php
  $sid = session_id();
  $plotFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.plt";
  $outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.png";
  $dataFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}.dat";

  if (!$plotFileHandle = fopen($plotFile, 'w'))
  {
         echo "Cannot open file ($plotFile)";
         return;
  }
 	getPageSelections($selectionsHash);
	if (!$_SESSION['IS_REPLICATE_TRACK'])
	{	
		unset($selectionsHash['Fields']);
		$selectionsHash['Field'] = $fields[$_SESSION[$searchGeneKey]['FIELDS'][0]];	
	}
	print printPageSelections($selectionsHash);
	
	$action = $_SERVER[PHP_SELF];
	echo "<form name=\"init_form\" method=\"post\" action=\"$action\" >\n";
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	
	
  $contents = "set title \"$plotField vs $plotTitles[0] Plot\"
	set key below left left reverse
    set xlabel \"{$plotTitles[0]}\"
    set ylabel \"{$plotField}\"\n";
    if (!$_SESSION['ToRemember'][$currPageNameUpper]['gridOn'])
    {	$contents .= 'un';	}
    $contents .= "set grid
    set data style {$_SESSION['ToRemember'][$currPageNameUpper]['data_style']}
    set terminal png
    set output \"{$outputFile}\"";
  $firstPlot = 1;
  $contents .= "\n\t\tplot";
  $legendTable = "<table><tr><th>Sr. No.</th><th>Legend</th>";
  if ($annotations)
  {	$legendTable .= "<th>Annotation</th>";	}
  $legendTable .= "</tr>\n";
  
  $cl = "dark-row";
  
  $std_dev_field = false;
  //Check if second field selected is std_dev
  if (!$_SESSION['IS_REPLICATE_TRACK'])
  {	
  	$process_field = $_SESSION[$searchGeneKey]['FIELDS'][0];
  	$std_dev_field = false;
	if ('mean' == $process_field OR 'mean_l' == $process_field OR 'median' == $process_field OR 'median_l' == $process_field)
	{	$std_dev_field = $_SESSION[$searchGeneKey]['FIELDS'][1];	}
		
	if (('mean' == $process_field OR 'median' == $process_field) AND 'std_dev' != $std_dev_field)
	{	$std_dev_field = false;	}
	elseif (('mean_l' == $process_field OR 'median_l' == $process_field) AND 'std_dev_l' != $std_dev_field)
	{	$std_dev_field = false;	}
	
	if (count($_SESSION[$searchGeneKey]['FIELDS']) > 1 AND !$std_dev_field)
	{	printMessage("Please note that you have selected more than one fields on the previous page. Below is a plot for '{$fields[$_SESSION[$searchGeneKey]['FIELDS'][0]]}'");	}
	
  }
  for ($i = 1; $i < count($plotTitles); $i++)
  {
    if ($cl == "dark-row")
    {	$cl = "light-row";	}
    else
    {	$cl = "dark-row";	}
    
    if ($std_dev_field)
    {
	    $col = 2*$i;
	    $std_dev_col = 2*$i + 1;
	}
    else
    {	$col = $i + 1;	}
    if (!$firstPlot)
    { $contents .= ", \\\n\t\t";  }
    $contents .= " \"$dataFile\" using 1:$col title '$i'";
    if ($std_dev_field)
    {	$contents .= ", \\\n\t\t\t \"$dataFile\" using 1:$col:$std_dev_col notitle with errorbars";	}
    
    $firstPlot = 0;
    $legendTable .= "<tr class=\"$cl\"><td>$i</td><td>{$plotTitles[$i]}</td>";
    
    if ($annotations)
    {
	    $identifiers = explode('_', $plotTitles[$i]);
	    $legendTable .= "<td>{$annotations[$identifiers[0]]}</td>";
    }
	    
    $legendTable .= "</tr>\n";
  }
	$legendTable .= "</table>";


  // Write $contents to our opened file.
  if (!fwrite($plotFileHandle, $contents))
  {
    printError("Cannot write to file ($plotFile)");
    return;
  }

  fclose($plotFileHandle);
  $com = "{$_SESSION['GNUPLOT_DIR']}gnuplot {$plotFile} 2>&1";
  exec($com, $retLines, $retValue);
  
  
  if (!$retValue)
  {
    //To prevent Browser from not caching Images.
    $junk = md5(time());
    print "<div class=\"plot-image\"> <img border=\"2\" src=\"{$outputFile}?<?=$junk?>\"></div>";
    fillOptions();
    print $legendTable;
    system("rm -f $plotFile");
  }
  else
  {
	  if ($retLines)
	  {
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  }
	  else
	  {	$msg = "GNUPlot command Failed. Command was $com <br />";	}
	  
	  printError ($msg);  
  }

  printControlBar($_SESSION['STEP_NUMBER'], 0);
  print "\n</form>";
  include ("footer.php");
?>

<?php
function fillOptions()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
	print "<p><table><tr><td>";
	
	//print Data Style Fieldset
	print '<fieldset width="20"><legend>&nbsp;&nbsp;Data Style&nbsp;&nbsp;</legend>';
	$data_styles = array('points'=>'Symbols', 'dots'=>'Dots', 'lines'=>'Lines', 'linespoints'=>'Lines And Symbols');
	foreach ($data_styles as $value=>$data_style)
	{	
		print "<input type=\"radio\" name=\"data_style\" value=\"$value\"";
		if ($value == $_SESSION['ToRemember'][$currPageNameUpper]['data_style'])
		{	print " checked";		}
		print ">$data_style<br />";
	}
	print '</fieldset>';
	
	print '</td><td>';
	
	//print Plot Style fieldset
	print '<fieldset width="20"><legend>&nbsp;&nbsp;Data Style&nbsp;&nbsp;</legend>';
	print "\n<p><input type=\"checkbox\" name=\"gridOn\"";
	if ($_SESSION['ToRemember'][$currPageNameUpper]['gridOn'])
	{	print " checked";	}
	print ">Grid<br /></p>\n";
	print '</fieldset>';
	
	print '</td><td>';
	
	//print submit button
	print '<p><input type="submit" name="submit" value="Update Plot"></p>';
	print "</td></tr>\n</table></p>";
}
?>
