<?php
/**
* This script gets the parameters for the K-Means Clustering
* Algorithm and passes it to the perl script running 'R'.
* Date: 28 May 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
?>

<?php
	$title = "DOME : K-Means Clustering Parameters";
	include("header.php");
?>
  


<?php
if ($errMsgs)
{	
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

print printPageSelections();
$self = $_SERVER[PHP_SELF];
print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";

//Set Default no of clusters to quarter of total number of lines in .dat file supplied.
$totLinesInDatFile = $_SESSION[$searchGeneKey]['totLinesInDatFile']; 
if ($totLinesInDatFile)
{	$defaultClusters = ceil($totLinesInDatFile / 4);	}
else
{	$defaultClusters = 10;	}

print "<p><label>Number of Clusters: </label><input type=\"text\" size=\"3\" name=\"NoOfClusters\" value=\"$defaultClusters\" /></p>";
print "<p><label>Maximum Iterations: </label><input type=\"text\" size=\"5\" name=\"maxIterations\" value=\"10000\" /></p>";
print "<p><label>Title: </label><input type=\"text\" size=\"100\" name=\"title\" value=\"K-Means Clustering run on ";
print "{$_SERVER['HTTP_HOST']} - ";
print date("r");
print "\" /></p>";
print "<p><label>Plots per line: </label><input type=\"text\" size=\"1\" name=\"plotsPerLine\" value=\"3\" /></p>";

printControlBar($_SESSION['STEP_NUMBER'], 1);
print "\n</form>";

include ("footer.php");
?>


<?php
function processForm($currPageName = "")
{
	global $errMsgs, $techniqueKey, $searchGeneKey;
	$currPageNameUpper = strtoupper($currPageName);
	$_SESSION[$currPageNameUpper]['NoOfClusters'] = floor($_REQUEST['NoOfClusters']);
	$_SESSION[$currPageNameUpper]['maxIterations'] = floor($_REQUEST['maxIterations']);
	$_SESSION[$currPageNameUpper]['title'] = $_REQUEST['title'];
	$_SESSION[$currPageNameUpper]['plotsPerLine'] = floor($_REQUEST['plotsPerLine']);
	
	//Validations
	$totLinesInDatFile = $_SESSION[$searchGeneKey]['totLinesInDatFile']; 
	if (!($_SESSION[$currPageNameUpper]['NoOfClusters'] > 1 && $_SESSION[$currPageNameUpper]['NoOfClusters'] < $totLinesInDatFile))
	{	
		if ($totLinesInDatFile == 1)
		{	$errMsgs[] = "You have just 1 entity. KMeans cannot be performed for only 1 cluster.";	}
		elseif ($totLinesInDatFile > 0)
		{	$errMsgs[] = "Number of Clusters should be greater than 1 and less than $totLinesInDatFile";	}
	}
	if (!($_SESSION[$currPageNameUpper]['maxIterations'] > 0))
	{	$errMsgs[] = "Maximum Number of Iterations should be greater than 0";	}
	if (!($_SESSION[$currPageNameUpper]['plotsPerLine'] > 0))
	{	$errMsgs[] = "Plots per line should be greater than 0";	}
	
	if ($errMsgs)
	{	return 0;	}
		
	$sid = session_id();
	$dataFile = "{$_SESSION['BROWSER_TMP_FULL']}$sid.dat";
	
	//$perlScriptFile = "kmeansByStatisticsR.pl";
	$perlScriptFile = "kmeansByRSPerl.pl";
	$outputFileNameBase = $sid;
	
	//$com = "export PATH; PATH=\$PATH:{$_SESSION['R_DIR']}; export R_HOME; R_HOME={$_SESSION['R_HOME']}; {$_SESSION['PERL_DIR']}perl $perlScriptFile \"$dataFile\" \"{$_SESSION['BROWSER_TMP_FULL']}\" \"$outputFileNameBase\" {$_SESSION[$currPageNameUpper]['maxIterations']} {$_SESSION[$currPageNameUpper]['NoOfClusters']} 2>&1;";
	$com = "export PATH; PATH=\$PATH:{$_SESSION['R_DIR']}; export R_HOME; R_HOME={$_SESSION['R_HOME']}; export LD_LIBRARY_PATH; LD_LIBRARY_PATH={$_SESSION['RSPERL_DIR']}libs:{$_SESSION['R_HOME']}/lib; export PERL5LIB; PERL5LIB={$_SESSION['PERL5LIB']}; {$_SESSION['PERL_DIR']}perl $perlScriptFile \"$dataFile\" \"{$_SESSION['BROWSER_TMP_FULL']}\" \"$outputFileNameBase\" {$_SESSION[$currPageNameUpper]['maxIterations']} {$_SESSION[$currPageNameUpper]['NoOfClusters']} 2>&1;";
	
	//print $com;
		
	$retString = exec($com, $retLines, $retValue);
	
	if ($retValue)
  	{	
	  	if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	$msg = "KMeansClustering system command Failed. Command was \"$com\"\nReturn: $retString RetValue = $retValue";	}
	  	
	  	$errMsgs[] = $msg;
	}
  	
	if ($errMsgs)
	{	
		return 0;
	}
	else
  	{
	  	$_SESSION['KMeansTitle'] = $title;
	  	return 1;	  	
  	}
}
?>
