<?php

/**

* This script is used to supply data file and call Brome.

* for DOME.

* Date: 15 Dec 2004

* @author Aejaaz Kamal <aekamal@vt.edu>

* Reversion:

* X. Jing Li, 4/6/2007: change the sql queries to get data from pathway_info,

*   map_component instead of map_component only.

*/



include_once("common.php");

include_once("searchGeneFunctions.php");

include_once("workFlow.php");



//Parse Get or Post step number and set the current step number.

setStepNumber();



//Sets Environment Variable

setVariables($_SESSION['STEP_NUMBER']);

doControlBarRedirection(1);



$title = "DOME : Select Map";

include("header.php");

?>





<?php

if ($errMsgs)

{	

	foreach ($errMsgs as $msg)

	{	printError($msg);	}

}



$action = $_SERVER[PHP_SELF];

echo "<form name=\"init_form\" method=\"post\" action=\"$action\" >\n";



fillForm();

 

printControlBar($_SESSION['STEP_NUMBER']);

print "\n</form>";



include ("footer.php");

?>



<?php

//Fill Functions

function fillForm()

{

	setStrings();

	fillMapSelectionBox();

}



function fillMapSelectionBox()

{

	global $rid_str, $cpd_id_str, $currPageName, $searchGeneKey, $techniqueKey;

	$currPageNameUpper = strtoupper($currPageName);

	

	print printPageSelections('', true, true);

	

/*	$sql = "SELECT DISTINCT m.map_id, m.map_name, UPPER(m.map_name) 

		FROM map m, map_type mt, map_component mc

		WHERE m.map_type_id = mt.map_type_id AND mc.map_id = m.map_id 

		AND (mc.kw_table_id = {$_SESSION['TableID']['COMPOUND']} OR mc.specie_id = {$_SESSION['CurrentSpecieID']})

		AND mt.map_type_name = '"

		. substr($_SESSION[$searchGeneKey]['analysis'] , 6) . "'";

	

	$sql .= " AND (";

			

	$firstORDone = false;

	$technique_types =  array_keys($_SESSION[$techniqueKey]['DATA']);

	foreach ($technique_types as $technique_type)

	{

		//==Hard Coding Here

		switch (strtoupper($technique_type))

		{

			case 'MRNA':

			$RecordIDs = $rid_str;

			$TableID = $_SESSION['TableID']['REPORTER'];

			break;

			

			case 'METABOLITE':

			$RecordIDs = $cpd_id_str;

			$TableID = $_SESSION['TableID']['COMPOUND'];

			break;

			

		}

		if ($firstORDone)

		{	$sql .= " OR";	}

		$firstORDone = true;

		

		$sql .= " (mc.kw_table_id = '$TableID'";

		if ($RecordIDs)

		{	$sql .= " AND mc.record_id IN ($RecordIDs)"; 	}

		$sql .= ")";

	}

	

	$sql .= ") ORDER BY UPPER(m.map_name)";

*/



  $sql = "SELECT DISTINCT m.\"map_id\", m.\"map_name\", UPPER(m.\"map_name\") 

		FROM \"map\" m, \"map_type\" mt, \"map_component\" mc, \"pathway_info\" pi

		WHERE m.\"map_type_id\" = mt.\"map_type_id\" AND mc.\"map_id\" = m.\"map_id\"

    AND  pi.\"kw_table_id\" = {$_SESSION['TableID']['COMPOUND']}

		AND mt.\"map_type_name\" = '"

		. substr($_SESSION[$searchGeneKey]['analysis'] , 6) . "'

    AND mc.\"map_component_id\" = pi.\"map_component_id\"";

	

	$sql .= " AND (";

			

	$firstORDone = false;

	$technique_types =  array_keys($_SESSION[$techniqueKey]['DATA']);

	foreach ($technique_types as $technique_type)

	{

		//==Hard Coding Here

		switch (strtoupper($technique_type))

		{

			case 'MRNA':

			$RecordIDs = $rid_str;

			$TableID = $_SESSION['TableID']['REPORTER'];

			break;

			

			case 'METABOLITE':

			$RecordIDs = $cpd_id_str;

			$TableID = $_SESSION['TableID']['COMPOUND'];

			break;

			

		}

		if ($firstORDone)

		{	$sql .= " OR";	}

		$firstORDone = true;

		

		$sql .= " (pi.kw_table_id = '$TableID'";

		if ($RecordIDs)

		{	$sql .= " AND pi.record_id IN ($RecordIDs)"; 	}

		$sql .= ")";

	}

	

	$sql .= ") ORDER BY UPPER(m.map_name)";



	//print $sql;

	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 

	{	printError("Error retrieving Maps. " . $sth->getMessage());	return 0;	}

	if ($sth->numRows() > 0)

	{

		print "<p><label>Maps: </label>";

		print "<select name=\"map_id\" size=\"10\">";

		while ($row = $sth->fetchRow()) 

		{

			print "\n\t<option value=\"$row[0]\"";

			if (isset($_SESSION[$currPageNameUpper]['map_id']))

			{

				if ($_SESSION[$currPageNameUpper]['map_id'] == $row[0])

				{	print " selected";	}

			}

			else

			{ 

				$_SESSION[$currPageNameUpper]['map_id'] = $row[0];

				print " selected";

			}

			print ">$row[1]</option>";

		}

		print "\n</select></p>";

	}

	else

	{

		printMessage("No maps found for your selections.");

		return 0;

	}

	return 1;

}



//Process Functions



function setMapStrings($map_id)

{

	global $map_rid_str, $map_cpd_id_str;

/*	$sql = "SELECT mc.kw_table_id, mc.record_id FROM map_component mc

		WHERE mc.map_id = '$map_id' 

		AND (mc.kw_table_id = {$_SESSION['TableID']['COMPOUND']} OR mc.specie_id = {$_SESSION['CurrentSpecieID']})

		ORDER BY mc.kw_table_id";

*/

	$sql = "SELECT pi.\"kw_table_id\", pi.\"record_id\" FROM \"map_component\" mc, \"pathway_info\" pi

		WHERE mc.\"map_id\" = '$map_id' 

    AND pi.\"map_component_id\" = mc.\"map_component_id\"

		ORDER BY pi.\"kw_table_id\"";



	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 

	{	$errMsgs[] = "Error retrieving Map components. " . $sth->getMessage();	return 0;}

	

	$firstRid = 1;	$firstCpdID = 1;

	$map_rid_str = ""; $map_cpd_id_str = "";

	while ($row = $sth->fetchRow())

	{

		switch ($row[0])

		{

		case $_SESSION['TableID']['REPORTER']:

			if ($firstRid)

			{	

				$map_rid_str = $row[1];

				$firstRid = 0;

			}

			else

			{	$map_rid_str .= ", $row[1]";	}

	  		break;

	  		

	  	case $_SESSION['TableID']['COMPOUND']:

			if ($firstCpdID)

			{	

				$map_cpd_id_str = $row[1];

				$firstCpdID = 0;

			}

			else

			{	$map_cpd_id_str .= ", $row[1]";	}

			break;

  		}

	}

	return 1;

}



function output_tab_delimited_for_brome($map_id)

{

	global $currPageName, $searchGeneKey;

	$currPageNameUpper = strtoupper($currPageName);

	

	$master_array = $_SESSION[$searchGeneKey]['MASTER_ARRAY'];

	$fieldarray = $_SESSION[$searchGeneKey]['FIELDS'];

	$label_names = $_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['label_names'];

	

	$process_field = $_SESSION[$searchGeneKey]['FIELDS'][0];

	

	$data_str = "Type\tBrome_id\tIdentifier";

	foreach ($label_names as $key => $name) 

	{	$data_str .= "\t$name";	}

	$data_str .= "\n";

	

	$ESNames = array_keys($master_array);

	if (count($ESNames) > 1)

	{	$MultipleCounts['Experiment Set'] = count($ESNames);	}

	$ESName = $ESNames[0];

		

	$ENames = array_keys($master_array[$ESName]);

	if (count($ENames) > 1)

	{	$MultipleCounts['Experiment'] = count($ENames);	}

	$EName = $ENames[0];

	

	//$sql = "SELECT mc.kw_table_id, mc.record_id, mc.brome_id, mc.component_name 

	//	FROM map_component mc WHERE mc.map_id = '$map_id' 

	//	AND (mc.kw_table_id = {$_SESSION['TableID']['COMPOUND']} OR mc.specie_id = {$_SESSION['CurrentSpecieID']})

	//	ORDER BY mc.brome_id";

		

/*	$sqlCompounds = "SELECT mc.\"kw_table_id\", mc.\"record_id\", mc.\"brome_id\", an.\"aname\"

		FROM map_component mc, allnames an 

		WHERE mc.map_id = '$map_id' 

		AND an.\"record_id\" = mc.\"record_id\"

		AND an.\"kw_table_id\" = mc.\"kw_table_id\"

		AND UPPER(an.\"is_primary\") = 'Y'

		AND mc.kw_table_id = {$_SESSION['TableID']['COMPOUND']}";

		

	$sqlGenes = "SELECT mc.\"kw_table_id\", mc.\"record_id\", mc.\"brome_id\", an.\"aname\"

		FROM map_component mc, \"reporter\" r, \"composite_sequence\" cs, \"allnames\" an, \"gene\" g

		WHERE mc.map_id = '$map_id' 

		AND r.\"reporter_id\" = mc.\"record_id\"

		AND r.\"composite_sequence_id\" = cs.\"composite_sequence_id\"

			AND an.\"record_id\" = cs.\"gene_id\"

			AND cs.\"gene_id\" = g.\"gene_id\"";

	if ($_SESSION['CurrentSpecieID'] > 0)

	{	$sqlGenes .= " AND g.\"specie_id\" = {$_SESSION['CurrentSpecieID']}";	}

	$sqlGenes .= " AND an.\"kw_table_id\" = '{$_SESSION['TableID']['GENE']}'

		AND UPPER(an.\"is_primary\") = 'Y'

		AND mc.kw_table_id = {$_SESSION['TableID']['REPORTER']}";

*/

  $sqlCompounds = "SELECT pi.\"kw_table_id\", pi.\"record_id\", mc.\"component_name\", an.\"aname\"

		FROM map_component mc, allnames an, \"pathway_info\" pi 

		WHERE mc.map_id = $map_id

    AND pi.\"map_component_id\" = mc.\"map_component_id\"

		AND an.\"record_id\" = pi.\"record_id\"

		AND an.\"kw_table_id\" = pi.\"kw_table_id\"

		AND UPPER(an.\"is_primary\") = 'Y'

		AND pi.kw_table_id = {$_SESSION['TableID']['COMPOUND']}";



	$sqlGenes = "SELECT pi.\"kw_table_id\", pi.\"record_id\", mc.\"component_name\", an.\"aname\"

		FROM \"map_component\" mc, \"pathway_info\" pi, \"reporter\" r, \"composite_sequence\" cs, \"allnames\" an, \"gene\" g

		WHERE mc.map_id = '$map_id' 

		AND mc.\"map_component_id\" = pi.\"map_component_id\"

    AND r.\"reporter_id\" = pi.\"record_id\"

		AND r.\"composite_sequence_id\" = cs.\"composite_sequence_id\"

    AND cs.\"gene_id\" = g.\"gene_id\"";

  if ($_SESSION['CurrentSpecieID'] > 0) {

    $sqlGenes .= " AND g.\"specie_id\" = {$_SESSION['CurrentSpecieID']}";

  }

  $sqlGenes .=  " AND an.\"record_id\" = cs.\"gene_id\" 

    AND an.kw_table_id = {$_SESSION['TableID']['GENE']}

    AND UPPER(an.\"is_primary\") = 'Y'

    AND pi.kw_table_id = {$_SESSION['TableID']['REPORTER']}";

  		

	$sql = "($sqlCompounds) UNION ($sqlGenes)";

	//print $sql;

		

	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 

	{	$errMsgs[] = "Error retrieving Map components. " . $sth->getMessage();	return; }

	

	while ($row = $sth->fetchRow())

	{

		$identifier = $row[3];

		if (isset($master_array[$ESName][$EName][$identifier]))

		{

			$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

			$secondaryID = $secondaryIDs[0];

		}

		else

		{	continue;	}

		

		if (isset($master_array[$ESName][$EName][$identifier][$secondaryID]))

		{

			$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			if (count($protocol_type_names) > 1)

			{	$MultipleCounts['Protocol Type'] = count($protocol_type_names);	}

			$protocol_type_name = $protocol_type_names[0];

		}

		else

		{	continue;	}

		

		foreach ($secondaryIDs as $secondaryID) 

		{

			if ($row[0] == $_SESSION['TableID']['REPORTER'])

			{	

				$line = "GENE";

				$MapLegend[$row[2]][$secondaryID] = $row[3];

			}

			elseif ($row[0] == $_SESSION['TableID']['COMPOUND'])

			{	$line = "COMPOUND";	}

			$line .= "\t$row[2]\t$row[3]";

			foreach ($label_names as $label_name) 

			{	

				$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name];

				$line .=  "\t$value";

				

				if (!$firstRun[$row[0]])

				{

					$minVal[$row[0]] = $value;

					$maxVal[$row[0]] = $value;

					$firstRun[$row[0]] = true;

				}

				if ($value < $minVal[$row[0]])

				{	$minVal[$row[0]] = $value;	}

				if ($value > $maxVal[$row[0]])

				{	$maxVal[$row[0]] = $value;	}

			}

			$data_str .= "$line\n";	

		}

		

	}

	$_SESSION[$currPageNameUpper]['firstRun'] = $firstRun;

	$_SESSION[$currPageNameUpper]['minVal'] = $minVal;

	$_SESSION[$currPageNameUpper]['maxVal'] = $maxVal;

	

	//Setting table string in the session variable for the legend

	//to the maps.

	if (isset($MapLegend))

	{

		$LegendTable = "\n<table>\n<tr><th>Legend</th></tr>";

		if (count($MultipleCounts))

		{

			$LegendTable .= "\n<tr><th class=\"dark-red\">Note: </th><td class=\"light-red\">Data generated contains multiple";

			$i = 0;

			foreach ($MultipleCounts as $key=>$count)

			{

				$i++;

				if (1 == $i)

				{	$LegendTable .= " {$key}s";	}

				elseif ($i == count($MultipleCounts))

				{	$LegendTable .= " and {$key}s";	}

				else

				{	$LegendTable .= ", {$key}s";	}

			}

			$LegendTable .= ". Maps shown are drawn only for Experiment Set '$ESName', Experiment '$EName'";

			if (isset($MultipleCounts['Protocol Type']))

			{	$LegendTable .= " and first Protocol Type found";	}

			$LegendTable .= '.';

			$LegendTable .= "</td></tr>";

		}

		$cl = "light-row";

		foreach ($MapLegend as $EC=>$TCs)

		{

			$LegendTable .= "\n<tr class=\"$cl\"><td>$EC</td><td>";

			$firstLine = true;

			foreach ($TCs as $secondaryID=>$TC)

			{

				if ($firstLine)

				{	

					$LegendTable .= "$TC";

					if (strlen($secondaryID) AND 'None' != $secondaryID)

					{	$LegendTable .= "_{$secondaryID}";	}

					$firstLine = false;

				}

				else

				{	

					$LegendTable .= "<br />$TC";	

					if (strlen($secondaryID) AND 'None' != $secondaryID)

					{	$LegendTable .= "_{$secondaryID}";	}

				}

			}

			$LegendTable .= "</td></tr>";

			if ($cl == "light-row")

			{	$cl = "dark-row";	}

			else

			{	$cl = "light-row";	}

		}

		$LegendTable .= "\n</table>";

		$_SESSION[$currPageNameUpper]['LegendTable'] = $LegendTable;	

	}

	else

	{	unset($_SESSION[$currPageNameUpper]['LegendTable']);	}

	

	return $data_str;

}





function processForm($currPageName)

{

	global $map_rid_str, $map_cpd_id_str, $errMsgs, $searchGeneKey, $techniqueKey;

	$currPageNameUpper = strtoupper($currPageName);

	$_SESSION[$currPageNameUpper]['map_id'] = $_REQUEST['map_id'];

		

	//Required Here. Strings set here are used by this page.

	setStrings();

	//This will set the global variables $map_rid_str & $map_cpd_id_str.

	$return = setMapStrings($_SESSION[$currPageNameUpper]['map_id']);	

	if (!$return)

	{	return 0;	}

	

	print_all_results(false, $map_rid_str, $map_cpd_id_str);

	if (!isset($_SESSION[$searchGeneKey]['MASTER_ARRAY']))

	{	

		$errMsgs[] = "No data found for drawing maps.";	

		return 0;

	}

	

	$data = output_tab_delimited_for_brome($_SESSION[$currPageNameUpper]['map_id']);

	if (!isset($_SESSION[$currPageNameUpper]['firstRun']))

	{

		$errMsgs[] = "No acceptable data found for drawing maps.";

		return 0;

	}

	$return = writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE']);

	if (!$return)

	{	return 0;	}

	return 1;

}

?>

