<?php
/**
* This script gets the parameters for the NMF
* Algorithm and passes it ometer software written by Pedro.
* Date: 1 Aug 2006
* @author Pedro Mendes and Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
?>

<?php
$title = "DOME : Non-negative Matrix Factorization Parameters";
include("header.php");
$currPageNameUpper = strtoupper($currPageName);
?>


<?php
if ($errMsgs)
{	
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
print printPageSelections();
$self = $_SERVER[PHP_SELF];
print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";

if (!isset($_SESSION[$currPageNameUpper]['noOfFactors']))
{	$_SESSION[$currPageNameUpper]['noOfFactors'] = 2;	}
print "<p><label>Number of Factors: </label><input type=\"text\" size=\"3\" name=\"noOfFactors\" value=\"{$_SESSION[$currPageNameUpper]['noOfFactors']}\" /></p>";


printControlBar($_SESSION['STEP_NUMBER'], 1);
print "\n</form>";

include ("footer.php");
?>


<?php
function processForm($currPageName = "")
{
	global $errMsgs;
	$currPageNameUpper = strtoupper($currPageName);

	if (strlen($_REQUEST['noOfFactors']))
	{	$_SESSION[$currPageNameUpper]['noOfFactors'] = floor($_REQUEST['noOfFactors']);	}
	else
	{	unset($_SESSION[$currPageNameUpper]['noOfFactors']);	}
		
	//Validations
	if (isset($_SESSION[$currPageNameUpper]['noOfFactors']) && $_SESSION[$currPageNameUpper]['noOfFactors'] < 2 )
	{	$errMsgs[] = "'Number of Factors' should be 2 or greater.";	}

	if ($errMsgs)
	{	return 0;	}
		
	$sid = session_id();
	$outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" ."{$sid}-nmf-loadings.dat";
	
	if (file_exists($outputFile))
  	{	unlink ($outputFile);	}
  	
	$dataFile = "{$_SESSION['BROWSER_TMP_FULL']}$sid.dat";
	//$dataFile = "/export/home/xingjing/data/dome/analysis/R/dataForR_kmeans_anova.txt";
	$executableFile = "{$_SESSION['OMETER_DIR']}ometer";
	//$perlScriptFile = "{$_SESSION['DOME_INSTALLATION_DIR_FULL']}kmeansByRSPerl.pl";
	//$perlScriptFile = "kmeansByRSPerl.pl";
	$outputFileNameBase = "{$_SESSION['BROWSER_TMP_RELATIVE']}$sid";
	$com = "export PATH; PATH=\$PATH:{$_SESSION['OMETER_DIR']}; $executableFile -o $outputFileNameBase --m=nmf";
	if ($_SESSION[$currPageNameUpper]['noOfFactors'] > 0)
	{	$com .= " --proj-dimension " . $_SESSION[$currPageNameUpper]['noOfFactors'];	}
	$com .= " --proj-2dplots $dataFile 2>&1";
	
	
	$retString = exec($com, $retLines);
	//$retString = exec("ls -al", $retLines);
	if (!file_exists($outputFile))
  	{	
	  	if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	
		  	$msg = "ometer output file not found. Command was \"$com\"<br />
	  		Return: <br />
	  		(RetValue = $retValue)";	
	  	}

	  	$errMsgs[] = $msg;
	}
  	
	if ($errMsgs)
	{	return 0;	}
	else
  	{  	return 1;	}
}
?>
