<?php
/**
* This script gets the parameters for the PCA
* Algorithm and passes it ometer software written by Pedro.
* Date: 23 Dec 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
?>

<?php
$title = "DOME : PCA Parameters";
include("header.php");
$currPageNameUpper = strtoupper($currPageName);
?>


<?php
if ($errMsgs)
{	
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
print printPageSelections();
$self = $_SERVER[PHP_SELF];
print "<form name=\"init_form\" method=\"post\" action=\"$self\" >\n";

if (!isset($_SESSION[$currPageNameUpper]['minVariance']))
{	$_SESSION[$currPageNameUpper]['minVariance'] = 80;	}

print "<p><label>Minimum Variance Explained: </label><input type=\"text\" size=\"2\" name=\"minVariance\" value=\"{$_SESSION[$currPageNameUpper]['minVariance']}\" /></p>";
print "<p><label>Minimum Number of Components: </label><input type=\"text\" size=\"3\" name=\"minComponents\" value=\"{$_SESSION[$currPageNameUpper]['minComponents']}\" /></p>";

printControlBar($_SESSION['STEP_NUMBER'], 1);
print "\n</form>";

include ("footer.php");
?>


<?php
function processForm($currPageName = "")
{
	global $errMsgs;
	$currPageNameUpper = strtoupper($currPageName);
	if (strlen($_REQUEST['minVariance']))
	{	$_SESSION[$currPageNameUpper]['minVariance'] = floor($_REQUEST['minVariance']);	}
	else
	{	unset($_SESSION[$currPageNameUpper]['minVariance']);	}
	if (strlen($_REQUEST['minComponents']))
	{	$_SESSION[$currPageNameUpper]['minComponents'] = floor($_REQUEST['minComponents']);	}
	else
	{	unset($_SESSION[$currPageNameUpper]['minComponents']);	}
		
	//Validations
	if (isset($_SESSION[$currPageNameUpper]['minVariance']) && !($_SESSION[$currPageNameUpper]['minVariance'] > 0 && $_SESSION[$currPageNameUpper]['minVariance'] <= 100))
	{	$errMsgs[] = "'Minimum Variance' should be greater than 0 and less than or equal to 100.";	}
	if (isset($_SESSION[$currPageNameUpper]['minComponents']) && $_SESSION[$currPageNameUpper]['minComponents'] <= 0 )
	{	$errMsgs[] = "'Minimum number of Components' should be greater than 0.";	}

	if ($errMsgs)
	{	return 0;	}
		
	$sid = session_id();
	$outputFile = "{$_SESSION['BROWSER_TMP_RELATIVE']}" . "{$sid}-pca-proj.dat";
	
	if (file_exists($outputFile))
  	{	unlink ($outputFile);	}
  	
	$dataFile = "{$_SESSION['BROWSER_TMP_FULL']}$sid.dat";
	//$dataFile = "/export/home/xingjing/data/dome/analysis/R/dataForR_kmeans_anova.txt";
	$executableFile = "{$_SESSION['OMETER_DIR']}ometer";
	//$perlScriptFile = "{$_SESSION['DOME_INSTALLATION_DIR_FULL']}kmeansByRSPerl.pl";
	//$perlScriptFile = "kmeansByRSPerl.pl";
	$outputFileNameBase = "{$_SESSION['BROWSER_TMP_RELATIVE']}$sid";
	$com = "export PATH; PATH=\$PATH:{$_SESSION['OMETER_DIR']}; $executableFile -o $outputFileNameBase --m=pca";
	if ($_SESSION[$currPageNameUpper]['minVariance'] > 0)
	{	$com .= " --proj-variance " . $_SESSION[$currPageNameUpper]['minVariance']/100;	}
	if ($_SESSION[$currPageNameUpper]['minComponents'] > 0)
	{	$com .= " --proj-dimension " . $_SESSION[$currPageNameUpper]['minComponents'];	}
	$com .= " --proj-2dplots $dataFile 2>&1";
	
	
	$retString = exec($com, $retLines);
	//$retString = exec("ls -al", $retLines);
	if (!file_exists($outputFile))
  	{	
	  	if ($retLines)
	  	{
		  foreach ($retLines as $retLine)
		  {	$msg .= "$retLine <br />";	}
	  	}
	  	else
	  	{	
		  	$msg = "ometer output file not found. Command was \"$com\"<br />
	  		Return: <br />
	  		(RetValue = $retValue)";	
	  	}

	  	$errMsgs[] = $msg;
	}
  	
	if ($errMsgs)
	{	return 0;	}
	else
  	{  	return 1;	}
}
?>
