<?php

/**
* This script displays the output in HTML table format.
* Date: 14 Dec 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);
?>

<?php
$title = "DOME : Table Output";
include("header.php");
?>

<?php
fillForm();
include ("footer.php");
?>


<?php
//Functions
function fillForm()
{
	global $currPageName, $searchGeneKey;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER['PHP_SELF'];
	echo "<form name=\"init_form\" method=\"post\" action=\"$action\" >\n";
	print printPageSelections();
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	if ($_SESSION[$searchGeneKey]['MASTER_ARRAY'])
	{
		if ($currPageNameUpper == 'SEARCHGENERESULTS')
		{	output_table_format();	}
		elseif ($currPageNameUpper == 'SEARCHGENERESULTS_REPLICATE')
		{	output_table_format_replicate();	}
			
		$totTime = microtime_float() - $_SESSION[$searchGeneKey]['START_TIME'];
		$totTime = number_format($totTime, 2, '.', '');
		print "<br \>Time-taken: $totTime second(s)";		
	}
	else
	{	printMessage("No data found for your selections.");	}
	
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	print "\n</form>";
}

function output_table_format()
{
	global $searchGeneKey;
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$annotations = &$_SESSION[$searchGeneKey]['ANNOTATIONS'];
	
	//headers is a hash with the header name as key and 0 as val.
	//In case there is only one type of value, then instead of a 0 the val is the actual single value.
	//For Example if the field Exp Set contains only one value 'Yeast', than
	//$headers[Exp Set] = "Yeast"
	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0,"Protocol Type"=>0, "Data Type"=>0);
	//Master Array has the following keys:
	//$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$field][$label_name]

	
	//Get counts of each keys
	foreach ($headers as $header=>$val)
	{
		//if there is ONLY one key for a particular header store it in $headers[$header]
		//(else 0 will be stored).
		if (isset($keys[$header]) AND count($keys[$header]) == 1)
		{
			$keysForHeader = array_keys($keys[$header]);
			$headers[$header] = $keys[$header][$keysForHeader[0]];
		}
		$count[$header] = count($keys[$header]);
		//This count array will store the number of Unique keys found for a header.
	}

	foreach ($headers as $header=>$val)
	{
		if ($val)
		{	
			if ($cl == 'light-red')
			{	$cl = 'dark-red';	}
			else
			{	$cl = 'light-red';	}
	
			$OneValueTable .= "\n<tr><th class=\"$cl\">$header</th><td class=\"$cl\">";
			if ('Secondary ID' == $header AND 'None' == $val)
			{		}
			else
			{	$OneValueTable .= $val;	}
			$OneValueTable .= "</td></tr>";
			if ($header == 'Identifier')
			{	
				if ($annotations)	
				{
					if ($cl == 'light-red')
					{	$cl = 'dark-red';	}
					else
					{	$cl = 'light-red';	}
					$OneValueTable .= "\n<tr><th class=\"$cl\">Annotation</th><td class=\"$cl\">$annotations[$val]</td></tr>";
				}
			}
		}
		else
		{	$headerRow .= "<th>$header</th>";	}
		
	}
	
	foreach ($keys['label_names'] as $label_name) 
	{	$headerRow .= "<th>$label_name</th>";	}
	if ($count['Identifier'] > 1 AND $annotations)
	{	$headerRow .= "<th>Annotation</th>";	}
	
	if ($OneValueTable)
	{
		print "<table cellspacing='2'><tr><th>Legend:</th></tr>$OneValueTable</table>";
		print "<br />";
	}
  	
	// This section is for print all data for selected genes or compounds 
	//in a table
  	
	// print the table header
	print "<table cellspacing='2'>";
	print "\n<tr>$headerRow</tr>";
	
  	$row_bgclolr = "light-row";
	$table_block = array();
	
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{    
		if ($es_bgcolor == "light-blue") 
      	{	$es_bgcolor = "dark-blue";	} 
      	else {	$es_bgcolor = "light-blue";	}
      	
      	$ENames = array_keys($master_array[$ESName]);
      	foreach ($ENames as $EName) 
		{    
			if ($e_bgcolor == "light-red") 
	      	{	$e_bgcolor = "dark-red";	} 
      		else {	$e_bgcolor = "light-red";	}
      	
			$identifiers = array_keys($master_array[$ESName][$EName]);
	    	foreach ($identifiers as $identifier) 
	    	{
	      		if ($id_bgcolor == "light-yellow") 
	      		{	$id_bgcolor = "dark-yellow";	} 
	      		else {	$id_bgcolor = "light-yellow";	}
	      		
	      		$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
		    	foreach ($secondaryIDs as $secondaryID) 
		    	{
		      		$protocol_types = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
					foreach ($protocol_types as $protocol_type) 
		      		{
			      		if ($protocol_bgcolor == "light-blue") 
					    {	$protocol_bgcolor = "dark-blue";	} 
					    else {	$protocol_bgcolor = "light-blue";	}
						
	      				$fields = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type]);
		      			foreach ($fields as $field) 
		      			{
			      			print "\n<tr>";
			      			if ($row_bgcolor == "light-row") 
		      				{	$row_bgcolor = "dark-row";	} 
		      				else {	$row_bgcolor = "light-row";	}
			      			if ($count['Exp Set'] > 1)
			      			{	print "<td class=\"$es_bgcolor\">$ESName</td>";	}
			      			if ($count['Experiment'] > 1)
			      			{	print "<td class=\"$e_bgcolor\">$EName</td>";	}
			      			if ($count['Identifier'] > 1)
			      			{	print "<td class=\"$id_bgcolor\">$identifier</td>";	}
			      			if ($count['Secondary ID'] > 1)
			      			{	
				      			if ('None' == $secondaryID)
				      			{	$secondaryIDVal = '';	}
				      			else
				      			{	$secondaryIDVal = $secondaryID;	}
				      			print "<td class=\"$id_bgcolor\">$secondaryIDVal</td>";	
				      		}
			      			if ($count['Protocol Type'] > 1)
			      			{	print "<td class=\"$protocol_bgcolor\">$protocol_type</td>";	}
			      			print "<td class=\"$row_bgcolor\">$field</td>";
			      			//Its a column and not a row hence use the array containing
			      			//all the keys.
			      			$label_names = $keys['label_names'];
			      			foreach ($label_names as $label_name) 
		      				{
			      				$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type][$field][$label_name];
			      						      				
			      				if ($value == "" OR $value == 0)
			      				{	//do nothing	
		      					}
			      				elseif (abs($value) > 0.001)
			      				{	$value = round($value, 4);	}
			      				else
			      				{	$value = sprintf("%2.4e", $value);	}
			      				print "<td class=\"$row_bgcolor\">$value</td>";
		      				}
		      				if ($count['Identifier'] > 1 AND $annotations)
							{	print "<td class=\"$row_bgcolor\">$annotations[$identifier]</td>";	}
		      				print "</tr>";
	      				}
		  			}
				}
			}
		}
	}
	print "</table>";
}

function output_table_format_replicate()
{
	global $searchGeneKey;
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$label_names = &$keys['Sampling Point'];
	$annotations = &$_SESSION[$searchGeneKey]['ANNOTATIONS'];

	//headers is a hash with the header name as key and 0 as val.
	//In case there is only one type of value, then instead of a 0 the val is the actual single value.
	//For Example if the field Exp Set contains only one value 'Yeast', than
	//$headers[Exp Set] = "Yeast"
	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0, "Protocol Type"=>0);
	//Master Array has the following keys:
	//$master_array[$ESName][$Experiment][$identifier][$secondaryID][$protocol_type][$sp_name][$biologicalReplicate][$technicalReplicate]

	
	//Get counts of each keys
	foreach ($headers as $header=>$val)
	{
		if (isset($keys[$header]) AND count($keys[$header]) == 1)
		{	
			$keysForHeader = array_keys($keys[$header]);
			$headers[$header] = $keys[$header][$keysForHeader[0]];	
		}
		$count[$header] = count($keys[$header]);
	}
	$header1ColSpan = 0;
	foreach ($headers as $header=>$val)
	{
		if ($val)
		{	
			if ($cl == 'light-red')
			{	$cl = 'dark-red';	}
			else
			{	$cl = 'light-red';	}
	
			$OneValueTable .= "\n<tr><th class=\"$cl\">$header</th><td class=\"$cl\">";
			if ('Secondary ID' == $header AND 'None' == $val)
			{		}
			else
			{	$OneValueTable .= $val;	}
			$OneValueTable .= "</td></tr>";
			if ($header == 'Identifier')
			{	
				if ($annotations)	
				{
					if ($cl == 'light-red')
					{	$cl = 'dark-red';	}
					else
					{	$cl = 'light-red';	}
					$OneValueTable .= "\n<tr><th class=\"$cl\">Annotation</th><td class=\"$cl\">$annotations[$val]</td></tr>";
				}
			}
		}
		else
		{	
			$headerRow .= "<th>$header</th>";	
			$header1ColSpan++;
		}
	}
	
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	$sp_name_orders = array_keys($SPTechnicalReplicates);
	foreach ($sp_name_orders as $sp_name_order)
	{
		$colSpan = 0;
		$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
		foreach ($biologicalReplicates as $biologicalReplicate)
		{
			$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
			$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);
			foreach ($technicalReplicates as $technicalReplicate)
			{
				$headerRow .= "<th>Replicate $biologicalReplicate";
				if ($TRCount > 1)
				{	$headerRow .= ".$technicalReplicate";	}
				$headerRow .= "</th>";
				$colSpan++;
			}
		}
		$headerLine1 .= "<th colspan=\"$colSpan\">{$label_names[$sp_name_order]}</th>";
	}
	if ($count['Identifier'] > 1 AND $annotations)
	{	$headerRow .= "<th>Annotation</th>";	}
	
	if ($OneValueTable)
	{
		print "<table cellspacing='2'><tr><th>Legend:</th></tr>$OneValueTable</table>";
		print "<br />";
	}
  	
	// This section is for print all data for selected genes in a table
  	// print the table header
	print "<table cellspacing='2'>";
	print "\n<tr><th colspan=\"$header1ColSpan\"></th>$headerLine1</tr>";
	print "\n<tr>$headerRow</tr>";
	
  	$row_bgclolr = "light-row";
	$table_block = array();
	
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{    
		if ($es_bgcolor == "light-blue") 
      	{	$es_bgcolor = "dark-blue";	} 
      	else {	$es_bgcolor = "light-blue";	}
      	$ENames = array_keys($master_array[$ESName]);
		foreach ($ENames as $EName) 
		{
			if ($e_bgcolor == "light-red") 
	      	{	$e_bgcolor = "dark-red";	} 
      		else {	$e_bgcolor = "light-red";	}
      		
      		$identifiers = array_keys($master_array[$ESName][$EName]);
  			foreach ($identifiers as $identifier) 
  			{
		    	if ($id_bgcolor == "light-yellow") 
	      		{	$id_bgcolor = "dark-yellow";	} 
	      		else {	$id_bgcolor = "light-yellow";	}
	      		$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
		    	foreach ($secondaryIDs as $secondaryID) 
		    	{
			    	$protocol_types = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
					foreach ($protocol_types as $protocol_type) 
		      		{
			      		if ($protocol_bgcolor == "light-blue") 
					    {	$protocol_bgcolor = "dark-blue"; $darkOrLight = 'dark';	} 
					    else {	$protocol_bgcolor = "light-blue"; $darkOrLight = 'light';	}
						print "\n<tr>";					
						if ($count['Exp Set'] > 1)
		      			{	print "<td class=\"$es_bgcolor\">$ESName</td>";	}
		      			if ($count['Experiment'] > 1)
		      			{	print "<td class=\"$e_bgcolor\">$EName</td>";	}
		      			if ($count['Identifier'] > 1)
		      			{	print "<td class=\"$id_bgcolor\">$identifier</td>";	}
		      			if ($count['Secondary ID'] > 1)
		      			{	
			      			if ('None' == $secondaryID)
			      			{	$secondaryIDVal = '';	}
			      			else
			      			{	$secondaryIDVal = $secondaryID;	}
			      			print "<td class=\"$id_bgcolor\">$secondaryIDVal</td>";	
			      		}
		      			if ($count['Protocol Type'] > 1)
		      			{	print "<td class=\"$protocol_bgcolor\">$protocol_type</td>";	}
		      			
					    $blueOrGrey = "blue";
		      			foreach ($sp_name_orders as $sp_name_order)
						{
							if ($blueOrGrey == 'blue') 
		      				{	$blueOrGrey = 'row';	} 
		      				else {	$blueOrGrey = 'blue';	}
		      				$row_bgcolor= "$darkOrLight-$blueOrGrey";
			      			$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
							foreach ($biologicalReplicates as $biologicalReplicate)
							{
								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
			      				foreach ($technicalReplicates as $technicalReplicate) 
		      					{
				      				$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];
				      				if ($value == "" OR $value == 0)
				      				{	//do nothing	
			      					}
				      				elseif (abs($value) > 0.001)
				      				{	$value = round($value, 4);	}
				      				else
				      				{	$value = sprintf("%2.4e", $value);	}
				      				print "<td class=\"$row_bgcolor\">$value</td>";
			      				}
		      				}
		  				}
		  				if ($count['Identifier'] > 1 AND $annotations)
						{	print "<td class=\"$row_bgcolor\">$annotations[$identifier]</td>";	}
		  				print "</tr>";
					}
				}
			}
		}
	}
	print "</table>";
}
?>