#!/usr/local/bin/perl

use DBI;
use DOMELIB;
use strict "vars";

#===============================================================================
# This script will read synonyms of an entity for allnames and add data into 
# "allnames".
#
# Author: X. Jing Li
# Date: April 3, 2006
# Reversions: 
#============================================================================== 

my ($database, $username, $password, $bnet_DB, $specieDB, $sql, $dbh, $sth, $rc, $mainsql,
    $infile, $kw_table_id, $name_type, @lines, $line, $primary, $syno, %syno_names, $rid, $unikey, $is_primary, %primary_rids, %primary_unikeys, %primary_types, %rid_types, $search_name, $log, $index
    );

#== get the global parameters:
($infile, $kw_table_id, $name_type) = @ARGV;

print "Start time: " . TimeStamp() . "\n";

#== connect to the database:
($database, $username, $password, $bnet_DB, $specieDB) = database_login2();
$dbh = DBI->connect($database,$username,$password) or die " Can't connect to $database:$DBI::errstr.";
$dbh->begin_work;
$sql = "set search_path to \"$bnet_DB\"";
$sth = $dbh-> prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

#== read all names and save in hash %syno_names:
open (IN, "<$infile") || die "Can not open the file $infile. $!\n";
@lines = <IN>;
close IN;

$line = shift @lines;
if ($line !~ /name/i) {
    chomp $line;
    $line =~ s/\"|
//g;
    ($primary, $syno) = split /\t/, $line;
    if ($syno ne "") {
        $syno_names{$syno} = $primary;
    }
}

foreach $line (@lines) {
    chomp $line;
    $line =~ s/\"|
//g;
    ($primary, $syno) = split /\t/, $line;
    if ($syno ne "") {
        $syno_names{$syno} = $primary;
    }
}

#== create a temp table for primary naems and synonyms:
$sql = "create TEMP table temp_names (syno varchar(1000), \"primary\" varchar(500)) ON COMMIT DROP;\n";
$index = 0;
foreach $syno (keys %syno_names) {
    $index++;
    $primary = $syno_names{$syno};
    $primary =~ s/\'/\'\'/g;
    $syno =~ s/\'/\'\'/g;
    $sql .= "/* $index */\ninsert into temp_names (\"primary\", syno) values (\'$primary\', \'$syno\');\n";
}
open (TMP, ">./tmp-plots/insertBnetSynonyms_temp.sql") or die "Cannot open temp file. $!";
print TMP $sql;

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

#== check the temp table record numbers:
#$sql = "select \"primary\" from temp_names order by \"primary\"";
#$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
#$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
#while ($primary = $sth->fetchrow()) {
#    print TMP "$primary\n";
#}
close TMP;

#== get all record_id for all primary names:
$sql = "select A.record_id, A.unikey, TN.\"primary\" from allnames A, temp_names TN where A.kw_table_id = $kw_table_id and UPPER(A.aname) = upper(TN.\"primary\")";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
while (($rid, $unikey, $primary) = $sth->fetchrow()) {
    if (!exists $primary_rids{$primary}) {
        $primary_rids{$primary} = $rid;
        $primary_unikeys{$primary} = $unikey;
    }
}
#print "There are " . (keys %primary_rids) . " records in hash Primary_rids.\n";

#== get all synonym that are already in allnames and delete from %syno_names:
$sql = "select A.record_id, A.aname, TN.syno, A.is_primary from allnames A, temp_names TN where A.kw_table_id = $kw_table_id and upper(A.aname) = upper(TN.syno) ";
$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
my $rows = $sth->rows();
while (($rid, $primary, $syno, $is_primary) = $sth->fetchrow()) {
    if ($is_primary eq $name_type && $rid == $primary_rids{$primary} ) {
       # print "delete syno = $syno, rid = $rid, is_primary = $is_primary \n";
        delete $syno_names{$syno};
    }
}
#print "There are $rows records in allnames and " . (keys %syno_names) . " new for allnames\n";

#== if name_type is annotation, check if the primary has annotation already. 
if ($name_type eq "A") {
    $sql = "select record_id from allnames where kw_table_id = $kw_table_id and is_primary = \'A\' and record_id in (select A.record_id from allnames A, temp_names TN where A.kw_table_id = $kw_table_id and UPPER(A.aname) = upper(TN.\"primary\"))";
    $sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";
    $rc = $sth->execute or die "Can't execute: $DBI::errstr.";
    while ($rid = $sth->fetchrow() ) {
        $rid_types{$rid} = "A";
    }
}

#== insert into allnames:
$mainsql = "";
$index = 0;
foreach $syno (keys %syno_names) {
    $index++;
    if ($syno !~ /\w|\d/) {
        next;
    }
    $primary = $syno_names{$syno};
    $rid = $primary_rids{$primary};
    $unikey = $primary_unikeys{$primary};
    $search_name = getSearchName($syno);
    $primary =~ s/\'/\'\'/g;
    $syno =~ s/\'/\'\'/g;
    $unikey =~ s/\'/\'\'/g;
    $search_name =~ s/\'/\'\'/g;
    
    if ($name_type eq "N") {
        $mainsql .= "/* $index */\ninsert into allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name, unikey) values (nextval('allnames_id_seq'), \'$syno\', $kw_table_id, $rid, \'$name_type\', \'$search_name\', \'$unikey\');\n";
    } elsif ($name_type eq "A") {
        if (exists $rid_types{$rid}) {
            $mainsql .= "/* $index */\nupdate allnames set aname = \'$syno\', search_name = \'$search_name\' where kw_table_id = $kw_table_id and record_id = $rid and is_primary = \'$name_type\' and unikey = \'$unikey\';\n";
        } else {
            $mainsql .= "/* $index */\ninsert into allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name, unikey) values (nextval('allnames_id_seq'), \'$syno\', $kw_table_id, $rid, \'$name_type\', \'$search_name\', \'$unikey\');\n";
        }
    }
}

$log = "./tmp-plots/insertBnetSynonyms_" . $name_type . ".log";
open (LOG, ">$log") or die "Can not open log file $log.$!";
print LOG $mainsql;
close LOG;
if ($mainsql ne "") {
    $sth = $dbh->prepare($mainsql) or die "Can't prepare: $DBI::errstr.";
    $rc = $sth->execute or die "Can't execute: $DBI::errstr.";
    if ($rc == 1) {
        $dbh->commit;
        #$dbh->rollback;
    } else {
        $dbh->rollback;
    }
}
$sth->finish;
$dbh->disconnect;

print "Ending time: " . TimeStamp() . "\n";

exit 0;

