<?php
/**
* This script is one step for the Wizard Type Front-End
* for DOME.
* Date: 3 Sept 2003
* @author Pedro Mendes <mendes@vt.edu>
* modified from Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
modifyPHPIniSettings(true);
//Sets Environment Variable
$_SESSION['STEP_NUMBER'] = 1; 
setVariables($_SESSION['STEP_NUMBER']);
?>

<?php

$stepCount = count(split(':', $_SESSION['STEP_NUMBER']));
$title = "Welcome to DOME-$SpeciesSchemaName";
$title_line2 = "Main Menu"; 
$header_img_class = "normal-box";
include("header.php");

if ($_SESSION['errMsgs'])
{	
	print "Please contact your <b>system administrator</b> to correct the following error(s) in the paramSettings.php file before proceeding:";
	foreach ($_SESSION['errMsgs'] as $msg)
	{	printError($msg);	}
	unset ($_SESSION['errMsgs']);
}

if ($_SESSION['Message'])
{	
	
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset ($_SESSION['Message']);
}
?>

<div class="left-align">
	<table class="main-menu-table"><tr><td>
 		<b>&nbsp;&nbsp;Database Query and Analysis&nbsp;&nbsp;</b>
 		<hr />
		<p class="help-tips"> Use this section to retrieve data from database or to do analysis on data using DOME </p>
 		<p>
		<ul>
 		<li><a href="step.php?stepno=1:1">Query summary data</a> (retrieves medians, standard deviations, etc.)</li>
		<li><a href="step.php?stepno=1:2">Query replicate data</a> (retrieves normalized measured values for each replicate)</li>
		<li><a href="step.php?stepno=1:13">Retrieve Raw data Files</a></li>
		<li><a href="restoreSavedSelections.php">Restore previously saved selections</a></li>
<?php	$_SESSION['allowAdd'] = false;	$_SESSION['allowEditDelete'] = false;	?>
		<li><a href="./bnet/simpleSearch.php" target="_bnet" >Query Biological Reference Information (BNet)</a><br /></li>
		<li><a href="queryMetadata.php">View Experimental Design</a><br /></li>
		</ul>
		</p>
		
	</td>
	
   
<?php
	if (strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER')
	{	
		print '<td>
	 		<b>&nbsp;&nbsp;Add data to database&nbsp;&nbsp;</b>
	 		<hr />
	 		<p class="help-tips">Use this section to add raw or processed data into the database. Please make sure that the corresponding Meta Data already exists.</p>
			<p><ul>';
			
		//Print Techniques.
		$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" ORDER BY UPPER(\"technique_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Techniques. " . $sth->getMessage());	return;	}
	
		while ($row = $sth->fetchRow()) 
		{
			//==Hard Coding Here
			switch(strtoupper($row[1]))
			{
			case 'AFFYMETRIX':
				$stepno = "1:12";
				$redirectFile = "addDataAffy.php";
				$technique_type = "Transcriptomics";
				break;
			case 'CE/MS':
				$stepno = "1:9";
				$redirectFile = "addDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'CE/LIF':
				$stepno = "1:10";
				$redirectFile = "addDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'GC/MS':
				$stepno = "1:3";
				$redirectFile = "addDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'LC/MS':
				$stepno = "1:7";
				$redirectFile = "addDataMetabolomics.php";
				$technique_type = "Metabolomics";
				break;
			case 'MICROARRAY':
				$stepno = "1:8";
				$redirectFile = "addDataMicroarray.php";
				$technique_type = "Transcriptomics";
				break;
			case 'PROTEOMICS':
				$stepno = "1:11";
				$redirectFile = "addDataProteomics.php";
				$technique_type = "Proteomics";
				$addDataLinksArray[$technique_type][] = "<a href=\"$redirectFile?technique_id=$row[0]\">2D-PAGE</a>";
				$stepno = "";	//Custom Links already printed in the above statement. Don't print links below.
				break;
			default:
				$stepno = "";
				break;
			}
			if ($stepno)
			{
				$addDataLinksArray[$technique_type][] = "\n<a href=\"$redirectFile?stepno=$stepno&technique_id=$row[0]\">$row[1]</a>";
			}
		}
		foreach ($addDataLinksArray as $technique_type=>$links)
		{
			print "<li>$technique_type: ";
			$firstDone = false;
			foreach ($links as $link)
			{
				if (!$firstDone)
				{	print $link; $firstDone = true;	}
				else
				{	print " | $link";	}
			}
			print "</li>";
		}
		
		print '</ul></p>
				</td>';	
				//End 'Add Data to DB' box
	}

		print "</tr>";	//End first row of boxes.
		print "<tr>";
		
	if (strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER')
	{	
		print '<td>
	 		<b>&nbsp;&nbsp;Data Processing &nbsp;&nbsp;</b>
			<hr />';
			
		//print '<li><a href="mergeCompounds.php?stepno=1:4">Merge Compounds</a></li>';	
		//print '<li><a href="sendUpdates.php?stepno=1:5">Send Updates</a></li>';	
		//print '<li><a href="processUpdates.php?stepno=1:6">Process Updates</a></li>';	
		print '<p class=\"li-separator\"></p>';
		print '<p><ul>';
		
		print "\n<li><b>Normalization:</b> <a href=\"normalize.php\">normalize Affymetrix data</a> | 
			<a href=\"customNormalizeAffy.php\">upload normalized Affrymetrix data</a> |
			<a href=\"normalize2Channel.php\">normalize 2-Channel microarray</a> (reference design) | 
			<a href=\"normalize2ChannelLoop.php\">normalize 2-Channel microarray</a> (loop design)";
		
		//Mean and Std Dev Links
		print '<li><b>Statistical Summaries:</b> ';
		//Print Techniques.
		$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" ORDER BY UPPER(\"technique_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Techniques. " . $sth->getMessage());	return;	}
		
		$metabolomics_technique_ids = "";
		while ($row = $sth->fetchRow()) 
		{
			//==Hard Coding Here
			switch(strtoupper($row[1]))
			{
			case 'AFFYMETRIX':
				$MAndSDArray[1] = "<a href=\"calculateMAndSD.php?technique_ids=$row[0]&title_suffix=Affymetrix Data\">1-Channel</a>";
				break;
			case 'CE/MS':
			case 'CE/LIF':
			case 'GC/MS':
			case 'LC/MS':
				if ($metabolomics_technique_ids)
				{	$metabolomics_technique_ids .= ", $row[0]";	}
				else
				{	$metabolomics_technique_ids .= $row[0];	}
			
				break;
			
			case 'MICROARRAY':
				$MAndSDArray[2] = "<a href=\"calculateMAndSD.php?technique_ids=$row[0]&title_suffix=Microarray Data\">2-Channel by Reference Design</a>";
				break;
			case 'PROTEOMICS':
				$MAndSDArray[5] = "<a href=\"calculateMAndSD.php?technique_ids=$row[0]&title_suffix=Proteomics Data\">Proteomics</a>";
				break;
			}
		}
		$MAndSDArray[3] = '<a href="calculateMAndSDLoop.php">2-Channel by Loop Design</a>';
		$MAndSDArray[4] = "<a href=\"calculateMAndSD.php?technique_ids=$metabolomics_technique_ids&title_suffix=Metabolites Data\">Metabolites</a>";
		$MAndSDArray[6] = '<a href="customMAndSD.php">Upload Means and Standard Deviations</a>';

		for ($i = 1; $i <= count($MAndSDArray); $i++)
		{	if ($i == 1)
			{	print $MAndSDArray[$i];	}
			else
			{	print " | $MAndSDArray[$i]";	}
		}
		print "</li>";
		
		//Compare Data Links
		print '<li><b>Sample Comparison</b>: <a href="compareData.php">Compare Samples</a> | <a href="customCompareData.php">Upload Sample Comparisons</a>';
		print '</p>
			</td>';	
				//End 'Data Processing and Insertion' box
	}
?>	

	
<?php
	if (strtoupper($_SESSION['role']) == 'MANAGER')
	{	
		print '<td>
	 		<b>&nbsp;&nbsp;Database Management (only accessible to Managers)&nbsp;&nbsp;</b>
	 		<hr />
			<p class="help-tips">Please create the required Meta Data for the project. This is the first step and is required before any data can be inserted into the Database.</p>
	 		<p><ul>';
		print '<li><a href="addMetaDataMenu.php">Add MetaData</a></li>	
		<li><a href="viewEditMetaDataMenu.php">View/Edit MetaData</a></li>
		<li><a href="deleteDataMenu.php">Delete Data</a></li>
		<li><a href="GEOMenu.php">GEO Menu</a></li>
		<li><a href="BNetMenu.php">BNet</a></li>';
		print '</ul></p>
				</td>';	
				//End 'Manage Metadata' box
	}
	print "</tr>";	//End Second Row
	print "<tr>";
	if (strtoupper($_SESSION['role']) != 'GUEST')
	{
		print '<td>';
		print "\n<ul>";
		if (strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER')
		{	print '<li><a href="cleanUpMenu.php">CleanUp</a></li>';		}
		print '<li><a href="changeInfo.php">Change Personal Info</a></li>';
		print '</ul></td>';
	}
?>	
</tr></table>
</div>
<?php 
	include("footer.php");
?>

