<?php
/**
* This script takes two compounds and merges them into one.
* Date: 02 Sep 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("compoundFrame.php");
include_once("workFlow.php");
//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
$currPageNameUpper = strtoupper($currPageName);
$title = "DOME : Merge Compounds";
include("header.php");
?>

<?php
for ($i = 1; $i <= 2; $i++)
{
	if ($_REQUEST["submit$i"] == 'Search')
	{	$_SESSION[$currPageNameUpper]["txtSearch$i"] = $_REQUEST["txtSearch$i"];	}
	elseif ($_REQUEST["submit$i"] == 'Set Selected Compound')
	{
		if ($_REQUEST["searchResults$i"] > 0)
		{	$_SESSION[$currPageNameUpper]["CpdID$i"] = $_REQUEST["searchResults$i"];	}
		else
		{	$errMsgs[] = "Please Select the compound to set.";	}
	}
	elseif ($_REQUEST["submit$i"] == 'Clear Selected Compound')
	{	unset($_SESSION[$currPageNameUpper]["CpdID$i"]);	}
}

if ($_REQUEST['submit'] == 'Merge Shown Compounds')
{
	$status = processMerge($_SESSION[$currPageNameUpper]['CpdID1'], $_SESSION[$currPageNameUpper]['CpdID2']);
	if ($status)
	{
		unset($_SESSION[$currPageNameUpper]['CpdID1']);
		unset($_SESSION[$currPageNameUpper]['CpdID2']);
	}
}

if ($errMsgs)
{
	foreach ($errMsgs as $msg)
	{
		printError($msg);
	}
}

if (strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER')	
{	fillForm();	}
else
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	}

include ("footer.php");
?>


<?php
//Functions

function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	print "\n<form name=\"searchCpd\" method=\"post\" action=\"{$_SERVER['PHP_SELF']}\" >\n";
	fillSearchCpdFrame("Main Compound", $_SESSION[$currPageNameUpper]['CpdID1'], $currPageNameUpper, "1");
	fillSearchCpdFrame("Compound To Merge", $_SESSION[$currPageNameUpper]['CpdID2'], $currPageNameUpper, "2");
	fillAddButtons();
	print "</form>";
}

function fillAddButtons()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	print "\n<div class=\"add-buttons\">";
	if ($_SESSION[$currPageNameUpper]['CpdID1'] > 0 && $_SESSION[$currPageNameUpper]['CpdID2'] > 0)
	{	
		print "\n<p><input type=\"submit\" name=\"submit\" value=\"Merge Shown Compounds\"></p>";
	}
	print "\n</div>";
}


/*==========================================
Request Functions
============================================*/
function processMerge($cpd_id_main, $cpd_id_to_merge)
{
	global $errMsgs;
	if (!($cpd_id_main > 0))
	{
		$errMsgs[] = "Invalid main Compound ID";
		return 0;	
	}
	if (!($cpd_id_to_merge > 0))
	{
		$errMsgs[] = "Invalid Compound ID for the compound to merge";
		return 0;
	}
	$qres = $_SESSION['dbh']->query("BEGIN TRANSACTION");
	if( DB::isError($qres) ) {printError("Error starting new transaction. (" . $qres->getMessage() . ")" );  return 0;}
	
	//Update ma_extract
	$sql = "SELECT * FROM ma_extract
		WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error selecting in 'ma_extract' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	if ($sth->numRows() > 0)
	{	
		$cpdIDToMergeFoundInDOME = true;	
		$tablesCpdIDToMergeFound[] = 'ma_extract';
	}
	
	//Update sp_summary
	$sql = "SELECT * FROM sp_summary
		WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error selecting in 'sp_summary' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	if ($sth->numRows() > 0)
	{	
		$cpdIDToMergeFoundInDOME = true;	
		$tablesCpdIDToMergeFound[] = 'sp_summary';
	}
	
	//Update sp_comparison
	$sql = "SELECT * FROM sp_comparison
		WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error selecting in 'sp_comparison' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	if ($sth->numRows() > 0)
	{	
		$cpdIDToMergeFoundInDOME = true;	
		$tablesCpdIDToMergeFound[] = 'sp_comparison';
	}
	
	//Update peak_cpd
	$sql = "SELECT * FROM peak_cpd
		WHERE cpd_id = '$cpd_id_to_merge'";
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error selecting in 'peak_cpd' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	if ($sth->numRows() > 0)
	{	
		$cpdIDToMergeFoundInDOME = true;	
		$tablesCpdIDToMergeFound[] = 'peak_cpd';
	}
	
	//Update metabolite_processed2
	$sql = "SELECT * FROM metabolite_processed2
		WHERE cpd_id = '$cpd_id_to_merge'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error selecting in 'metabolite_processed2' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	if ($sth->numRows() > 0)
	{	
		$cpdIDToMergeFoundInDOME = true;	
		$tablesCpdIDToMergeFound[] = 'metabolite_processed2';
	}
	
	if ($cpdIDToMergeFoundInDOME)
	{	
		$errmsg = "The compound ID to merge ($cpd_id_to_merge) found in DOME database in the following tables:<br />\n<ol>";
		foreach ($tablesCpdIDToMergeFound as $table)
		{
			$errmsg .= "\n\t<li>$table</li>";
		}
		$errmsg .= "</ol><br />";
		$errmsg .= " Compounds NOT merged.";
		printError($errmsg); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	//Update complex_member
	$sql = "UPDATE complex_member SET record_id = '$cpd_id_main'
		WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'complex_member' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Update event_component
	$sql = "UPDATE event_component SET record_id = '$cpd_id_main'
		WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'event_component' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Update evidence - Avoid Duplicates!
	$sql = "UPDATE evidence SET record_id = '$cpd_id_main' 
		WHERE evidence.record_id = '$cpd_id_to_merge' 
		AND evidence.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
		AND evidence.evidence_id NOT IN 
			(SELECT o.evidence_id FROM evidence o, evidence n
			WHERE o.record_id = '$cpd_id_to_merge'
			AND o.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			AND n.record_id = '$cpd_id_main'
			AND n.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			AND n.reference_id = o.reference_id
			AND n.evidence_code_id = o.evidence_code_id)";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'evidence' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	//Delete Rest
	$sql = "DELETE FROM evidence 
		WHERE record_id = '$cpd_id_to_merge' 
		AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error deleting in 'evidence' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	
	//Update external_links - Avoid Duplicates!
	$sql = "UPDATE external_links SET record_id = '$cpd_id_main' 
		WHERE record_id = '$cpd_id_to_merge' 
		AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
		AND external_links_id NOT IN
		(SELECT o.external_links_id FROM external_links o, external_links n
			WHERE o.record_id = '$cpd_id_to_merge' 
			AND n.record_id = '$cpd_id_main'
			AND o.external_database_id = n.external_database_id)";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'external_links' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Delete Rest of external_links.
	$sql = "DELETE FROM external_links 
		WHERE record_id = '$cpd_id_to_merge' 
		AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'external_links' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Update specie_compound - Avoid Duplicates!
	$sql = "UPDATE specie_compound SET cpd_id = '$cpd_id_main'
		WHERE cpd_id = '$cpd_id_to_merge'
		AND specie_id NOT IN 
		(SELECT specie_id FROM specie_compound WHERE cpd_id = '$cpd_id_main')";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'specie_compound' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	//DELETE Rest of the specie_compound links.
	$sql = "DELETE FROM specie_compound WHERE cpd_id = '$cpd_id_to_merge'";
		
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("$sql  Error deleting in 'specie_compound' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Update cpd_derivative
	$sql = "UPDATE cpd_derivative SET cpd_id = '$cpd_id_main'
		WHERE cpd_id = '$cpd_id_to_merge'";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging in 'cpd_derivative' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	
	//Delete the merged compound ID
	$sql = "DELETE FROM compound
		WHERE cpd_id = '$cpd_id_to_merge'";
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error deleting compound in 'compound' table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Finally update allnames - Note this should be done after deleting the merged 
	//compound, otherwise the trigger will not let u delete the merged compound.
	$sql = "UPDATE allnames SET record_id = '$cpd_id_main', is_primary = 'N'
				WHERE record_id = '$cpd_id_to_merge' AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error merging names in allnames table. Compounds Not merged. (" . $sth->getMessage() . ")"); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	//Update event primary name in allnames
	$sql = "SELECT DISTINCT event_id FROM event_component ec 
		WHERE ec.record_id = '$cpd_id_main'
		AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

	if (!populateReactionNames($sql)) 
	{	printError("Error updating Primary Name for Event. Compounds Not merged."); 
		$_SESSION['dbh']->query("ROLLBACK");	
		return 0;
	}
	
	$_SESSION['dbh']->query("COMMIT");
	printMessage("Compound with ID '$cpd_id_to_merge' merged with main compound ID '$cpd_id_main' successfully!");
	return 1;
}

function populateReactionNames($event_id_list = "")
{
	$sql = "SELECT event_id FROM event";
	if ($event_id_list)
	{	$sql .= " WHERE event_id IN ($event_id_list)";	}
	$sql .= " ORDER BY event_id";
	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 
	{	
		printError("Error searching for event_ids. (" . $sth->getMessage() . ")");
		return 0;
	}
	
	while ($row = $sth->fetchRow())
	{
		$reactionString = getReactionString($row[0], $_SESSION['dbh']);
		$search_name = $_SESSION['dbh']->quote(convertToSearchName($reactionString));
		$reactionString = $_SESSION['dbh']->quote($reactionString);
		
		$sql = "SELECT aname, search_name FROM allnames WHERE 
		kw_table_id = '{$_SESSION['TableID']['EVENT']}' 
		AND record_id = $row[0]
		AND UPPER(is_primary) = 'Y'";
		$sthR = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sthR) ) 
		{	
			print "Error getting from allnames for event_id $row[0]. (" . $sthR->getMessage() . ")"; 
			return 0;
		}

		if ($sthR->numRows() > 0)
		{
			$rowR = $sthR->fetchRow();
			$reactionStringR = $_SESSION['dbh']->quote($rowR[0]);
			$search_nameR = $_SESSION['dbh']->quote($rowR[1]);
			if ($reactionString != $reactionStringR OR $search_name != $search_nameR)
			{
				$sql = "UPDATE allnames SET aname = $reactionString, 
				search_name = $search_name
				WHERE kw_table_id = '{$_SESSION['TableID']['EVENT']}'
				AND record_id = '$row[0]'
				AND UPPER(is_primary) = 'Y'";
				
				$sthR = $_SESSION['dbh']->query($sql);
				if ( DB::isError($sthR) ) 
				{	
					print "Error adding or updating allnames table. (" . $sthR->getMessage() . ")"; 
					return 0;
				}
			}
		}
		else
		{
			$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
				VALUES (nextval('allnames_id_seq'), $reactionString, '{$_SESSION['TableID']['EVENT']}', '$row[0]', 'Y', $search_name)";
			
			$sthR = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sthR) ) 
			{	
				print "Error adding or updating allnames table. (" . $sthR->getMessage() . ")"; 
				return 0;
			}
		}
	}
	return 1;
}
?>
