<?php
/**
* This script is a Front-End for normalizing data already added 
* in the DOME database for different techniques.
* Date: 3 May 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");
$currPageName = 'NORMALIZE';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php

$title = "Normalize 1-Channel Affymetrix Data";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER' OR strtoupper($_SESSION['role']) == 'EDITOR'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}
?>

<?php

if ($_REQUEST['submit'] == 'Normalize' AND $_SESSION[$currPageNameUpper]['force_add'] == 0)
{	processForm(0);	}
elseif ($_REQUEST['submit'] == 'Continue')
{	processForm(1);	}
elseif ($_REQUEST['submit'] == 'Cancel')
{	$_SESSION[$currPageNameUpper]['force_add'] = 0;	}
else
{	$_SESSION[$currPageNameUpper]['force_add'] = 0;	}


if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
fillForm($_SESSION[$currPageNameUpper]['force_add']);
include_once("footer.php");
?>

<?php
//Functions
function fillForm($force_add = 0)
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	
	if ($force_add)
	{
		print "\n<div class=\"controlBar\">";
		print "\n<input type=\"submit\" name=\"submit\" value=\"Cancel\" /> ";
		print "<input type=\"submit\" name=\"submit\" value=\"Continue\" />";
		print "\n</div>";
	}
	else
	{
	
		print '<p class="help-tips">Please provide information about which data sample you want to normalize and choose a protocol to be used for normalization. The data would be stored in the database after normalization to assist in further quering.</p>';
		
		//Get technique_id
		$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" 
		WHERE UPPER(\"technique_name\") = 'AFFYMETRIX'";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error retrieving Techniques. " . $sth->getMessage();	return;	}
		$row = $sth->fetchRow();
		$_SESSION[$currPageNameUpper]['technique_id'] = $row[0];
				
		printMetaDataSelectionsMultiple("", $_SESSION[$currPageNameUpper]);
			
		//Print Normalization Method
		$sql = "SELECT \"protocol_type_id\", \"protocol_type_name\" FROM \"protocol_type\" 
				WHERE UPPER(\"method\") = 'STATISTICAL' 
				AND technique_id = '{$_SESSION[$currPageNameUpper]['technique_id']}'
			ORDER BY UPPER(\"protocol_type_name\")";
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	printError("Error retrieving Protocol Type. " . $sth->getMessage());	return;	}
		print "\n<p><label>Normalization Method: </label>";
		print "<select name=\"protocol_type_id\">";
		
		print "\n\t<option value=\"0\">--Select One--</option>";
		while ($row = $sth->fetchRow()) 
		{
			print "\n\t<option value=\"$row[0]\"";
			if ($_SESSION[$currPageNameUpper]['protocol_type_id'] == $row[0])
			{	print " selected";	}
			print ">$row[1]</option>";
		}
		print "\n</select></p>";
		
		printExtractMethod($_SESSION[$currPageNameUpper]['technique_id']);
		
		print "<input type=\"submit\" name=\"submit\" value=\"Normalize\" />";
	}
	print "\n</form>";

}


function printMetaDataSelectionsMultiple($identifier = "", $valuesArray, $printBiologicalReplicate = true, $printTechnicalReplicate = false, $requiredArray = "", $labelsArray = "")
{
	if (!isset($labelsArray['experiment_set_ids']))
	{	$labelsArray['experiment_set_ids'] = 'Experiment Sets';	}
	if (!isset($labelsArray['exp_names']))
	{	$labelsArray['exp_names'] = 'Experiments';	}
	if (!isset($labelsArray['sampling_point_label_ids']))
	{	$labelsArray['sampling_point_label_ids'] = 'Sampling Points';	}
	if (!isset($labelsArray['tissue_type_label_ids']))
	{	$labelsArray['tissue_type_label_ids'] = 'Tissue Type';	}
	if (!isset($labelsArray['biological_replicates']))
	{	$labelsArray['biological_replicates'] = 'Biological Replicates';	}
	if (!isset($labelsArray['technical_replicate']))
	{	$labelsArray['technical_replicates'] = 'Technical Replicates';	}
	
	
	if (!isset($valuesArray['experiment_set_ids']))
	{	$valuesArray['experiment_set_ids'] = array();	}
	if (!isset($valuesArray['exp_names']))
	{	$valuesArray['exp_names'] = array();	}
	if (!isset($valuesArray['sampling_point_label_ids']))
	{	$valuesArray['sampling_point_label_ids'] = array();	}
	if (!isset($valuesArray['tissue_type_label_ids']))
	{	$valuesArray['tissue_type_label_ids'] = array();	}
	if (!isset($valuesArray['biological_replicates']))
	{	$valuesArray['biological_replicates'] = array();	}
	if (!isset($valuesArray['technical_replicates']))
	{	$valuesArray['technical_replicates'] = array();	}
	
	print "\n<table width=\"80%\"><tr><td>";
	//Print Experiment Sets. 
	$sql = "SELECT exp_set_id, exp_set_name  FROM experiment_set ORDER BY UPPER(exp_set_name)";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Experiment Sets. " . $sth->getMessage());	return;	}
	print "\n<p><label>{$labelsArray['experiment_set_ids']}";
	if ($requiredArray['experiment_set_ids'])
	{	print " *";	}
	print ": </label>";
	print "<select name=\"";
	if ($identifier)
	{	print "{$identifier}[";	}
	print "experiment_set_ids";
	if ($identifier)
	{	print "]";	}
	print "[]\"";
	print " size=\"4\" \"multiple\">";
	//print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if (in_array($row[0], $valuesArray['experiment_set_ids']))
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//Print Experiments. 
	$sql = "SELECT DISTINCT \"exp_name\", UPPER(\"exp_name\") FROM \"experiment\" 
		ORDER BY UPPER(\"exp_name\")";
    $sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Experiments. " . $sth->getMessage());	return;	}
	
	print "\n<p><label>{$labelsArray['exp_names']}";
	if ($requiredArray['exp_names'])
	{	print " *";	}
	print ": </label>";
	print "<select name=\"";
	if ($identifier)
	{	print "{$identifier}[";	}
	print "exp_names";
	if ($identifier)
	{	print "]";	}
	print "[]\"";
	print " size=\"4\" \"multiple\">";
	print "\n\t<option value=\"0\">--None--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if (in_array($row[0], $valuesArray['exp_names']))
		{	print " selected";	}
		print ">$row[0]</option>";
	}
	print "\n</select></p>";
	
	print "\n</td><td>";
	
	//Print Sampling Points. 
	$sql = "SELECT label_id, name FROM label 
		WHERE kw_table_id = '{$_SESSION['TableID']['SAMPLING_POINT']}'
		ORDER by \"order\"";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Sampling Points. " . $sth->getMessage());	return;	}
	
	print "\n<p><label>{$labelsArray['sampling_point_label_ids']}";
	if ($requiredArray['sampling_point_label_ids'])
	{	print " *";	}
	print ": </label>";
	
	print "<select name=\"";
	if ($identifier)
	{	print "{$identifier}[";	}
	print "sampling_point_label_ids";
	if ($identifier)
	{	print "]";	}
	print "[]\"";
	print " size=\"10\" \"multiple\">";
	print "\n\t<option value=\"0\">--None--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if (in_array($row[0], $valuesArray['sampling_point_label_ids']))
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	if ($printBiologicalReplicate)
	{
		//Print Biological Replicates.
		print "\n<p><label>{$labelsArray['biological_replicates']}";
		
		if ($requiredArray['biological_replicates'])
		{	print " *";	}
		print ": </label>";
		print "<select name=\"";
		if ($identifier)
		{	print "{$identifier}[";	}
		print "biological_replicates";
		if ($identifier)
		{	print "]";	}
		print "[]\"";
		print " size=\"4\" \"multiple\">";
		print "\n\t<option value=\"0\">--None--</option>";
		for ($i = 1; $i <= $_SESSION['totReplicates']; $i++)
		{
			print "\n\t<option value=\"$i\"";
			if (in_array($i, $valuesArray['biological_replicates']))
			{	print " selected";	}
			print ">$i</option>";
		}
		print "\n</select></p>";
	}
	
	if ($printTechnicalReplicate)
	{
		//Print Technical Replicates.
		print "\n<p><label>{$labelsArray['technical_replicates']}";
		
		if ($requiredArray['technical_replicates'])
		{	print " *";	}
		print ": </label>";
		print "<input name=\"";
		if ($identifier)
		{	print "{$identifier}[";	}
		print "technical_replicates";
		if ($identifier)
		{	print "]";	}
		print "[]\"";
		if (isset($valuesArray['technical_replicates']))
		{	$defaultValue = $valuesArray['technical_replicates'];	}
		else
		{	$defaultValue = 1;	}
		
		print " value=\"$defaultValue\" size=\"2\" />";
		print "</p>";
	}
	print "\n</td></tr></table>";
	//Print Tissue Type. 
	$sql = "SELECT \"label_id\", \"name\" FROM \"label\" 
			WHERE \"kw_table_id\" = '{$_SESSION['TableID']['SAMPLE']}' ORDER BY UPPER(\"name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Tissue Types. " . $sth->getMessage());	return;	}
		
	print "\n<p><label>{$labelsArray['tissue_type_label_ids']}";
	if ($requiredArray['tissue_type_label_ids'])
	{	print " *";	}
	print ": </label>";
	print "<select name=\"";
	if ($identifier)
	{	print "{$identifier}[";	}
	print "tissue_type_label_ids";
	if ($identifier)
	{	print "]";	}
	print "\"";
	print " size=\"1\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($valuesArray['tissue_type_label_ids'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
}


/**============================
* Request Functions
*============================*/
function processForm($force_add = 0)
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	if (!$force_add)
	{
		$_SESSION[$currPageNameUpper]['experiment_set_ids'] = $_REQUEST['experiment_set_ids'];
		$_SESSION[$currPageNameUpper]['exp_names'] = $_REQUEST['exp_names'];
		$_SESSION[$currPageNameUpper]['sampling_point_label_ids'] = $_REQUEST['sampling_point_label_ids'];
		$_SESSION[$currPageNameUpper]['biological_replicates'] = $_REQUEST['biological_replicates'];
		$_SESSION[$currPageNameUpper]['tissue_type_label_ids'] = $_REQUEST['tissue_type_label_ids'];
		$_SESSION[$currPageNameUpper]['protocol_type_id'] = $_REQUEST['protocol_type_id'];
		$_SESSION[$currPageNameUpper]['extract_id'] = $_REQUEST['extract_id'];
		
		
		if (!$_SESSION[$currPageNameUpper]['experiment_set_ids'])
		{	$errMsgs[] = "Please Select an Experiment Set.";	}
		
		/*
		if (!$_SESSION[$currPageNameUpper]['exp_names'])
		{	$errMsgs[] = "Please Select an Experiment.";	}
			
		if (!$_SESSION[$currPageNameUpper]['sampling_point_label_ids'])
		{	$errMsgs[] = "Please Select a Sampling Point.";	}
		
		if (!$_SESSION[$currPageNameUpper]['biological_replicates'])
		{	$errMsgs[] = "Please Select the biological replicate.";	}
		*/
		if (!$_SESSION[$currPageNameUpper]['tissue_type_label_ids'])
		{	$errMsgs[] = "Please Select a Tissue Type";	}
		
		if (!$_SESSION[$currPageNameUpper]['protocol_type_id'])
		{	$errMsgs[] = "Please Select a Normalization Method.";	}
		
		if (!$_SESSION[$currPageNameUpper]['extract_id'])
		{	$errMsgs[] = "Please Select an Extraction Method.";	}
		
		if ($errMsgs)
		{	return 0;	}
		
		
		//Now find out sampling_replicate_id from the given info.
		$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
			, \"sampling_point\" sp
			, \"experiment\" e
			WHERE e.\"exp_set_id\" IN ('" . join ("', '", $_SESSION[$currPageNameUpper]['experiment_set_ids']) . "')";
			if ($_SESSION[$currPageNameUpper]['exp_names'][0])
			{	$sql .= "\n AND e.\"exp_name\" IN ('" . join ("', '", $_SESSION[$currPageNameUpper]['exp_names']) . "')";	}
			$sql .= "\n AND sp.\"experiment_id\" = e.\"experiment_id\"";
			if ($_SESSION[$currPageNameUpper]['sampling_point_label_ids'][0])
			{	$sql .= "\n AND sp.\"label_id\" IN ('" . join ("', '", $_SESSION[$currPageNameUpper]['sampling_point_label_ids']) . "')";	}
			$sql .= "\n AND sr.\"sampling_point_id\" = sp.sampling_point_id";
			if ($_SESSION[$currPageNameUpper]['biological_replicates'][0])
			{	$sql .= "\n AND sr.\"replicate\" IN ('" . join ("', '", $_SESSION[$currPageNameUpper]['biological_replicates']) . "')";	}
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error retrieving Sampling Replicates. " . $sth->getMessage();	
			return 0;
		}
		
		if ($sth->numrows() > 0)
		{
			while ($row = $sth->fetchRow())
			{	$srids[] = $row[0];	}
			$_SESSION[$currPageNameUpper]['sampling_replicate_ids'] = join(", ", $srids);
		}
		else
		{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided";	}
		
		if ($errMsgs)
		{	return 0;	}
	}

	//Validating Normalization Method
	$sql = "SELECT \"protocol_type_id\", \"method_options\" FROM \"protocol_type\" 
		WHERE \"technique_id\" = '{$_SESSION[$currPageNameUpper]['technique_id']}'
		AND \"protocol_type_id\" = '{$_SESSION[$currPageNameUpper]['protocol_type_id']}'";
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error checking for protocol. " . $sth->getMessage();	
		return 0;
	}
	if ($sth->numrows() == 0)
	{	$errMsgs[] = "Normalization Method Not Found for selected technique.";	}
	else
	{	
		$row = $sth->fetchrow();
		$ptMethodOptions = $row[1];
	}
	if ($errMsgs)
	{	return 0;	}
	
	//print "ptMethodOptions=$ptMethodOptions";
	$methodLines = split('##', $ptMethodOptions);
	//print_r($methodLines);
	$nameValuePair = split('=', $methodLines[0]);
	//print_r($nameValuePair);
	$perlScriptFile = preg_replace('/"/', "", $nameValuePair[1]);
	//print "perlScriptFile=$perlScriptFile";
	//$perlScriptFile = "normalizeAffyByR.pl";
	
	
	$prefix = $_SESSION['BROWSER_TMP_FULL'] . session_id();
	$sampling_replicate_ids = $_SESSION[$currPageNameUpper]['sampling_replicate_ids'];
	$protocol_type_id = $_SESSION[$currPageNameUpper]['protocol_type_id'];
	$extract_id = $_SESSION[$currPageNameUpper]['extract_id'];
	$tissue_type_label_ids = $_SESSION[$currPageNameUpper]['tissue_type_label_ids'];
	$force_add = $_SESSION[$currPageNameUpper]['force_add'];
	
	$com = "export PATH; PATH=\$PATH:{$_SESSION['R_DIR']}; export R_HOME; R_HOME={$_SESSION['R_HOME']}; export LD_LIBRARY_PATH; LD_LIBRARY_PATH={$_SESSION['RSPERL_DIR']}libs:{$_SESSION['R_HOME']}/lib; export PERL5LIB; PERL5LIB={$_SESSION['PERL5LIB']}; {$_SESSION['PERL_DIR']}perl $perlScriptFile \"$prefix\" \"$sampling_replicate_ids\" $protocol_type_id $extract_id $tissue_type_label_ids $force_add 2>&1;";
	//print $com;
	
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
	  	if (!$msg)
	  	{	$msg = "System command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
		//redirect
		print "<meta http-equiv=\"refresh\" content=\"2; URL=intro.php?stepno=1\">";
		exit();
	}
	elseif ($retValue == 99)	//data exists
	{
		$_SESSION[$currPageNameUpper]['force_add'] = 1;
		$_SESSION['Message'][] = $msg;
	}
	else
	{	
		$_SESSION[$currPageNameUpper]['force_add'] = 0;
		if (!$msg)
	  	{	$msg = "System command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn: $retString RetValue = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}
	return 1;
}
?>
