#!/usr/local/bin/perl



use DBI;

use DOMELIB;

use strict "vars";



#===============================================================================

# This script will normalize cDNA data by script name from "protocol_type" table

# "method_options script name and insert results into ma_norm with corresponding

# protocol_type_id. 

#

# author: X. Jing Li

# date: Sept.2, 2005

# reversion: 

#  10_18_2005: add channel2 parameters and elimilate the extract_id.

#===============================================================================



my ($prefix, $srid1, $tissue_type_label_id1, $srid2, $tissue_type_label_id2, $ptid, $extract_id) = @ARGV;

print "normalizeCDnas.pl: @ARGV\n";

my ($database, $username, $password, $bnet_DB, $specieDB, $dbh, $sth, $rc,$sql,

    $value, $script_name, $method, $cmd, $ok);



#== connect to the database:

($database, $username, $password, $bnet_DB, $specieDB) = database_login2();

$dbh = DBI->connect($database,$username,$password) or die "Can't connect to $database:$DBI::errstr.";

$sql = "set search_path to \"$specieDB\"";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";



#== get the script name:

$sql = "select method_options from protocol_type where protocol_type_id = $ptid";

$sth = $dbh->prepare($sql) or die "Can't prepare: $DBI::errstr.";

$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

$value = $sth->fetchrow();

$sth->finish;

$dbh->disconnect;



if ($value =~ /SCRIPT/) {

    ($script_name, $method) = split /\\n/, $value;

    $script_name =~ s/SCRIPT=|\"//g;

    $method =~ s/OPT=//g;

    $cmd = "perl ./$script_name @ARGV";

    print $cmd . "\n";

    $ok = exec $cmd;

    print "ok = $ok\n";

}



exit $ok;





