<?php
/**
* This script helps the curator to update B-Net with 
* the updates sent in a file using the sendUpdates.php script.
* All Updates are stored in a hash.
* Every individual table belongs to a group.
* Groups are done in order to be able to retrieve entities
* while displaying updates on the Front-End.
* Hence this hash containing updates is referenced as follows
* $updatesHash[TABLE_GROUP][UNIQUE_KEY_FOR_THIS RECORD][TABLE_NAME]
* The location referenced above contains the new record (as an array
* mostly of fields other than the UNIQUE_KEY) when there is
* an Insert or Update. In case of a Delete it contains the value 'D'.
* Note that there can be an additional unique key for the Hash
* $updatesHash after the three keys described above in the cases
* where more than one update can be done on the same table for a particular
* unique group.
* 
* Date: 25 Oct 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
$currPageName = "PROCESS_UPDATES_RIGHT";
$title = "DOME : Process Updates";
include("header.php");
?>

	

<?php
if (!(strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER'))	
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}


if ($_SESSION['errMsgs'])
{
	foreach ($_SESSION['errMsgs'] as $msg)
	{
		printError($msg);
	}
	unset($_SESSION['errMsgs']);
}

fillForm();
include ("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	print "<form name=\"init_form\" method=\"post\" action=\"processUpdatesTop.php\" enctype=\"multipart/form-data\" target=\"_top\">\n";
	
	$currGroup = $_SESSION['PROCESS_UPDATES']['CURRENT_GROUP'];
	$currIdentifier = key($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]);
	fillGroup($currGroup, $currIdentifier);
	print "\n<p><input type=\"submit\" name=\"submit\" value=\"Update\"></p>";
	
	print "</form>";	
}

function fillGroup($group, $identifier)
{
	global $errMsgs;
	print "Updates For " .  strtolower($group) . " '$identifier':";
	print "\n<table class=\"updates-table\">
	<tr><th></th><th>Operation</th><th>Table</th><th>Fields</th></tr>";
	foreach ($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier] as $table => $row)
	{
		switch ($table)
		{
		case 'ACTIVITY':
			$i = 0;
			foreach ($row as $unique => $updatesRow)
			{
				$rec = split(':', $unique);
				$EC = $rec[0];
				$protein_pn = $rec[1];
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>EC:</label>$EC";
				print "<br \><label>Protein:</label>$protein_pn";
				print "</td></tr>";
				$i++;
			}
			break;
		case 'ALLNAMES':
			$i = 0;
			foreach ($row as $aname => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				if ($updatesRow == 'D')
				{
					print "<label>aname: </label>$aname";
				}
				else
				{
					print "<label>aname: </label><input type=\"text\" name=\"aname_$i\" value=\"$aname\">";
					print "<br /><label>is_primary: </label>$updatesRow[0]";
				}
				print "</td></tr>";
				$i++;
			}
			break;
			
		case 'COMPLEX':
			printInitialCells($table, $row);
			print "<td><label>Complex: </label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>location: </label>";
				$sql = "SELECT location_id, location_name from location ORDER BY location_name";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error getting location_names. (" . $sth->getMessage() . ")"; 
					continue;
				}
				print '<select name=\"location_id\">';
				while ($rec = $sth->fetchRow())
				{
					print "\t<option value=\"$rec[0]\"";
					if ($rec[1] == $row[0])
					{	print " selected";	}
					print ">$rec[1]</option>\n";
				}
				print "\n</select>";
			}
			print"</td></tr>";
			break;
		case 'COMPLEX_MEMBER':
			$i = 0;
			foreach ($row as $unique => $updatesRow)
			{
				$rec = split(':', $unique);
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<br /><label>Entity: </label>$rec[0]";
				print "<br /><label>Primary Name: </label>$rec[1]";
				if ($updatesRow != 'D')
				{
					print "<br /><label>stoichiometry: </label>$updatesRow[0]";
				}
				print "</td></tr>";
				$i++;
			}
			break;	
		case 'COMPOUND':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	print "<br /><label>cpd_formula: </label><input type=\"text\" name=\"cpd_formula\" value=\"$row[0]\">";
				print "<br /><label>mol_wt: </label><input type=\"text\" name=\"mol_wt\" value=\"$row[1]\">";
			}
			print"</td></tr>";
			break;
		
		case 'CPD_DERIVATIVE':
			$i = 0;
			foreach ($row as $derName => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				if ($updatesRow == 'D')
				{	print "<label>name: </label>$derName";	}
				else
				{	print "<label>name: </label><input type=\"text\" name=\"name_$i\" value=\"$derName\">";	}
				print "</td></tr>";
				$i++;
			}
			break;	
		
		
		case 'EC':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>EC: </label><input type=\"text\" name=\"ec_name\" value=\"$row[0]\">";
			}
			print"</td></tr>";
			break;
		case 'EVENT':
			printInitialCells($table, $row);
			print "<td><label>Event: </label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>event_type: </label>";
				$sql = "SELECT event_type_id, event_type_name from event_type";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error getting event_types. (" . $sth->getMessage() . ")"; 
					continue;
				}
				print '<select name=\"event_type_id\">';
				while ($rec = $sth->fetchRow())
				{
					print "\t<option value=\"$rec[0]\"";
					if ($rec[1] == $row[0])
					{	print " selected";	}
					print ">$rec[1]</option>\n";
				}
				print "\n</select>";
			}
			print"</td></tr>";
			break;
		case 'EVENT_COMPONENT':
			$i = 0;
			foreach ($row as $unique => $updatesRow)
			{
				$rec = split(':', $unique);
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<br /><label>Entity: </label>$rec[0]";
				print "<br /><label>Primary Name: </label>$rec[1]";
				print "<br /><label>is_substrate: </label>$rec[2]";
				if ($updatesRow != 'D')
				{
					print "<br /><label>stoichiometry: </label>$updatesRow[0]";
					print "<br /><label>location: </label>$updatesRow[1]";
				}
				print "</td></tr>";
				$i++;
			}
			break;	
		case 'EVENT_EC':
			$i = 0;
			foreach ($row as $EC => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>EC:</label>$EC";
				print "</td></tr>";
				$i++;
			}
			break;
		case 'EVENT_TYPE':
			printInitialCells($table, $row);
			print "<td><label>Event Type: </label>$identifier";
			print"</td></tr>";
			break;
		case 'EVIDENCE':
			$i = 0;
			foreach ($row as $unique => $updatesRow)
			{
				$records = split('::', $unique);
				$locator = $records[0];
				$ECRecord = split(':', $records[1]);
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>Reference locator: </label>$locator";
				print "<br /><label>Evidence Code: </label>$ECRecord[0]";
				print "<br /><label>Evidence Code kw_table: </label>$ECRecord[1]";
				print "<br /><label>Evidence Code Technique: </label>$ECRecord[2]";
				print "<br /><label>Evidence Code Strength: </label>$ECRecord[3]";

				print "</td></tr>";
				$i++;
			}
			break;	
			
		case 'EVIDENCE_CODE':
			$ECRecord = split(':', $identifier);
			printInitialCells($table, $row);
			print "<td><label>Evidence Code: </label>$ECRecord[0]";
			print "<br /><label>kw_table: </label>$ECRecord[1]";
			print "<br /><label>technique: </label>$ECRecord[2]";
			print "<br /><label>strength: </label>$ECRecord[3]";
			
			print"</td></tr>";
			break;
			
		case 'EXTERNAL_DATABASE':
			printInitialCells($table, $row);
			print "<td><label>full_db_name: </label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>database_name: </label><input type=\"text\" name=\"database_name\" value=\"$row[0]\">";	
				print "<br /><label>url: </label><input type=\"text\" name=\"url\" value=\"$row[1]\">";	
			}
			print"</td></tr>";
			break;
			
		case 'EXTERNAL_LINKS':
			$i = 0;
			foreach ($row as $ExtDBname => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>full_db_name:</label>$ExtDBname";
				if ($updatesRow != 'D')
				{
					print "<br /><label>external_table_name: </label><input type=\"text\" name=\"external_table_name_$i\" value=\"$updatesRow[0]\">";
					print "<br /><label>external_field_name: </label><input type=\"text\" name=\"external_field_name_$i\" value=\"$updatesRow[1]\">";
					print "<br /><label>internal_field_name: </label><input type=\"text\" name=\"internal_field_name_$i\" value=\"$updatesRow[2]\">";
					print "<br /><label>external_id: </label><input type=\"text\" name=\"external_id_$i\" value=\"$updatesRow[3]\">";
				}
				print "</td></tr>";
				$i++;
			}
			break;
		case 'GENE':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	print "<br /><label>SPECIES: </label><i>$row[0]</i>";	}
			print"</td></tr>";
			break;
			
		case 'LOCATION':
			printInitialCells($table, $row);
			print "<td><label>location_name: </label>$identifier";
			print"</td></tr>";
			break;
			
		case 'MRNA':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>GENE: </label>$row[0]";	
				print "<br /><label>PROTEIN: </label>$row[1]";	
			}
			print"</td></tr>";

			break;
			
		case 'PROTEIN':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	print "<br /><label>SPECIES: </label><i>$row[0]</i>";	}
			print"</td></tr>";
			break;
			
		case 'PROTEIN_EC':
			$i = 0;
			foreach ($row as $EC => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>EC:</label>$EC";
				print "</td></tr>";
				$i++;
			}
			break;
		case 'REFERENCE':
			printInitialCells($table, $row);
			print "<td><label>locator:</label>$identifier";
			if ($row != 'D')
			{	
				print "<br /><label>authors: </label><input type=\"text\" name=\"authors\" value=\"$row[0]\">";	
				print "<br /><label>year: </label><input type=\"text\" name=\"year\" value=\"$row[1]\">";	
				print "<br /><label>title: </label><input type=\"text\" name=\"title\" value=\"$row[2]\">";	
				print "<br /><label>pubmed_accession: </label><input type=\"text\" name=\"pubmed_accession\" value=\"$row[3]\">";	
			}
			print"</td></tr>";
			break;	
		case 'SPECIE_COMPOUND':
			$i = 0;
			foreach ($row as $SpName => $updatesRow)
			{
				print "\n<tr><td><input type=\"checkbox\" name=\"{$table}_$i\" checked></td><td>";
				if ($updatesRow == 'D')
				{	print 'Delete';	}
				else
				{	print 'Insert/Update';	}
				print "</td><td>$table</td><td>";
				print "<label>SPECIES: </label><i>$SpName</i>";
				print "</td></tr>";
				$i++;
			}
			break;
			
		case 'SPECIES':
			printInitialCells($table, $row);
			print "<td><label>Primary Name: </label>$identifier";
			if ($row != 'D')
			{	print "<br /><label>taxon_ncbi_accession: </label><input type=\"text\" name=\"taxon_ncbi_accession\" value=\"$row[0]\">";	}
			print"</td></tr>";
			break;
		}
	}
	print "</table>";
}

function printInitialCells($table, $row)
{
	print "\n<tr><td><input type=\"checkbox\" name=\"$table\" checked></td><td>";
	if ($row == 'D')
	{	print 'Delete';	}
	else
	{	print 'Insert/Update';	}
	print "</td><td>$table</td>";
}

?>
