<?php
/**
* This script is the top level of the two Frameset
* structure for comparing and doing updates to B-Net.
* 
* Date: 25 Oct 2004
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");
include_once("deleteFunctions.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
$title = "DOME : Process Updates";
include("header.php");
?>

<?php
if (!(strtoupper($_SESSION['role']) == 'EDITOR' OR strtoupper($_SESSION['role']) == 'MANAGER'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}

if ($_REQUEST['submit'] == 'Update')
{	processForm();	}
fillForm();

/*
fillMRNANames();*/

?>


<?php

function fillForm()
{
	$row = findGroupAndIdentifier();
	if ($row == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']);
		unset($_SESSION['errMsgs']);
		printMessage("All Updates are Complete! You will be redirected to the main menu.");
		//redirect to intro
		print "<meta http-equiv=\"refresh\" content=\"7; URL=intro.php\">";
	}
	else
	{
		$group = $row[0]; $identifier = $row[1];
		$leftSrc = findLeftSrc($group, $identifier);
		$rightSrc = "processUpdatesRight.php";
		print "<frameset cols=\"50%, 50%\" border=\"1\">
					<frame name=\"left\"  src=\"$leftSrc\">
					<frame name=\"right\" src=\"$rightSrc\">
			</frameset>
			<noframes>
				<body bgcolor=\"#FFFFFF\">
					You must use a frames enabled browser
				</body>
			</noframes>";
	}
		
}

function findGroupAndIdentifier()
{
	if (!isset($_SESSION['PROCESS_UPDATES']['GROUPS']))
	{	
		printMessage("Group Ordering Array Not set or all the updates are already complete!");	
		return;
	}
	if (!$_SESSION['PROCESS_UPDATES']['updatesHash'])
	{
		return 'PROCESSED';
	}
	$updatesHashGroups = array_keys($_SESSION['PROCESS_UPDATES']['updatesHash']);
	//Advance to next group in Updates Hash.
	$currGroup = current($_SESSION['PROCESS_UPDATES']['GROUPS']);
	while ($currGroup)
	{
		if (in_array($currGroup, $updatesHashGroups))
		{	break;	}
		else
		{	$currGroup = next($_SESSION['PROCESS_UPDATES']['GROUPS']);	}
	}
	$_SESSION['PROCESS_UPDATES']['CURRENT_GROUP'] = $currGroup;
	while ($currGroup)
	{
		$currIdentifier = key($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]);
		//print_r($_SESSION['PROCESS_UPDATES']['updatesHash']);
		//print "<br /> Now Processing $currGroup '$currIdentifier'";
		switch($currGroup)
		{
		case 'ACTIVITY':
			$status = processActivity($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
		case 'COMPLEX':
			
			$status = processComplex($currIdentifier);	
			$ret = processComplexMember($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;

		case 'COMPOUND':
			
			$status = processCompound($currIdentifier);	
			$ret = processCompoundDer($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
	
			$ret = processSpecieCompound($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
		
		case 'EC':
			$status = processEC($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
				
		case 'EVENT':
			
			$status = processEvent($currIdentifier);	
			$ret = processEventEC($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processEventComponent($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processActivity($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
		
		case 'EVENT_TYPE':
			$status = processEventType($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
			
		case 'EVIDENCE_CODE':
			$status = processEvidenceCode($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
	
		case 'EXTERNAL_DATABASE':
			$status = processExternalDatabase($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;

		case 'GENE':
			
			$status = processGene($currIdentifier);	
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
			
		case 'LOCATION':
			$status = processLocator($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
		
		case 'MRNA':
			$status = processMrna($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
			
		case 'PATHWAY':
			break;
		case 'PROTEIN':
			
			$status = processProtein($currIdentifier);	
			$ret = processProteinEC($currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
			
		case 'REFERENCE':
			
			$status = processReference($currIdentifier);	
						
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
			
		case 'SPECIES':
			
			$status = processSpecies($currIdentifier);	
			$ret = processRest($currGroup, $currIdentifier);
			if ($status == 'PROCESSED')
			{	$status = $ret;	}
			
			if ($status != 'PROCESSED')
			{	return array($currGroup, $currIdentifier);	}
			break;
		default:
			return array($currGroup, $currIdentifier);
			break;
		}
		
		//The current identifier has been processed. Unset it from the 
		//main updatesHash before proceding to the next identifier.
		unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup][$currIdentifier]);
		
		if (count($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]) == 0)
		{
			//Before Leaving 'COMPOUND' group Recalculate the Primary Names in allnames
			//for events that were updated.
			if ($currGroup == 'COMPOUND')
			{	include("populateReactionNames.php");	}
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]);
			$updatesHashGroups = array_keys($_SESSION['PROCESS_UPDATES']['updatesHash']);
			//Advance to next group in Updates Hash.			
			$currGroup = next($_SESSION['PROCESS_UPDATES']['GROUPS']);
			while ($currGroup)
			{
				if (in_array($currGroup, $updatesHashGroups))
				{	break;	}
				else
				{	$currGroup = next($_SESSION['PROCESS_UPDATES']['GROUPS']);	}
			}
			$_SESSION['PROCESS_UPDATES']['CURRENT_GROUP'] = $currGroup;
		}
	}
	
	if ($_SESSION['errMsgs'])
	{
		foreach ($_SESSION['errMsgs'] as $msg)
		{
			printError($msg);
		}
		unset($_SESSION['errMsgs']);
	}

	return 'PROCESSED';

}


function processRest($group, $identifier)
{
	$ret = processAllNames($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}
	
	$ret = processEvidence($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}
	
	$ret = processExternalLinks($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}
	
	return $ret;
}

function processActivity($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['ACTIVITY'][$identifier]['ACTIVITY'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$row = split('::', $identifier);
	if ($row[1] != 'NULL')
	{
		$rec = split(':', $row[1]);
		$protein_pn = $rec[0];
		$state_type = $rec[1];
	}
	$rec = split(':', $row[0]);
	$event_pn = $rec[0];
	$EC = $rec[1];
	
	$sql = "SELECT a.activity_id FROM allnames an1";
	if ($protein_pn)
	{	$sql .= ", allnames an2";	}
	
	$sql .= ", activity a, ec
	WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
	AND an1.kw_table_id = '{$_SESSION['TableID']['EVENT']}'
	AND UPPER(an1.is_primary) = 'Y'
	AND a.event_id = an1.record_id
	AND ec.ec_name = '$EC'
	AND a.ec_id = ec.ec_id";
	
	if ($protein_pn)
	{	$sql .= " AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($protein_pn) . ")
		AND an2.kw_table_id = '{$_SESSION['TableID']['PROTEIN']}'
		AND UPPER(an2.is_primary) = 'Y'
		AND a.protein_id = an2.record_id";	
	}
	else
	{	$sql .= " AND a.protein_id IS NULL";	}
	
				
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'EVENT' for table 'ACTIVITY' and identifier '$identifier:$unique'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND'; 	}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{	$status = 'PROCESSED';	}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['ACTIVITY'][$identifier]['ACTIVITY']);
	}
	
	return $status;
}


function processAllNames($group, $identifier, $aname = "")
{
	if ($aname)
	{
		$ANs = array($aname => $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'][$aname]);
	}
	else
	{
		$ANs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'];
	}
	if (!$ANs)
	{	return 'PROCESSED';	}
	
	foreach ($ANs as $aname => $updatesRow)
	{
		$sql = "SELECT an1.name_id, an1.is_primary
		FROM  allnames an1, allnames an2
		WHERE UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an2.kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(an2.is_primary) = 'Y'
		AND UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($aname) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND an1.record_id = an2.record_id";
				
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group '$group' for table 'ALLNAMES' and identifier '$aname'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{	
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND';		}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{
				if ($updatesRow[0] == $row[1])
				{	$status = 'PROCESSED';	}
				else
				{	return $row[0];		}
			}
			
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'][$aname]);
		}
	}
	return $status;
}

function processComplex($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
		
	$sql = "SELECT an.record_id, l.location_name FROM complex c, location l, allnames an
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['COMPLEX']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = c.complex_id
		AND c.location_id = l.location_id";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'COMPLEX' for '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX']);
	}
	return $status;
}


function processComplexMember($identifier, $unique = "")
{
	if ($unique)
	{
		$CMs = array($unique => $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX_MEMBER'][$unique]);
	}
	else
	{
		$CMs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX_MEMBER'];
	}
	
	if (!$CMs)
	{	return 'PROCESSED';	}
	foreach ($CMs as $unique => $updatesRow)
	{
		$rec = split(':', $unique);
		$sql = "SELECT cm.complex_member_id, cm.stoichiometry
		FROM complex_member cm, allnames an1, allnames an2
		WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID']['COMPLEX']}'
		AND UPPER(an1.is_primary) = 'Y'
		AND cm.complex_id = an1.record_id
		AND cm.kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'
		AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($rec[1]) . ")
		AND UPPER(an2.is_primary) = 'Y'
		AND cm.record_id = an2.record_id
		AND an2.kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'";
		
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'COMPLEX' for table 'COMPLEX_MEMBER' and identifier '$unique'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{	
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND';	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{
				if ($updatesRow[0] == $row[1])
				{	$status = 'PROCESSED';	}
				else
				{	return $row[0];	}
			}
			
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX_MEMBER'][$unique]);
		}
	}
	return $status;
}


function processCompound($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['COMPOUND'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
		
	$sql = "SELECT an.record_id, c.cpd_formula, c.mol_wt FROM compound c, allnames an 
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = c.cpd_id";
	
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'COMPOUND' for table 'COMPOUND' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];		}
		else
		{
			if ($updatesRow[0] == $row[1] && floatval($updatesRow[1]) == floatval($row[2]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['COMPOUND']);
	}
	return $status;
}

function processCompoundDer($identifier, $derName = "")
{
	if ($derName)
	{
		$CDs = array($derName => $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'][$derName]);
	}
	else
	{
		$CDs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'];
	}
	
	if (!$CDs)
	{	return 'PROCESSED';	}
	
	foreach ($CDs as $derName => $updatesRow)
	{
		$sql = "SELECT cd.cpd_derivative_id FROM cpd_derivative cd, allnames an 
			WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
			AND an.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			AND UPPER(an.is_primary) = 'Y'
			AND an.record_id = cd.cpd_id
			AND UPPER(cd.name) = UPPER('$derName')";
			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'COMPOUND' for table 'CPD_DERIVATIVE' and identifier '$identifier:$derName'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND'; 	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{	$status = 'PROCESSED';	}
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'][$derName]);
		}
	}
	return $status;
}

function processEC($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EC'][$identifier]['EC'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	
	$sql = "SELECT an.record_id, ec.ec_name FROM ec, allnames an
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['EC']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = ec.ec_id";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'EC' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EC'][$identifier]['EC']);
	}
	return $status;
}

function processEvent($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
		
	$sql = "SELECT an.record_id, et.event_type_name FROM event e, event_type et, allnames an
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['EVENT']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = e.event_id
		AND e.event_type_id = et.event_type_id";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'EVENT' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT']);
	}
	return $status;
}

function processEventEC($identifier, $EC = "")
{
	if ($EC)
	{
		$EECs = array($EC => $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_EC'][$EC]);
	}
	else
	{
		$EECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_EC'];
	}
	
	if (!$EECs)
	{	return 'PROCESSED';	}
	
	foreach ($EECs as $EC => $updatesRow)
	{
		$sql = "SELECT eec.event_ec_id FROM  allnames an, event_ec eec, ec
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['EVENT']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = eec.event_id
		AND ec.ec_name = '$EC'
		AND ec.ec_id = eec.ec_id";

			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'EVENT' for table 'EVENT_EC' and identifier '$identifier:$EC'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND'; 	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{	$status = 'PROCESSED';	}
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_EC'][$EC]);
		}
	}
	return $status;
}

function processEventComponent($identifier, $unique = "")
{
	if ($unique)
	{
		$ECs = array($unique => $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_COMPONENT'][$unique]);
	}
	else
	{
		$ECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_COMPONENT'];
	}
	
	if (!$ECs)
	{	return 'PROCESSED';	}
	foreach ($ECs as $unique => $updatesRow)
	{
		$rec = split(':', $unique);
		$sql = "SELECT ec.event_component_id, ec.stoichiometry, l.location_name
		FROM event_component ec, allnames an1, allnames an2, location l
		WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID']['EVENT']}'
		AND UPPER(an1.is_primary) = 'Y'
		AND ec.event_id = an1.record_id
		AND ec.kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'
		AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($rec[1]) . ")
		AND UPPER(an2.is_primary) = 'Y'
		AND ec.record_id = an2.record_id
		AND an2.kw_table_id = '{$_SESSION['TableID'][$rec[0]]}'
		AND ec.location_id = l.location_id
		AND UPPER(ec.is_substrate) = UPPER('$rec[2]')";
		
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'EVENT' for table 'EVENT_COMPONENT' and identifier '$unique'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{	
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND';	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{
				if ($updatesRow[0] == $row[1] && strtoupper($updatesRow[1]) == strtoupper($row[2]))
				{	$status = 'PROCESSED';	}
				else
				{	return $row[0];	}
			}
			
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_COMPONENT'][$unique]);
		}
	}
	return $status;
}

function processEventType($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT_TYPE'][$identifier]['EVENT_TYPE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$sql = "SELECT et.event_type_id 
	 FROM event_type et	WHERE UPPER(et.event_type_name) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")";
		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'event_type' with identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{	$status = 'PROCESSED';	}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT_TYPE'][$identifier]['EVENT_TYPE']);
	}
	return $status;
}

function processEvidence($group, $identifier, $unique = "")
{
	if ($unique)
	{
		$EVs = array($unique => $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EVIDENCE'][$unique]);
	}
	else
	{
		$EVs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EVIDENCE'];
	}
	
	if (!$EVs)
	{	return 'PROCESSED';	}
	
	foreach ($EVs as $unique => $updatesRow)
	{
		$records = split('::', $unique);
		$locator = $records[0];
		$ECRecord = split(':', $records[1]);
		
		if ($group == 'COMPOUND')
		{	
			$sql = "SELECT ev.evidence_id 
			 FROM  evidence ev, allnames an, specie_compound sc, reference ref, 
			 evidence_code ec, ref_kw_table r
			WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
			AND an.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
			AND UPPER(an.is_primary) = 'Y'
			AND an.record_id = sc.cpd_id
			AND ec.kw_table_id = r.kw_table_id
			AND UPPER(ref.locator) = UPPER('$locator')
			AND UPPER(ec.evidence_code) = UPPER('$ECRecord[0]')
			AND UPPER(r.kw_table) =  UPPER('$ECRecord[1]')
			AND UPPER(ec.technique) = UPPER('$ECRecord[2]')
			AND UPPER(ec.strength) = UPPER('$ECRecord[3]')
			AND ev.reference_id = ref.reference_id
			AND ev.evidence_code_id = ec.evidence_code_id
			AND sc.specie_cpd_id = ev.record_id
			AND ev.kw_table_id = '{$_SESSION['TableID']['SPECIE_COMPOUND']}'";
		}
		else
		{
			$sql = "SELECT ev.evidence_id 
			 FROM  evidence ev, allnames an, reference ref, 
			 evidence_code ec, ref_kw_table r
			WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
			AND an.kw_table_id = '{$_SESSION['TableID'][$group]}'
			AND UPPER(an.is_primary) = 'Y'
			AND ec.kw_table_id = r.kw_table_id
			AND UPPER(ref.locator) = UPPER('$locator')
			AND UPPER(ec.evidence_code) = UPPER('$ECRecord[0]')
			AND UPPER(r.kw_table) =  UPPER('$ECRecord[1]')
			AND UPPER(ec.technique) = UPPER('$ECRecord[2]')
			AND UPPER(ec.strength) = UPPER('$ECRecord[3]')
			AND ev.reference_id = ref.reference_id
			AND ev.evidence_code_id = ec.evidence_code_id
			AND an.record_id = ev.record_id
			AND ev.kw_table_id = '{$_SESSION['TableID'][$group]}'";
		}
		
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group '$group' for table 'EVIDENCE' and identifier '$unique'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND'; 	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{	$status = 'PROCESSED';	}
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EVIDENCE'][$unique]);
		}
	}
	return $status;
}

function processEvidenceCode($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVIDENCE_CODE'][$identifier]['EVIDENCE_CODE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$ECRecord = split(':', $identifier);
	
	$sql = "SELECT ec.evidence_code_id 
	 FROM evidence_code ec, ref_kw_table r
	WHERE ec.kw_table_id = r.kw_table_id
	AND UPPER(ec.evidence_code) = UPPER('$ECRecord[0]')
	AND UPPER(r.kw_table) =  UPPER('$ECRecord[1]')
	AND UPPER(ec.technique) = UPPER('$ECRecord[2]')
	AND UPPER(ec.strength) = UPPER('$ECRecord[3]')";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'evidence_code' with identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{	$status = 'PROCESSED';	}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVIDENCE_CODE'][$identifier]['EVIDENCE_CODE']);
	}
	return $status;
}

function processExternalDatabase($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EXTERNAL_DATABASE'][$identifier]['EXTERNAL_DATABASE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$sql = "SELECT ed.external_database_id, ed.database_name, ed.url
		FROM external_database ed
		WHERE ed.full_db_name = '$identifier'";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'external_database' with identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]) && strtoupper($updatesRow[1]) == strtoupper($row[2]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];	}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EXTERNAL_DATABASE'][$identifier]['EXTERNAL_DATABASE']);
	}
	return $status;
}



function processExternalLinks($group, $identifier, $ExtDBname = "")
{
	if ($ExtDBname)
	{
		$ELs = array($ExtDBname => $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'][$ExtDBname]);
	}
	else
	{
		$ELs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'];
	}
	
	if (!$ELs)
	{	return 'PROCESSED';	}
	foreach ($ELs as $ExtDBname => $updatesRow)
	{
		$sql = "SELECT external_links_id, el.external_table_name, 
			el.external_field_name, el.internal_field_name, el.external_id
		FROM external_links el, allnames an, external_database ed
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(an.is_primary) = 'Y'
		AND ed.external_database_id = el.external_database_id
		AND UPPER(ed.full_db_name) = UPPER('$ExtDBname')
		AND el.record_id = an.record_id
		AND el.kw_table_id = '{$_SESSION['TableID'][$group]}'";
				
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group '$group' for table 'EXTERNAL_LINKS' and identifier '$ExtDBname'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{	
			if ($updatesRow == 'D')
			{
				$status = 'PROCESSED';
			}
			else
			{
				return 'NOT FOUND';
			}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{
				return $row[0];
			}
			else
			{
				if (strtoupper($updatesRow[0]) == strtoupper($row[1]) && strtoupper($updatesRow[1]) == strtoupper($row[2]) && strtoupper($updatesRow[2]) == strtoupper($row[3]) && strtoupper($updatesRow[3]) == strtoupper($row[4]))
				{
					$status = 'PROCESSED';
				}
				else
				{
					return $row[0];
				}
			}
			
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'][$ExtDBname]);
		}
	}
	return $status;
}

function processGene($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['GENE'][$identifier]['GENE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	
	$sql = "SELECT an1.record_id, an2.aname FROM gene g, allnames an1, allnames an2
		WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID']['GENE']}'
		AND UPPER(an1.is_primary) = 'Y'
		AND an1.record_id = g.gene_id
		AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an2.kw_table_id = '{$_SESSION['TableID']['SPECIES']}'
		AND UPPER(an2.is_primary) = 'Y'
		AND an2.record_id = g.specie_id";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'GENE' for table 'GENE' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['GENE'][$identifier]['GENE']);
	}
	return $status;
}


function processLocation($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['LOCATION'][$identifier]['LOCATION'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$sql = "SELECT l.location_id FROM location l
		WHERE l.location_name = '$identifier'";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'location' with identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{	$status = 'PROCESSED';	}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['LOCATION'][$identifier]['LOCATION']);
	}
	return $status;
}



function processMrna($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['MRNA'][$identifier]['MRNA'];

	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	
	$sql = "SELECT m.mrna_id, an2.aname, an3.aname FROM  mrna m, allnames an1, allnames an2, allnames an3
	WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
	AND an1.kw_table_id = '{$_SESSION['TableID']['MRNA']}'
	AND UPPER(an1.is_primary) = 'Y'
	AND an2.record_id = m.gene_id
	AND an2.kw_table_id = '{$_SESSION['TableID']['GENE']}'
	AND UPPER(an2.is_primary) = 'Y'
	AND an3.record_id = m.protein_id
	AND an3.kw_table_id = '{$_SESSION['TableID']['PROTEIN']}'
	AND UPPER(an3.is_primary) = 'Y'";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'MRNA' for table 'MRNA' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND'; 	}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{	
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]) && strtoupper($updatesRow[1]) == strtoupper($row[2]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['MRNA'][$identifier]['MRNA']);
	}
	return $status;
}

function processProtein($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	
	$sql = "SELECT an.record_id, an2.aname FROM protein p, allnames an1, allnames an2
		WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID']['PROTEIN']}'
		AND UPPER(an1.is_primary) = 'Y'
		AND an1.record_id = p.protein_id
		AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an2.kw_table_id = '{$_SESSION['TableID']['SPECIES']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an2.record_id = p.specie_id";

		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'PROTEIN' for table 'PROTEIN' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{		
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];		}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN']);
	}
	return $status;
}

function processProteinEC($identifier, $EC = "")
{
	if ($EC)
	{
		$PECs = array($EC => $_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN_EC'][$EC]);
	}
	else
	{
		$PECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN_EC'];
	}
	
	if (!$PECs)
	{	return 'PROCESSED';	}
	
	foreach ($PECs as $EC => $updatesRow)
	{
		$sql = "SELECT pec.protein_ec_id FROM  allnames an, protein_ec pec, ec
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID']['PROTEIN']}'
		AND UPPER(an.is_primary) = 'Y'
		AND an.record_id = pec.protein_id
		AND ec.ec_name = '$EC'
		AND ec.ec_id = pec.ec_id";

			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'PROTEIN' for table 'PROTEIN_EC' and identifier '$identifier:$EC'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND'; 	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{	$status = 'PROCESSED';	}
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN_EC'][$EC]);
		}
	}
	return $status;
}

function processReference($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['REFERENCE'][$identifier]['REFERENCE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$sql = "SELECT ref.reference_id, ref.authors, ref.year, ref.title, 
		ref.pubmed_accession 
		FROM reference ref
		WHERE ref.locator = '$identifier'";
		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in table 'reference' with identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{	return $row[0];	}
		else
		{			
			if (strtoupper($updatesRow[0]) == strtoupper($row[1]) && strtoupper($updatesRow[1]) == strtoupper($row[2]) && strtoupper($updatesRow[2]) == strtoupper($row[3]) && strtoupper($updatesRow[3]) == strtoupper($row[4]))
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];	}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['REFERENCE'][$identifier]['REFERENCE']);
	}
	return $status;
}


function processSpecieCompound($identifier, $SpName = "")
{
	if ($SpName)
	{
		$SCs = array($SpName => $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['SPECIE_COMPOUND'][$SpName]);
	}
	else
	{
		$SCs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['SPECIE_COMPOUND'];
	}
	
	if (!$SCs)
	{	return 'PROCESSED';	}
	
	foreach ($SCs as $SpName => $updatesRow)
	{
		$sql = "SELECT sc.specie_cpd_id FROM  allnames an1, allnames an2, 
		specie_compound sc
		WHERE UPPER(an1.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an1.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'
		AND UPPER(an1.is_primary) = 'Y'
		AND an1.record_id = sc.cpd_id
		AND UPPER(an2.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($SpName) . ")
		AND an2.kw_table_id = '{$_SESSION['TableID']['SPECIES']}'
		AND UPPER(an2.is_primary) = 'Y'
		AND an2.record_id = sc.specie_id";

			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error checking in Group 'COMPOUND' for table 'SPECIE_COMPOUND' and identifier '$identifier:$SpName'. (" . $sth->getMessage() . ")";
			return 'ERROR';
		}
		if ($sth->numRows() == 0)
		{
			if ($updatesRow == 'D')
			{	$status = 'PROCESSED';	}
			else
			{	return 'NOT FOUND'; 	}
		}
		else
		{
			$row = $sth->fetchRow();
			if ($updatesRow == 'D')
			{	return $row[0];	}
			else
			{	$status = 'PROCESSED';	}
		}
		if ($status == 'PROCESSED')
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['SPECIE_COMPOUND'][$SpName]);
		}
	}
	return $status;
}


function processSpecies($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	$sql = "SELECT s.specie_id, s.taxon_ncbi_accession 
		FROM  allnames an, species s
		WHERE s.specie_id = an.record_id 
		AND an.kw_table_id = '{$_SESSION['TableID']['SPECIES']}'
		AND UPPER(an.is_primary) = 'Y'
		AND UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")";
		
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error checking in Group 'SPECIES' for table 'SPECIES' and identifier '$identifier'. (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	//print "Numrows:" . $sth->numRows();
	if ($sth->numRows() == 0)
	{
		if ($updatesRow == 'D')
		{	$status = 'PROCESSED';	}
		else
		{	return 'NOT FOUND';		}
	}
	else
	{
		$row = $sth->fetchRow();
		if ($updatesRow == 'D')
		{
			//Don't allow the species to be deleted!
			$_SESSION['errMsgs'][] = "Update contains a deleted species. As a security measure, a species cannot be deleted using updates. Species '$identifier' not deleted. (" . $sth->getMessage() . ")";
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES']);
			return 'ERROR';
		}
		else
		{
			if ($updatesRow[0] == $row[1])
			{	$status = 'PROCESSED';	}
			else
			{	return $row[0];	}
		}
	}
	if ($status == 'PROCESSED')
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES']);
	}
	return $status;
}


function findLeftSrc($group, $identifier)
{
	$url = $_SESSION['BNET_URL'];
	
	$group = strtoupper($group);
	
	$sql = "SELECT an.record_id FROM  allnames an 
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(an.is_primary) = 'Y'";
	
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error getting ID for '$group' and identifier '$identifier'.  (" . $sth->getMessage() . ")";
		return "";
	}
	elseif ($sth->numRows() == 0)
	{	$notFound = 1;	}
	
	if ($notFound)
	{	
		$url .= "simpleSearch.php";	
		return $url;
	}
	else
	{	
		$row = $sth->fetchRow();
		$identifier = $row[0];	
	}
	
	switch($group)
	{
	case 'COMPOUND':
		$url .= "showCompounds.php?cpd_id=$identifier";
		break;	
	case 'GENE':
		$url .= "showGenes.php?gene_id=$identifier";
		break;	
	case 'PROTEIN':
		$url .= "showProteins.php?protein_id=$identifier";
		break;	
	case 'SPECIES':
		$url .= "showSpecies.php?specie_id=$identifier";
		break;	
	}
	return $url;
}

function updateActivity($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['ACTIVITY'][$identifier]['ACTIVITY'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	if ($_REQUEST['ACTIVITY'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteActivity($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processActivity($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$row = split('::', $identifier);
				if ($row[1] != 'NULL')
				{
					$rec = split(':', $row[1]);
					$protein_pn = $rec[0];
					$state_type = $rec[1];
				}
				$rec = split(':', $row[0]);
				$event_pn = $rec[0];
				$EC = $rec[1];
				if ($event_pn != 'NULL')
				{
					$event_id = getEntityID('EVENT', $event_pn);
					if ($event_id == 'ERROR')
					{	return 'ERROR';		}
				}
				
				if ($EC != 'NULL')
				{
					$sql = "SELECT ec_id FROM EC WHERE ec = '$EC'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error getting EC from 'ec' table for '$EC'. (" . $sth->getMessage() . ")"; 	
						return 'ERROR';
					}
					if ($sth->numRows() > 0)
					{	
						$row = $sth->fetchRow();
						$ec_id = $row[0];	
					}
				}
				if ($protein_pn != 'NULL')
				{
					$protein_id = getEntityID('PROTEIN', $protein_pn);
					if ($protein_id == 'ERROR')
					{	return 'ERROR';		}
					
					$sql = "SELECT state_id FROM state WHERE type = '$state_type'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{
						$_SESSION['errMsgs'][] = "Error getting state_id in state table for ACTIVITY '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
					
					$row = $sth->fetchRow();
					$state_id = $row[0];
					if ($protein_id AND $state_id)
					{
						$sql = "SELECT protein_state_id FROM protein_state 
							WHERE protein_id = '$protein_id' AND state_id = '$state_id'";
						$sth = $_SESSION['dbhBNet']->query($sql);
						if ( DB::isError($sth) ) 
						{
							$_SESSION['errMsgs'][] = "Error getting state_id in state table for ACTIVITY '$identifier'. (" . $sth->getMessage() . ")"; 
							return 'ERROR';
						}
						
						$row = $sth->fetchRow();
						$protein_state_id = $row[0];
					}
				}
				
				//Adding in activity
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('activity_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new activity ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newAID = $rec[0];
				
				if ($protein_state_id > 0)
				{
			    	$sql = "INSERT INTO activity (activity_id, event_id, ec_id, protein_state_id) 
						VALUES ('$newAID', '$event_id', '$ec_id', '$protein_state_id')";
				}
				else
				{
			    	$sql = "INSERT INTO activity (activity_id, event_id, ec_id) 
						VALUES ('$newAID', '$event_id', '$ec_id')";
				}
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{
					$_SESSION['errMsgs'][] = "Error adding record in activity table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			//skipping updates part.
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['ACTIVITY'][$identifier]['ACTIVITY']);
	}
	return 'PROCESSED';
}


function updateAllNames($group, $identifier)
{
	$ANs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'];
	if (!$ANs)
	{	return 'PROCESSED';	}

	//Validated. Now Adding
	$i = 0;
	foreach ($ANs as $aname => $updatesRow)
	{
		$key1 = "ALLNAMES_$i";
		$key2 = "aname_$i";
		if ($_REQUEST[$key1])
		{	
			if ($updatesRow == 'D')
			{
				$status = deleteAllNames($group, $identifier, $aname);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$anameR = $_REQUEST[$key2];
				$search_name = convertToSearchName($anameR);
				if (strlen($anameR) == 0)
				{
					$_SESSION['errMsgs'][] = "Length of Synonym must be greater than 0.";
					return 'ERROR';
				}
				unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'][$aname]);
				$_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'][$anameR] = $updatesRow;
				$ret = processAllNames($group, $identifier, $anameR);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$record_id = getEntityID($group, $identifier);
					if ($record_id == 'ERROR')
					{	return 'ERROR';		}
					//Adding in allnames
					$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
						VALUES (nextval('allnames_id_seq'), '$anameR', '{$_SESSION['TableID'][$group]}', '$record_id', '$updatesRow[0]', '$search_name')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding in allnames table for group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				elseif ($ret > 0) //Updation required.
				{
					//Adding in allnames
					$sql = "UPDATE allnames SET aname = '$anameR', 
						is_primary = '$updatesRow[0]', search_name = '$search_name')
						WHERE name_id = '$ret'";
					
				    	$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error updating group '$group', identifier '$identifier' in allnames table. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}	
				}
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['ALLNAMES'][$aname]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateComplex($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['COMPLEX'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteComplex($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processComplex($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$complex_id = getEntityID('COMPLEX', $identifier);
				if ($complex_id == 'ERROR')
				{	return 'ERROR';		}
				
				//Adding in complex table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('complex_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new complex ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newCID = $rec[0];
				
				$sql = "INSERT INTO complex (complex_id, location_id) 
					VALUES ('$newCID', '{$_REQUEST['location_id']}')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in complex table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
				
				//Adding in allnames
				$search_name = convertToSearchName($identifier);
				$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
					VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['COMPLEX']}', '$newCID', 'Y', '$search_name')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'COMPLEX', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			elseif ($ret > 0) //Updation required.
			{
				//Updating COMPLEX
			    $sql = "UPDATE complex SET location_id = '{$_REQUEST['location_id']}'
			    	WHERE event_id = '$ret'";
				
			    $sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error updating complex '$identifier' in event table. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}	
			}
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX']);
	}

	return 'PROCESSED';
}

function updateComplexMember($identifier)
{
	$CMs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX_MEMBER'];
	if (!$CMs)
	{	return 'PROCESSED';	}
		
	//Validated. Now Adding
	$i = 0;
	foreach ($$CMs as $unique => $updatesRow)
	{
		$key1 = "COMPLEX_MEMBER_$i";
		if ($_REQUEST[$key1])
		{
			if ($updatesRow == 'D')
			{
				$status = deleteComplexMember($identifier, $unique);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processComplexMember($identifier, $unique);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$complex_id = getEntityID('COMPLEX', $identifier);
					if ($complex_id == 'ERROR')
					{	return 'ERROR';		}
					
					$rec = split(':', $unique);
					$record_id = getEntityID($rec[0], $rec[1]);
					if ($record_id == 'ERROR')
					{	return 'ERROR';		}
									
					
					//Adding in complex_member
					$sql = "INSERT INTO complex_member (complex_member_id, record_id, kw_table_id, stoichiometry, complex_id) 
						VALUES (nextval('complex_member_id_seq'), '$record_id', '{$_SESSION['TableID'][$rec[0]]}', '$updatesRow[0]', '$complex_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding in 'complex_member' table for group ''EVENT'', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				//skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPLEX'][$identifier]['COMPLEX_MEMBER'][$unique]);
		}
		$i++;
	}
	return 'PROCESSED';
}


function updateCompound($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['COMPOUND'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	if ($_REQUEST['COMPOUND'])
	{
		if ($updatesRow == 'D')
		{
			return deleteCompound($identifier);
		}
		else
		{
			$_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['COMPOUND'] = array($_REQUEST['cpd_formula'], $_REQUEST['mol_wt']);	
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['COMPOUND']);
		return 'PROCESSED';
	}
	$ret = processCompound($identifier);
	if ($ret == 'ERROR')
	{	return 'ERROR';		}
	elseif ($ret == 'NOT FOUND')
	{
	
		//Adding the compound to the compound table
		//First getting new cpd_id
		$qres = $_SESSION['dbhBNet']->query("SELECT nextval('cpd_id_seq')");
	    if( DB::isError($qres) )
	    {	
		    $_SESSION['errMsgs'][] = "Error getting new Compound ID. (" . $qres->getMessage() . ")"; 
		    return 'ERROR';
		}
	    $rec = $qres->fetchRow();
	    $newCpdID = $rec[0];
	    
	    //Adding in compound
	    $sql = "INSERT INTO compound (cpd_id, cpd_formula, mol_wt) 
			VALUES ('$newCpdID', '{$_REQUEST['cpd_formula']}', '{$_REQUEST['mol_wt']}')";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding compound '$identifier' in compound table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
		
		//Adding in allnames
		$search_name = convertToSearchName($identifier);
		$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
			VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['COMPOUND']}', '$newCpdID', 'Y', '$search_name')";
			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'COMPOUND', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}
	}
	elseif ($ret > 0) //Updation required.
	{
		//Updating compound
	    $sql = "UPDATE compound SET cpd_formula = '{$_REQUEST['cpd_formula']}', 
	    	mol_wt = '{$_REQUEST['mol_wt']}'
	    	WHERE cpd_id = '$ret'";
		
	    $sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error updating compound '$identifier' in compound table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
	}
	return 'PROCESSED';
}


function updateCompoundDer($identifier)
{
	$CDs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'];
	if (!$CDs)
	{	return 'PROCESSED';	}
	
	
	//Validated. Now Adding
	$i = 0;
	foreach ($CDs as $derName => $updatesRow)
	{
		$key1 = "CPD_DERIVATIVE_$i";
		$key2 = "name_$i";
		if ($_REQUEST[$key1])
		{	
			if ($updatesRow == 'D')
			{
				$status = deleteCompoundDer($identifier, $derName);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$name = $_REQUEST[$key2];
				if (strlen($name) == 0)
				{
					$_SESSION['errMsgs'][] = "Length of Compound Derviative Name must be greater than 0.";
					return 'ERROR';
				}
				unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'][$derName]);
				$_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'][$name] = $updatesRow;
				$ret = processCompoundDer($identifier, $name);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$cpd_id = getEntityID('COMPOUND', $identifier);
					if ($cpd_id == 'ERROR')
					{	return 'ERROR';		}
					//Now adding the compound Derivative to the cmp_derivative table
					//First getting new cpd_derivative_id
					$qres = $_SESSION['dbhBNet']->query("SELECT nextval('cpd_derivative_id_seq')");
				    if( DB::isError($qres) )
				    {	
					    $_SESSION['errMsgs'][] = "Error getting new Compound Derivative ID. Derivative '$name' Not added. (" . $qres->getMessage() . ")"; 
					    return 'ERROR';
					}
				    $rec = $qres->fetchRow();
				    $newCpdDerID = $rec[0];
					
				    //Adding in cpd_derivative
				    $sql = "INSERT INTO cpd_derivative (cpd_derivative_id, cpd_id, name) 
						VALUES ('$newCpdDerID', '$cpd_id', '$name')";
					$sth = $_SESSION['dbhBNet']->query($sql);
					
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding compound derivative '$name' in cpd_derivative table. (" . $sth->getMessage() . ")"; 	
						return 'ERROR';
					}
				}
				elseif ($ret > 0)
				{	
					//Updating cpd_derivative
				    $sql = "UPDATE cpd_derivative SET name = '$name' 
				    	WHERE cpd_derivative_id = '$ret'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error updating compound derivative '$name' in cpd_derivative table. (" . $sth->getMessage() . ")"; 	
						return 'ERROR';
					}
				}
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['CPD_DERIVATIVE'][$derName]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateEC($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EC'][$identifier]['EC'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['EC'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteEC($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			if (strlen($_REQUEST['ec_name']) == 0)
			{
				$_SESSION['errMsgs'][] = "Length of EC entered must be greater than 0.";
				return 'ERROR';
			}
			$ret = processEC($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$ec_id = getEntityID('EC', $identifier);
				if ($ec_id == 'ERROR')
				{	return 'ERROR';		}
				
				//Adding in ec table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('ec_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new ec ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newECID = $rec[0];
				
				$sql = "INSERT INTO ec (ec_id, ec_name) 
					VALUES ('$newECID', '{$_REQUEST['ec_name']}')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in ec table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
				
				//Adding in allnames
				$search_name = convertToSearchName($identifier);
				$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
					VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['EC']}', '$newECID', 'Y', '$search_name')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'EC', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			elseif ($ret > 0) //Updation required.
			{
				//Updating EC
			    $sql = "UPDATE ec SET ec_name = '{$_REQUEST['ec_name']}'
			    	WHERE ec_id = '$ret'";
				
			    $sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error updating ec '$identifier' in ec table. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}	
			}
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EC'][$identifier]['EC']);
	}

	return 'PROCESSED';
}

function updateEvent($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['EVENT'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteEvent($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processEvent($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$event_id = getEntityID('EVENT', $identifier);
				if ($event_id == 'ERROR')
				{	return 'ERROR';		}
				
				//Adding in event table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('event_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new event ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newEID = $rec[0];
				
				$sql = "INSERT INTO event (event_id, event_type_id) 
					VALUES ('$newEID', '{$_REQUEST['event_type_id']}')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in event table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
				
				//Adding in allnames
				$search_name = convertToSearchName($identifier);
				$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
					VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['EVENT']}', '$newEID', 'Y', '$search_name')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'EVENT', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			elseif ($ret > 0) //Updation required.
			{
				//Updating EVENT
			    $sql = "UPDATE event SET event_type_id = '{$_REQUEST['event_type_id']}'
			    	WHERE event_id = '$ret'";
				
			    $sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error updating event '$identifier' in event table. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}	
			}
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT']);
	}

	return 'PROCESSED';
}

function updateEventEC($identifier)
{
	$ECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_EC'];
	if (!$ECs)
	{	return 'PROCESSED';	}
	
	//Validated. Now Adding
	$i = 0;
	foreach ($ECs as $EC => $updatesRow)
	{
		$key1 = "EVENT_EC_$i";
		if ($_REQUEST[$key1])
		{	
			if ($updatesRow == 'D')
			{
				$status = deleteEventEC($identifier, $EC);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processEventEC($identifier, $EC);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$event_id = getEntityID('EVENT', $identifier);
					if ($event_id == 'ERROR')
					{	return 'ERROR';		}
					$sql = "SELECT ec_id FROM EC WHERE ec = '$EC'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error getting EC from 'ec' table for '$EC'. (" . $sth->getMessage() . ")"; 	
						return 'ERROR';
					}
					if ($sth->numRows() > 0)
					{	
						$row = $sth->fetchRow();
						$ec_id = $row[0];	
					}
					
					//Adding in event_ec table
					$qres = $_SESSION['dbhBNet']->query("SELECT nextval('event_ec_id_seq')");
				    if( DB::isError($qres) )
				    {	
					    $_SESSION['errMsgs'][] = "Error getting new event_ec ID. (" . $qres->getMessage() . ")"; 	
					    return 'ERROR';
					}
				    $rec = $qres->fetchRow();
				    $newEECID = $rec[0];
					
					$sql = "INSERT INTO event_ec (event_ec_id, event_id, ec_id) 
						VALUES ('$newEECID', '$event_id', '$ec_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding record in event_ec table for '$identifier', '$EC'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				//skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_EC'][$EC]);
		}
		$i++;
	}
	return 'PROCESSED';
}


function updateEventComponent($identifier)
{
	$ECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_COMPONENT'];
	if (!$ECs)
	{	return 'PROCESSED';	}
		
	//Validated. Now Adding
	$i = 0;
	foreach ($ECs as $unique => $updatesRow)
	{
		$key1 = "EVENT_COMPONENT_$i";
		if ($_REQUEST[$key1])
		{
			if ($updatesRow == 'D')
			{
				$status = deleteEventComponent($identifier, $unique);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processEventComponent($identifier, $unique);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$event_id = getEntityID('EVENT', $identifier);
					if ($event_id == 'ERROR')
					{	return 'ERROR';		}
					
					$rec = split(':', $unique);
					$record_id = getEntityID($rec[0], $rec[1]);
					if ($record_id == 'ERROR')
					{	return 'ERROR';		}
									
					
					$sql = "SELECT location_id FROM location WHERE UPPER(location_name) = UPPER('$updatesRow[1]')";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error checking for location_id in location group ''EVENT'', identifier '$identifier', unique '$unique'. (" . $sth->getMessage() . ")";
						return 'ERROR';
					}
					if ($sth->numRows() == 0)
					{
						$_SESSION['errMsgs'][] = "location_id for location '$updatesRow[1]' not found. Cannot proceed without location_id";
						return 'ERROR';
					}
					$row = $sth->fetchRow();
					$location_id = $row[0];
					
					//Adding in Event Component
					$sql = "INSERT INTO event_component (event_component_id, record_id, kw_table_id, is_substrate, location_id, stoichiometry, event_id) 
						VALUES (nextval('event_component_id_seq'), '$record_id', '{$_SESSION['TableID'][$rec[0]]}', '$rec[2]', $location_id, '$updatesRow[0]', '$event_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding in 'Event Component' table for group ''EVENT'', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				//skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT'][$identifier]['EVENT_COMPONENT'][$unique]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateEventType($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT_TYPE'][$identifier]['EVENT_TYPE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['EVENT_TYPE'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteEventType($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processEventType($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				//Adding in event_type table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('event_type_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new event_type ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newETID = $rec[0];
				
			    $sql = "INSERT INTO event_type (event_type_id, event_type_name) 
					VALUES ('$newETID', '$identifier')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in event_type table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			//Updation not required.
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVENT_TYPE'][$identifier]['EVENT_TYPE']);
	}
	return 'PROCESSED';
}

function updateEvidence($group, $identifier)
{
	$EVs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EVIDENCE'];
	if (!$EVs)
	{	return 'PROCESSED';	}

	//Validated. Now Adding
	$i = 0;
	foreach ($EVs as $unique => $updatesRow)
	{
		$key1 = "EVIDENCE_$i";
		if ($_REQUEST[$key1])
		{
			if ($updatesRow == 'D')
			{
				$status = deleteEvidence($group, $identifier, $unique);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processEvidence($group, $identifier, $unique);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$record_id = getEntityID($group, $identifier);
					if ($record_id == 'ERROR')
					{	return 'ERROR';		}	
					$records = split('::', $unique);
					$locator = $records[0];
					$ECRecord = split(':', $records[1]);
		
					//Getting Reference ID
					$sql = "SELECT reference_id FROM reference WHERE locator = '$locator'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error checking for reference_id in reference - group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")";
						return 'ERROR';
					}
					if ($sth->numRows() == 0)
					{
						$_SESSION['errMsgs'][] = "reference_id for locator '$locator' not found. Cannot proceed without reference_id";
						return 'ERROR';
					}
					$row = $sth->fetchRow();
					$reference_id = $row[0];
					
					//Getting evidence_code_id
					$sql = "SELECT evidence_code_id FROM evidence_code ec
						WHERE UPPER(ec.evidence_code) = UPPER('$ECRecord[0]')
						AND ec.kw_table_id = '{$_SESSION['TableID'][$ECRecord[1]]}'
						AND UPPER(ec.technique) = UPPER('$ECRecord[2]')
						AND UPPER(ec.strength) = UPPER('$ECRecord[3]')";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error checking for evidence_code_id in evidence_code - group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")";
						return 'ERROR';
					}
					if ($sth->numRows() == 0)
					{
						$_SESSION['errMsgs'][] = "evidence_code_id for unique code '$unique' not found. Cannot proceed without evidence_code_id";
						return 'ERROR';
					}
					$row = $sth->fetchRow();
					$evidence_code_id = $row[0];
					
					if ($group == 'COMPOUND')
					{
						//Getting specie_compound ID
						$sql = "SELECT specie_cpd_id FROM specie_compound
							WHERE specie_id = '{$_SESSION['CurrentSpecieID']}'
							AND cpd_id = '$record_id'";
						$sth = $_SESSION['dbhBNet']->query($sql);
						if ( DB::isError($sth) ) 
						{	
							$_SESSION['errMsgs'][] = "Error checking for specie_compound_id in specie_compound - group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")";
							return 'ERROR';
						}
						if ($sth->numRows() == 0)
						{
							$_SESSION['errMsgs'][] = "specie_cpd_id for specie_id '{$_SESSION['CurrentSpecieID']}' and cpd_id '$record_id' not found. Cannot proceed without specie_cpd_id";
							return 'ERROR';
						}
						$row = $sth->fetchRow();
						$specie_compound_id = $row[0];
						
						//Evidence SQL
						$sql = "INSERT INTO evidence (evidence_id, reference_id, evidence_code_id, kw_table_id, record_id) 
							VALUES (nextval('evidence_id_seq'), '$reference_id', '$evidence_code_id', '{$_SESSION['TableID']['SPECIE_COMPOUND']}', '$specie_compound_id')";
					}
					else
					{
						//Adding in Evidence
						$sql = "INSERT INTO evidence (evidence_id, reference_id, evidence_code_id, kw_table_id, record_id) 
							VALUES (nextval('evidence_id_seq'), '$reference_id', '$evidence_code_id', '{$_SESSION['TableID'][$group]}', '$record_id')";	
					}
					
											
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding in 'Evidence' table for group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}	
				//No Updates can happen for an Evidence. Hence skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EVIDENCE'][$unique]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateEvidenceCode($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EVIDENCE_CODE'][$identifier]['EVIDENCE_CODE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['EVIDENCE_CODE'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteEvidenceCode($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processEvidenceCode($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$ECRecord = split(':', $identifier);
				//Adding in evidence_code table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('evidence_code_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new evidence_code ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newECID = $rec[0];
				
			    $key = $ECRecord[1];
				$sql = "INSERT INTO evidence_code (evidence_code_id, evidence_code, kw_table_id, technique, strength) 
					VALUES ('$newECID', '$ECRecord[0]', '{$_SESSION['TableID'][$key]}', '$ECRecord[2]', '$ECRecord[3]')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in evidence_code table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
				
			}
			//Updation not required.
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EVIDENCE_CODE'][$identifier]['EVIDENCE_CODE']);
	}

	return 'PROCESSED';
}

function updateExternalDatabase($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['EXTERNAL_DATABASE'][$identifier]['EXTERNAL_DATABASE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['EXTERNAL_DATABASE'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteExternalDatabase($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			if (strlen($_REQUEST['database_name']) == 0)
			{
				$_SESSION['errMsgs'][] = "Please enter database_name";
				return 'ERROR';
			}
			if (strlen($_REQUEST['url']) == 0)
			{
				$_SESSION['errMsgs'][] = "Please enter url";
				return 'ERROR';
			}
			
			$ret = processExternalDatabase($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				//Adding in external_database table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('external_database_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new external_database ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newEDID = $rec[0];
				
			    $sql = "INSERT INTO external_database (external_database_id, database_name, full_db_name, url) 
					VALUES ('$newEDID', '$identifier', '{$_REQUEST['database_name']}', '{$_REQUEST['url']}')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in external_database table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			elseif ($ret > 0) //Updation required.
			{
				//Updating External Database
			    $sql = "UPDATE external_database SET 
			    database_name = '{$_REQUEST['database_name']}',
			    url = '{$_REQUEST['url']}'
			    WHERE external_database_id = '$ret'";
				
			    $sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error updating external_database '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}	
			}
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['EXTERNAL_DATABASE'][$identifier]['EXTERNAL_DATABASE']);
	}

	return 'PROCESSED';
}

function updateExternalLinks($group, $identifier)
{
	$ELs = $_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'];
	if (!$ELs)
	{	return 'PROCESSED';	}
		
	//Validated. Now Adding
	$i = 0;
	foreach ($ELs as $ExtDBname => $updatesRow)
	{
		$key1 = "EXTERNAL_LINKS_$i";
		$key2 = "external_table_name_$i";
		$key3 = "external_field_name_$i";
		$key4 = "internal_field_name_$i";
		$key5 = "external_id_$i";
		
		if ($_REQUEST[$key1])
		{
			if ($updatesRow == 'D')
			{
				$status = deleteExternalLinks($group, $identifier, $ExtDBname);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$external_table_name = $_REQUEST[$key2];
				$external_field_name = $_REQUEST[$key3];
				$internal_field_name = $_REQUEST[$key4];
				$external_id = $_REQUEST[$key5];
				
				$_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'][$ExtDBname] = array($external_table_name, $external_field_name, $internal_field_name, $external_id);
				$ret = processExternalLinks($group, $identifier, $ExtDBname);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$record_id = getEntityID($group, $identifier);
					if ($record_id == 'ERROR')
					{	return 'ERROR';		}
					$sql = "SELECT external_database_id FROM external_database WHERE UPPER(full_db_name) = UPPER('$ExtDBname')";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error checking for external_database_id in external links - group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")";
						return 'ERROR';
					}
					if ($sth->numRows() == 0)
					{
						$_SESSION['errMsgs'][] = "external_database_id for External Database '$ExtDBname' not found. Cannot proceed without external_database_id";
						return 'ERROR';
					}
					$row = $sth->fetchRow();
					
					//Adding in External Links
					$sql = "INSERT INTO external_links (external_links_id, external_database_id, external_table_name, external_field_name, internal_field_name, external_id, kw_table_id, record_id) 
						VALUES (nextval('external_links_id_seq'), '$row[0]', '$external_table_name', '$external_field_name', '$internal_field_name', '$external_id',  '{$_SESSION['TableID'][$group]}', '$record_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding in 'External Links' table for group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				elseif ($ret > 0)
				{	
					$sql = "SELECT external_database_id FROM external_database WHERE UPPER(full_db_name) = UPPER('$ExtDBname')";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error checking for external_database_id in external links - group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")";
						return 'ERROR';
					}
					if ($sth->numRows() == 0)
					{
						$_SESSION['errMsgs'][] = "external_database_id for External Database '$ExtDBname' not found. Cannot proceed without external_database_id";
						return 'ERROR';
					}
					$row = $sth->fetchRow();
					
					//Updating External Links
					$sql = "UPDATE external_links SET external_table_name = '$external_table_name', 
						external_field_name = '$external_field_name', internal_field_name = '$internal_field_name', 
						external_id = '$external_id'
						WHERE external_links_id = '$ret'";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error updating 'External Links' table for group '$group', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$group][$identifier]['EXTERNAL_LINKS'][$ExtDBname]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateGene($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['GENE'][$identifier]['GENE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	if ($_REQUEST['GENE'])
	{
		if ($updatesRow == 'D')
		{
			return deleteGene($identifier);
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['GENE'][$identifier]['GENE']);
		return 'PROCESSED';
	}
	$ret = processGene($identifier);
	if ($ret == 'ERROR')
	{	return 'ERROR';		}
	elseif ($ret == 'NOT FOUND')
	{
		//Adding the gene
		//First getting new gene_id
		$qres = $_SESSION['dbhBNet']->query("SELECT nextval('gene_id_seq')");
	    if( DB::isError($qres) )
	    {	
		    $_SESSION['errMsgs'][] = "Error getting new Gene ID. (" . $qres->getMessage() . ")"; 
		    return 'ERROR';
		}
	    $rec = $qres->fetchRow();
	    $newGeneID = $rec[0];
	    
	    //Then specie ID
	    $specie_id = getEntityID('SPECIES', $updatesRow[0]);
	    if ($specie_id == 'ERROR')
	    {	return 'ERROR';	}
	    
	    //Adding in compound
	    $sql = "INSERT INTO gene (gene_id, specie_id) VALUES ('$newGeneID', '$specie_id')";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding gene '$identifier' in gene table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
		
		//Adding in allnames
		$search_name = convertToSearchName($identifier);
		$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
			VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['GENE']}', '$newGeneID', 'Y', '$search_name')";
			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'GENE', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}
	}
	//skipping updation part.
	return 'PROCESSED';
}


function updateLocation($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['LOCATION'][$identifier]['LOCATION'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['LOCATION'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteLocation($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processLocation($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				//Adding in location table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('location_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new Location ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newLID = $rec[0];
				
			    $sql = "INSERT INTO location (location_id, location_name) 
					VALUES ('$newLID', '$identifier')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in location table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			//Updation not required.
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['LOCATION'][$identifier]['LOCATION']);
	}

	return 'PROCESSED';
}


function updateMrna($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['MRNA'][$identifier]['MRNA'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
		
	if ($_REQUEST['MRNA'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteMrna($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processMrna($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			elseif ($ret == 'NOT FOUND')
			{	
				$gene_id = getEntityID('GENE', $updatesRow[0]);
				if ($gene_id == 'ERROR')
				{	return 'ERROR';		}
				$protein_id = getEntityID('PROTEIN', $updatesRow[1]);
				if ($protein_id == 'ERROR')
				{	return 'ERROR';		}
				
				//Adding in mrna table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('mrna_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new mrna ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newMrnaID = $rec[0];
				
				$sql = "INSERT INTO mrna (mrna_id, gene_id, protein_id) 
					VALUES ('$newMrnaID', '$gene_id', '$protein_id')";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in mrna table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			//No Updates can happen for Mrna. Hence skipping updates part.
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['MRNA'][$identifier]['MRNA']);
	}

	return 'PROCESSED';
}

function updateProtein($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	if ($_REQUEST['PROTEIN'])
	{
		if ($updatesRow == 'D')
		{
			return deleteProtein($identifier);
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN']);
		return 'PROCESSED';
	}
	$ret = processProtein($identifier);
	if ($ret == 'ERROR')
	{	return 'ERROR';		}
	elseif ($ret == 'NOT FOUND')
	{
		//Adding the protein
		//First getting new protein_id
		$qres = $_SESSION['dbhBNet']->query("SELECT nextval('gene_id_seq')");
	    if( DB::isError($qres) )
	    {	
		    $_SESSION['errMsgs'][] = "Error getting new Protein ID. (" . $qres->getMessage() . ")"; 
		    return 'ERROR';
		}
	    $rec = $qres->fetchRow();
	    $newProteinID = $rec[0];
	    
	    //Then specie ID
	    $specie_id = getEntityID('SPECIES', $updatesRow[0]);
	    if ($specie_id == 'ERROR')
	    {	return 'ERROR';	}
	    
	    //Adding in compound
	    $sql = "INSERT INTO protein (protein_id, specie_id) VALUES ('$newProteinID', '$specie_id')";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding protein '$identifier' in protein table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
		
		//Adding in allnames
		$search_name = convertToSearchName($identifier);
		$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
			VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['PROTEIN']}', '$newProteinID', 'Y', '$search_name')";
			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'PROTEIN', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}
	}
	//skipping updation part.
	return 'PROCESSED';
}

function updateProteinEC($identifier)
{
	$ECs = $_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN_EC'];
	if (!$ECs)
	{	return 'PROCESSED';	}
	
	//Validated. Now Adding
	$i = 0;
	foreach ($ECs as $EC => $updatesRow)
	{
		$key1 = "PROTEIN_EC_$i";
		if ($_REQUEST[$key1])
		{	
			if ($updatesRow == 'D')
			{
				$status = deleteProteinEC($identifier, $EC);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processProteinEC($identifier, $EC);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$protein_id = getEntityID('PROTEIN', $identifier);
					if ($protein_id == 'ERROR')
					{	return 'ERROR';		}
					$sql = "SELECT ec_id FROM EC WHERE ec = '$EC'";
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error getting EC from 'ec' table for '$EC'. (" . $sth->getMessage() . ")"; 	
						return 'ERROR';
					}
					if ($sth->numRows() > 0)
					{	
						$row = $sth->fetchRow();
						$ec_id = $row[0];	
					}
					
					//Adding in protein_ec table
					$qres = $_SESSION['dbhBNet']->query("SELECT nextval('protein_ec_id_seq')");
				    if( DB::isError($qres) )
				    {	
					    $_SESSION['errMsgs'][] = "Error getting new Protein EC ID. (" . $qres->getMessage() . ")"; 	
					    return 'ERROR';
					}
				    $rec = $qres->fetchRow();
				    $newPECID = $rec[0];
					
					$sql = "INSERT INTO protein_ec (protein_ec_id, protein_id, ec_id) 
						VALUES ('$newPECID', '$protein_id', '$ec_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding record in protein_ec table for '$identifier', '$EC'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				//skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['PROTEIN'][$identifier]['PROTEIN_EC'][$EC]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateReference($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['REFERENCE'][$identifier]['REFERENCE'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
		
	if ($_REQUEST['REFERENCE'])
	{	
		if ($updatesRow == 'D')
		{
			$status = deleteReference($identifier);
			if ($status == 'ERROR')
			{	return 'ERROR';		}
		}
		else
		{
			$ret = processReference($identifier);
			if ($ret == 'ERROR')
			{	return 'ERROR';		}
			
			$authors = $_SESSION['dbhBNet']->quote($_REQUEST['authors']);
			$year = $_SESSION['dbhBNet']->quote($_REQUEST['year']);
			$title = $_SESSION['dbhBNet']->quote($_REQUEST['title']);
			$locator = $_SESSION['dbhBNet']->quote($identifier);
			$pubmed_accession = $_SESSION['dbhBNet']->quote($_REQUEST['pubmed_accession']);
			
			if ($ret == 'NOT FOUND')
			{	
				//Adding in reference table
				$qres = $_SESSION['dbhBNet']->query("SELECT nextval('reference_id_seq')");
			    if( DB::isError($qres) )
			    {	
				    $_SESSION['errMsgs'][] = "Error getting new Reference ID. (" . $qres->getMessage() . ")"; 	
				    return 'ERROR';
				}
			    $rec = $qres->fetchRow();
			    $newRID = $rec[0];
				
			    
			    $sql = "INSERT INTO reference (reference_id, authors, year, title, locator, pubmed_accession) 
					VALUES ('$newRID', $authors, $year, $title, $locator, $pubmed_accession)";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error adding record in reference table for '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
			elseif ($ret > 0)
			{	
				//Updating Reference
				$sql = "UPDATE reference SET authors = $authors, year = $year, 
					title = $title, pubmed_accession = $pubmed_accession 
					WHERE reference_id = '$ret'";
					
				$sth = $_SESSION['dbhBNet']->query($sql);
				if ( DB::isError($sth) ) 
				{	
					$_SESSION['errMsgs'][] = "Error updating reference table for locator '$identifier'. (" . $sth->getMessage() . ")"; 
					return 'ERROR';
				}
			}
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['REFERENCE'][$identifier]['REFERENCE']);
	}
	return 'PROCESSED';
}

function updateRest($group, $identifier)
{
	
	$ret = updateAllNames($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}
	
	$ret = updateEvidence($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}

	$ret = updateExternalLinks($group, $identifier);
	if ($ret != 'PROCESSED')
	{	return $ret;	}
	
	return $ret;
}

function updateSpecieCompound($identifier)
{
	$SCs = $_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['SPECIE_COMPOUND'];
	if (!$SCs)
	{	return 'PROCESSED';	}
	
	//Validated. Now Adding
	$i = 0;
	foreach ($SCs as $SpName => $updatesRow)
	{
		$key1 = "SPECIE_COMPOUND_$i";
		if ($_REQUEST[$key1])
		{	
			if ($updatesRow == 'D')
			{
				$status = deleteSpecieCompound($identifier, $SpName);
				if ($status == 'ERROR')
				{	return 'ERROR';		}
			}
			else
			{
				$ret = processSpecieCompound($identifier, $SpName);
				if ($ret == 'ERROR')
				{	return 'ERROR';		}
				elseif ($ret == 'NOT FOUND')
				{	
					$cpd_id = getEntityID('COMPOUND', $identifier);
					if ($cpd_id == 'ERROR')
					{	return 'ERROR';		}
					$specie_id = getEntityID('SPECIES', $SpName);
					if ($specie_id == 'ERROR')
					{	return 'ERROR';		}
					
					//Adding in specie_compound table
					$qres = $_SESSION['dbhBNet']->query("SELECT nextval('specie_cpd_id_seq')");
				    if( DB::isError($qres) )
				    {	
					    $_SESSION['errMsgs'][] = "Error getting new Specie-Compound ID. (" . $qres->getMessage() . ")"; 	
					    return 'ERROR';
					}
				    $rec = $qres->fetchRow();
				    $newSCID = $rec[0];
					
					$sql = "INSERT INTO specie_compound (specie_cpd_id, specie_id, cpd_id) 
						VALUES ('$newSCID', '$specie_id', '$cpd_id')";
						
					$sth = $_SESSION['dbhBNet']->query($sql);
					if ( DB::isError($sth) ) 
					{	
						$_SESSION['errMsgs'][] = "Error adding record in specie_compound table for '$SpName'. (" . $sth->getMessage() . ")"; 
						return 'ERROR';
					}
				}
				//No Updates can happen for specie_compound. Hence skipping updates part.
			}
		}
		else
		{
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['COMPOUND'][$identifier]['SPECIE_COMPOUND'][$SpName]);
		}
		$i++;
	}
	return 'PROCESSED';
}

function updateSpecies($identifier)
{
	$updatesRow = $_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES'];
	if (!$updatesRow)
	{	return 'PROCESSED';	}
	
	if ($_REQUEST['SPECIES'])
	{
		if ($updatesRow == 'D')
		{
			$_SESSION['errMsgs'][] = "Deletion of species is not allowed. Species '$identifier' NOT deleted.";
			unset($_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES']);
			return 'PROCESSED';
		}
		else
		{
			$_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES'] = array($_REQUEST['taxon_ncbi_accession']);	
		}
	}
	else
	{
		unset($_SESSION['PROCESS_UPDATES']['updatesHash']['SPECIES'][$identifier]['SPECIES']);
		return 'PROCESSED';
	}
	$ret = processSpecies($identifier);
	if ($ret == 'ERROR')
	{	return 'ERROR';		}
	elseif ($ret == 'NOT FOUND')
	{
		//First getting new specie_id
		$qres = $_SESSION['dbhBNet']->query("SELECT nextval('specie_id_seq')");
	    if( DB::isError($qres) )
	    {	
		    $_SESSION['errMsgs'][] = "Error getting new Compound ID. (" . $qres->getMessage() . ")"; 
		    return 'ERROR';
		}
	    $rec = $qres->fetchRow();
	    $newSpcID = $rec[0];
	    
	    //Adding in species
	    $sql = "INSERT INTO species (specie_id, taxon_ncbi_accession) 
			VALUES ('$newSpcID', '{$_REQUEST['taxon_ncbi_accession']}')";
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding species '$identifier' in species table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
		
		//Adding in allnames
		$search_name = convertToSearchName($identifier);
		$sql = "INSERT INTO allnames (name_id, aname, kw_table_id, record_id, is_primary, search_name) 
			VALUES (nextval('allnames_id_seq'), '$identifier', '{$_SESSION['TableID']['SPECIES']}', '$newSpcID', 'Y', '$search_name')";
			
		$sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error adding in allnames table for group 'SPECIES', identifier '$identifier'. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}
	}
	elseif ($ret > 0) //Updation required.
	{
		//Updating species
	    $sql = "UPDATE species SET taxon_ncbi_accession = '{$_REQUEST['taxon_ncbi_accession']}', 
	    	WHERE specie_id = '$ret'";
		
	    $sth = $_SESSION['dbhBNet']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$_SESSION['errMsgs'][] = "Error updating specie '$identifier' in species table. (" . $sth->getMessage() . ")"; 
			return 'ERROR';
		}	
	}
	return 'PROCESSED';
}


function getEntityID($group, $identifier)
{
	$group = strtoupper($group);
	$sql = "SELECT an.record_id FROM  allnames an 
		WHERE UPPER(an.aname) = UPPER(" . $_SESSION['dbhBNet']->quote($identifier) . ")
		AND an.kw_table_id = '{$_SESSION['TableID'][$group]}'
		AND UPPER(an.is_primary) = 'Y'";
	
	$sth = $_SESSION['dbhBNet']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$_SESSION['errMsgs'][] = "Error getting ID for '$group' and identifier '$identifier'.  (" . $sth->getMessage() . ")";
		return 'ERROR';
	}
	if ($sth->numRows() == 0)
	{	
		$_SESSION['errMsgs'][] = "No $group named '$identifier' found in the database.  '$identifier' should be present in $group for the operation to proceed.";
		return 'ERROR';
	}
	$row = $sth->fetchRow();
	return $row[0];
}

function processForm()
{
	$currGroup = $_SESSION['PROCESS_UPDATES']['CURRENT_GROUP'];
	$currIdentifier = key($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]);
	$isMainEntityBeingDeleted = ($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup][$currIdentifier][$currGroup] == 'D');
	$_SESSION['dbhBNet']->query("BEGIN TRANSACTION");
	switch($currGroup)
	{
	case 'ACTIVITY':
		$status = updateActivity($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'COMPLEX':
		$status = updateComplex($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'COMPOUND':
		$status = updateCompound($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateCompoundDer($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateSpecieCompound($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
		
	case 'EC':
		$status = updateEC($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'EVENT':
		$status = updateEvent($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateActivity($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateEventEC($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateEventComponent($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'EVENT_TYPE':
		$status = updateEventType($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'EVIDENCE_CODE':
		$status = updateEvidenceCode($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'EXTERNAL_DATABASE':
		$status = updateExternalDatabase($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
		
	case 'GENE':
		$status = updateGene($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		
		if (!$isMainEntityBeingDeleted)
		{
			/*$status = updateMrna($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}*/
			
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'LOCATION':
		$status = updateLocation($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'MRNA':
		$status = updateMrna($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'PATHWAY':
		break;
	case 'PROTEIN':
		$status = updateProtein($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateProteinEC($currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
			
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	case 'REFERENCE':
		$status = updateReference($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;	
	case 'SPECIES':
		$status = updateSpecies($currIdentifier);	
		if ($status == 'ERROR')
		{	
			$_SESSION['dbhBNet']->query("ROLLBACK");
			return;	
		}
		if (!$isMainEntityBeingDeleted)
		{
			$status = updateRest($currGroup, $currIdentifier);
			if ($status == 'ERROR')
			{	
				$_SESSION['dbhBNet']->query("ROLLBACK");
				return;	
			}
		}
		break;
	}
	
	$_SESSION['errMsgs'][] = "$status";
	$_SESSION['dbhBNet']->query("COMMIT");
	unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup][$currIdentifier]);
	if (count($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]) == 0)
	{
		//Before Leaving 'COMPOUND' group Recalculate the Primary Names in allnames
		//for events that were updated.
		if ($currGroup == 'COMPOUND')
		{	include("populateReactionNames.php");	}
		unset($_SESSION['PROCESS_UPDATES']['updatesHash'][$currGroup]);
	}
}
?>
