<?php
/**
* This script helps to produce Sample
* file to submit to GEO.
* Date: 11 Dec 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

//Functions
function produceSampleFile($sampling_replicate_id1, $sampling_replicate_id2 = 0, $protocol_type_id)
{
	global $errMsgs;
	$sid = session_id();
	$sampleFileRelative = "{$_SESSION['BROWSER_TMP_RELATIVE']}sampleFile-{$sid}.txt";
	$sampleFileFull = "{$_SESSION['BROWSER_TMP_FULL']}sampleFile-{$sid}.txt";
	//Open file to write
	if (!$sampleFileHandle = fopen($sampleFileFull, 'w'))
	{
		$errMsgs[] = "Cannot open Platform file ($sampleFile)";
		return false;
	}
	produceSampleText($sampleFileHandle, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id);
	fclose ($sampleFileHandle);
}

function produceSampleText(&$file_descriptor, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id)
{
	global $errMsgs;
	
	if ($sampling_replicate_id2 > 0)
	{
		//Get Sample Data from different tables.
		$sql1 = "SELECT h.\"hybridization_id\", h.\"labeled_extract1_id\", h.\"labeled_extract2_id\", 
			h.\"sample_entity\", h.\"sample_title\", 
			hp.\"full_protocol_description\", sp.\"full_protocol_description\", 
			h.\"other_description\", ab.\"platform_geo_accession\",
			bp1.\"biosource_properties_name\", e1.\"exp_name\", l1.\"name\", sr1.\"replicate\",
			bp1.\"organism\", bp1.\"contact_details_for_sample\", bp1.\"cell_type\",
			bp1.\"sex\", bp1.\"age\", bp1.\"developmental_stage\", bp1.\"strain_or_line\",
			bp1.\"genetic_variation\", bp1.\"individual_number\", bp1.\"individual_genetic_charactersti\",
			bp1.\"disease_state\", bp1.\"targeted_cell_type\", bp1.\"cell_line\", 
			bp1.\"organism_part\", bp1.\"biomaterial_provider\", 
			bm1.\"invivo_treatment\", bm1.\"invitro_treatment\", 
			bm1.\"treatment_type\", bm1.\"compound\", bm1.\"separation_technique\", 		
			gc1.\"atmosphere\", gc1.\"contaminant_organism\", gc1.\"density_range\", 
			gc1.\"generations\", gc1.\"host\", gc1.\"humidity\", gc1.\"light\", 
			gc1.\"medium\", gc1.\"nutrients\", gc1.\"temperature\", 
			ext1.\"extract_molecule\", ext1.\"extraction_method\", 
			sl1.\"label_used\", sl1.\"label_incorporation_method\"
		FROM \"hybridization\" h, \"hybridization_protocol\" hp, \"scanning_protocol\" sp,
			\"raw_data\" rd, \"array_batch\" ab, \"array\" a, 
			\"biosource_properties\" bp1, \"experiment\" e1, \"label\" l1, \"sampling_replicate\" sr1,
			\"biomaterial_manipulation\" bm1, \"growth_conditions\" gc1, \"extract\" ext1,
			\"sample_labeling\" sl1, 
			\"labeled_extract\" le1, \"sample_extract\" se1, \"sample\" s1,	\"sampling_point\" sp1
		WHERE sr1.\"sampling_replicate_id\" = $sampling_replicate_id1
			AND s1.\"sampling_replicate_id\" = sr1.\"sampling_replicate_id\"	
			AND se1.\"sample_id\" = s1.\"sample_id\"
			AND se1.\"extract_id\" = ext1.\"extract_id\"
			AND le1.\"sample_extract_id\" = se1.\"sample_extract_id\"
			AND le1.\"sample_labeling_id\" = sl1.\"sample_labeling_id\"
			AND h.\"labeled_extract1_id\" = le1.\"labeled_extract_id\"
			AND h.\"hybridization_protocol_id\" = hp.\"hybridization_protocol_id\"
			AND h.\"array_id\" = a.\"array_id\"
			AND a.\"array_batch_id\" = ab.\"array_batch_id\"
			AND rd.\"hybridization_id\" = h.\"hybridization_id\"
			AND rd.\"scanning_protocol_id\" = sp.\"scanning_protocol_id\"
			AND sr1.\"sampling_point_id\" = sp1.\"sampling_point_id\"
			AND sp1.\"experiment_id\" = e1.\"experiment_id\"
			AND sp1.\"label_id\" = l1.\"label_id\"
			AND e1.\"biomaterial_manipulation_id\" = bm1.\"biomaterial_manipulation_id\"
			AND bm1.\"growth_conditions_id\" = gc1.\"growth_conditions_id\"
			AND bm1.\"biosource_properties_id\" = bp1.\"biosource_properties_id\"";
		
		$sql2 = "SELECT h.\"hybridization_id\", h.\"labeled_extract2_id\", 
			bp1.\"biosource_properties_name\", e1.\"exp_name\", l1.\"name\", sr1.\"replicate\",
			bp1.\"organism\", bp1.\"contact_details_for_sample\", bp1.\"cell_type\",
			bp1.\"sex\", bp1.\"age\", bp1.\"developmental_stage\", bp1.\"strain_or_line\",
			bp1.\"genetic_variation\", bp1.\"individual_number\", bp1.\"individual_genetic_charactersti\",
			bp1.\"disease_state\", bp1.\"targeted_cell_type\", bp1.\"cell_line\", 
			bp1.\"organism_part\", bp1.\"biomaterial_provider\", 
			bm1.\"invivo_treatment\", bm1.\"invitro_treatment\", 
			bm1.\"treatment_type\", bm1.\"compound\", bm1.\"separation_technique\", 		
			gc1.\"atmosphere\", gc1.\"contaminant_organism\", gc1.\"density_range\", 
			gc1.\"generations\", gc1.\"host\", gc1.\"humidity\", gc1.\"light\", 
			gc1.\"medium\", gc1.\"nutrients\", gc1.\"temperature\", 
			ext1.\"extract_molecule\", ext1.\"extraction_method\", 
			sl1.\"label_used\", sl1.\"label_incorporation_method\"
		FROM \"hybridization\" h, 
			\"biosource_properties\" bp1, \"experiment\" e1, \"label\" l1, \"sampling_replicate\" sr1,
			\"biomaterial_manipulation\" bm1, \"growth_conditions\" gc1, \"extract\" ext1,
			\"sample_labeling\" sl1, 
			\"labeled_extract\" le1, \"sample_extract\" se1, \"sample\" s1,	\"sampling_point\" sp1
		WHERE sr1.\"sampling_replicate_id\" = $sampling_replicate_id2
			AND s1.\"sampling_replicate_id\" = sr1.\"sampling_replicate_id\"
			AND se1.\"sample_id\" = s1.\"sample_id\"
			AND se1.\"extract_id\" = ext1.\"extract_id\"
			AND h.\"labeled_extract2_id\" = le1.\"labeled_extract_id\"
			AND le1.\"sample_extract_id\" = se1.\"sample_extract_id\"
			AND le1.\"sample_labeling_id\" = sl1.\"sample_labeling_id\"
			AND sr1.\"sampling_point_id\" = sp1.\"sampling_point_id\"
			AND sp1.\"experiment_id\" = e1.\"experiment_id\"
			AND sp1.\"label_id\" = l1.\"label_id\"
			AND e1.\"biomaterial_manipulation_id\" = bm1.\"biomaterial_manipulation_id\"
			AND bm1.\"growth_conditions_id\" = gc1.\"growth_conditions_id\"
			AND bm1.\"biosource_properties_id\" = bp1.\"biosource_properties_id\"";
			
	
		$sql = "SELECT * FROM ($sql1) AS a, ($sql2) AS b 
			WHERE a.\"hybridization_id\" = b.\"hybridization_id\"";
	}
	else
	{
		//Get Sample Data from different tables.
		$sql = "SELECT h.\"hybridization_id\", h.\"labeled_extract1_id\", h.\"labeled_extract2_id\", 
			h.\"sample_entity\", h.\"sample_title\", 
			hp.\"full_protocol_description\", sp.\"full_protocol_description\", 
			h.\"other_description\", ab.\"platform_geo_accession\",
			bp1.\"biosource_properties_name\", e1.\"exp_name\", l1.\"name\", sr1.\"replicate\",
			bp1.\"organism\", bp1.\"contact_details_for_sample\", bp1.\"cell_type\",
			bp1.\"sex\", bp1.\"age\", bp1.\"developmental_stage\", bp1.\"strain_or_line\",
			bp1.\"genetic_variation\", bp1.\"individual_number\", bp1.\"individual_genetic_charactersti\",
			bp1.\"disease_state\", bp1.\"targeted_cell_type\", bp1.\"cell_line\", 
			bp1.\"organism_part\", bp1.\"biomaterial_provider\", 
			bm1.\"invivo_treatment\", bm1.\"invitro_treatment\", 
			bm1.\"treatment_type\", bm1.\"compound\", bm1.\"separation_technique\", 		
			gc1.\"atmosphere\", gc1.\"contaminant_organism\", gc1.\"density_range\", 
			gc1.\"generations\", gc1.\"host\", gc1.\"humidity\", gc1.\"light\", 
			gc1.\"medium\", gc1.\"nutrients\", gc1.\"temperature\", 
			ext1.\"extract_molecule\", ext1.\"extraction_method\", 
			'biotin' AS \"label_used\"
		FROM \"hybridization\" h, \"hybridization_protocol\" hp, \"scanning_protocol\" sp,
			\"raw_data\" rd, \"array_batch\" ab, \"array\" a, 
			\"biosource_properties\" bp1, \"experiment\" e1, \"label\" l1, \"sampling_replicate\" sr1,
			\"biomaterial_manipulation\" bm1, \"growth_conditions\" gc1, \"extract\" ext1,
			\"labeled_extract\" le1, \"sample_extract\" se1, \"sample\" s1,	\"sampling_point\" sp1
		WHERE sr1.\"sampling_replicate_id\" = $sampling_replicate_id1
			AND s1.\"sampling_replicate_id\" = sr1.\"sampling_replicate_id\"	
			AND se1.\"sample_id\" = s1.\"sample_id\"
			AND se1.\"extract_id\" = ext1.\"extract_id\"
			AND le1.\"sample_extract_id\" = se1.\"sample_extract_id\"
			AND h.\"labeled_extract1_id\" = le1.\"labeled_extract_id\"
			AND h.\"hybridization_protocol_id\" = hp.\"hybridization_protocol_id\"
			AND h.\"array_id\" = a.\"array_id\"
			AND a.\"array_batch_id\" = ab.\"array_batch_id\"
			AND rd.\"hybridization_id\" = h.\"hybridization_id\"
			AND rd.\"scanning_protocol_id\" = sp.\"scanning_protocol_id\"
			AND sr1.\"sampling_point_id\" = sp1.\"sampling_point_id\"
			AND sp1.\"experiment_id\" = e1.\"experiment_id\"
			AND sp1.\"label_id\" = l1.\"label_id\"
			AND e1.\"biomaterial_manipulation_id\" = bm1.\"biomaterial_manipulation_id\"
			AND bm1.\"growth_conditions_id\" = gc1.\"growth_conditions_id\"
			AND bm1.\"biosource_properties_id\" = bp1.\"biosource_properties_id\"";	
	}
	//print $sql;
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	$errMsgs[] = "Error retrieving Hybridization data for Samples. " . $sth->getMessage();	return false;	}

	if ($sth->numRows() == 0)
	{	
		$errMsgs[] = "No Samples for the selected combination are in the database or the sample(s) have not been linked with at least one of Biomaterial Manipulation, Biosource Properties, Growth Conditions, Sample Labeling, Hybridization Protocol or Scanning Protocol have not been defined in the database.";
		return false;
	}

	$ret = iterateHybridizationQuery($sth, $file_descriptor, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id);
	return $ret;
}


function iterateHybridizationQuery(&$sthHQ, &$file_descriptor, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id)
{
	global $errMsgs;
	//Get protocol_type_desc
	$sql = "SELECT \"protocol_type_desc\" FROM \"protocol_type\" 
		WHERE \"protocol_type_id\" = $protocol_type_id";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving protocol_type_desc. " . $sth->getMessage());	return false;	}

	if ($sth->numRows() == 0)
	{	
		$errMsgs[] = "Protocol Not found.";
		return false;
	}
	$row = $sth->fetchRow();
	$protocol_type_desc = $row[0];
	
	//Get Species Name
	$sql = "SELECT \"aname\" FROM \"allnames\" a, \"ref_kw_table\" r
		WHERE UPPER(\"is_primary\") = 'Y'
		AND a.\"kw_table_id\" = r.\"kw_table_id\"
		AND UPPER(r.\"kw_table\") = 'SPECIES'
		AND \"record_id\" = {$_SESSION['CurrentSpecieID']}";
		
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Species Name. " . $sth->getMessage());	return false;	}

	if ($sth->numRows() == 0)
	{	
		$errMsgs[] = "Name for Species Not found.";
		return false;
	}
	$row = $sth->fetchRow();
	$speciesName = $row[0];
	
	
	while ($row = $sthHQ->fetchrow())
	{
		$strSample = '';
		$hybridization_id = $row[0];
		$sampleName = $row[3];
		$strSample = "^SAMPLE = $sampleName\n";
		fillField($sampleName, 'Sample_title', $row[4], true, $line);
		if (strlen($line)){	$strSample .= $line;	}
		
		if ($row[48] > 0)	//labeled_extract2_id
		{	$noOfChannels = 2;	}
		else
		{	$noOfChannels = 1;	}
		//Channel Fields
		for ($c = 1; $c <= $noOfChannels; $c++)
		{
			if (1 == $c)
			{	$base = 9;	}	//start of sql1 channel fields
			elseif (2 == $c)
			{	$base = 49;	}	//start of sql2 channel fields
			
			$value = "{$row[$base + 0]}_{$row[$base + 1]}_{$row[$base + 2]}_{$row[$base + 3]}";
			fillField($sampleName, "Sample_source_name_ch{$c}", $value, true, $line);
			if (strlen($line)){	$strSample .= $line;	}
			
			$strSample .= "!Sample_organism_ch{$c} = $speciesName\n";
			
			//Biosource Properties fields - at least one required.
			$atLeastOneFound = false;
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 4], false, $line, "Organism");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 5], false, $line, "Contact details for sample");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 6], false, $line, "Cell Type");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 7], false, $line, "Sex");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 8], false, $line, "Age");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 9], false, $line, "Developmental Stage");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 10], false, $line, "Strain or line");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 11], false, $line, "Genetic Variation");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 12], false, $line, "Individual Number");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 13], false, $line, "Individual genetic characterstics");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 14], false, $line, "Disease State");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 15], false, $line, "Targeted cell type");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 16], false, $line, "Cell line");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			fillField($sampleName, "Sample_characterstics_ch{$c}", $row[$base + 17], false, $line, "Organism part");
			if (strlen($line)){	$strSample .= $line; $atLeastOneFound = true;	}
			
			if (!$atLeastOneFound)
			{	$errMsgs[] = "Please provide at least one characteristics for Sample '$sampleName'";	}
			
			fillField($sampleName, "Sample_biomaterial_provider_ch{$c}", $row[$base + 18], false, $line);
			if (strlen($line)){	$strSample .= $line;	}
			
			//Biomaterial Manipulation fields
			fillField($sampleName, "Sample_treatement_protocol_ch{$c}", $row[$base + 19], false, $line, "Invivo treatment");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_treatement_protocol_ch{$c}", $row[$base + 20], false, $line, "Invitro treatment");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_treatement_protocol_ch{$c}", $row[$base + 21], false, $line, "Treatment type");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_treatement_protocol_ch{$c}", $row[$base + 22], false, $line, "Compound");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_treatement_protocol_ch{$c}", $row[$base + 23], false, $line, "Separation technique");
			if (strlen($line)){	$strSample .= $line;	}
			
			//Growth Conditions Fields
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 24], false, $line, "Atmosphere");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 25], false, $line, "Contaminant Organism");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 26], false, $line, "Density range");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 27], false, $line, "Generations");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 28], false, $line, "Host");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 29], false, $line, "Humidity");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 30], false, $line, "Light");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 31], false, $line, "Medium");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 32], false, $line, "Nutrients");
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_growth_protocol_ch{$c}", $row[$base + 33], false, $line, "Temperature");
			if (strlen($line)){	$strSample .= $line;	}
			
			fillField($sampleName, "Sample_molecule_ch{$c}", $row[$base + 34], true, $line);
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_extract_protocol_ch{$c}", $row[$base + 35], false, $line);
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_label_ch{$c}", $row[$base + 36], true, $line);
			if (strlen($line)){	$strSample .= $line;	}
			fillField($sampleName, "Sample_label_protocol_ch{$c}", $row[$base + 37], false, $line);
			if (strlen($line)){	$strSample .= $line;	}
		}
		
		fillField($sampleName, 'Sample_hyb_protocol', $row[5], false, $line);
		if (strlen($line)){	$strSample .= $line;	}
		fillField($sampleName, 'Sample_scan_protocol', $row[6], false, $line);
		if (strlen($line)){	$strSample .= $line;	}
		
		$strSample .= "!Sample_data_processing = $protocol_type_desc\n";
		
		fillField($sampleName, 'Sample_description', $row[7], true, $line);
		if (strlen($line)){	$strSample .= $line;	}
		fillField($sampleName, 'Sample_platform_id', $row[8], true, $line);
		if (strlen($line)){	$strSample .= $line;	}

		$strSample .= printSampleTable($hybridization_id, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id);
					
		// Write $data to our opened file.
		if (!fwrite($file_descriptor, $strSample))
		{
			$errMsgs[] =  "Cannot write to file for sample '$sampleName'";
			return false;
		}
	}
	return true;
}

function fillField($sampleName, $field_name, $value, $is_required = false, &$line, $valuePrefix = '')
{
	global $errMsgs;
	$line = '';
	$value = trim($value);
	
	if ($is_required AND !$value)
	{	
		$msg = "Please specify";
		if (strlen($valuePrefix))
		{	$msg .= " $valuePrefix for";	}
		$msg .= " '$field_name' for Sample with title '$sampleName'.";	
		$errMsgs[] = $msg;
		return false;
	}
	elseif (strlen($value))
	{	
		$line = '!' . "$field_name = ";
		if (strlen($valuePrefix))
		{	$line .= "$valuePrefix: ";	}
		$line .= "$value\n";
		return true;
	}
}


function printSampleTable($hybridization_id, $sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id)
{
	global $errMsgs;
	
	$strSample = '!Sample_table_begin' . "\n";
	if ($sampling_replicate_id2 > 0)
	{
		//Print Sample Table
		$strSample .= '#ID_REF = 
#VALUE =
#CH1_SIG_MEAN = 
#CH1_BKD_MEAN = 
#CH2_SIG_MEAN = 
#CH2_BKD_MEAN = 
#CH1_SIG_MEDIAN = 
#CH1_BKD_MEDIAN = 
#CH2_SIG_MEDIAN = 
#CH2_BKD_MEDIAN = ' . "\n";
 
		
		$strSample .= "ID_REF\tVALUE\tCH1_SIG_MEAN\tCH1_BKD_MEAN\tCH2_SIG_MEAN\tCH2_BKD_MEAN\tCH1_SIG_MEDIAN\tCH1_BKD_MEDIAN\tCH2_SIG_MEDIAN\tCH2_BKD_MEDIAN\n";
		
		$sql = "SELECT man.\"feature_id\", man.\"intensity_l\", q.\"F532_Mean\",
			\"B532_Mean\", \"F635_Mean\", \"B635_Mean\", \"F532_Median\", 
			\"B532_Median\", \"F635_Median\", \"B635_Median\"
		FROM \"ma_norm\" man, \"quantification\" q, \"image_analysis\" ia, \"raw_data\" rd
		WHERE rd.\"hybridization_id\" = $hybridization_id
			AND ia.\"raw_data_id\" = rd.\"raw_data_id\"
			AND q.\"image_analysis_id\" = ia.\"image_analysis_id\"
			AND man.\"sampling_replicate1_id\" = $sampling_replicate_id1
			AND man.\"sampling_replicate_id\" = $sampling_replicate_id2
			AND man.\"feature_id\" = q.\"feature_id\"
			AND man.\"protocol_type_id\" = $protocol_type_id";
		
		//print $sql;
	
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error retrieving data from quantification and ma_norm. " . $sth->getMessage();	return false;	}
	
		while ($row = $sth->fetchRow())
		{
			$ID_REF = getIDREFforGEO($row[0]);
			$strSample .= "$ID_REF\t$row[1]\t$row[2]\t$row[3]\t$row[4]\t$row[5]\t$row[6]\t$row[7]\t$row[8]\t$row[9]\n";
		}
	}
	else
	{
		//Print Sample Table
		$strSample .= '#ID_REF = 
#VALUE = ' . "\n";
		
		$strSample .= "ID_REF\tVALUE\n";
		
		$sql = "SELECT cs.\"probe_name\", man.\"intensity_l\"
		FROM \"ma_norm\" man, \"reporter\" r, \"composite_sequence\" cs 
		WHERE man.\"sampling_replicate_id\" = $sampling_replicate_id1
			AND man.\"sampling_replicate1_id\" IS NULL
			AND man.\"protocol_type_id\" = $protocol_type_id
			AND r.\"reporter_id\" = man.\"reporter_id\"
			AND cs.\"composite_sequence_id\" = r.\"composite_sequence_id\"
		ORDER BY UPPER(cs.\"probe_name\")";
		
		//print $sql;
	
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	$errMsgs[] = "Error retrieving data from ma_norm. " . $sth->getMessage();	return false;	}
	
		while ($row = $sth->fetchRow())
		{	$strSample .= "$row[0]\t$row[1]\n";	}
	}
	$strSample .= '!Sample_table_end' . "\n";
	
	return $strSample;
}

function getIDREFforGEO($ID)
{
	$nameParts = split(' ', $_SESSION['SPECIES_NAME']);
	foreach ($nameParts as $namePart)
	{	
		if (strlen($namePart) > 0)
		{	$speciesInitials .= strtoupper(chr(ord($namePart)));	}
	}
	return $speciesInitials . str_pad($ID, 7, "0", STR_PAD_LEFT);
}

?>


