<?php
/**
* This script is a Front-End for producing platform file for 
* 2 channel microarray data to submit to GEO.
* Date: 12 Jan 2007
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");
include_once("produceSampleFile.php");
$currPageName = 'PRODUCE_SAMPLE_1CHANNEL';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
if (isset($_REQUEST['technique_id']))
{	$_SESSION[$currPageNameUpper]['technique_id'] = $_REQUEST['technique_id'];	}

$title = "Produce 1-Channel Sample File";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER' OR strtoupper($_SESSION['role']) == 'EDITOR'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}
?>

<?php
if ($_REQUEST['submit'] == 'Produce Sample File')
{	processForm();	}
else
{	fillForm();	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
	fillForm();
}

include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	
		
	print "<form name=\"init_form\" method=\"post\" action=\"$self\">\n";
	
	
	print '<p class="help-tips">Please provide information about which data sample you want to submit to GEO and choose a protocol to be used for normalization.</p>';
	
	//Get technique_id
	$sql = "SELECT \"technique_id\", \"technique_name\" FROM \"technique\" 
	WHERE UPPER(\"technique_name\") = 'AFFYMETRIX'";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	$errMsgs[] = "Error retrieving Techniques. " . $sth->getMessage();	return;	}
	$row = $sth->fetchRow();
	$_SESSION[$currPageNameUpper]['technique_id'] = $row[0];
	
	print "<table width=\"100%\"><tr>";	//start table
	print "<td>";
	$identifier = "channel1";
	print "<fieldset><legend> &nbsp;&nbsp;Channel 1";
	print "&nbsp;&nbsp; </legend>";	
	printMetaDataSelections($identifier, $_SESSION[$currPageNameUpper][$identifier], true, false, false);
	print "</fieldset></td>";
	
	print "</tr></table>"; //end table
	
	
	//Print Normalization Method
	$sql = "SELECT \"protocol_type_id\", \"protocol_type_name\" FROM \"protocol_type\" 
			WHERE UPPER(\"method\") = 'STATISTICAL' 
			AND technique_id = '{$_SESSION[$currPageNameUpper]['technique_id']}'
			ORDER BY UPPER(\"protocol_type_name\")";

	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Normalization Method. " . $sth->getMessage());	return;	}
	print "\n<p><label>Normalization Method: </label>";
	print "<select name=\"protocol_type_id\">";
	
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['protocol_type_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	print "<input type=\"submit\" name=\"submit\" value=\"Produce Sample File\" />";
	
	print "\n</form>";
	print "<br /><br /><a href=\"GEOMenu.php\"><-Back to GEO Menu</a>";

}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
	$_SESSION[$currPageNameUpper]['channel1'] = $_REQUEST['channel1'];
	$_SESSION[$currPageNameUpper]['protocol_type_id'] = $_REQUEST['protocol_type_id'];
	
	$identifier = "channel1";
	if (!$_SESSION[$currPageNameUpper][$identifier]['experiment_set_id'])
	{	$errMsgs[] = "Please Select an Experiment Set.";	}
	
	if (!$_SESSION[$currPageNameUpper][$identifier]['exp_name'])
	{	$errMsgs[] = "Please Select an Experiment.";	}
	
	if (!$_SESSION[$currPageNameUpper][$identifier]['sampling_point_label_id'])
	{	$errMsgs[] = "Please Select a Sampling Point.";	}
	
	if (!$_SESSION[$currPageNameUpper][$identifier]['biological_replicate'])
	{	$errMsgs[] = "Please Select the biological replicate number.";	}

	
	if (!$_SESSION[$currPageNameUpper]['protocol_type_id'])
	{	$errMsgs[] = "Please Select a Normalization Method.";	}
	
	if ($errMsgs)
	{	return 0;	}
		
	//Now find out sampling_replicate_id from the given info.

	
	$sql = "SELECT sr.\"sampling_replicate_id\" FROM \"sampling_replicate\" sr
			, \"sampling_point\" sp
			, \"experiment\" e
		WHERE e.\"exp_set_id\" = '{$_SESSION[$currPageNameUpper][$identifier]['experiment_set_id']}'
		AND e.\"exp_name\" = '{$_SESSION[$currPageNameUpper][$identifier]['exp_name']}'
		AND sp.\"experiment_id\" = e.\"experiment_id\"
		AND sp.\"label_id\" = '{$_SESSION[$currPageNameUpper][$identifier]['sampling_point_label_id']}'
		AND sr.\"sampling_point_id\" = sp.sampling_point_id
		AND sr.\"replicate\" = '{$_SESSION[$currPageNameUpper][$identifier]['biological_replicate']}'";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error retrieving Sampling Replicate for channel $i. " . $sth->getMessage();	
		return 0;
	}

	if ($sth->numrows() > 0)
	{
		$row = $sth->fetchRow();
		$_SESSION[$currPageNameUpper][$identifier]['sampling_replicate_id'] = $row[0];
		//print "Set sampling_replicate_id = {$_SESSION[$currPageNameUpper]['sampling_replicate_id']} ($n)";
	}
	else
	{	$errMsgs[] = "Sampling Replicate not found in the database for the information provided.";	}

	//Validating Normalization Method
	$sql = "SELECT \"protocol_type_id\" FROM \"protocol_type\" 
		WHERE \"technique_id\" = '{$_SESSION[$currPageNameUpper]['technique_id']}'
		AND \"protocol_type_id\" = '{$_SESSION[$currPageNameUpper]['protocol_type_id']}'";
		
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error checking for Normalization Method. " . $sth->getMessage();	
		return 0;
	}
	if ($sth->numrows() == 0)
	{	$errMsgs[] = "Normalization Method Not Found for selected technique.";	}
	
	if ($errMsgs)
	{	return 0;	}
	
	$sampling_replicate_id1 = $_SESSION[$currPageNameUpper]['channel1']['sampling_replicate_id'];
	$protocol_type_id = $_SESSION[$currPageNameUpper]['protocol_type_id'];
	
	//print "$sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id";
	produceSampleFile($sampling_replicate_id1, $sampling_replicate_id2, $protocol_type_id);
	
	$sid = session_id();
	$sampleFileRelative = "{$_SESSION['BROWSER_TMP_RELATIVE']}sampleFile-{$sid}.txt";
	if (!$errMsgs)
	{	print "<br /><a href=\"$sampleFileRelative\" target=\"sample_file\">Sample File</a>";	}
	
  	if ($errMsgs)
	{	return 0;	}
	return 1;
}

?>
