<?php

/**
* This script displays the output zip file
* Date: 19 Feb 2007
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);
?>

<?php
$title = "DOME : Raw Data File Output";
include("header.php");
?>

<?php
fillForm();
include ("footer.php");
?>


<?php
//Functions
function fillForm()
{
	global $currPageName, $prevPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$prevPageNameUpper = strtoupper($prevPageName);
	print printPageSelections();
	
	
	$start_time = microtime_float();
	
	produceZip($_SESSION[$prevPageNameUpper]['FILE_RESULTS']);
	$totTime = microtime_float() - $start_time;
	$totTime = number_format($totTime, 2, '.', '');
	print "<p>Time-taken: $totTime second(s)</p>";		
	
		
	$self = $_SERVER['PHP_SELF'];
	echo "<form name=\"init_form\" method=\"post\" action=\"$action\" >\n";
	printControlBar($_SESSION['STEP_NUMBER'], 0);
	print "\n</form>";
}


function produceZip($filesToZip)
{
	$zipBinary = getZipBinary();
	if (strlen($zipBinary))
	{
		$firstFile = true;
		foreach ($filesToZip as $file)
		{
			if (file_exists($file) AND is_readable($file))
			{	
				if (!$firstFile)
				{ $files .= ' ';	}
				$files .= "\"$file\"";	
				$firstFile = false;
			}
			
		}
		$fileZip = $_SESSION['BROWSER_TMP_RELATIVE'] . "files_" . session_id() . ".zip" ;
		//First Remove Old zip file.
		$com = "rm -f $fileZip";
		exec($com, $retLines, $retValue);
		if ($retValue)
		{	printError("Cannot remove old zip file $fileZip");	}
		
		$com = "$zipBinary -1 \"$fileZip\" $files";
		//print $com;
		exec($com, $retLines, $retValue);
		if (!$retValue)
		{		
			system("chmod 644 \"$fileZip\"");
			print "<p>Here is the zipped File (" . sprintf("%u", filesize($fileZip)) . " bytes): <br /><a href=\"$fileZip\">Zipped File</a></p>";
		}
		else
		{	
			$msg = "Error occured while zipping. Following is the output <br />";
			if ($retLines)
		  	{
				foreach ($retLines as $retLine)
				{	$msg .= "$retLine <br />";	}
			}
			printError($msg);
		}
	}
	else
	{	print "zip not found. zip file not produced.";	}
}

function getZipBinary()
{
	if (file_exists('/usr/bin/zip') AND is_executable('/usr/bin/zip'))
	{	$zipBinary = '/usr/bin/zip';	}
	elseif (file_exists('/bin/zip') AND is_executable('/bin/zip'))
	{	$zipBinary = '/bin/zip';	}
	return $zipBinary;
}

/*===================
Zip Single File Functions
=====================*/
function fillFormSingle()
{
	if (!isset($_REQUEST['location']))
	{	print "Location Not supplied."; return;	}
	if (!isset($_REQUEST['file_name']))
	{	print "File Name Not supplied."; return;	}
	$location = $_REQUEST['location'];
	$file_name = $_REQUEST['file_name'];
	
	
	$checkFile = "{$location}{$file_name}";
	if (!file_exists($checkFile))
	{	print "File does not exist on the location specified."; return;	}
	if (!is_readable($checkFile))
	{	print "File '$checkFile' is not readable."; return;	}
	
	//Try Zipping files only when target file is larger than 100KB else just plain copy.
	if (filesize($checkFile) > 100000)
	{	$tryDoingZip = true;	}
	else
	{	$tryDoingZip = false;	}
	
	
	$zipBinary = getZipBinary();
	if ($tryDoingZip AND strlen($zipBinary))
	{
		$fileParts = split('[.]', $file_name);
		$fileNameWithoutExt = $fileParts[0];
		$fileZip = $_SESSION['BROWSER_TMP_RELATIVE'] . $fileNameWithoutExt. ".zip";
				
		$com = "$zipBinary -1 \"$fileZip\" \"$checkFile\"";
		//print $com;
		exec($com, $retLines, $retValue);
		if (!$retValue)
		{		
			system("chmod 644 \"$fileZip\"");
			print "<p>Here is the zipped File (" . sprintf("%u", filesize($fileZip)) . " bytes):<br /><a href=\"$fileZip\">Zipped File</a></p>";
		}
		else	//Try alternative method of pure copying.
		{	
			$destination = "{$_SESSION['BROWSER_TMP_RELATIVE']}$file_name";
			doCopyMethod($checkFile, $destination);	
		}
	}
	else	//Try alternative method of pure copying.
	{	
		$destination = "{$_SESSION['BROWSER_TMP_RELATIVE']}$file_name";
		doCopyMethod($checkFile, $destination);	
	}
}

function doCopyMethod($checkFile, $destination)
{
	$com = "cp \"$checkFile\" \"$destination\"";
	exec($com, $retLines, $retValue);

	if (!$retValue)
	{	print "<p>Here is the File: <br /><a href=\"$destination\">File</a></p>";	}
	else
	{	print "Both Zip and copying of file failed.";	}
}

?>