<?php
/**
* This script shows Experiment Metadata in a table format.
* Will accept in request 'exp_set_id', 'experiment_id', 
* 'exp_set_name' or 'exp_name', 
* Date: 26 Apr 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
$currPageName = 'QUERY_METADATA';
?>

<?php
if (strlen($_REQUEST['windowSize']))
{	$windowSize = $_REQUEST['windowSize'];	}
$title = "DOME : View Experimental Design";
include("header.php");


$exp_set_id = $_REQUEST['exp_set_id'];
$experiment_id = $_REQUEST['experiment_id'];
$exp_set_name = $_REQUEST['exp_set_name'];
$exp_name = $_REQUEST['exp_name'];


if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

fillForm();
if (!isset($_REQUEST['dontPrintFooter']))
{	include_once("footer.php");	}
?>

<?php
//Functions
function fillForm()
{
	global $currPageName, $exp_set_id, $experiment_id, $exp_set_name, $exp_name;
	$currPageNameUpper = strtoupper($currPageName);
	$startCol = 0;
	
	if ($exp_set_id > 0)
	{	$experiment_id = 0;	}
	
	if (strlen($exp_set_name))
	{	$exp_name = '';	}
	
	//Print Experiment Sets. 
	$sql = "SELECT es.\"exp_set_name\", e.\"exp_name\", l.\"name\", l.\"order\",
		UPPER(es.\"exp_set_name\"), UPPER(e.\"exp_name\")
		FROM \"experiment_set\" es, \"experiment\" e, \"sampling_point\" sp, \"label\" l
		WHERE e.\"exp_set_id\" = es.\"exp_set_id\"
			AND sp.\"label_id\" = l.\"label_id\"
			AND sp.\"experiment_id\" = e.\"experiment_id\"";
	if ($exp_set_id > 0)
	{	$sql .= " AND es.\"exp_set_id\" = $exp_set_id";	$startCol = 1;	}
	elseif (strlen($exp_set_name))
	{	$sql .= " AND UPPER(es.\"exp_set_name\") = UPPER('$exp_set_name')";	$startCol = 1;	}
	
	if ($experiment_id > 0)
	{	$sql .= " AND e.\"experiment_id\" = $experiment_id"; }
	elseif (strlen($exp_name))
	{	$sql .= " AND UPPER(e.\"exp_name\") = UPPER('$exp_name')";	}
		
	$sql .= " ORDER BY UPPER(es.\"exp_set_name\"), UPPER(e.\"exp_name\"), l.\"order\"";
	
	//print $sql;
	
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Metadata. " . $sth->getMessage());	return;	}
	
	if ($sth->numRows() > 0)
    {
	    $metadata_array = array();
	    $label_names = array();
	    while($row = $sth->fetchRow())
	    {
		    $metadata_array[$row[0]][$row[1]][$row[2]] = 1;
		    if (!in_array($row[2], $label_names))
		    {	$label_names[] = $row[2];	}
	    }
	}

	$ESNames = array_keys($metadata_array);
	$cl = 'dark-row-centered';
	$EClass = 'dark-blue';
	foreach ($ESNames as $ESName)
	{
		print "<label>Metadata for Experiment Set '$ESName':</label><br />";
		print "<table width=\"100%\">\n\t<tr><th width=\"10%\">Experiment Name</th><th>" . join("</th><th>", $label_names) . "</th></tr>";
		
		$ENames = array_keys($metadata_array[$ESName]);
		foreach ($ENames as $EName)
		{
			if ('dark-row-centered' == $cl)
			{	$cl = 'light-row-centered';	$EClass = 'light-blue';	}
			else
			{	$cl = 'dark-row-centered'; $EClass = 'dark-blue';	}
			print "\n\t<tr><td class=\"$EClass\">$EName</td>";
			foreach ($label_names as $label_name)
			{
				print "<td class=\"$cl\">";
				if ($metadata_array[$ESName][$EName][$label_name])
				{	print "X";	}
				print "</td>";
			}
			print "</tr>";
		}
		print "</table><br /><br />";
	}
}
?>
