<?php

/**
* This script displays a table for selection of raw data files.
* Date: 22 Jan 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("workFlow.php");

//Parse Get or Post step number and set the current step number.
setStepNumber();

//Sets Environment Variable
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(1);
$currPageName = 'RAW_DATA_FILES';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
$title = "DOME : Raw Data Files";
include("header.php");
?>

<?php
if ($errMsgs)
{	
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
fillForm();
include ("footer.php");
?>
<script type="text/javascript">
function setCheckbox(form, val) 
{
  	for (i=0; i<form.elements.length; i++)
 	{	form.elements[i].checked = val;	}
}
</script>

<?php
//Functions
function fillForm()
{
	global $currPageNameUpper;
	
	$self = $_SERVER['PHP_SELF'];
	echo "<form name=\"init_form\" method=\"post\" action=\"$action\" >\n";
	print printPageSelections();
	printControlBar($_SESSION['STEP_NUMBER']);
	if (callFillMasterArray())
	{	
		unset ($_SESSION[$currPageNameUpper]['FILES']);
		//$url = "produceZipFile.php?location=ALL";
		//print "<p><a href=\"$url\"
			 //target=\"zip\" onClick=\"wopen('$url', 'zip_file_window', 400, 100); return false;\">Get All Files Shown Below</a> (May take very long)</p>";
		
		output_table_for_raw_data_files();	
		print "\n<p align=\"center\"><input type=\"button\" onClick=\"setCheckbox(this.form, true)\" value=\"Select All\">\n";
		print "\n<input type=\"button\" onClick=\"setCheckbox(this.form, false)\" value=\"Clear All\"></p>\n";
	}
	printControlBar($_SESSION['STEP_NUMBER']);
	print "\n</form>";
}

function callfillMasterArray()
{
	setSPString();
	$sql = getSQLRawData();
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		printError("Error Retrieving raw file data." . $sth->getMessage());	
		return false;	
	}
	if ($sth->numRows() > 0)
	{	fillMasterArray($sth);	}
	else
	{	
		printError("No Files found for your selections.");
		return false;
	}
	return true;
}

function fillMasterArray(&$sth)
{
	global $master_array, $keys;
		
	$ESNames = &$keys['Exp Set'];
	$ENames = &$keys['Experiment'];
	$technique_types = &$keys['Technique Type'];
	$technique_names = &$keys['Technique Name'];
	$label_names = &$keys['Sampling Point'];
	$biologicalReplicates = &$keys['Biological Replicate'];
	$technicalReplicates = &$keys['Technical Replicate'];
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	
	
	if (!$ESNames) {	$ESNames = array(); 	}
	if (!$ENames) {	$ENames = array(); 	}
	if (!$technique_types) {	$technique_types = array(); 	}
	if (!$technique_names) {	$technique_names = array(); 	}
	if (!$label_names) {	$label_names = array(); 	}
	if (!$biologicalReplicates) {	$biologicalReplicates = array(); 	}

	//Master Array has the following keys:
	//master_array[exp_set_name][experiment][technique_type][technique_name][sp_name][BiologicalReplicateNumber][TechnicalReplicateNumber]
	
	while ($row = $sth->fetchRow()) 
	{
		//es."exp_set_name", e."exp_name", a."technique_type", a."technique_name", 
		//l."name", l."order", a."replicate", a."technical_replicate", a."location", 
		//a."file_name", a."file_type"
		$ESName = $row[0];
		$EName = $row[1];
		$technique_type = $row[2];
		$technique_name = $row[3];
		$label_name = $row[4];
		$label_order = $row[5];
		$replicate = $row[6];
		$technical_replicate = $row[7];
		$location = $row[8];
		$file_name = $row[9];
		$file_type = $row[10];
		
		$fileArray['location'] = $location;
		$fileArray['file_name'] = $file_name;
		$fileArray['file_type'] = $file_type;
				
		$master_array[$ESName][$EName][$technique_type][$technique_name][$label_name][$replicate][$technical_replicate][] = $fileArray;
		
		//Check if we have seen this key before
		//if no add it to the array of keys for the respective field.
		$ESNames[$ESName]++;
		$ENames[$EName]++;
		$label_names[$label_order] = $label_name;
			
		$technique_types[$technique_type]++;
		$technique_names[$technique_name]++;
		$protocol_type_names[$protocol_type_name]++;
		$biologicalReplicates[$replicate]++;
		
		//technicalReplicates have to be handled slightly differently.
		//because we are keeping track of keys for technical replicate
		//for EACH of the biological replicates (and not just one
		//set of keys for all biological replicates)
		if (!$technicalReplicates[$replicate])
		{	$technicalReplicates[$replicate] = array();		}
		if (!$SPTechnicalReplicates[$label_order][$replicate])
		{	$SPTechnicalReplicates[$label_order][$replicate] = array();		}
		
		if (!in_array($technical_replicate, $technicalReplicates[$replicate]))
		{	$technicalReplicates[$replicate][] = $technical_replicate;	}
		if (!in_array($technical_replicate, $SPTechnicalReplicates[$label_order][$replicate]))
		{	$SPTechnicalReplicates[$label_order][$replicate][] = $technical_replicate;	}
		$totRows++;
	}
	//In cases where there may be no data for initial sampling points
	//the $SPTechnicalReplicates will contain sampling points in wrong order.
	//So sort this array's keys to correct the order.
	ksort($SPTechnicalReplicates);
	
	//Convert Key arrays to proper format.
	if ($totRows)
	{
		$keys['Exp Set'] = array_keys($keys['Exp Set']);
		$keys['Experiment'] = array_keys($keys['Experiment']);
		$keys['Technique Type'] = array_keys($keys['Technique Type']);
		$keys['Technique Name'] = array_keys($keys['Technique Name']);
	}
}

function getSQLRawData()
{
	global $spidInStr;
	
	$sqlMetabolite = "(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Processed' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"metabolite_measurement\" mm,
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'METABOLITE'
		AND mm.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND fll.\"file_location_link_id\" = mm.\"proc_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")
	UNION
		(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Raw' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"metabolite_measurement\" mm,
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'METABOLITE'
		AND mm.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND fll.\"file_location_link_id\" = mm.\"raw_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")";
	//print $sqlMetabolite;
	
	$sqlProtein = "(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Processed' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"proteomics_measurement\" pm,
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'PROTEIN'
		AND pm.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND fll.\"file_location_link_id\" = pm.\"proc_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")
	UNION
		(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Raw' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"proteomics_measurement\" pm,
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'PROTEIN'
		AND pm.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND fll.\"file_location_link_id\" = pm.\"raw_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")";
	
	$sqlMRNA = "(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Processed' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"labeled_extract\" le, 
		\"hybridization\" h, \"raw_data\" rd, \"image_analysis\" ia,
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'MRNA'
		AND le.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND h.\"labeled_extract2_id\" = le.\"labeled_extract_id\"
		AND rd.\"hybridization_id\" = h.\"hybridization_id\"
		AND ia.\"raw_data_id\" = rd.\"raw_data_id\"
		AND fll.\"file_location_link_id\" = ia.\"file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")
	UNION
		(SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Cy3' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"labeled_extract\" le, 
		\"hybridization\" h, \"raw_data\" rd, 
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'MRNA'
		AND le.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND h.\"labeled_extract2_id\" = le.\"labeled_extract_id\"
		AND rd.\"hybridization_id\" = h.\"hybridization_id\"
		AND fll.\"file_location_link_id\" = rd.\"cy3_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")
	UNION
		 (SELECT sr.\"sampling_point_id\", sr.\"replicate\", se.\"technical_replicate\",
		t.\"technique_type\", t.\"technique_name\", 
		fl.\"location\", f.\"file_name\", 'Cy5' AS \"file_type\"
	FROM \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se, 
		\"extract\" e, \"technique\" t, \"labeled_extract\" le, 
		\"hybridization\" h, \"raw_data\" rd, 
		\"file_location_link\" fll, \"file_location\" fl, \"file\" f
	WHERE sr.\"sampling_point_id\" IN ($spidInStr)
		AND s.\"sampling_replicate_id\" = sr.\"sampling_replicate_id\" 
		AND se.\"sample_id\" = s.\"sample_id\"
		AND e.\"extract_id\" = se.\"extract_id\"
		AND t.\"technique_id\" = e.\"technique_id\"
		AND UPPER(t.\"technique_type\") = 'MRNA'
		AND le.\"sample_extract_id\" = se.\"sample_extract_id\"
		AND h.\"labeled_extract2_id\" = le.\"labeled_extract_id\"
		AND rd.\"hybridization_id\" = h.\"hybridization_id\"
		AND fll.\"file_location_link_id\" = rd.\"cy5_file_location_link_id\"
		AND fl.\"file_location_id\" = fll.\"file_location_id\"
		AND f.\"file_id\" = fll.\"file_id\")";
		
	//print $sqlMRNA;
	
	$sqlAll = "$sqlMetabolite
		UNION 
		$sqlProtein
		UNION
		$sqlMRNA";
		
	$sql = "SELECT es.\"exp_set_name\", e.\"exp_name\", 
		a.\"technique_type\", a.\"technique_name\", l.\"name\", l.\"order\",
		a.\"replicate\", a.\"technical_replicate\",
		a.\"location\", a.\"file_name\", a.\"file_type\"
	FROM ($sqlAll) a, \"sampling_point\" sp, \"experiment\" e, \"experiment_set\" es, \"label\" l
		WHERE sp.\"sampling_point_id\" = a.\"sampling_point_id\"
		AND e.\"experiment_id\" = sp.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND l.\"label_id\" = sp.\"label_id\"
	ORDER BY UPPER(es.\"exp_set_name\"), UPPER(e.\"exp_name\"), 
		UPPER(a.\"technique_type\"), UPPER(a.\"technique_name\"), l.\"order\", UPPER(a.\"file_type\")";
		
	return $sql;
}


function output_table_for_raw_data_files()
{
	global $master_array, $keys, $currPageNameUpper;
		
	$label_names = &$keys['Sampling Point'];
	
	//headers is a hash with the header name as key and 0 as val.
	//In case there is only one type of value, then instead of a 0 the val is the actual single value.
	//For Example if the field Exp Set contains only one value 'Yeast', than
	//$headers[Exp Set] = "Yeast"
	$headers = array("Exp Set"=>0, "Experiment"=>0, "Technique Type"=>0, "Technique Name"=>0);
	//Master Array has the following keys:
	//master_array[exp_set_name][experiment][technique_type][technique_name][sp_name][BiologicalReplicateNumber][TechnicalReplicateNumber]

	
	//Get counts of each keys
	foreach ($headers as $header=>$val)
	{
		if (isset($keys[$header]) AND count($keys[$header]) == 1)
		{	
			$keysForHeader = array_keys($keys[$header]);
			$headers[$header] = $keys[$header][$keysForHeader[0]];	
		}
		$count[$header] = count($keys[$header]);
	}
	$header1ColSpan = 0;
	foreach ($headers as $header=>$val)
	{
		if ($val)
		{	
			if ($cl == 'light-red')
			{	$cl = 'dark-red';	}
			else
			{	$cl = 'light-red';	}
	
			$OneValueTable .= "\n<tr><th class=\"$cl\">$header</th><td class=\"$cl\">";
			$OneValueTable .= $val;
			$OneValueTable .= "</td></tr>";
		}
		else
		{	
			$headerRow .= "<th>$header</th>";	
			$header1ColSpan++;
		}
	}
	
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	$sp_name_orders = array_keys($SPTechnicalReplicates);
	foreach ($sp_name_orders as $sp_name_order)
	{
		$colSpan = 0;
		$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
		foreach ($biologicalReplicates as $biologicalReplicate)
		{
			$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
			$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);
			foreach ($technicalReplicates as $technicalReplicate)
			{
				$headerRow .= "<th>Replicate $biologicalReplicate";
				if ($TRCount > 1)
				{	$headerRow .= ".$technicalReplicate";	}
				$headerRow .= "</th>";
				$colSpan++;
			}
		}
		$headerLine1 .= "<th colspan=\"$colSpan\">{$label_names[$sp_name_order]}</th>";
	}

	if ($OneValueTable)
	{
		print "<table cellspacing='2'><tr><th>Legend:</th></tr>$OneValueTable</table>";
		print "<br />";
	}
  	
	// This section is for print all data for selected genes in a table
  	// print the table header
	print "<table cellspacing='2'>";
	print "\n<tr><th colspan=\"$header1ColSpan\"></th>$headerLine1</tr>";
	print "\n<tr>$headerRow</tr>";
	
  	$row_bgclolr = "light-row";
  	
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{    
		if ($es_bgcolor == "light-blue") 
      	{	$es_bgcolor = "dark-blue";	} 
      	else {	$es_bgcolor = "light-blue";	}
      	$ENames = array_keys($master_array[$ESName]);
		foreach ($ENames as $EName) 
		{
			if ($e_bgcolor == "light-red") 
	      	{	$e_bgcolor = "dark-red";	} 
      		else {	$e_bgcolor = "light-red";	}
      		
      		$technique_types = array_keys($master_array[$ESName][$EName]);
  			foreach ($technique_types as $technique_type) 
  			{
		    	if ($tt_bgcolor == "light-yellow") 
	      		{	$tt_bgcolor = "dark-yellow";	} 
	      		else {	$tt_bgcolor = "light-yellow";	}
	      		$technique_names = array_keys($master_array[$ESName][$EName][$technique_type]);
		    	foreach ($technique_names as $technique_name) 
		    	{
		      		if ($tn_bgcolor == "light-blue") 
				    {	$tn_bgcolor = "dark-blue"; $darkOrLight = 'dark';	} 
				    else {	$tn_bgcolor = "light-blue"; $darkOrLight = 'light';	}
					print "\n<tr>";					
					if ($count['Exp Set'] > 1)
	      			{	print "<td class=\"$es_bgcolor\">$ESName</td>";	}
	      			if ($count['Experiment'] > 1)
	      			{	print "<td class=\"$e_bgcolor\">$EName</td>";	}
	      			if ($count['Technique Type'] > 1)
	      			{	print "<td class=\"$tt_bgcolor\">$technique_type</td>";	}
	      			if ($count['Technique Name'] > 1)
	      			{	print "<td class=\"$tn_bgcolor\">$technique_name</td>";	}
	      			
				    $blueOrGrey = "blue";
	      			foreach ($sp_name_orders as $sp_name_order)
					{
						if ($blueOrGrey == 'blue') 
	      				{	$blueOrGrey = 'row';	} 
	      				else {	$blueOrGrey = 'blue';	}
	      				$row_bgcolor= "$darkOrLight-$blueOrGrey";
		      			$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
						foreach ($biologicalReplicates as $biologicalReplicate)
						{
							$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
		      				foreach ($technicalReplicates as $technicalReplicate) 
	      					{
		      					$countFiles = count($master_array[$ESName][$EName][$technique_type][$technique_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate]);
		      					print "<td class=\"$row_bgcolor\">\n<table width='93'><tr><td>";
		      					$firstOver = false;
			      				for ($i = 0; $i < $countFiles; $i++)
			      				{
				      				$fileArray = $master_array[$ESName][$EName][$technique_type][$technique_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate][$i]; 
				      								      				
				      				$location = $fileArray['location'];
				      				$file_name = $fileArray['file_name'];
				      				$file_type = $fileArray['file_type'];
				      				$file_complete = "{$location}{$file_name}";
				      				if ($firstOver)
				      				{	print "</td></tr><tr><td>";	}
				      				print "\n<input type=\"checkbox\" name=files[$file_complete]";
				      				if (isset($_SESSION[$currPageNameUpper]['FILE_RESULTS']) AND in_array($file_complete, $_SESSION[$currPageNameUpper]['FILE_RESULTS']))
				      				{	print " checked";	}
				      				print ">$file_type</input>";
				      				//printFileLink($location, $file_name, $file_type);
				      				//Build All Files array
				      				$firstOver = true;
			      				}
			      				print "</td></tr></table>";	//inner table
			      				print "</td>";
		      				}
	      				}
	  				}
	  				print "</tr>";
				}
			}
		}
	}
	print "</table>";
}
/*
function printFileLink($location, $file_name, $file_type)
{
	$url = "produceZipFile.php?location={$location}&file_name={$file_name}";
	print "<a href=\"$url\"
			 target=\"zip\" onClick=\"wopen('$url', 'zip_file_window', 400, 100); return false;\">$file_type</a>";
}*/

function setSPString()
{
	global $spidInStr;
	//Get all Sampling Point IDs in a string
	if (isset($_SESSION['SAMPLING_POINT']['SAMPLING_POINT']))
	{
	  $spids = $_SESSION['SAMPLING_POINT']['SAMPLING_POINT'];
	  $firstKey = 1;
	  $spidInStr = "";
	  foreach($spids as $key=>$value)
	  {
	  if ($value)
	  {
	    if (!$firstKey)
	      { $spidInStr .= ", "; }
	      $spidInStr .= $key;
	      $firstKey = 0;
	    }
	  }
	}
}

//Process Functions
function processForm($currPageName)
{
	global $errMsgs;
	$currPageNameUpper = strtoupper($currPageName);
	if ($_REQUEST['files'])
	{	$_SESSION[$currPageNameUpper]['FILE_RESULTS'] = array_keys($_REQUEST['files']);	}
	else
	{	
		$_SESSION[$currPageNameUpper]['FILE_RESULTS'] = array();
		$errMsgs[] = "Please select at least one file.";
		return 0;
	}
	print "<p>Zipping " . count($_SESSION[$currPageNameUpper]['FILE_RESULTS']) . " Files. Please wait...</p>";
	return 1;
}


?>