<?php
/**
* This script is a Front-End for inserting Reference Gel Data
* in the DOME database.
* Date: 31 Oct 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");

$currPageName = 'REFERENCE_GEL_DATA';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php
if (isset($_REQUEST['technique_ids']))
{	$_SESSION[$currPageNameUpper]['technique_ids'] = strtoupper($_REQUEST['technique_ids']);	}

$title = "Protein Index";
include("header.php");
if (!(strtoupper($_SESSION['role']) == 'MANAGER' OR strtoupper($_SESSION['role']) == 'EDITOR'))
{	printError("You are not authorized to view this page. Your role level should be 'editor' or 'manager' to view this page.");	exit();}
?>

<?php


if ($_REQUEST['submit'] == 'Insert Data')
{	processForm();	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}

if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
fillForm();
include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	
	print '<p class="help-tips"></p>';
	
	//This MAX_SIZE is an advisory to the browser. (So that the user does not find
	// that his file is rejected by the php on the server after uploading it).
	print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
	print "<p><label>Data File: </label>";
	print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
	print "</p>";
	
	//printMetaDataSelections("", $_SESSION[$currPageNameUpper], true, true);
	
	//Print Protocol
	$sql = "SELECT \"protocol_type_id\", \"protocol_type_name\" FROM \"protocol_type\" pt, \"technique\" t 
			WHERE UPPER(pt.\"method\") = 'EXPERIMENTAL' 
			AND pt.\"technique_id\" = t.\"technique_id\"
			AND t.\"technique_id\" IN ({$_SESSION[$currPageNameUpper]['technique_ids']})
			ORDER BY UPPER(\"protocol_type_name\")";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Protocol. " . $sth->getMessage());	return;	}
	print "\n<p><label>Protocol: </label>";
	print "<select name=\"protocol_type_id\">";
	
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['protocol_type_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";
	
	//printExtractMethod($_SESSION[$currPageNameUpper]['technique_ids']);
	
	//Print Researchers. 
	$sql = "SELECT person_id, person_name FROM person ORDER BY person_name";
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	printError("Error retrieving Researchers. " . $sth->getMessage());	return;	}
	print "<p><label>Researcher: </label>";
	print "<select name=\"researcher_id\">";
	print "\n\t<option value=\"0\">--Select One--</option>";
	while ($row = $sth->fetchRow()) 
	{
		print "\n\t<option value=\"$row[0]\"";
		if ($_SESSION[$currPageNameUpper]['researcher_id'] == $row[0])
		{	print " selected";	}
		print ">$row[1]</option>";
	}
	print "\n</select></p>";

	print "<input type=\"submit\" name=\"submit\" value=\"Insert Data\" />";

	print "\n</form>";

}


/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);

	$_SESSION[$currPageNameUpper]['protocol_type_id'] = $_REQUEST['protocol_type_id'];
	$_SESSION[$currPageNameUpper]['researcher_id'] = $_REQUEST['researcher_id'];
		
	if ($_FILES['uploadFile']['name'] == "")
	{	$errMsgs[] = "Please select the Data File to upload.";	}
		
	if (!$_SESSION[$currPageNameUpper]['protocol_type_id'])
	{	$errMsgs[] = "Please Select a Protocol.";	}
	
	if (!$_SESSION[$currPageNameUpper]['researcher_id'])
	{	$errMsgs[] = "Please Select the name of the Researcher.";	}
	
	if ($errMsgs)
	{	return 0;	}
	
	$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
	$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
	if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
	{
	   //File is valid, and was successfully uploaded
	   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
	   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
	   system("chmod 644 $uploadfile");
	} 
	else 
	{
		$errMsgs[] = "Could not move the uploaded file to the Destination on the server";
		return 0;
	}
	
	if ($errMsgs)
	{	return 0;	}
	
	$perlScriptFile = "insertProteomicsRefInfo.pl";
	$data_file = $_SESSION[$currPageNameUpper]['uploadFile'];
	$file_home = $_SESSION['FILE_HOME'];
	$protocol_type_id = $_SESSION[$currPageNameUpper]['protocol_type_id'];
	$person_id = $_SESSION[$currPageNameUpper]['researcher_id'];

	$com = "{$_SESSION['PERL_DIR']}perl $perlScriptFile \"$data_file\" \"$file_home\" $protocol_type_id $person_id 2>&1;";
	//print $com;
	$retString = exec($com, $retLines, $retValue);
	
	if ($retLines)
  	{
		foreach ($retLines as $retLine)
		{	$msg .= "$retLine <br />";	}
  	}
	if ($retValue == 0)	//success
  	{	
		if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' returned a successful value.";	}
	  	
	  	$_SESSION['Message'][] = $msg;
		//redirect
		print "<meta http-equiv=\"refresh\" content=\"0; URL=intro.php?stepno=1\">";
		exit();
	}
	else
	{	
	  	if (!$msg)
	  	{	$msg = "system command to '$perlScriptFile' failed. <br />Command was \"$com\"\nReturn Value = $retValue";	}
	  	$errMsgs[] = $msg;
	}
	
  	if ($errMsgs)
	{	return 0;	}

	return 1;
}

?>
