<?php
/**
* This script accepts a "savedState" file created by a previously saved
* state of the software by the user.
* Date: 21 Nov 2006
* @author Aejaaz Kamal <aekamal@vt.edu>
*/


include_once("common.php");
$currPageName = 'RESTORE_SAVED_STATE';
$currPageNameUpper = strtoupper($currPageName);
?>

<?php

$title = "Restore Saved Selections";
include("header.php");
?>

<?php

if ($_REQUEST['submit'])
{	processForm();	}

if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}
fillForm();
include_once("footer.php");
?>

<?php
//Functions
function fillForm()
{
	global $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	print "<form name=\"init_form\" method=\"post\" action=\"$self\" enctype=\"multipart/form-data\">\n";
	
	//This MAX_SIZE is an advisory to the browser. (So that the user does not find
	// that his file is rejected by the php on the server after uploading it).
	print '<input type="hidden" name="MAX_FILE_SIZE" value="30000000" />';
	print "<p><label>Selections File: </label>";
	print '<input name="uploadFile" size="48" type="file" value="Select File using browse"/>';
	print "</p>";
	
	print "<input type=\"submit\" name=\"submit\" value=\"Restore Saved Selections\" />";
	print "\n</form>";
}


/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
	if ($_FILES['uploadFile']['name'] == "")
	{	$errMsgs[] = "Please select the previously saved file containing your selections.";	}	
	
	if ($errMsgs)
	{	return 0;	}
		
	$uploaddir = $_SESSION['BROWSER_TMP_FULL'];
	$uploadfile = $uploaddir . $_FILES['uploadFile']['name'];
	if (move_uploaded_file($_FILES['uploadFile']['tmp_name'], $uploadfile)) 
	{
	   //File is valid, and was successfully uploaded
	   $_SESSION[$currPageNameUpper]['uploadFile'] = $uploadfile;
	   $_SESSION[$currPageNameUpper]['uploadFileName'] = $_FILES['uploadFile']['name'];
	   system("chmod 644 $uploadfile");
	} 
	else 
	{
		$errMsgs[] = "Could not move the uploaded file to the Destination on the server";
		return 0;
	}	
	
	if ($errMsgs)
	{	return 0;	}
	
	include("{$_SESSION['BROWSER_TMP_RELATIVE']}{$_SESSION[$currPageNameUpper]['uploadFileName']}");
	if (!isset($selectionArray))
	{	
		$errMsgs[] = "Uploaded File does not have information about selections.";	
		return 0;
	}
	
	foreach ($selectionArray as $key=>$value)
	{	$_SESSION[$key] = $value;	}
	
	//redirect
	print "<meta http-equiv=\"refresh\" content=\"0; URL=searchGene.php?stepno={$_SESSION['STEP_NUMBER']}\">";
	return 1;
}
?>
