<?php
/**
* This script choses the format of data
* for DOME.
* Date: 30 Sept 2003
* @author Aejaaz Kamal <aekamal@vt.edu>
* update: Dec. 12, 2003, X. Jing Li
*/
  include_once("common.php");
?>
<?php

setStepNumber();
setVariables($_SESSION['STEP_NUMBER']);
doControlBarRedirection(0);

if (isset($_REQUEST['data_format']))
{  $data_format = $_REQUEST['data_format']; }
else
{ $data_format = $_SESSION['DATA_FORMAT']['data_format']; }


?>

<?php 
$title = "DOME : {$labelNames['PAGE_LABEL']}"; 
include("header.php");
?>

<?php
fillForm($_SESSION['STEP_NUMBER'], $currPageName);
include("footer.php");

function fillForm($stepNumber, $currPageName)
{
  print "\n<div class=\"step{$stepNumber}-form\">\n";
  print "\n<div class=\"retrieve-file-links\">\n";
  fillFiles();
  print "</div>";
  fillStepControls($stepNumber, $currPageName);
  print "</div>";
}

function fillFiles()
{
  global $prevPageName, $data_format;
  $prevPageNameUpper = strtoupper($prevPageName);

  //print "data_format = $data_format<br />";
  $prevPageNameUpper = strtoupper($prevPageName);
  // 1. create a hash to store the sampling_point_id and its label:
  $samplingPointIds = array();
  $strSPSQLFilteredByUserInput = filterByUserInput('sampling_point');
  $rst = $_SESSION['dbh']->query($strSPSQLFilteredByUserInput);
  if (DB::isError($rst)) {
    printError("Error finding Files. [" . $rst->getMessage() . "]" );
    return;
  }
  if ($rst->numRows() > 0){
    while ($row = $rst->fetchRow()) {
      $samplingPointIds[$row[1]] = $row[2];
    }
  }

  // 2. create a hash for technique ids and name
  $techniqueIds = array();
  $strTechniqueFilteredByUserInput = filterTechniqueByUserInput();
  $rst = $_SESSION['dbh']->query($strTechniqueFilteredByUserInput);
  if (DB::isError($rst)) {
    printError("Error finding Files. [" . $rst->getMessage() . "]" );
    return;
  }
  if ($rst->numRows() > 0){
    while ($row = $rst->fetchRow()) {
      $techniqueIds[$row[0]] = $row[1];
    }
  }
  //print out the Ids:
  //foreach ($techniqueIds as $key => $name ) {
  //  print "key = $key, name = $name<br>";
  //}
  //print "strTechniqueFilteredByUserInput = $strTechniqueFilteredByUserInput<br>";
  // now we will trace the trail of tables to get the files involved in these sampling
  // points and techniques:
  // 3. sampling_replicate::
  $fileLocationLinkIds = array();
  //$sql = "select sampling_replicate_id from sampling_replicate where sampling_point_id in (";
  $sql = "select file_location_link_id from image_analysis where raw_data_id in ("
    . "select raw_data_id from raw_data where hybridization_id in ("
    . "select hybridization_id from hybridization where labeled_extract2_id in ("
    . "select labeled_extract_id from labeled_extract where technique_id in (";
  $index = 1;
  foreach ($techniqueIds as $key => $value) {
    if ($index) {
      $sql .= "$key";
      $index = 0;
    } else {
      $sql .= ", $key";
    }
  }
  $sql .= ") and sample_extract_id in ("
    . "select sample_extract_id from sample_extract where sample_id in ("
    . "select sample_id from sample where sampling_replicate_id in ("
    . "select sampling_replicate_id from sampling_replicate where sampling_point_id in (";
  $index = 1;
  foreach ($samplingPointIds as $key => $value  ) {
    //print "key = $key, name = $name<br>";
    if ($index) {
      $sql .= "$key";
      $index = 0;
    } else {
      $sql .= ", $key";
    }
  }
  $sql .= ") ))))))";
  //print "sql =$sql<br />";

  $rst = $_SESSION['dbh']->query($sql);
  if (DB::isError($rst)) {
    printError("Error finding Files. [" . $rst->getMessage() . "]" );
    return;
  }
  if ($rst->numRows() > 0){
    while ($row = $rst->fetchRow()) {
      $fileLocationLinkIds[] = $row[0];
    }
  }
  else
  {
	  printMessage("No files found for the selections made."); return;
  }
  //foreach ($fileLocationLinkIds as $id ) {
  //  print "file_locatio_link_id = $id<br>";
 // }

  // 4. get the file location and file name for each image_analysis_id
  if ($data_format == "TTEST") {
    // this is for ttest. it is only related to each sampling_point
    // get all exp_set_id from SESSION['EXPERIMENT']['EXPERIMENT']
    $exp_ids = $_SESSION['EXPERIMENT']['EXPERIMENT'];
    $expIds = array_keys($exp_ids);
    $exp_ids_str = "(" . implode(", ", $expIds) . ")";
    $sql = "select distinct(exp_set_id) from experiment where experiment_id"
      . " in $exp_ids_str order by exp_set_id ASC";
    $rst = $_SESSION['dbh']->query($sql);
    if (DB::isError($rst)) {
      printError("Error finding Files. [" . $rst->getMessage() . "]" );
      return;
    }
    $exp_set_names = array();
    while ($row = $rst->fetchRow()) {
      $esid = $row[0];
      if ($esid == 1) {
        $exp_set_names[] = "Yeast_Y";
      } else if ($esid == 2) {
        $exp_set_names[] = "MeJa_MeJa";
      }
    }
    $sql = "select l.name from sampling_point sp, label l"
      . " where sp.sampling_point_id in (";
    $index = 1;
    foreach ($samplingPointIds as $key => $value  ) {
      //print "key = $key, name = $name<br>";
      if ($index) {
        $sql .= "$key";
        $index = 0;
      } else {
        $sql .= ", $key";
      }
    }
    $sql .= ") and sp.label_id = l.label_id order by l.\"order\" ASC";
    //print "$sql<br>";
    $rst = $_SESSION['dbh']->query($sql);
    if (DB::isError($rst)) {
      printError("Error finding Files. [" . $rst->getMessage() . "]" );
      return;
    }
    if ($rst->numRows() > 0){
      //print "<ul>";
      $link_strs = array();
      for ($i = 0; $i<count($exp_set_names); $i++) {
        $prefix = $exp_set_names[$i];
        $link_strs[$i] = "";
      }
      $seenFiles = array();
      while ($row = $rst->fetchRow()) {
        $lname = $row[0];
        if (!$seenFiles[$lname]) {
          $seenFiles[$lname] = 1;
          $name = str_replace(" ", "", $lname);
          $name = str_replace("min", "m", $name);
          $name = str_replace("h", "H", $name);
          for ($i = 0; $i<count($exp_set_names); $i++) {
            $prefix = $exp_set_names[$i];
            $file = "ttest_mt-rna_" . $prefix . $name . ".txt";
            $fullname = "AllFiles/ttest/" . $file;
            $link_strs[$i] .= "<a href=$fullname target=\"_blank\">$file</a><br/>";
          }
        }
      }
      $ln_str = "";
      for ($i = 0; $i<count($exp_set_names); $i++) {
        $ln_str .= $link_strs[$i];
      }
      echo $ln_str;
      //print "</ul>";
    }
    else
    {
      printError("Filename and Path not found in database.");
    }

  }
  else {
    $sql = "select fl.location, f.file_name from file_location fl, file f, "
      . "file_location_link fll where fll.file_id = f.file_id and "
      . "fll.file_location_id = fl.file_location_id "
      . "and fll.file_location_link_id in (";
    $index = 1;
    foreach ($fileLocationLinkIds as $id ) {
      if ($index) {
        $sql .= "$id";
        $index = 0;
      } else {
        $sql .= ", $id";
      }
    }
    $sql .= ") ORDER BY f.file_name";
    //print "sql = $sql<br />";

    $rst = $_SESSION['dbh']->query($sql);
    if (DB::isError($rst)) {printError("Error finding Files. [" . $rst->getMessage() . "]" ); return;}
    if ($rst->numRows() > 0)
    {
      //print "<ul>";
      while ($row = $rst->fetchRow())
      {
        if ($data_format == "RAW")
        {
          //print "<li><a href=\"./AllFiles/{$row[1]}\">$row[1]</a></li>";
          print "<a href=\"./AllFiles/{$row[1]}\" target=\"_blank\">$row[1]</a><br/>";
        }
        elseif ($data_format == "PROCESSED")
        {
          $fullname = "AllFiles/processed/proc_" . $row[1];
          //print "fullname = $fullname<br>";
          if (file_exists($fullname) ) {
            //print "<li><a href=$fullname>proc_$row[1]</a></li>";
            print "<a href=$fullname target=\"_blank\">proc_$row[1]</a><br/>";
          } else {
            //print "<li>proc_$row[1]</li>";
            print "proc_$row[1]<br/>";
          }
        }
        elseif ($data_format == "STAT_PLOTS")
        {
          $name = $row[1];
          $array = explode(".", $name);
          $file = "plot_" . $array[0] . ".jpeg";
          $fullname = "AllFiles/stat_plots/" . $file;
          //print "fullname = $fullname<br>";
          if (file_exists($fullname)) {
            //print "<li><a href=$fullname>$file</a></li>";
            print "<a href=$fullname target=\"_blank\">$file</a><br/>";
          } else {
            //print "<li>$file </li>";
            print "$file <br/>";
          }
        }
      }
      //print "</ul>";
    }
    else
    {
      printError("Filename and Path not found in database.");
    }
  }
}

function fillStepControls($stepNumber, $currPageName)
{
  $currPageNameLower = strtolower($currPageName);
  $self = $_SERVER['PHP_SELF'];

  print "<form name=\"{$currPageNameLower}-form\" method=\"get\" action=\"{$self}\">\n";
  printControlBar($stepNumber);
  print "</form>";
}

function filterTechniqueByUserInput()
{
  $strSQLPrev = "SELECT t.technique_id, t.technique_name FROM technique t";
  $strSQLPrev .= " WHERE t.technique_id in (";

  $firstCondition = 1;
  $IDs = $_SESSION['TECHNIQUE']['TECHNIQUE'];
  while (list ($key, $val) = each ($IDs))
  {
    if ($val) {
      if ($firstCondition)
      {
        $strSQLPrev .= $key;
        $firstCondition = 0;
      } else {
        $strSQLPrev .= ", " . $key;
      }
    }
  }
  $strSQLPrev .= ")";


  //print "<br><br>FILTER_Technique_SQL: $strSQLPrev";
  return $strSQLPrev;
}

?>
