<?php

/** This php script searches the processed data in DOME by either TC number

  * or gene description. It uses the values like the experiment_ids, sampling_point_ids, 

  * technique_ids, set in the session variables on the previous pages.

  *

  * author: Aejaaz Kamal <aekamal@vt.edu>

  * After initial code from X. Jing Li

  * Date: 19 Apr 2004

  */





include_once("common.php");

include_once("workFlow.php");

include_once("searchGeneFunctions.php");



setStepNumber();

//Sets Environment Variable

setVariables($_SESSION['STEP_NUMBER']);



doControlBarRedirection(1);  



setStrings();



$title = "Choose : Output";

include("header.php");

?>

<script type="text/javascript">

function setCheckboxGroup(form, checkboxSet, val) 

{

  	comparisonValue = checkboxSet + "_results[]";

	for (i=0; i<form.elements.length; i++)

 	{

	 	if (form.elements[i].name == comparisonValue)

	    {	form.elements[i].checked = val;	  }

  	}

}

</script>



<?php

if ($_SESSION['errMsgs'])

{	

	foreach ($_SESSION['errMsgs'] as $msg)

	{	printError($msg);	}

	unset($_SESSION['errMsgs']);

}

fillForm();

include("footer.php");

?>



<?php

function fillForm()

{

	global $currPageName, $prevPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$prevPageNameUpper = strtoupper($prevPageName);

	$atleastOneFound = 0;

	//$stime = microtime_float();

	echo "<form name=\"init_form\" method=\"post\" action=\"{$_SERVER['PHP_SELF']}\" >\n";

	print printPageSelections();

	printControlBar($_SESSION['STEP_NUMBER'], 1);

	print "\n<table><tr><td class=\"layout-main-col\">";

	

	unset($_SESSION[$currPageNameUpper]['ANNOTATIONS']);

	

	$firstDone = false;

	foreach ($_SESSION[$prevPageNameUpper]['TECHNIQUE'] as $technique_id=>$checked)

	{

		if ($checked AND $technique_id > 0)

		{		

			if (!$firstDone)

			{	$techniqueIDs = $technique_id; $firstDone = true;	}

			else

			{	$techniqueIDs .= ", $technique_id";	}

		}

	}

		

	$sql = "SELECT technique_id, technique_type, UPPER(technique_type)

			FROM technique 

			WHERE technique_id IN ($techniqueIDs)

			ORDER BY UPPER(technique_type)";

	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 

	{	printError("Error finding technique_types from the database.");	}

	

	while($row = $sth->fetchRow())

	{	$techniquesArray[$row[1]][] = $row[0];	}

	foreach ($techniquesArray as $technique_type=>$techniqueIDsArray)

	{

		unset($recordIDs);

		$techniqueIDs = join(', ', $techniqueIDsArray);

		$map_ids = join(', ', $_SESSION[$prevPageNameUpper]['map_ids']);

		$retVal = printSearchResults(strtoupper($technique_type), $techniqueIDs, $_SESSION[$prevPageNameUpper]['DATA'][$technique_type]['NAMES'], $_SESSION[$prevPageNameUpper]['DATA'][$technique_type]['ISEXACT'], $recordIDs, $map_ids);

		if ($retVal)

		{		$atleastOneFound++;		  }

		

		//print "<br/>Finished $technique_type: " . (microtime_float() - $stime);

		print printProtocol($technique_type, $recordIDs);	

		print "<hr />";

		//print "<br/>Finished $technique_type Protocol: " . (microtime_float() - $stime);

		

	}

  if ($atleastOneFound)

  {

	  print "</td><td class=\"layout-right-col\">";

	  print "\n<table><tr><td>";

	  printOutput();

	  print "<hr />";

	  printMissingValues();

	  print "<hr />";

	  if (!$_SESSION['IS_REPLICATE_TRACK'])

	  {

		  print "</td></tr>\n<tr><td>";

		  printFilterBy();

	  }

	  print "\n</td></tr></table>";

  }

  print "</td></tr></table>";

  printControlBar($_SESSION['STEP_NUMBER'], 1);

  print "\n</form>";



}



function printSearchResults($technique_type, $techniqueIDs, $searchNames, $searchType = "like", &$recordIDs, $map_ids)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	

	$atleastOneFound = 0;

	if ($searchType == 'browse')

	{

		$atleastOneFound = 1;

		print "<h3>$technique_type Results - All Data</h3>";

	}

	elseif ($searchNames != "") 

	{

		$searchNamesArray = explode("\r", $searchNames);

	    print "<h3>$technique_type Results matching";

	    foreach ($searchNamesArray as $key => $value) 

	    {

			if (strlen(trim($value)) == 0)

	    	{	continue;	}

		    $i++;

	    	if ($i > 1)

	    	{	print " OR";	}

		    print " '$value'";

		    $searchNamesArray[$key] = strtoupper(trim($value));

	    }

	    print "</h3>";

	

	    $recordIDs = getRecordIDsFromUserTyping($technique_type, $searchNamesArray, $searchType);

	}

	elseif (0 == strlen($searchNames)) 

	{	print "<h3>$technique_type:</h3>";	}

	

	if (strlen($map_ids) > 0 AND '0' != $map_ids)

    {

	    $recordIDsMaps = getRecordIDsFromUserMapSelections($technique_type, $map_ids);

	    if (strlen($recordIDs) AND strlen($recordIDsMaps))

	    {	$recordIDs = "$recordIDs, $recordIDsMaps";	}

	    elseif (strlen($recordIDsMaps))

	    {	$recordIDs = $recordIDsMaps;	}

    }

    //print "<br>map_ids = $map_ids, recordIDs = $recordIDs";

    if (strlen($recordIDs))

    {

	    $sql = getSearchResultsSQL($technique_type, $techniqueIDs, $recordIDs);

	    //echo "sql = $sql<br>";

	    

	    $sth = $_SESSION['dbh']->query($sql);

	    if ( DB::isError($sth) ) 

	    {

			printError("Could Not retrieve $technique_type Names."); return $atleastOneFound;

	    }

	    $rownum = $sth->numrows();

	    if ($rownum > 0) 

	    {

		    $atleastOneFound = 1;

		    displaySearchResults($sth, $technique_type, $recordIDs);

	    } 

	    else 

	    {	printMessage ("No $technique_type or $technique_type data found for the given search criteria.");	}

	    

    }

	

	if ($atleastOneFound AND $searchType != 'browse')

	{

		print "\n<p><input type=\"button\" onClick=\"setCheckboxGroup(this.form, '$technique_type', true)\" value=\"Select All\">\n";

		print "\n<input type=\"button\" onClick=\"setCheckboxGroup(this.form, '$technique_type', false)\" value=\"Clear All\"></p>\n";

	}

	return $atleastOneFound;

}



function getRecordIDsFromUserTyping($technique_type, $searchNamesArray, $searchType = "like")

{

	switch (strtoupper($technique_type))

	{

	case 'METABOLITE':

		foreach ($searchNamesArray as $key => $value) 

		{

			$searchNamesArray[$key] = convertToSearchName($value);

		}

		

		$sqlEntityIDs = "SELECT DISTINCT record_id FROM allnames"  

		      . " WHERE";

		if ($searchType == "like")

		{	

			$firstLike = 1;

			foreach ($searchNamesArray as $key => $value) 

			{

				if ($firstLike)

				{

					$sqlEntityIDs .= " (UPPER(search_name) LIKE UPPER('%$value%')";	

					$firstLike = 0;

				}

				else

				{

					$sqlEntityIDs .= " OR UPPER(search_name) LIKE UPPER('%$value%')";	

				}

			}

			$sqlEntityIDs .= ")";

		}

		else

		{

			$strEntitys = implode("', '", $searchNamesArray);

			$strEntitys = strtoupper($strEntitys);

			$sqlEntityIDs .= " UPPER(search_name) IN ('$strEntitys')";	

		}

		$sqlEntityIDs .= " AND kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'";

		

		$sth = $_SESSION['dbh']->query($sqlEntityIDs);

	    if ( DB::isError($sth) ) 

	    {

	     	printError("Could Not retrieve $technique_type Names."); return "";

	    }

	    if ($sth->numRows() == 0)

	    {	return 0;   }

	    $firstID = true; $recordIDs = "";

	    while($row = $sth->fetchRow())

	    {

		    if ($firstID)

		    {	$firstID = false;	}

		    else

		    {	$recordIDs .= ", ";	}

		    

		    $recordIDs .= "'$row[0]'";

	    }

		break;

	

	case 'MRNA':

		foreach ($searchNamesArray as $key => $value) 

		{

			$searchNamesArrayConverted[$key] = convertToSearchName($value);

		}

		

		$sqlEntityIDs = "SELECT DISTINCT record_id FROM allnames, gene g WHERE";

		$sqlGeneIDs = "SELECT DISTINCT gene_id FROM composite_sequence WHERE";

		if ($searchType == "like")

		{	

			$firstLike = 1;

			foreach ($searchNamesArrayConverted as $key => $value) 

			{

				if ($firstLike)

				{

					$sqlEntityIDs .= " (UPPER(search_name) LIKE UPPER('%$value%')";	

					$sqlGeneIDs .= " (UPPER(probe_name) LIKE UPPER('%{$searchNamesArray[$key]}%')";	

					$firstLike = 0;

				}

				else

				{

					$sqlEntityIDs .= " OR UPPER(search_name) LIKE UPPER('%$value%')";	

					$sqlGeneIDs .= " OR UPPER(probe_name) LIKE UPPER('%{$searchNamesArray[$key]}%')";	

				}

			}

			$sqlEntityIDs .= ")"; $sqlGeneIDs .= ")";

		}

		else

		{

			$strEntitys = implode("', '", $searchNamesArrayConverted);

			$strEntitys = strtoupper($strEntitys);

			$sqlEntityIDs .= " UPPER(search_name) IN ('$strEntitys')";

			$strEntitys = implode("', '", $searchNamesArray);

			$sqlGeneIDs .= " UPPER(probe_name) IN ('$strEntitys')";	

		}

		$sqlEntityIDs .= " AND kw_table_id = '{$_SESSION['TableID']['GENE']}'

			AND \"record_id\" = g.\"gene_id\"";

		if ($_SESSION['CurrentSpecieID'] > 0)

		{	$sqlEntityIDs .= " AND g.\"specie_id\" = {$_SESSION['CurrentSpecieID']}";	}

		

		$sqlGeneIDsUnion = "SELECT DISTINCT record_id FROM (($sqlEntityIDs) UNION ($sqlGeneIDs)) a";

		

		$sqlReporterIDs = "SELECT r.\"reporter_id\" FROM 

			\"reporter\" r, \"composite_sequence\" cs, ($sqlGeneIDsUnion) gids

			WHERE cs.\"gene_id\" = gids.\"record_id\"

			AND r.\"composite_sequence_id\" = cs.\"composite_sequence_id\"";

			

		$sth = $_SESSION['dbh']->query($sqlReporterIDs);

	    if ( DB::isError($sth) ) 

	    {

	     	printError("Could Not retrieve reporter_ids."); return "";

	    }

	    if ($sth->numRows() == 0)

	    {	return 0;   }

	    $firstID = true; $recordIDs = "";

	    while($row = $sth->fetchRow())

	    {

		    if ($firstID)

		    {	$firstID = false;	}

		    else

		    {	$recordIDs .= ", ";	}

		    

		    $recordIDs .= "'$row[0]'";

	    }

		break;

		

	case 'PROTEIN':

		foreach ($searchNamesArray as $key => $value) 

		{

			$searchNamesArrayConverted[$key] = convertToSearchName($value);

		}

		

		$sqlEntityIDs = "SELECT DISTINCT \"record_id\" FROM \"allnames\" WHERE";

		$sqlRefSpot = "SELECT \"reference_spot_id\", CAST(\"reference_spot_id\" AS TEXT) FROM \"reference_spot\" WHERE";

		$sqlRSPS1 = "SELECT \"reference_spot_id\", \"annotation\" FROM \"ref_spot_protein_state\" WHERE";

		$sqlRSPS2 = "SELECT \"reference_spot_id\", \"support\" FROM \"ref_spot_protein_state\" WHERE";

				

		if ($searchType == "like")

		{	

			$firstLike = 1;

			foreach ($searchNamesArrayConverted as $key => $value) 

			{

				if ($firstLike)

				{

					$sqlEntityIDs .= " (UPPER(\"search_name\") LIKE UPPER('%$value%')";	

					$sqlRefSpot .= " (UPPER(\"reference_spot_id\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

					$sqlRSPS1 .= " (UPPER(\"annotation\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

					$sqlRSPS2 .= " (UPPER(\"support\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

					$firstLike = 0;

				}

				else

				{

					$sqlEntityIDs .= " OR UPPER(\"search_name\") LIKE UPPER('%$value%')";	

					$sqlRefSpot .= " OR UPPER(\"reference_spot_id\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

					$sqlRSPS1  .= " OR UPPER(\"annotation\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

					$sqlRSPS2  .= " OR UPPER(\"support\") LIKE UPPER('%{$searchNamesArray[$key]}%')";

				}

			}

			$sqlEntityIDs .= ")"; $sqlRefSpot .= ")"; $sqlRSPS1  .= ")"; $sqlRSPS2  .= ")";

		}

		else

		{

			$strEntitys = implode("', '", $searchNamesArrayConverted);

			$strEntitys = strtoupper($strEntitys);

			$sqlEntityIDs .= " UPPER(\"search_name\") IN ('$strEntitys')";	

			

			$strEntitys = implode("', '", $searchNamesArray);

			$strEntitys = strtoupper($strEntitys);

			$sqlRefSpot .= " UPPER(\"reference_spot_id\") IN ('$strEntitys')";

			

			$sqlRSPS1  .= " UPPER(\"annotation\") IN ('$strEntitys')";

			$sqlRSPS2  .= " UPPER(\"support\") IN ('$strEntitys')";

		}

		$sqlEntityIDs .= " AND kw_table_id = '{$_SESSION['TableID']['PROTEIN_STATE']}'";

		

		$sqlSpotIDs = "SELECT rs.\"reference_spot_id\", CAST(rs.\"reference_spot_id\" AS TEXT)

			FROM \"reference_spot\" rs, \"ref_spot_protein_state\" rsps, \"protein_state\" ps

				, \"protein\" p, ($sqlEntityIDs) pids

				WHERE  p.\"protein_id\" = pids.\"record_id\"

				AND ps.\"protein_id\" = p.\"protein_id\"

				AND rsps.\"protein_state_id\" = ps.\"protein_state_id\"

				AND rs.\"reference_spot_id\" = rsps.\"reference_spot_id\"";

		

		$sqlUnionSpotIDs = "($sqlRefSpot) UNION ($sqlSpotIDs) UNION ($sqlRSPS1) UNION ($sqlRSPS2)";

		//print $sqlUnionSpotIDs;

		$sth = $_SESSION['dbh']->query($sqlUnionSpotIDs);

	    

		if ( DB::isError($sth) ) 

	    {  	printError("Could Not retrieve Spot Names. " . $sth->getMessage()); return "";    }

	    

	    if ($sth->numRows() == 0)

	    {	return 0;   }

	    $firstID = true; $recordIDs = "";

	    while($row = $sth->fetchRow())

	    {

		    if ($firstID)

		    {	$firstID = false;	}

		    else

		    {	$recordIDs .= ", ";	}

		    

		    $recordIDs .= "'$row[0]'";

	    }

		break;

	}

	return $recordIDs;

}



function getRecordIDsFromUserMapSelections($technique_type, $map_ids = 0)

{

	switch (strtoupper($technique_type))

	{

	case 'METABOLITE':

		$kw_table_id = 11;

		break;

	case 'MRNA':

		$kw_table_id = 33;

		break;

	case 'PROTEIN':

		return '';

		break;

	}

	

/*	$sql = "SELECT mc.\"record_id\" FROM \"map_component\" mc, map m

		WHERE m.map_id IN ($map_ids) AND mc.kw_table_id = $kw_table_id";

	if ($_SESSION['CurrentSpecieID'] > 0)

	{	$sql .= " AND mc.specie_id = {$_SESSION['CurrentSpecieID']}";	}

	$sql .= " AND mc.map_id = m.map_id";

*/

  $sql = "SELECT pi.\"record_id\" FROM \"map_component\" mc, \"map\" m, \"pathway_info\" pi

		WHERE m.map_id IN ($map_ids) 

    AND pi.map_component_id = mc.map_component_id 

    AND pi.kw_table_id = $kw_table_id 

	  AND mc.map_id = m.map_id";



	$sth = $_SESSION['dbh']->query($sql);

	    

	if ( DB::isError($sth) ) 

    {  	printError("Could Not retrieve Map Components. " . $sth->getMessage()); return false;    }

	    

    if ($sth->numRows() == 0)

    {	return false;   }

    $firstID = true; $recordIDs = "";

    while($row = $sth->fetchRow())

    {

	    if ($firstID)

	    {	$firstID = false;	}

	    else

	    {	$recordIDs .= ", ";	}

	    

	    $recordIDs .= "'$row[0]'";

    }

	return $recordIDs;

}







function getSearchResultsSQL($technique_type, $techniqueIDs, $recordIDs, $gene_ids = '')

{

	global $spidInStr, $tissue_type_label_id_str;

	switch (strtoupper($technique_type))

	{

	case 'METABOLITE':



	    $sqlAN = "SELECT * FROM allnames an 

	    	WHERE an.record_id IN ($recordIDs)

	    	AND an.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'

	    	AND UPPER(an.is_primary) = 'Y'";

		    

		if ($_SESSION['IS_REPLICATE_TRACK'])

		{

			

			$sql = "SELECT DISTINCT an.record_id, an.aname, UPPER(an.aname) FROM ($sqlAN) an, 

				metabolite_processed2 mp2, protocol_type pt

				WHERE an.record_id = mp2.cpd_id

				AND mp2.\"protocol_type_id\" = pt.protocol_type_id

				AND pt.\"technique_id\" IN ($techniqueIDs)

				ORDER BY UPPER(an.aname)";

		}

		else

		{

			

			$sqlP1D = "SELECT * FROM sp_summary p1d, protocol p, protocol_type pt

				WHERE p1d.record_id IN ($recordIDs)

				AND p1d.kw_table_id = '{$_SESSION['TableID']['COMPOUND']}'

				AND p1d.sampling_point_id IN ($spidInStr)

				AND p1d.label_id IN ($tissue_type_label_id_str)

				AND p1d.protocol_id = p.protocol_id

				AND p.protocol_type_id = pt.protocol_type_id

				AND pt.technique_id IN ($techniqueIDs)

				ORDER BY p1d.record_id";

			

			$sql = "SELECT DISTINCT an.record_id, an.aname, UPPER(an.aname) FROM 

				($sqlP1D) p1d, ($sqlAN) an

				WHERE p1d.record_id = an.record_id

				AND an.kw_table_id = p1d.kw_table_id

				ORDER BY UPPER(an.aname)";

		}

		break;

	case 'MRNA':

	    //First Get gene_ids correspoding to the reporter IDs.

		$sqlGeneIDs = "SELECT cs.\"gene_id\" FROM 

			\"reporter\" r, \"composite_sequence\" cs, gene g

			WHERE r.\"reporter_id\" IN ($recordIDs)

			AND r.\"composite_sequence_id\" = cs.\"composite_sequence_id\"

			AND cs.\"gene_id\" = g.\"gene_id\"";

			if ($_SESSION['CurrentSpecieID'] > 0)

			{	$sqlGeneIDs .= " AND g.\"specie_id\" = {$_SESSION['CurrentSpecieID']}";	}

			

		$sth = $_SESSION['dbh']->query($sqlGeneIDs);

	    if ( DB::isError($sth) ) 

	    {

	     	printError("Could Not retrieve Gene IDs."); return "";

	    }

	    if ($sth->numRows() == 0)

	    {	return 0;   }

	    $firstID = true; $gene_ids = "";

	    while($row = $sth->fetchRow())

	    {

		    if ($firstID)

		    {	$firstID = false;	}

		    else

		    {	$gene_ids .= ", ";	}

		    

		    $gene_ids .= "'$row[0]'";

	    }	

		

	

		$sqlAN = "SELECT an1.\"record_id\", an1.\"aname\" AS \"tc\"

	    , an2.\"aname\" AS \"annotation\" 

	    FROM (SELECT * FROM \"allnames\" WHERE \"record_id\" IN ($gene_ids)

			AND \"kw_table_id\" = '{$_SESSION['TableID']['GENE']}'

			AND \"is_primary\" = 'Y') an1 

		LEFT JOIN 

			(SELECT * FROM \"allnames\" WHERE \"record_id\" IN ($gene_ids)

			AND \"kw_table_id\" = '{$_SESSION['TableID']['GENE']}'

			AND \"is_primary\" = 'A') an2

		ON an1.record_id = an2.record_id";

	    

		if ($_SESSION['IS_REPLICATE_TRACK'])

		{

			

			$sql = "SELECT DISTINCT r.\"reporter_id\", an.\"tc\"

				, an.\"annotation\", UPPER(an.\"tc\") 

				FROM \"ma_norm\" man, \"composite_sequence\" cs, \"reporter\" r

				, \"protocol_type\" pt, ($sqlAN) an

				WHERE r.reporter_id IN ($recordIDs)

				AND man.reporter_id IN ($recordIDs)

				AND man.reporter_id = r.reporter_id

				AND r.composite_sequence_id = cs.composite_sequence_id

				AND an.record_id = cs.gene_id

				AND man.\"protocol_type_id\" = pt.\"protocol_type_id\"

				AND pt.\"technique_id\" IN ($techniqueIDs)

				ORDER BY UPPER(an.\"tc\")";

		}

		else

		{

				

			$sql = "SELECT DISTINCT r.\"reporter_id\", an.\"tc\"

				, an.\"annotation\", UPPER(an.\"tc\") 

				FROM \"composite_sequence\" cs, \"reporter\" r

				, \"sp_summary\" p1d, ($sqlAN) an, protocol p, protocol_type pt

				WHERE r.reporter_id IN ($recordIDs)

				AND p1d.record_id IN ($recordIDs)

				AND r.reporter_id = p1d.record_id

				AND p1d.kw_table_id = '{$_SESSION['TableID']['REPORTER']}'

				AND p1d.sampling_point_id IN ($spidInStr)

				AND p1d.label_id IN ($tissue_type_label_id_str)

				AND r.composite_sequence_id = cs.composite_sequence_id

				AND an.record_id = cs.gene_id

				AND p1d.protocol_id = p.protocol_id

				AND p.protocol_type_id = pt.protocol_type_id

				AND pt.technique_id IN ($techniqueIDs)

				ORDER BY UPPER(an.\"tc\")";

		}

		break;

		

	case 'PROTEIN':

		

		if ($_SESSION['IS_REPLICATE_TRACK'])

		{

			$sql = "SELECT DISTINCT rs.\"reference_spot_id\", CAST(rs.\"reference_spot_id\" AS TEXT), UPPER(rs.\"reference_spot_id\") 

				FROM \"proteomics_data\" pd, \"reference_spot\" rs, \"protocol_type\" pt

				WHERE rs.\"reference_spot_id\" IN ($recordIDs)

				AND pd.\"reference_spot_id\" = rs.\"reference_spot_id\"

				AND pd.\"protocol_type_id\" = pt.\"protocol_type_id\"

				AND pt.\"technique_id\" IN ($techniqueIDs)

				ORDER BY rs.\"reference_spot_id\"";

		}

		else

		{

			

			$sqlP1D = "SELECT * FROM sp_summary p1d, protocol p, protocol_type pt

				WHERE p1d.record_id IN ($recordIDs)

				AND p1d.kw_table_id = '{$_SESSION['TableID']['REFERENCE_SPOT']}'

				AND p1d.sampling_point_id IN ($spidInStr)

				AND p1d.label_id IN ($tissue_type_label_id_str)

				AND p1d.protocol_id = p.protocol_id

				AND p.protocol_type_id = pt.protocol_type_id

				AND pt.technique_id IN ($techniqueIDs)

				ORDER BY p1d.record_id";

				

			$sql = "SELECT DISTINCT rs.\"reference_spot_id\", CAST(rs.\"reference_spot_id\" AS TEXT), UPPER(rs.\"reference_spot_id\") 

				FROM ($sqlP1D) p1d, \"reference_spot\" rs

				WHERE rs.\"reference_spot_id\" IN ($recordIDs)

				AND p1d.\"record_id\" = rs.\"reference_spot_id\"

				ORDER BY rs.\"reference_spot_id\"";

		}

		break;

	}

	return $sql;

}



function displaySearchResults(&$sth, $technique_type, &$recordIDs)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	

	$annotationsArray = &$_SESSION[$currPageNameUpper]['ANNOTATIONS'];

	echo "\n<ol>";

	$Results = array();

	while ($row = $sth->fetchrow()) 

	{

        $ID = $row[0];

	    switch (strtoupper($technique_type))

	    {

	    case 'MRNA':

			$annotation = $row[2];

	    	$annotationsArray[$row[1]] = $annotation;

	    	$Name = $row[1];

	    	if ($annotation)

	    	{	$Name .= ":$annotation";	}

		    $sql = "SELECT cs.gene_id FROM composite_sequence cs, reporter r

		    	WHERE r.reporter_id = '$ID'

		    	AND r.composite_sequence_id = cs.composite_sequence_id";

		    $sthCS = $_SESSION['dbh']->query($sql);

		    if ( DB::isError($sthCS) ) 

		    {	printError("Error retrieving gene_id for reporter_id $ID. (" . $sthCS->getMessage() . ")"); 	}

		    

		    if ($sthCS->numRows() > 0)

		    {	

			    $rec = $sthCS->fetchRow();

			    $gene_id = $rec[0];

			    $extLinksStr = getExternalLinks($_SESSION['TableID']['GENE'], $gene_id);

			}

			break;

	    case 'METABOLITE':

		    $Name = $row[1];	

		    $extLinksStr = getExternalLinks($_SESSION['TableID']['COMPOUND'], $ID);

		    break;

		

		case 'PROTEIN':

		    /*$sqlProteins = "SELECT an.record_id, an.\"aname\"

			FROM \"reference_spot\" rs, \"ref_spot_protein_state\" rsps, \"protein_state\" ps

				, \"allnames\" an

				WHERE  rs.\"reference_spot_id\" = '$ID'

				AND rsps.\"reference_spot_id\" = rs.\"reference_spot_id\"

				AND ps.\"protein_state_id\" = rsps.\"protein_state_id\"

				AND an.\"record_id\" = ps.\"protein_id\"

				AND an.\"kw_table_id\" = {$_SESSION['TableID']['PROTEIN']}

				AND UPPER(an.\"is_primary\") = 'Y'";*/

				

			$sqlProteins = "SELECT rsps.\"reference_spot_id\", rsps.\"annotation\", rsps.\"support\"

				FROM \"ref_spot_protein_state\" rsps WHERE rsps.\"reference_spot_id\" = '$ID'";

			//print $sqlProteins;

		    $sthP = $_SESSION['dbh']->query($sqlProteins);

		    if ( DB::isError($sthP) ) 

		    {	printError("Error retrieving Proteins for spot_id '$ID'. (" . $sthP->getMessage() . ")"); 	return;	}

		    

		    if ($sthP->numRows() > 0)

		    {	

			    $firstAnnotation = true;

			    while ($rec = $sthP->fetchRow())

			    {

				    if ($firstAnnotation)

				    {	

					    $annotation = $rec[1];

					    if (strlen($rec[1]) > 0)

					    {	$annotation .= ":";	    }

					    $annotation .= $rec[2];	

					    $firstAnnotation = false;

				    }

				    else

				    {	

					    $annotation .= ", {$rec[1]}";	

					    if (strlen($rec[1]) > 0)

					    {	$annotation .= ":";	    }

					    $annotation .= $rec[2];	

					}

			    }

			    $annotationsArray[$row[1]] = $annotation;

			}

			$Name = "$row[1]:(Proteins: ";

			if (strlen($annotation) > 0)

			{	$Name .= $annotation;	}

			else

			{	$Name .= 'none';	}

			

			$Name .= ")";

			break;

		}

	    $Results[] = $ID;

		echo  "\n\t<li>";

    	echo  "<input type=\"checkbox\" name=\"{$technique_type}_results[]\"";

    	if (!isset($_SESSION[$currPageNameUpper]['DATA'][$technique_type]['RESULTS']))

    	{ echo  " checked";  }

    	elseif (in_array($ID, $_SESSION[$currPageNameUpper]['DATA'][$technique_type]['RESULTS']))

      	{ echo  " checked";  }

     	

      	echo  " value=\"" . strtoupper(trim($ID)) . "\" />";

	 	echo  "$Name";

	 	if ($extLinksStr)

	 	{	echo " ($extLinksStr)";	}

	 	echo "</li>";

  	}

  	$recordIDs = "'" . join("', '", $Results) . "'";

  	$_SESSION[$currPageNameUpper]['DATA'][$technique_type]['SEARCH_RESULTS'] = $Results;

	setStrings();

	echo  "\n</ol>";

}



function output_file_format()

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$fieldarray = &$_SESSION[$currPageNameUpper]['FIELDS'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['label_names'];

	$annotations = &$_SESSION[$currPageNameUpper]['ANNOTATIONS'];

	

	if (!$master_array)

	{	return "No data found for your selections";	}

	

	// This section is for print all data for selected genes in a tab

	// delimted text form

	$data_str = "Exp Set\tExperiment\tIdentifier\tSecondary ID\tProtocol Type Name\tData Type";

	foreach ($label_names as $key => $name) 

	{

		$data_str .= "\t$name";

	}

	if ($annotations)

	{	$data_str .= "\tAnnotation";	}

	$data_str .= "\n";

	$ESNames = array_keys($master_array);

	foreach ($ESNames as $ESName) 

	{

		$ENames = array_keys($master_array[$ESName]);

		foreach ($ENames as $EName) 

		{

			$identifiers = array_keys($master_array[$ESName][$EName]);

			foreach ($identifiers as $identifier) 

			{

				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

				foreach ($secondaryIDs as $secondaryID) 

				{

					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

					foreach ($protocol_type_names as $protocol_type_name) 

					{

						for ($i=0; $i<count($fieldarray); $i++) 

						{

							$fieldname = str_replace("\"", "", $fieldarray[$i]);

							$data_str.= "$ESName\t$EName\t$identifier";

							if ('None' == $secondaryID)

							{	$data_str.= "\t";	}

							else

							{	$data_str.= "\t$secondaryID";	}

							$data_str.= "\t$protocol_type_name\t$fieldname";

							foreach ($label_names as $label_name) 

							{

								$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$fieldarray[$i]][$label_name];

								$data_str.= "\t$value";

							}

							if ($annotations)

							{	$data_str.= "\t{$annotations[$identifier]}";	}

							$data_str.= "\n";

						}

					}

				}

			}

		}

	}

	return $data_str;

}



function output_file_format_replicate()

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['Sampling Point'];

	

	$annotations = &$_SESSION[$currPageNameUpper]['ANNOTATIONS'];

	if (!$master_array)

	{	return "No data found for your selections";	}

	

	foreach ($label_names as $label_order=>$label_name) 

	{	

		switch ($_SESSION['PLOT_TIMES_IN'])

		{

		case 'min':

			$time = $label_order;

			break;

		case 'hr':

			$time = $label_order/60;

			break;

		case 'day':

			$time = $label_order/(60 * 24);

			break;

		case 'wk':

			$time = $label_order/(60 * 24 * 7);

			break;

		}

		$sp_value = substr($time, 0, 4);

		$sp_values[$label_name] = $sp_value;

	}

	

	

	//Master Array has the following keys:

	//master_array[exp_set_name][experiment][identifier][secondaryID][protocol_type_name][sp_name][BiologicalReplicateNumber][TechnicalReplicateNumber]

	

	

	// This section is for print all data for selected genes in a tab

	// delimted text form

	$data_str = "Exp Set\tExperiment\tIdentifier\tSecondary ID\tProtocol Type";

	

	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];

	$sp_name_orders = array_keys($SPTechnicalReplicates);

	foreach ($sp_name_orders as $sp_name_order)

	{

		$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

		foreach ($biologicalReplicates as $biologicalReplicate)

		{

			$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

			$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);

			foreach ($technicalReplicates as $technicalReplicate)

			{

				$data_str .= "\t{$label_names[$sp_name_order]}_Replicate $biologicalReplicate";

				if ($TRCount > 1)

				{	$data_str .= ".$technicalReplicate";	}

			}

		}

	}



	if ($annotations)

	{	$data_str .= "\tAnnotation";	}

	$data_str .= "\n";

  

  

	$ESNames = array_keys($master_array);

	foreach ($ESNames as $ESName) 

	{    

		$ENames = array_keys($master_array[$ESName]);

		foreach ($ENames as $EName) 

		{

	    	$identifiers = array_keys($master_array[$ESName][$EName]);

  			foreach ($identifiers as $identifier) 

  			{

	      		$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

		    	foreach ($secondaryIDs as $secondaryID) 

		    	{

					$protocol_types = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

					foreach ($protocol_types as $protocol_type) 

		      		{

			      		$data_str.= "$ESName\t$EName\t$identifier";

						if ('None' == $secondaryID)

						{	$data_str.= "\t";	}

						else

						{	$data_str.= "\t$secondaryID";	}

						$data_str .= "\t$protocol_type";

			      		

						foreach ($sp_name_orders as $sp_name_order)

						{

							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

							foreach ($biologicalReplicates as $biologicalReplicate)

							{

								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

			      				foreach ($technicalReplicates as $technicalReplicate) 

		      					{

				      				$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];

				      				$data_str .= "\t$value";

			      				}

		      				}

      					}

      					if ($annotations)

						{	$data_str.= "\t{$annotations[$identifier]}";	}

      					$data_str.= "\n";

      				}

  				}

			}

		}

	}

	return $data_str;

}





function output_tab_delimited_format_kmeans()

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['label_names'];

	$process_field = $_SESSION[$currPageNameUpper]['FIELDS'][0];

	// This section is for print all data for selected genes in a tab

	// delimted text form

	$data_str = "identifier";

	foreach ($label_names as $key => $name) 

	{	$data_str .= "\t$name";		}

	$data_str .= "\n";

	

	$ESNames = array_keys($master_array);

	$countES = count($ESNames);

	foreach ($ESNames as $ESName) 

	{

		$ENames = array_keys($master_array[$ESName]);

		$countE = count($ENames);

		foreach ($ENames as $EName) 

		{

			$identifiers = array_keys($master_array[$ESName][$EName]);

			foreach ($identifiers as $identifier) 

			{

				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

				foreach ($secondaryIDs as $secondaryID) 

				{

					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

					$countProtocolTypes = count($protocol_type_names);

					foreach ($protocol_type_names as $protocol_type_name) 

					{

						$line = "$identifier";

						if ('None' != $secondaryID AND '' != $secondaryID)

						{	$line .= "_{$secondaryID}";	}

						if ($countProtocolTypes > 1)

						{	$line .= "_{$protocol_type_name}";	}

						if ($countE > 1)

						{	$line .= "_{$EName}";	}

						if ($countES > 1)

						{	$line .= "_{$ESName}";	}

						$discardLine = 0;

						foreach ($label_names as $label_name) 

						{

							$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name];

							if (strlen($value)) 

							{	$line .= "\t$value";	} 

							else 

							{	$discardLine = 1;	}

						}

						$line .= "\n";

						if (!$discardLine)

						{	

							$data_str .= $line;	

							$totLinesWritten++;

						}

					}

				}

			}

		}

	}

	$_SESSION[$currPageNameUpper]['totLinesInDatFile'] = $totLinesWritten;

	return $data_str;

}



function output_tab_delimited_format_kmeans_replicate()

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['Sampling Point'];

	

	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];

	$sp_name_orders = array_keys($SPTechnicalReplicates);

	

	// This section is for print all data for selected genes in a tab

	// delimted text form

	$data_str = "identifier";

	foreach ($sp_name_orders as $sp_name_order)

	{

		$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

		foreach ($biologicalReplicates as $biologicalReplicate)

		{

			$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

			$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);

			foreach ($technicalReplicates as $technicalReplicate)

			{

				$data_str .= "\t{$label_names[$sp_name_order]}";

				$data_str .= "_Rep {$biologicalReplicate}";

				if ($TRCount > 1)

				{	$data_str .= ".$technicalReplicate";	}

			}

		}

	}

	$data_str .= "\n";

	

	$ESNames = array_keys($master_array);

	$countES = count($ESNames);

	foreach ($ESNames as $ESName) 

	{

		$ENames = array_keys($master_array[$ESName]);

		$countE = count($ENames);

		foreach ($ENames as $EName) 

		{

			$identifiers = array_keys($master_array[$ESName][$EName]);

			foreach ($identifiers as $identifier) 

			{

				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

				foreach ($secondaryIDs as $secondaryID) 

				{

					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

					$countProtocolTypes = count($protocol_type_names);

					foreach ($protocol_type_names as $protocol_type_name) 

					{

						$line = "$identifier";

						if ('None' != $secondaryID AND '' != $secondaryID)

						{	$line .= "_{$secondaryID}";	}

						if ($countProtocolTypes > 1)

						{	$line .= "_{$protocol_type_name}";	}

						if ($countE > 1)

						{	$line .= "_{$EName}";	}

						if ($countES > 1)

						{	$line .= "_{$ESName}";	}

						$discardLine = 0;

						foreach ($sp_name_orders as $sp_name_order)

						{

							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

							foreach ($biologicalReplicates as $biologicalReplicate)

							{

								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

								$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);

								foreach ($technicalReplicates as $technicalReplicate)

								{

									$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];

									if (strlen($value)) 

									{	$line .= "\t$value";	} 

									else 

									{	$discardLine = 1;	}

								}

							}

						}

						$line .= "\n";

						if (!$discardLine)

						{	

							$data_str .= $line;	

							$totLinesWritten++;

						}

					}

				}

			}

		}

	}

	$_SESSION[$currPageNameUpper]['totLinesInDatFile'] = $totLinesWritten;

	return $data_str;

}





function output_tab_delimited_format_ometer(&$data_str, $checkMissingValues = true)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS'];

	

	$ESNames = &$keys['Exp Set'];

	$ENames = &$keys['Experiment'];

	$identifiers = &$keys['Identifier'];

	$protocol_type_names = &$keys['Protocol Type'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['label_names'];



	$process_field = $_SESSION[$currPageNameUpper]['FIELDS'][0];

	

	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0, "Protocol Type"=>0, "Data Type"=>0);

	//Master Array has the following keys:

	//$master_array[$ESName][$EName][$identifier][$protocol_type_name][$field][$label_name]

	

	//Get counts of each keys

	foreach ($headers as $header=>$val)

	{

		if (isset($keys[$header]) AND count($keys[$header]) == 1)

		{

			$keysForHeader = array_keys($keys[$header]);

			$headers[$header] = $keys[$header][$keysForHeader[0]];

		}

		$count[$header] = count($keys[$header]);

	}

	

	//Print Header of the tab-delimited file

	$headerLine = "names";

		

	$identifier = $identifiers[0];

	//Please Note that the code will not be able to detect missing values

	//if there is a missing identifier in the first Experiment because

	//we do not build the Identifier keys array completely while building

	//the master_array as it takes too much time. So, checking this way is

	//the only option left and may produce a bug if first experiment does not 

	//contain all the identifiers.

	foreach ($ESNames as $ESName) 

	{

    	foreach ($ENames as $EName) 

    	{    

	    	if ($checkMissingValues AND !isset($master_array[$ESName][$EName]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (Experiment).";

				return 1;

			}

	    	if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (identifier).";

				return 1;

			}

			

			$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

			$secondaryID = $secondaryIDs[0];

			

			$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			$protocol_type_name = $protocol_type_names[0];

			

			if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (protocol_type).";

				return 1;

			}	

			foreach ($label_names as $label_name)

			{

				if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name]))

				{

					$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (Sampling Point).";

					return 1;

				}

				$headerValue = $label_name;

				if ($count['Experiment'] > 1)

	      		{	$headerValue .= "_{$EName}";	}

	      		if ($count['Exp Set'] > 1)

				{	$headerValue .= "_{$ESName}";	}

	      		$headerLine .= "\t$headerValue";

			}

		}

	}

	$data_str .= "{$headerLine}\n";

	

	//Now output data.



	foreach ($identifiers as $identifier) 

	{

		$ESName = $ESNames[0];

		$EName = $ENames[0];

		$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

		foreach ($secondaryIDs as $secondaryID) 

		{

			$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			$countPT = count($protocol_type_names);

			foreach ($protocol_type_names as $protocol_type_name) 

			{

				$line = "$identifier";

				if ('None' != $secondaryID AND '' != $secondaryID)

				{	$line .= "_{$secondaryID}";	}

				if ($countPT > 1)

				{	$line .= "_{$protocol_type_name}";	}

		        foreach ($ESNames as $ESName) 

		        {

			        $anyExperimentNull = false;

			        foreach ($ENames as $EName) 

			    	{

				    	$allValuesNullForExpt = true;

						foreach ($label_names as $label_name) 

						{

							$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name];

							if (strlen($value))

							{	$line .= "\t{$value}"; $allValuesNullForExpt = false;	}

							else

							{

								if ($checkMissingValues)

								{

									$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values.";

									return 1;

								}

							}

						}

					}

					if ($allValuesNullForExpt)

					{	$anyExperimentNull = true;	}

				}

				if ($checkMissingValues OR !$anyExperimentNull)

				{	$data_str .= "{$line}\n";	}

			}

		}

    }

	return 0;

}



function output_tab_delimited_format_ometer_replicate(&$data_str, $checkMissingValues = true)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS'];

	

	$ESNames = &$keys['Exp Set'];

	$ENames = &$keys['Experiment'];

	$identifiers = &$keys['Identifier'];

	$protocol_type_names = &$keys['Protocol Type'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['Sampling Point'];

	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];

	$sp_name_orders = array_keys($SPTechnicalReplicates);

	



	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0, "Protocol Type"=>0);

	//Master Array has the following keys:

	//master_array[exp_set_name][experiment][identifier][secondaryID][protocol_type_name][sp_name][BiologicalReplicateNumber][TechnicalReplicateNumber]

	

	//Get counts of each keys

	foreach ($headers as $header=>$val)

	{

		if (isset($keys[$header]) AND count($keys[$header]) == 1)

		{

			$keysForHeader = array_keys($keys[$header]);

			$headers[$header] = $keys[$header][$keysForHeader[0]];

		}

		$count[$header] = count($keys[$header]);

	}

	

	//Print Header of the tab-delimited file

	$headerLine = "names";

		

	$identifier = $identifiers[0];

	//Please Note that the code will not be able to detect missing values

	//if there is a missing identifier in the first Experiment because

	//we do not build the Identifier keys array completely while building

	//the master_array as it takes too much time. So, checking this way is

	//the only option left and may produce a bug if first experiment does not 

	//contain all the identifiers.

	foreach ($ESNames as $ESName) 

	{

    	foreach ($ENames as $EName) 

    	{    

	    	if ($checkMissingValues AND !isset($master_array[$ESName][$EName]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (Experiment).";

				return 1;

			}

	    	if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (identifier).";

				return 1;

			}

			

			$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

			$secondaryID = $secondaryIDs[0];

			

			$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			$protocol_type_name = $protocol_type_names[0];

			

			if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]))

			{

				$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (protocol_type).";

				return 1;

			}	

			foreach ($sp_name_orders as $sp_name_order)

			{

				if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$sp_name_order]))

				{

					$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (Sampling Point).";

					return 1;

				}

				

				$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

				foreach ($biologicalReplicates as $biologicalReplicate)

				{

					$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

					$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);

					foreach ($technicalReplicates as $technicalReplicate)

					{

						if ($checkMissingValues AND !isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate]))

						{

							$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values (Replicate).";

							return 1;

						}

						$headerValue = "{$label_names[$sp_name_order]}";

						$headerValue .= "_Rep {$biologicalReplicate}";

						if ($TRCount > 1)

						{	$headerValue .= ".$technicalReplicate";	}

		      			if ($count['Experiment'] > 1)

		      			{	$headerValue .= "_{$EName}";	}

						if ($count['Exp Set'] > 1)

		      			{	$headerValue .= "_{$ESName}";	}

		      			$headerLine .= "\t$headerValue";

					}

				}

			}

		}

	}

	$data_str .= "{$headerLine}\n";

	

	//Now output data.

	foreach ($identifiers as $identifier) 

	{

		$ESName = $ESNames[0];

		$EName = $ENames[0];

		$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

		foreach ($secondaryIDs as $secondaryID) 

		{

			$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			$countPT = count($protocol_type_names);

			foreach ($protocol_type_names as $protocol_type_name) 

			{

				$line = "$identifier";

				if ('None' != $secondaryID AND '' != $secondaryID)

				{	$line .= "_{$secondaryID}";	}

				if ($countPT > 1)

				{	$line .= "_{$protocol_type_name}";	}

		        foreach ($ESNames as $ESName) 

		        {

			        $anyExperimentNull = false;

			        foreach ($ENames as $EName) 

			    	{

				    	$allValuesNullForExpt = true;

						foreach ($sp_name_orders as $sp_name_order)

						{

							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

							foreach ($biologicalReplicates as $biologicalReplicate)

							{

								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

			      				foreach ($technicalReplicates as $technicalReplicate) 

		      					{

			      					$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];

									if (strlen($value))

									{	$line .= "\t{$value}"; $allValuesNullForExpt = false;	}

									else

									{

										if ($checkMissingValues)

										{

											$_SESSION['errMsgs'][] = "Data generated for your selections contains missing values.";

											return 1;

										}

									}

								}

							}

						}

					}

					if ($allValuesNullForExpt)

					{	$anyExperimentNull = true;	}

				}

				if ($checkMissingValues OR !$anyExperimentNull)

				{	$data_str .= "{$line}\n";	}

			}

		}

    }

	return 0;

}





function output_GNUPlot_format(&$plot_data_str)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION['SEARCHGENE']['MASTER_ARRAY_KEYS'];

	

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['label_names'];

		

	$process_field = $_SESSION[$currPageNameUpper]['FIELDS'][0];

	

	//headers is a hash with the header name as key and 0 as val.

	//In case there is only one type of value, then instead of a 0 the val is the actual single value.

	//For Example if the field Exp Set contains only one value 'Yeast', than

	//$headers[Exp Set] = "Yeast"

	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0, "Protocol Type"=>0, "Data Type"=>0);

	//Master Array has the following keys:

	//$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$field][$label_name]



	

	//Get counts of each keys

	foreach ($headers as $header=>$val)

	{

		if (isset($keys[$header]) AND count($keys[$header]) == 1)

		{

			$keysForHeader = array_keys($keys[$header]);

			$headers[$header] = $keys[$header][$keysForHeader[0]];

		}

		$count[$header] = count($keys[$header]);

	}

	



	//Check if second field selected is std_dev

	$std_dev_field = false;

	if ('mean' == $process_field OR 'mean_l' == $process_field OR 'median' == $process_field OR 'median_l' == $process_field)

	{	$std_dev_field = $_SESSION[$currPageNameUpper]['FIELDS'][1];	}

		

	if (('mean' == $process_field OR 'median' == $process_field) AND 'std_dev' != $std_dev_field)

	{	$std_dev_field = false;	}

	elseif (('mean_l' == $process_field OR 'median_l' == $process_field) AND 'std_dev_l' != $std_dev_field)

	{	$std_dev_field = false;	}

	

	if (0 == count($master_array))

	{	

		$_SESSION['errMsgs'][] = 'Cannot plot. All Values empty for the data generated for your selections.';

		return 0;

	}

	//Start preparing string of titles and header for the output file.

	$plot_data_comment_str = "#Time";

	$plot_data_title_str = "Time ({$_SESSION['PLOT_TIMES_IN']}s)";

    $plot_data_str = "";

    $sessionID = session_id();

    $ESNames = array_keys($master_array);

    foreach ($ESNames as $ESName) 

    {

	    $ENames = array_keys($master_array[$ESName]);

	    foreach ($ENames as $EName) 

	    {

	        $identifiers = array_keys($master_array[$ESName][$EName]);

	    	foreach ($identifiers as $identifier) 

	    	{

		    	$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

		    	foreach ($secondaryIDs as $secondaryID) 

		    	{

			    	$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

					foreach ($protocol_type_names as $protocol_type_name) 

					{

						$id = "$identifier";

						if ($count['Secondary ID'] > 1 AND 'None' != $secondaryID)

						{	$id .= "_{$secondaryID}";	}

						if ($count['Protocol Type'] > 1)

						{	$id .= "_{$protocol_type_name}";	}

						if ($count['Experiment'] > 1)

						{	$id .= "_{$EName}";	}

						if ($count['Exp Set'] > 1)

						{	$id .= "_{$ESName}";	}

						$plot_data_comment_str .= "\t\"$id\"";

						$plot_data_title_str .= ":$id";

					}

				}

        	}

    	}

	}

      $_SESSION['DOGNUPLOT']['PLOT_TITLE'] = $plot_data_title_str;

      $plot_data_comment_str .= "\n";

      

	foreach ($label_names as $label_order=>$label_name) 

	{

		$totMinutes = -1;

		$label_name_parts = split(' ', $label_name);

		switch(strtolower($label_name_parts[1]))

		{

		case 'minutes':

		case 'min':

		case 'mins':

		case 'm':

			$totMinutes = trim($label_name_parts[0]);

			break;

		case 'hours':

		case 'hr':

		case 'hrs':

		case 'h':

			$totMinutes = trim($label_name_parts[0]) * 60;

			break;

		case 'days':

		case 'day':

		case 'd':

			$totMinutes = trim($label_name_parts[0]) * 60 * 24;

			break;

		case 'weeks':

		case 'week':

		case 'wk':

		case 'w':

			$totMinutes = trim($label_name_parts[0]) * 60 * 24 * 7;

			$_SESSION['PLOT_TIMES_IN'] = 'wk';

			break;

		}

		if ($totMinutes > -1)

		{	$label_order = $totMinutes;	}

		

		switch ($_SESSION['PLOT_TIMES_IN'])

		{

		case 'min':

			$time = $label_order;

			break;

		case 'hr':

			$time = $label_order/60;

			break;

		case 'day':

			$time = $label_order/(60 * 24);

			break;

		case 'wk':

			$time = $label_order/(60 * 24 * 7);

			break;

		}

		$line = substr($time, 0, 4);

		$discardLine = true;

        foreach ($ESNames as $ESName) 

        {

	    	$ENames = array_keys($master_array[$ESName]);

	        foreach ($ENames as $EName) 

	    	{    

				$identifiers = array_keys($master_array[$ESName][$EName]);

				foreach ($identifiers as $identifier) 

				{

					$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

			    	foreach ($secondaryIDs as $secondaryID) 

			    	{

						$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

						foreach ($protocol_type_names as $protocol_type_name)

						{

							//print "<br />$ESName:$identifier:$protocol_type_name:$process_field:$label_name";

							$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name];

							if (strlen($value)) 

							{	

								$line .= "\t$value";	

								$discardLine = false;

							} 

							else 

							{	$line .= "\tN/A";	}

							

							if ($std_dev_field)

							{

								$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$std_dev_field][$label_name];

								if (strlen($value)) 

								{	

									$line .= "\t$value";	

									$discardLine = false;

								} 

								else 

								{	$line .= "\tN/A";	}

							}

		            	}

	            	}

            	}

			}

        }

        if (!$discardLine)

        {	$plot_data_str .= "$line\n";	}

        

	}

	$plot_data_str = $plot_data_comment_str . $plot_data_str;

	return 1;

}





function output_GNUPlot_format_replicate(&$plot_data_str)

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$master_array = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY'];

	$keys = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS'];

	$label_names = &$_SESSION[$currPageNameUpper]['MASTER_ARRAY_KEYS']['Sampling Point'];

	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];

	$sp_name_orders = array_keys($SPTechnicalReplicates);

	

		

	//headers is a hash with the header name as key and 0 as val.

	//In case there is only one type of value, then instead of a 0 the val is the actual single value.

	//For Example if the field Exp Set contains only one value 'Yeast', than

	//$headers[Exp Set] = "Yeast"

	$headers = array("Exp Set"=>0, "Experiment"=>0, "Identifier"=>0, "Secondary ID"=>0, "Protocol Type"=>0);

	

	

	//Get counts of each keys

	foreach ($headers as $header=>$val)

	{

		if (isset($keys[$header]) AND count($keys[$header]) == 1)

		{	

			$keysForHeader = array_keys($keys[$header]);

			$headers[$header] = $keys[$header][$keysForHeader[0]];	

		}

		$count[$header] = count($keys[$header]);

	}

	

	

	$plot_data_comment_str = "#Time";

	$plot_data_title_str = "Time ({$_SESSION['PLOT_TIMES_IN']}s)";

    $plot_data_str = "";

    $sessionID = session_id();

    

    

    $ESNames = array_keys($master_array);

    foreach ($ESNames as $ESName) 

    {

	    $ENames = array_keys($master_array[$ESName]);

	    foreach ($ENames as $EName) 

	    {

		    $identifiers = array_keys($master_array[$ESName][$EName]);

	    	foreach ($identifiers as $identifier) 

	    	{

		    	$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

		    	foreach ($secondaryIDs as $secondaryID) 

		    	{

			    	$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

			  		foreach ($protocol_type_names as $protocol_type_name) 

		      		{

						$id = "$identifier";

						if ($count['Secondary ID'] > 1 AND 'None' != $secondaryID)

						{	$id .= "_{$secondaryID}";	}

						if ($count['Protocol Type'] > 1)

						{	$id .= "_{$protocol_type_name}";	}

						if ($count['Experiment'] > 1)

						{	$id .= "_{$EName}";	}

						if ($count['Exp Set'] > 1)

						{	$id .= "_{$ESName}";	}

						$plot_data_comment_str .= "\t\"$id\"";

						$plot_data_title_str .= ":$id";

		          	}

	          	}

			}

		}

	}



	$_SESSION['DOGNUPLOT_REPLICATE']['PLOT_TITLE'] = $plot_data_title_str;

	$plot_data_comment_str .= "\n";

      

	foreach ($sp_name_orders as $sp_name_order)

	{

		$totMinutes = -1;

		$label_name_parts = split(' ', $label_names[$sp_name_order]);

		switch(strtolower($label_name_parts[1]))

		{

		case 'minutes':

		case 'min':

		case 'mins':

		case 'm':

			$totMinutes = trim($label_name_parts[0]);

			break;

		case 'hours':

		case 'hr':

		case 'hrs':

		case 'h':

			$totMinutes = trim($label_name_parts[0]) * 60;

			break;

		case 'days':

		case 'day':

		case 'd':

			$totMinutes = trim($label_name_parts[0]) * 60 * 24;

			break;

		case 'weeks':

		case 'week':

		case 'wk':

		case 'w':

			$totMinutes = trim($label_name_parts[0]) * 60 * 24 * 7;

			break;

		}

		if ($totMinutes > -1)

		{	$label_order = $totMinutes;	}

		else

		{	$label_order = $sp_name_order;	}

		

		switch ($_SESSION['PLOT_TIMES_IN'])

		{

		case 'min':

			$time = $label_order;

			break;

		case 'hr':

			$time = $label_order/60;

			break;

		case 'day':

			$time = $label_order/(60 * 24);

			break;

		case 'wk':

			$time = $label_order/(60 * 24 * 7);

			break;

		}

		$sp_value = substr($time, 0, 4);

		$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);

		foreach ($biologicalReplicates as $biologicalReplicate)

		{

			$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];

			$TRCount = count($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);

			foreach ($technicalReplicates as $technicalReplicate)

			{

		    	$discardLine = true;

				$line = $sp_value;

				foreach ($ESNames as $ESName) 

		        {

			    	$ENames = array_keys($master_array[$ESName]);

			        foreach ($ENames as $EName) 

			    	{    

						$identifiers = array_keys($master_array[$ESName][$EName]);

				    	foreach ($identifiers as $identifier) 

				    	{

					    	$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);

					    	foreach ($secondaryIDs as $secondaryID) 

					    	{

						    	$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);

						  		foreach ($protocol_type_names as $protocol_type_name) 

					      		{

				      				$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];

									if (strlen($value)) 

									{	

										$line .= "\t$value";	

										$discardLine = false;

									} 

									else 

									{	$line .= "\tN/A";	}

								}

	      					}

      					}

	            	}

            	}

            	if (!$discardLine)

        		{	$plot_data_str .= "$line\n";	}

			}

        }

	}

	$plot_data_str = $plot_data_comment_str . $plot_data_str;



	return 1;

}



function printProtocol($technique_type, $recordIDs)

{

	global $spidInStr, $currPageName, $prevPageName;

	$currPageNameUpper = strtoupper($currPageName);

	$prevPageNameUpper = strtoupper($prevPageName);

	$technique_type = strtoupper($technique_type);

	

	$isFirst = true;

	foreach ($_SESSION[$prevPageNameUpper]['TECHNIQUE'] as $technique_id=>$isOn)

	{	

		if ($isOn)

		{	

			if ($isFirst)

			{	$isFirst = false;	}

			else

			{		$techniqueIDs .= ", ";		}

			

			$techniqueIDs .= "'$technique_id'";		

		}

	}

	

	$sql = "SELECT technique_id FROM technique 

		WHERE UPPER(technique_type) = '$technique_type' 

		AND technique_id IN ($techniqueIDs)";

	$sth = $_SESSION['dbh']->query($sql);

	//print $sql;

	if ( DB::isError($sth) ) 

	{

		printError("Could not retrieve technique_types. " . $sth->getMessage());

		return "";

	}

	

	if ($sth->numRows() > 0)

	{

		$isFirst = true;

		$techniqueIDs = "";

		//If at least one technique_id was selected for this technique_type.

		while ($row = $sth->fetchRow())

		{

			if ($isFirst)

			{	$isFirst = false;	}

			else

			{		$techniqueIDs .= ", ";		}

			$techniqueIDs .= "'$row[0]'";

		}

	}

	else

	{	//no technique_id selected for this type. Hence ignore technique_ids

		//for the rest of this function code.

		$techniqueIDs = "";

	}

		

	//==Hard Coding Here.

	switch ($technique_type)

  	{

	  	case 'METABOLITE':

			$TableID = $_SESSION['TableID']['COMPOUND'];

			//Doing this because searching by recordIDs 

			//is using a seq scan on mp2 even after indexing.

			$_SESSION['dbh']->query("SET enable_seqscan TO OFF");

			break;

		case 'MRNA':

			$TableID = $_SESSION['TableID']['REPORTER'];

			break;

		case 'PROTEIN':

			$TableID = $_SESSION['TableID']['REFERENCE_SPOT'];

			break;

	}

	

	$sqlProtocolType = "SELECT DISTINCT pt.\"protocol_type_id\", pt.\"protocol_type_name\", UPPER(pt.\"protocol_type_name\") FROM 

		\"protocol_type\" pt, \"technique\" t";

		if (!$_SESSION['IS_REPLICATE_TRACK'] AND $recordIDs)

		{	$sqlProtocolType .= ", \"sp_summary\" p1d, \"protocol\" p";	}

		elseif ($_SESSION['IS_REPLICATE_TRACK'] AND $recordIDs)

		{

			switch ($technique_type)

		  	{

			  	case 'METABOLITE':

					$sqlMP2 = "SELECT DISTINCT mp2.\"protocol_type_id\" FROM \"metabolite_processed2\" mp2

						, metabolite_measurement mm

						, sampling_replicate sr

						, sample_extract se

						, sample s

						WHERE mp2.\"cpd_id\" IN ($recordIDs)

						AND mm.metabolite_measurement_id = mp2.metabolite_measurement_id

						AND s.sampling_replicate_id = sr.sampling_replicate_id

						AND se.sample_id = s.sample_id

						AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'

						AND mm.sample_extract_id = se.sample_extract_id

						AND sr.sampling_point_id IN ($spidInStr)

						ORDER BY mp2.\"protocol_type_id\"";

			  		$sqlProtocolType .= ", ($sqlMP2) mp2";

					break;

				case 'MRNA':

					$sqlProtocolType .= ", \"ma_norm\" man

						, sample_extract se	

						, sample s

						, sampling_replicate sr";

					break;

				case 'PROTEIN':

					$sqlProtocolType .= ", \"proteomics_data\" pd

						, \"proteomics_measurement\" pm

						, \"sample_extract\" se	

						, \"sample\" s

						, \"sampling_replicate\" sr";

					break;

			}

		}

		$sqlProtocolType .= " WHERE UPPER(pt.\"method\") = 'STATISTICAL'

		AND pt.\"technique_id\" = t.\"technique_id\"";

		if ($techniqueIDs)

		{	$sqlProtocolType .= " AND t.\"technique_id\" IN ($techniqueIDs)";	}

		if (!$_SESSION['IS_REPLICATE_TRACK'] AND $recordIDs)

		{	

			$sqlProtocolType .= " AND p1d.\"record_id\" IN ($recordIDs)

			AND p1d.\"sampling_point_id\" IN ($spidInStr)

			AND p1d.\"kw_table_id\" = '$TableID'

			AND p1d.\"protocol_id\" = p.\"protocol_id\"

			AND p.\"protocol_type_id\" = pt.\"protocol_type_id\"";	

			

		}

		elseif ($_SESSION['IS_REPLICATE_TRACK'] AND $recordIDs)

		{

			switch ($technique_type)

		  	{

			  	case 'METABOLITE':

					$sqlProtocolType .= " AND mp2.\"protocol_type_id\" = pt.\"protocol_type_id\"";	

					break;

				case 'MRNA':

					$sqlProtocolType .= " AND man.\"reporter_id\" IN ($recordIDs)

						AND man.protocol_type_id = pt.protocol_type_id

						AND man.sample_extract_id = se.sample_extract_id

						AND se.sample_id = s.sample_id

						AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'

						AND s.sampling_replicate_id = sr.sampling_replicate_id

						AND sr.sampling_point_id IN ($spidInStr)";

					break;

				case 'PROTEIN':

					$sqlProtocolType .= " AND pd.\"reference_spot_id\" IN ($recordIDs)

						AND pd.\"protocol_type_id\" = pt.protocol_type_id

						AND pd.\"proteomics_measurement_id\" = pm.\"proteomics_measurement_id\"

						AND pm.sample_extract_id = se.sample_extract_id

						AND se.sample_id = s.sample_id

						AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'

						AND s.sampling_replicate_id = sr.sampling_replicate_id

						AND sr.sampling_point_id IN ($spidInStr)";	

					break;

			}

		}

		$sqlProtocolType .= " AND UPPER(t.technique_type) = '$technique_type'

		ORDER BY UPPER(pt.protocol_type_name) ASC";

		



	//echo "$sqlProtocolType <br/>";

	$sth = $_SESSION['dbh']->query($sqlProtocolType);

	if ( DB::isError($sth) ) {

		printError("Could not retrieve protocol_type_names. " . $sth->getMessage());

		return "";

	}

	if ($technique_type == 'METABOLITE')

	{	$_SESSION['dbh']->query("SET enable_seqscan TO ON");	}

   

    print  "\n<div class=\"protocol\">";

	print "\n<p>";

	print "\n<label>Normalization Method: </label>";

	print "\n<select name=\"protocol_type_id[$TableID][]\" size=\"5\" multiple>";

	//print "\n\t<option value=\"0\">--select one--</option>";  

    $firstOption = true; $firstID = true;

	while($row = $sth->fetchRow())

    {

	    print "\n\t<option value=\"$row[0]\"";

	    if ($firstID)

	    {

		    $firstID = false;

	    	$protocol_type_ids .=  "'$row[0]'";

	    }

	    else

	    {	$protocol_type_ids .=  ", '$row[0]'";	}

		if (isset($_SESSION[$currPageNameUpper]['protocol_type_id'][$TableID]))

		{	    

		    if (in_array($row[0], $_SESSION[$currPageNameUpper]['protocol_type_id'][$TableID]))

		    {	print " selected";    }

	    }

	    else

	    {

		    if ($firstOption)

	    	{	

	    		$firstOption = false;	

	    		print " selected";

    		}		    

	    }

		    

	    print ">$row[1]</option>";

    }

  	print "</select></p>";

	

  	$sql = "SELECT DISTINCT protocol_name FROM protocol" .

		" WHERE protocol_type_id IN ($protocol_type_ids)" .

	  	" AND UPPER(protocol_name) <> 'MEAN'" .

	  	" ORDER BY protocol_name";

	

	//echo $sql . "<br/>";	

	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) {

		//printError("Could not retrieve protocol names. " . $sth->getMessage());

		return "";

	}

  	

	if (!$_SESSION['IS_REPLICATE_TRACK'])

	{

	  	print "\n<p>";

		print "\n<label>Statistical Test: </label>";

		print "\n<select name=\"protocol_name[$TableID]\">";

	    while($row = $sth->fetchRow())

	    {

		    print "\n\t<option>$row[0]</option>";  

	    }

  

    	print "</select></p>";

	}

	print "</div>";

	return $ret;

}



function printFilterBy()

{

	print "\n<div class=\"filter-by\">";

	print "\n<h3>Filters: </h3>";

	print "<table><tr><td>";

	printFilter(0);

	print "</td></tr><tr><td>";

	printFilter(1);

	print "</td></tr></table>";

	print "<hr />";

	print "</div>";

}





function printFilter($index)

{

	global $currPageName, $fields;

	$currPageNameUpper = strtoupper($currPageName);

	print "\n<p>";

	print "With <select name=\"filter-field[$index]\">";

	print "\n\t<option value=\"0\"";

	if ($_SESSION[$currPageNameUpper]['filter-field'][$index] == '0')

	{	print " selected";	}

	print ">--select one--</option>";

	

	foreach ($fields as $key=>$name)

    {

		if ($name)

		{  

			print "\n\t<option value=\"$key\"";

			if ($_SESSION[$currPageNameUpper]['filter-field'][$index] == $key)

			{	print " selected";	}

			print ">$name</option>"; 

		}

    }

    print "</select>";

    print " greater than ";

	print "<input type=\"text\" name=\"minVal[$index]\" size=\"4\" value=\"{$_SESSION[$currPageNameUpper]['minVal'][$index]}\"/>";

	print " and less than ";

	print "<input type=\"text\" name=\"maxVal[$index]\" size=\"4\" value=\"{$_SESSION[$currPageNameUpper]['maxVal'][$index]}\" />";

	print "\n</p>";

}



function printOutput()

{

	global $currPageName, $fields;

	$currPageNameUpper = strtoupper($currPageName);

        

    //Print Output Fieldset

    print "<div class=\"DataProcessing\">";

    print "<h3>Output: </h3>";

    

    //Print Analysis selection box

    $analysisArray = array("Table Format",  "Tab Delimited File", "Plot Data", "K-Means Clustering", "PCA", "FA", "NMF", "Biplot" );



    //Append Map options

	if (!$_SESSION['IS_REPLICATE_TRACK'])

	{

		$sql = "SELECT map_type_id, map_type_name FROM map_type ORDER BY UPPER(map_type_name)";

		$sth = $_SESSION['dbh']->query($sql);

		if ( DB::isError($sth) ) 

		{	printError("Error retrieving Map Types. " . $sth->getMessage());	}

	

		while ($row = $sth->fetchRow()) 

		{

			array_push($analysisArray, "Map - $row[1]");

		}

	}



	//Print Analysis box

	print "\n&nbsp;&nbsp;<label>Analysis: </label><br />";

    print "\n<select name=\"analysis\" size=\"10\">\n";



	foreach ($analysisArray as $key=>$name)

    {

		if ($name)

		{

		  if (!isset($_SESSION[$currPageNameUpper]['analysis']))

		  {	$_SESSION[$currPageNameUpper]['analysis'] = $name;	}

			print "\n\t<option";

		  if ($_SESSION[$currPageNameUpper]['analysis'] == $name)

		  {	print " selected";	}

		  print ">$name</option>"; 

		}

	}

	print "</select>\n";

	

	

    //print process field selection box

    if ($_SESSION['IS_REPLICATE_TRACK'])

    {

	    $IsAvgArray = array(false=>"Display All Technical Replicates", 

	    			true=>"Average Technical Replicates");

	    

	    print "&nbsp;&nbsp;&nbsp;&nbsp;\n<br /><br /><br />"; 

	    

	    foreach ($IsAvgArray as $key=>$name)

	    {

			if ($name)

			{ 

				if (!isset($_SESSION[$currPageNameUpper]['IsAvg']))

				{	$_SESSION[$currPageNameUpper]['IsAvg'] = false;		}

				print "<input type=\"radio\" name=\"IsAvg\" value=\"$key\"";

				if ($key == $_SESSION[$currPageNameUpper]['IsAvg'])

				{	print " checked";	}

				print ">$name<br />";

			}

	    }

	    

	    //Is Log Checkbox

		print "&nbsp;&nbsp;&nbsp;&nbsp;"; 

	    print "\n<br /><input type=\"checkbox\" name=\"IsLog\"";

		if ($_SESSION[$currPageNameUpper]['IsLog'])

		{	print "\"checked\"";	}

		print ">Log Data</input>";

    }

    else

    {

	    print "<br /><br /><br />&nbsp;&nbsp;with field(s)&nbsp;&nbsp;"; 

	    print "<br /><select name=\"fields[]\" size=\"11\" \"multiple\">";

	    foreach ($fields as $key=>$name)

	    {

			if ($name)

			{ 

			  if (!isset($_SESSION[$currPageNameUpper]['FIELDS']))

			  {	$_SESSION[$currPageNameUpper]['FIELDS'][] = "mean";	}

				print "\n\t<option value=\"$key\"";

			  if (in_array($key, $_SESSION[$currPageNameUpper]['FIELDS']))

			  {	print " selected";	}

			  print ">$name</option>"; 

			}

	    }

	    print "\n</select>";

    }

    

    

    

    //print transformation box

    print "<br /><br />";

    print "&nbsp;&nbsp;and scaling&nbsp;&nbsp;"; 

    print "<br /><select name=\"transformation\" size=\"4\">";

    $transformationArray = array('--none--', 'Centered', 'Standardized By Mean', 'Z-Score');

    foreach ($transformationArray as $key=>$name)

    {

		if ($name)

		{ 

		  if (!isset($_SESSION[$currPageNameUpper]['transformation']))

		  {	$_SESSION[$currPageNameUpper]['transformation'] = $name;	}

			print "\n\t<option ";

		  if ($_SESSION[$currPageNameUpper]['transformation'] == $name)

		  {	print " selected";	}

		  print ">$name</option>"; 

		}

    }

    print "\n</select>";

    

    

    print "&nbsp;&nbsp;&nbsp;&nbsp;"; 

        

    print "\n<br/>";

    //print "\n</fieldset>";

    print "</div></p>";

}



function printMissingValues()

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	print "<h3>Missing Values: </h3>";

	//Is Log Checkbox

	print "\n<p><input type=\"checkbox\" name=\"omitRows\"";

	if ($_SESSION[$currPageNameUpper]['omitRows'])

	{	print "\"checked\"";	}

	print ">Omit Rows</input>";

	print "</p>";

}

    



function processForm($currPageName = "")

{

	global $rid_str, $cpd_id_str, $spot_id_str;

	$currPageNameUpper = strtoupper($currPageName);

	$_SESSION[$currPageNameUpper]['protocol_name'] = $_REQUEST['protocol_name'];

	$_SESSION[$currPageNameUpper]['protocol_type_id'] = $_REQUEST['protocol_type_id'];

	$_SESSION[$currPageNameUpper]['filter-field'] = $_REQUEST['filter-field'];

	$_SESSION[$currPageNameUpper]['minVal'] = $_REQUEST['minVal'];

	$_SESSION[$currPageNameUpper]['maxVal'] = $_REQUEST['maxVal'];

	

	$_SESSION[$currPageNameUpper]['analysis'] = $_REQUEST['analysis'];

	$_SESSION[$currPageNameUpper]['FIELDS'] = $_REQUEST['fields'];

	$_SESSION[$currPageNameUpper]['transformation'] = $_REQUEST['transformation'];

	$_SESSION[$currPageNameUpper]['omitRows'] = $_REQUEST['omitRows'];

	$_SESSION[$currPageNameUpper]['IsAvg'] = $_REQUEST['IsAvg'];

	$_SESSION[$currPageNameUpper]['IsLog'] = $_REQUEST['IsLog'];

		

	

    if (isset($_SESSION[$currPageNameUpper]['filter-field']))

	{

		foreach ($_SESSION[$currPageNameUpper]['filter-field'] as $index => $filterField)

	    {

		    if (!$_SESSION[$currPageNameUpper]['minVal'][$index] AND !$_SESSION[$currPageNameUpper]['maxVal'][$index])

		    {	$_SESSION[$currPageNameUpper]['filter-field'][$index] = '0';	}

	    }

    }

	

	if (isset($_SESSION[$currPageNameUpper]['DATA']))

	{

		$technique_types = array_keys($_SESSION[$currPageNameUpper]['DATA']);

		foreach ($technique_types as $technique_type)

		{

			$key = "{$technique_type}_results";

			if ($_REQUEST[$key])

			{	$_SESSION[$currPageNameUpper]['DATA'][$technique_type]['RESULTS'] = $_REQUEST[$key];	}

			else

			{	$_SESSION[$currPageNameUpper]['DATA'][$technique_type]['RESULTS'] = array();	}

		}

	}

	setStrings();

	

				

	//If anything other than map selected

	if (!preg_match('/^Map - /', $_SESSION[$currPageNameUpper]['analysis']))

	{

		//Fill The Master Array

		$_SESSION[$currPageNameUpper]['START_TIME'] = microtime_float();

		

	  	print_all_results(true, $rid_str, $cpd_id_str, $spot_id_str); 

	  	if (!$_SESSION[$currPageNameUpper]['MASTER_ARRAY'])

	  	{

		  	$_SESSION['errMsgs'][] = "No Data found for your selections.";

		  	return 0;

	  	}

	

		  	

	  	switch($_SESSION[$currPageNameUpper]['analysis'])

	    {

		case 'Tab Delimited File':

			if ($_SESSION['IS_REPLICATE_TRACK'])

			{	$data = output_file_format_replicate();  	}

			else

			{	$data = output_file_format();	}

			writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE'], "results.xls");

		  	//exit();

		    break;

		case 'Plot Data':

			if (!$_SESSION['IS_REPLICATE_TRACK'])

	  		{	$retVal = output_GNUPlot_format($data); 	}

		  	elseif ($_SESSION['IS_REPLICATE_TRACK'])

	  		{	$retVal = output_GNUPlot_format_replicate($data);	}  	

			if (0 == $retVal)

			{	return 0;	}

	  		writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE']);

		  	break;

	  	

		case 'K-Means Clustering':

		  	if ($_SESSION['IS_REPLICATE_TRACK'])

	  		{	$data = output_tab_delimited_format_kmeans_replicate();	}  	

		  	else

	  		{	$data = output_tab_delimited_format_kmeans();	}



			writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE']);

		  	break;

		

		case 'PCA':

		case 'FA':

		case 'NMF':

		case 'Biplot':

		  	if ($_SESSION[$currPageNameUpper]['omitRows'])

		  	{	$checkMissingValues = false;	}

		  	else

		  	{	$checkMissingValues = true;	}

			

		  	if ($_SESSION['IS_REPLICATE_TRACK'])

	  		{	$retVal = output_tab_delimited_format_ometer_replicate($data, $checkMissingValues);	}

		  	else

		  	{	$retVal = output_tab_delimited_format_ometer($data, $checkMissingValues);	}

		  			

		  	if ($retVal)

		  	{	return 0;	}

	  	

			writeFile($data, $_SESSION['BROWSER_TMP_RELATIVE']);

		  	break;

  		}

	}

	return 1;

}



?>

