<?php
/** This php stores the functions for the file searchGene.php
  *
  * author: Aejaaz Kamal
  * Date: 16 Dec 2004
  */

function getSQLIdentifiers($TableID, $RecordIDsStr)
{
	switch ($TableID)
	{
	case $_SESSION['TableID']['REPORTER']: 
	  	$sqlIdentifiers = "SELECT r.\"reporter_id\" AS \"record_id\", 
	  	an.\"aname\"AS \"identifier\", cs.\"probe_name\" as identifier2
	  	FROM \"reporter\" r, \"composite_sequence\" cs, \"allnames\" an, \"gene\" g";
		if ($RecordIDsStr)
	  	{	$sqlIdentifiers .= " WHERE r.\"reporter_id\" IN ($RecordIDsStr) AND ";	}
	  	else
	  	{	$sqlIdentifiers .= " WHERE";	}
		$sqlIdentifiers .= " r.\"composite_sequence_id\" = cs.\"composite_sequence_id\"
			AND an.\"record_id\" = cs.\"gene_id\"
			AND cs.\"gene_id\" = g.\"gene_id\"";
		if ($_SESSION['CurrentSpecieID'] > 0)
		{	$sqlIdentifiers .= " AND g.\"specie_id\" = {$_SESSION['CurrentSpecieID']}";	}
		$sqlIdentifiers .= " AND an.\"kw_table_id\" = '{$_SESSION['TableID']['GENE']}'
			AND UPPER(an.\"is_primary\") = 'Y'
				ORDER BY r.\"reporter_id\"";
		break;
		
	case $_SESSION['TableID']['COMPOUND']: 

		$sqlIdentifiers = "SELECT \"record_id\", \"aname\" AS \"identifier\", 'None' as identifier2
		FROM \"allnames\"";
		if ($RecordIDsStr)
	  	{	$sqlIdentifiers .= " WHERE \"record_id\" IN ($RecordIDsStr) AND ";	}
	  	else
	  	{	$sqlIdentifiers .= " WHERE";	}
	  	$sqlIdentifiers .= " \"kw_table_id\" = '$TableID' AND UPPER(\"is_primary\") = 'Y'
			ORDER BY \"record_id\"";
		break;
		
	case $_SESSION['TableID']['REFERENCE_SPOT']: 
		
		$sqlIdentifiers = "SELECT \"reference_spot_id\" AS record_id, 
			CAST(\"reference_spot_id\" AS TEXT) AS identifier, 'None' as identifier2
			FROM \"reference_spot\"";
		if ($RecordIDsStr)
	  	{	$sqlIdentifiers .= " WHERE \"reference_spot_id\" IN ($RecordIDsStr)";	}
		$sqlIdentifiers .= " ORDER BY \"reference_spot_id\"";
	}
	return $sqlIdentifiers;
}

  
function getDataSQL($TableID, $RecordIDsStr, $protocol_name, $protocol_type_id_str)
{
	global $fieldstr, $spidInStr, $tissue_type_label_id_str, $searchGeneKey;
	
	$sqlIdentifiers = getSQLIdentifiers($TableID, $RecordIDsStr);
	
	if (strpos( $fieldstr, "ratio_of_me") or strpos( $fieldstr, "p_value")  or strpos( $fieldstr, "difference_of_me"))
	{
	  	$sqlProcess1Distinct = "SELECT DISTINCT process1_id from process1 
		WHERE (sampling_point1_id IN ($spidInStr) 
			AND sp1_tissue_type_label_id IN ($tissue_type_label_id_str)
		AND sampling_point2_id IN ($spidInStr)
			AND sp2_tissue_type_label_id IN ($tissue_type_label_id_str)
			)
     	ORDER BY process1_id";
     	
		$sqlComparison = "SELECT c.record_id, p1.sampling_point1_id AS sampling_point_id, p1.sampling_point2_id, 
	  		p.protocol_id, p.protocol_type_id, p.protocol_type_name
	  		, c.\"p_value\", c.\"ratio_of_means\", c.\"ratio_of_medians\", c.\"difference_of_means\", c.\"difference_of_medians\"
	  		, c.\"p_value_l\", c.\"ratio_of_means_l\", c.\"ratio_of_medians_l\", c.\"difference_of_means_l\", c.\"difference_of_medians_l\"
	  	 FROM \"sp_comparison\" c,(SELECT protocol_id, pt.protocol_type_id, pt.protocol_type_name 
	  		FROM protocol p, protocol_type pt WHERE p.protocol_type_id = pt.protocol_type_id 
	  		AND p.protocol_type_id IN ($protocol_type_id_str)
			AND protocol_name = '$protocol_name') p, process1 p1
			WHERE c.protocol_id = p.protocol_id
	    	AND kw_table_id = '$TableID'";
	    if ($RecordIDsStr)
		{	$sqlComparison .=  " AND record_id IN ($RecordIDsStr)";	}
		
		$sqlComparison .= " AND p1.process1_id IN ($sqlProcess1Distinct)
			AND c.process1_id = p1.process1_id
		    ORDER by c.record_id";
	}
  	
	if (strpos( $fieldstr, "mean") or strpos( $fieldstr, "median") or strpos( $fieldstr, "std_dev") or strpos( $fieldstr, "N_data"))
  	{
	  	$sqlMeanProtocolID = "SELECT p.protocol_id, p.protocol_type_id, pt.protocol_type_name FROM protocol p, protocol_type pt WHERE"
  		. " p.protocol_type_id IN ($protocol_type_id_str) AND p.protocol_type_id = pt.protocol_type_id"
  		. " AND UPPER(protocol_name) = 'MEAN'";
    
  		//$sqlProcess1 = "SELECT * FROM process1 WHERE process1_id IN ($sqlProcess1Distinct)";
	  	
		$sqlProcessed1_data = "SELECT p1d.\"record_id\", p1d.\"sampling_point_id\", 
			prtcl.\"protocol_id\", prtcl.\"protocol_type_id\", prtcl.\"protocol_type_name\"
			, p1d.\"mean\", p1d.\"median\", p1d.\"std_dev\"
			, p1d.\"mean_l\", p1d.\"median_l\", p1d.\"std_dev_l\" 
			, p1d.\"N_data\" FROM \"sp_summary\" p1d, ($sqlMeanProtocolID) prtcl";
	  	if ($RecordIDsStr)	
		{	
			$sqlProcessed1_data .= " WHERE p1d.\"record_id\" IN ($RecordIDsStr)";	
			$whereDone = true;
		}
		if ($whereDone)
		{	$sqlProcessed1_data .= " AND";	}
		else
		{	$sqlProcessed1_data .= " WHERE";	}
		
		$sqlProcessed1_data .= " p1d.\"sampling_point_id\" IN ($spidInStr)
		    AND p1d.\"kw_table_id\" = '$TableID'
		    AND p1d.\"label_id\" = $tissue_type_label_id_str
		    AND prtcl.\"protocol_id\" = p1d.\"protocol_id\"
		    ORDER BY p1d.\"record_id\"";
		//print "<br />sqlProcessed1_data = $sqlProcessed1_data<br />";
	}
		    
 	if ($sqlProcessed1_data AND $sqlComparison)
 	{
	 	$sqlP1DC = "SELECT p1d.\"record_id\", p1d.\"sampling_point_id\", p1d.\"protocol_id\", 
	 		p1d.\"protocol_type_id\", p1d.\"protocol_type_name\", p1d.\"mean\", 
	 		p1d.\"median\", p1d.\"std_dev\", p1d.\"N_data\", c.\"ratio_of_means\", c.\"ratio_of_medians\",
	 		c.\"p_value\", c.\"difference_of_means\", c.\"difference_of_medians\",
	 		p1d.\"mean_l\", p1d.\"median_l\", p1d.\"std_dev_l\", c.\"ratio_of_means_l\", c.\"ratio_of_medians_l\",
	 		c.\"p_value_l\", c.\"difference_of_means_l\", c.\"difference_of_medians_l\"
	 		FROM ($sqlProcessed1_data) p1d LEFT JOIN ($sqlComparison) c
	 		ON p1d.\"record_id\" = c.\"record_id\"
	 		AND p1d.\"sampling_point_id\" = c.\"sampling_point_id\"
	 		AND p1d.\"protocol_type_id\" = c.\"protocol_type_id\"
			ORDER BY p1d.\"record_id\"";
	}
	elseif ($sqlComparison)
	{	$sqlP1DC = $sqlComparison;	}
	elseif ($sqlProcessed1_data)
	{	$sqlP1DC = $sqlProcessed1_data;	}
		
		
	$sql = "SELECT es.\"exp_set_name\", e.\"exp_name\", i.\"identifier\", i.\"identifier2\", p1dc.\"protocol_type_name\", 
		l.\"name\", l.\"order\", $fieldstr FROM ($sqlP1DC) p1dc, 
		\"sampling_point\" sp, \"experiment\" e, \"experiment_set\" es, \"label\" l, ($sqlIdentifiers) i 
		WHERE i.\"record_id\" = p1dc.\"record_id\"
		AND sp.\"sampling_point_id\" = p1dc.\"sampling_point_id\"
		AND e.\"experiment_id\" = sp.\"experiment_id\"
		AND e.\"exp_set_id\" = es.\"exp_set_id\"
		AND l.\"label_id\" = sp.\"label_id\"";
  
	
	if (isset($_SESSION[$searchGeneKey]['filter-field']))
	{
		foreach ($_SESSION[$searchGeneKey]['filter-field'] as $index => $filterField)
		{
			if ($filterField)
			{
				if (is_numeric($_SESSION[$searchGeneKey]['minVal'][$index]))
				{	$sql .= " AND \"{$filterField}\" >= {$_SESSION[$searchGeneKey]['minVal'][$index]}";	}
				if (is_numeric($_SESSION[$searchGeneKey]['maxVal'][$index]))
				{	$sql .= " AND \"{$filterField}\" <= {$_SESSION[$searchGeneKey]['maxVal'][$index]}";	}
			}
		}
	}

	$sql .= " ORDER BY UPPER(es.exp_set_name), UPPER(e.exp_name), UPPER(i.identifier), UPPER(p1dc.protocol_type_name), l.\"order\"";
	//print "\n$sql";
	return "($sql)";
}

function getDataSQLReplicate($TableID, $RecordIDsStr, $protocol_type_id_str, $avgTechnicalReplicates, $isLog)
{
	global $spidInStr, $currPageName;
	$currPageNameUpper = strtoupper($currPageName);
	
		
	$sqlSP = "SELECT sp.sampling_point_id, es.exp_set_name, e.exp_name, 
		l.name AS sp_name,
		l.\"order\" AS sp_name_order FROM sampling_point sp, 
		experiment e, label l, experiment_set es
		WHERE sp.sampling_point_id IN ($spidInStr)
		AND e.experiment_id = sp.experiment_id
		AND es.exp_set_id = e.exp_set_id
		AND l.label_id = sp.label_id
		ORDER BY sp.\"sampling_point_id\"";
	
	$sqlProtocolType = "SELECT protocol_type_id, protocol_type_name FROM protocol_type
		WHERE protocol_type_id IN ($protocol_type_id_str) ORDER BY UPPER(protocol_type_name)";
		
		
	$sqlIdentifiers = getSQLIdentifiers($TableID, $RecordIDsStr);
	
		 
	switch ($TableID)
	{
	case $_SESSION['TableID']['REPORTER']: 
		
		$sqlNormData = "SELECT man.reporter_id AS record_id, man.protocol_type_id, 
			sr.sampling_point_id, sr.replicate";
			
		if ($avgTechnicalReplicates)
		{	
			$sqlNormData .= ", 1 AS technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", AVG(man.intensity_l)";			}
			else
			{	$sqlNormData .= ", AVG(man.intensity)";			}
		}
		else
		{	
			$sqlNormData .= ", se.technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", man.intensity_l";	}
			else
			{	$sqlNormData .= ", man.intensity";	}
				
		}
 		$sqlNormData .= " AS normalized_intensity
				FROM ma_norm man
					, sample_extract se	
					, sample s
					, sampling_replicate sr";
			if ($RecordIDsStr)
			{	$sqlNormData .= " WHERE man.reporter_id IN ($RecordIDsStr) AND";	}
			else
			{	$sqlNormData .= " WHERE";	}
			$sqlNormData .= " man.sample_extract_id = se.sample_extract_id
			AND se.sample_id = s.sample_id
			AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'
			AND s.sampling_replicate_id = sr.sampling_replicate_id";
			
			if ($avgTechnicalReplicates)
			{
				$sqlNormData .= " GROUP BY man.reporter_id, man.protocol_type_id, 
					sr.sampling_point_id, sr.replicate";
			}
			$sqlNormData .= " ORDER BY man.reporter_id, sr.sampling_point_id";
		
		//print "sqlNormData = $sqlNormData <br /><br/>";

		break;
	case $_SESSION['TableID']['COMPOUND']: 

		$sqlNormData = "SELECT mp2.cpd_id AS record_id, mp2.protocol_type_id, 
			sr.sampling_point_id, sr.replicate";
		if ($avgTechnicalReplicates)
		{	
			$sqlNormData .= ", 1 AS technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", AVG(mp2.norm_intensity_l)";			}
			else
			{	$sqlNormData .= ", AVG(mp2.norm_intensity)";			}
		}
		else
		{	
			$sqlNormData .= ", se.technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", mp2.norm_intensity_l";	}
			else
			{	$sqlNormData .= ", mp2.norm_intensity";	}
		}
			
 		$sqlNormData .= " AS normalized_intensity
			FROM metabolite_processed2 mp2, metabolite_measurement mm
			, sampling_replicate sr
			, sample_extract se
			, sample s";
		if ($RecordIDsStr)
		{	$sqlNormData .= " WHERE mp2.cpd_id IN ($RecordIDsStr) AND";	}
		else
		{	$sqlNormData .= " WHERE";	}
		$sqlNormData .= " mm.metabolite_measurement_id = mp2.metabolite_measurement_id
			AND s.sampling_replicate_id = sr.sampling_replicate_id
			AND se.sample_id = s.sample_id
			AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'
			AND mm.sample_extract_id = se.sample_extract_id";
		if ($avgTechnicalReplicates)
		{
			$sqlNormData .= " GROUP BY mp2.cpd_id, mp2.protocol_type_id, 
				sr.sampling_point_id, sr.replicate";
		}
		$sqlNormData .= " ORDER BY mp2.cpd_id, sr.sampling_point_id";
		
		//print "sqlNormData = $sqlNormData <br /><br/>";
		break;
	case $_SESSION['TableID']['REFERENCE_SPOT']: 
		
		$sqlNormData = "SELECT pd.\"reference_spot_id\" AS record_id, pd.protocol_type_id, 
			sr.sampling_point_id, sr.replicate";
			
		if ($avgTechnicalReplicates)
		{	
			$sqlNormData .= ", 1 AS technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", AVG(pd.\"normalized_intensity_l\")";			}
			else
			{	$sqlNormData .= ", AVG(pd.\"normalized_intensity\")";			}
		}
		else
		{	
			$sqlNormData .= ", se.technical_replicate";
			if ($isLog)
			{	$sqlNormData .= ", pd.\"normalized_intensity_l\"";	}
			else
			{	$sqlNormData .= ", pd.\"normalized_intensity\"";	}
				
		}
 		$sqlNormData .= " AS normalized_intensity
				FROM \"proteomics_data\" pd
					, \"proteomics_measurement\" pm
					, \"sample_extract\" se	
					, \"sample\" s
					, \"sampling_replicate\" sr";
			if ($RecordIDsStr)
			{	$sqlNormData .= " WHERE pd.\"reference_spot_id\" IN ($RecordIDsStr) AND";	}
			else
			{	$sqlNormData .= " WHERE";	}
			$sqlNormData .= " pd.\"proteomics_measurement_id\" = pm.\"proteomics_measurement_id\"
			AND pm.sample_extract_id = se.sample_extract_id
			AND se.sample_id = s.sample_id
			AND s.label_id = '{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'
			AND s.sampling_replicate_id = sr.sampling_replicate_id";
			
			if ($avgTechnicalReplicates)
			{
				$sqlNormData .= " GROUP BY pd.\"reference_spot_id\", pd.protocol_type_id, 
					sr.sampling_point_id, sr.replicate";
			}
			$sqlNormData .= " ORDER BY pd.\"reference_spot_id\", sr.sampling_point_id";
		
		//print "sqlNormData = $sqlNormData <br /><br/>";

		break;
	}
		
	$sql = "SELECT sp.exp_set_name, sp.exp_name, i.identifier
		, i.identifier2, pt.protocol_type_name, sp.sp_name, sp.sp_name_order
		, nd.replicate, nd.technical_replicate,	nd.normalized_intensity 
		FROM ($sqlIdentifiers) i , ($sqlNormData) nd
			, ($sqlSP) sp
			, ($sqlProtocolType) pt
		WHERE sp.sampling_point_id = nd.sampling_point_id
			AND nd.record_id = i.record_id
			AND nd.protocol_type_id = pt.protocol_type_id
			ORDER BY UPPER(sp.exp_set_name), UPPER(sp.exp_name), sp.sp_name_order, 
			UPPER(i.identifier), UPPER(pt.protocol_type_name), 
			nd.replicate, nd.technical_replicate";
	
	//print "sql = $sql<br /> <br />";
		
	return "($sql)";
}

function setStrings()
{
	global $spidInStr, $tissue_type_label_id_str, $exp_ids_str, $fieldstr, $rid_str, $all_rid_str;
	global $cpd_id_str, $all_cpd_id_str;
	global $spot_id_str, $all_spot_id_str;
	global $currPageName, $searchGeneKey, $techniqueKey;
	
		
	//Get all Sampling Point IDs in a string
	if (isset($_SESSION['SAMPLING_POINT']['SAMPLING_POINT']))
	{
	  $spids = $_SESSION['SAMPLING_POINT']['SAMPLING_POINT'];
	  $firstKey = 1;
	  $spidInStr = "";
	  foreach($spids as $key=>$value)
	  {
	  if ($value)
	  {
	    if (!$firstKey)
	      { $spidInStr .= ", "; }
	      $spidInStr .= $key;
	      $firstKey = 0;
	    }
	  }
	}
	
	if (isset($_SESSION['SAMPLING_POINT']['tissue_type_label_id']))
	{	$tissue_type_label_id_str = "'{$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}'";	}

	// get the process1_id for the experiment_ids in session
	if (isset($_SESSION['EXPERIMENT']['EXPERIMENT']))
	{
    	$exp_ids = array();
    	$expids = $_SESSION['EXPERIMENT']['EXPERIMENT'];
    	foreach ( $expids as $key => $value ) {
      		if ($value){
        		$exp_ids[] = $key;
      		}
    	}
  	}
  	//print "expids = $expids<br>";
  	$exp_ids_str = implode(", ", $exp_ids);
	
	//Now setting $fieldstr
	$currPageNameUpper = strtoupper($currPageName);
	if (isset($_SESSION[$searchGeneKey]['FIELDS']))
	{
	  	$fields = $_SESSION[$searchGeneKey]['FIELDS'];
		$fieldarray = array();
		foreach ( $fields as $key =>$name ) 
		{
		    if ($name != "")
		    {
		      $fieldarray[] = "\"" . $name . "\"";
		    }
	  	}
		//The leading space is put so that a check with strpos function cannot return a '0'.
	  	$fieldstr = ' ' .  implode(", ", $fieldarray);
	}
	if (isset($_SESSION[$searchGeneKey]['filter-field']))
	{
		foreach ($_SESSION[$searchGeneKey]['filter-field'] as $index => $filterField)
		{
			if (!strpos($fieldstr, $filterField) AND $filterField)
			{
				$fieldstr .= ", \"{$_SESSION[$searchGeneKey]['filter-field'][$index]}\"";
			}
		}
	}
	
	if (isset($_SESSION[$searchGeneKey]['DATA']))
	{
		$technique_types = array_keys($_SESSION[$searchGeneKey]['DATA']);
		foreach ($technique_types as $technique_type)
		{
			$id_str = "";
			//Now setting $cpd_id_str
			if ($_SESSION[$searchGeneKey]['DATA'][$technique_type]['RESULTS'])
			{
				$firstID = 1;
				foreach ($_SESSION[$searchGeneKey]['DATA'][$technique_type]['RESULTS'] as $ID) 
				{
					if ($firstID)
					{	
						$id_str = $ID;
						$firstID = 0;
					}
					else
					{	$id_str .= ", $ID";		}
			  	}
	  		}
	  		//Now setting $all_cpd_id_str
	  		if ($_SESSION[$searchGeneKey]['DATA'][$technique_type]['SEARCH_RESULTS'])
	  		{  	$all_id_str = implode(", ", $_SESSION[$searchGeneKey]['DATA'][$technique_type]['SEARCH_RESULTS']);	}
	  		switch (strtoupper($technique_type))
		  	{
		  	case 'METABOLITE':
		  		$cpd_id_str = $id_str;
		  		$all_cpd_id_str = $all_id_str;
		  		break;
		  	case 'MRNA':
		  		$rid_str = $id_str;
		  		$all_rid_str = $all_id_str;
		  		break;
		  	case 'PROTEIN':
		  		$spot_id_str = $id_str;
		  		$all_spot_id_str = $all_id_str;
		  		break;
	  		}
	  	}
  	}
  	//print "$rid_str:$all_rid_str";
  	//print "<br>$cpd_id_str:$all_cpd_id_str";
}

function print_all_results($browseAllowed = true, $rid_str = "", $cpd_id_str = "", $spot_id_str = "")
{
	global $searchGeneKey, $techniqueKey, $fieldstr;
	unset($_SESSION[$searchGeneKey]['MASTER_ARRAY']);
	unset($_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']);
	unset($_SESSION[$searchGeneKey]['MASTER_ARRAY_COUNTS']);
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
  
	$RecIDs['Metabolite'] = $cpd_id_str;
	$RecIDs['mRNA'] = $rid_str;
	$RecIDs['Protein'] = $spot_id_str;
	
	if ($browseAllowed AND isset($_SESSION[$techniqueKey]['DATA']))
	{
		$technique_types = array_keys($_SESSION[$techniqueKey]['DATA']);
		foreach ($technique_types as $technique_type)
		{
			if($_SESSION[$techniqueKey]['DATA'][$technique_type]['ISEXACT'] == 'browse')
		  	{
				switch($technique_type)
				{
				case 'Metabolite':
					$TableID = $_SESSION['TableID']['COMPOUND'];
					break;
				case 'mRNA':
					$TableID = $_SESSION['TableID']['REPORTER'];
					break;
				case 'Protein':
					$TableID = $_SESSION['TableID']['REFERENCE_SPOT'];
					break;
				}
				
				$sqlIdentifiers = getSQLIdentifiers($TableID, "");
				
				$sth = $_SESSION['dbh']->query($sqlIdentifiers);
				if ( DB::isError($sth) ) 
				{	
					printError("Error Browsing for $technique_type data. " . $sth->getMessage());	
					return;	
				}
				$firstDone = false;
				while ($row = $sth->fetchRow()) 
			    {
				    if (!$firstDone)
				    {	$RecIDs[$technique_type] = $row[0]; $firstDone = true;	}
				    else
				    {    $RecIDs[$technique_type] .= ", $row[0]";	}
			    }
			}
		}
    }
    
    if ($RecIDs['Metabolite'])
    {    
	    $stime = microtime_float();
	    print "Now Processing Metabolites...";
	    $totRows += callGetDataSQL($_SESSION['TableID']['COMPOUND'], $RecIDs['Metabolite']);
	    print "<br />Finished Processing Metabolites. (" . (microtime_float() - $stime) . " secs)";
	    print "<hr />";
    }
    if ($RecIDs['mRNA'])
    {
	    $stime = microtime_float();
	    print "Now Processing mRNAs...";
    	$totRows += callGetDataSQL($_SESSION['TableID']['REPORTER'], $RecIDs['mRNA']);
    	print "<br />Finished Processing mRNAs. (" . (microtime_float() - $stime) . " secs)";
    	print "<hr />";
	}
	if ($RecIDs['Protein'])
	{
		$stime = microtime_float();
		print "Now Processing Proteins...";
		$totRows += callGetDataSQL($_SESSION['TableID']['REFERENCE_SPOT'], $RecIDs['Protein']);
		print "<br />Finished Processing Proteins. (" . (microtime_float() - $stime) . " secs)";
		print "<hr />";
	}
		
	//Convert Key arrays to proper format.
	if ($totRows)
	{
		$keys['Exp Set'] = array_keys($keys['Exp Set']);
		$keys['Experiment'] = array_keys($keys['Experiment']);
		$keys['Identifier'] = array_keys($keys['Identifier']);
		$keys['Secondary ID'] = array_keys($keys['Secondary ID']);
		$keys['Protocol Type'] = array_keys($keys['Protocol Type']);
		if ($_SESSION['IS_REPLICATE_TRACK'])
		{	
			$keys['Biological Replicate'] = array_keys($keys['Biological Replicate']);	
			
			if ($_SESSION[$searchGeneKey]['omitRows'])
			{	removeNullRowsReplicate(false);	}
			doTransformationReplicate();	
		}
		else
		{
			$removalDone = false;
			if ($_SESSION[$searchGeneKey]['omitRows'])
			{	removeNullRows('', false); }
			else
			{	removeNullRows();	}
			
			doTransformation();	
		}
	}
}

function callGetDataSQL($TableID, $RecIDstr)
{
	global $searchGeneKey;
	$totRows = 0;
	$bunchSize = 50;
    if (strlen($RecIDstr) > 0 AND isset($_SESSION[$searchGeneKey]['protocol_type_id'][$TableID]))
	{
		$protocol_type_id_str = implode( ", ", $_SESSION[$searchGeneKey]['protocol_type_id'][$TableID]);
		
		$RIDArray = split(", ", $RecIDstr);
		$noOfIterations = ceil(count($RIDArray)/$bunchSize);
		print str_repeat(' ', 300);	//browsers like IE don't display a 
					//page until they have recieved 256 bytes. Force them to display.
		for ($j = 1; $j <= $noOfIterations; $j++)	
		{
			$stime = microtime_float();
			print "<br />Now doing iteration $j of $noOfIterations.";
			flush();
			unset($RIDArrayBunch);
			for ($i = $bunchSize * ($j - 1); $i < ($bunchSize * $j); $i++)
			{	
				if ($RIDArray[$i])
				{	$RIDArrayBunch[] = $RIDArray[$i];	}
			}
				
			$rec_id_str_bunch = implode(", ", $RIDArrayBunch);
 			
			if ($_SESSION['IS_REPLICATE_TRACK'])
  			{	$sql = getDataSQLReplicate($TableID, $rec_id_str_bunch, $protocol_type_id_str, $_SESSION[$searchGeneKey]['IsAvg'], $_SESSION[$searchGeneKey]['IsLog']);	}
  			else
  			{	$sql = getDataSQL($TableID, $rec_id_str_bunch, $_SESSION[$searchGeneKey]['protocol_name'][$TableID], $protocol_type_id_str);	}
  			//print $sql;
  			$retRows = callFillMasterArray($sql);
  			if ($retRows)
  			{	$totRows += $retRows;	}
  			$totTime = number_format(microtime_float() - $stime, 3, '.', '');
  			print " Finished: $totTime secs";
  			if ($totTime > 100)
  			{	print " Oops!";	}
  			if ($totTime > 200)
  			{	print " Sorry!";	}
		}
		if ($_SESSION['IS_REPLICATE_TRACK'])
		{
			$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['Sampling Point'];
			if ($label_names)
			{	ksort($label_names);	}

			$biologicalReplicates = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['Biological Replicate'];
			if ($biologicalReplicates)
			{	asort($biologicalReplicates);	}
		}
		else
		{
			//get label_names in right order (it may be out of order if the first identifier did
			//not have data for the first time point).
			$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['label_names'] ;
			if ($label_names)
			{	ksort($label_names);	}
		}
  	}
  	return $totRows;
}

function callFillMasterArray($sql)
{
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		printError("Error Retrieving data." . $sth->getMessage());	
		return;	
	}
	//print "<br>Done PAResults: " . (microtime_float() - $stime);
	$rownum = $sth->numrows();
	if ($rownum > 0) 
	{	
		if ($_SESSION['IS_REPLICATE_TRACK'])
		{	fillMasterArrayReplicate($sth);	}
		else
		{	fillMasterArray($sth);	}
	}
	return $rownum;
}

function fillMasterArray(&$sth)
{
	global $searchGeneKey, $fieldstr;
	$fields = $_SESSION[$searchGeneKey]['FIELDS'];
	
	// create a master data structure of 6D arrays to hold all data. It has to
    // be an associated array of arrays which will have the following structure:
    // master_array[exp_set_name][exp_name][identifier][protocol_type_name][field_name][label.name]
    // where I can get field_name from $fieldarray and rest from the SQL.
   
    $master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$counts = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_COUNTS'];
    
	$ESNames = &$keys['Exp Set'];
	$ENames = &$keys['Experiment'];
	$identifiers = &$keys['Identifier'];
	$secondaryIDs = &$keys['Secondary ID'];
	$protocol_type_names = &$keys['Protocol Type'];
	$label_names = &$keys['label_names'] ;
	
	if (!$ESNames) {	$ESNames = array(); 	}
	if (!$ENames) {	$ENames = array(); 	}
	if (!$identifiers) {	$identifiers = array(); 	}
	if (!$secondaryIDs) {	$secondaryIDs = array(); 	}
	if (!$protocol_type_names) {	$protocol_type_names = array(); 	}
	if (!$label_names) {	$label_names = array(); 	}

    // get the data out of the database and save in the hash for further manipulation
    while ($row = $sth->fetchRow()) 
    {
	    //es.exp_set_name, e.exp_name, i.identifier, p1dc.protocol_type_name, l.\"name\", $fieldstr 
		$ESName = $row[0]; 
		$EName = $row[1];
		$identifier = $row[2];
		$secondaryID = $row[3];
		$protocol_type_name = $row[4];
		$label_name = $row[5];
		$label_order = $row[6];
		
		$ESNames[$ESName]++;
		$ENames[$EName]++;
		$identifiers[$identifier]++;
		$secondaryIDs[$secondaryID]++;
		$protocol_type_names[$protocol_type_name]++;
		$label_names[$label_order] = $label_name;
		
		
		$i = 7;
		foreach ($fields as $field)
		{
			$field_value = $row[$i];
			//if ($field_value != "")
			{
			  	//print "<br />$ESName:$identifier:$protocol_type_name:$field:$label_name";
				$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$field][$label_name] = $field_value;
				$counts['Exp Set'][$ESName]++;
				$counts['Experiment'][$EName]++;
				$counts['Identifier'][$identifier]++;
				$counts['Secondary ID'][$secondaryID]++;
				$counts['Protocol Type'][$protocol_type_name]++;
				$counts['label_names'][$label_name]++;
				
				//echo "rid = $rid, tc = $identifier, ESName = $ESName, label_name = $label_name<br>";
		
			} 
  			$i++;
		}
	}
}

function fillMasterArrayReplicate(&$sth)
{
	global $searchGeneKey;
		
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$counts = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_COUNTS'];
	
	$ESNames = &$keys['Exp Set'];
	$ENames = &$keys['Experiment'];
	$identifiers = &$keys['Identifier'];
	$secondaryIDs = &$keys['Secondary ID'];
	$protocol_type_names = &$keys['Protocol Type'];
	$label_names = &$keys['Sampling Point'];
	$biologicalReplicates = &$keys['Biological Replicate'];
	$technicalReplicates = &$keys['Technical Replicate'];
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	
	
	if (!$ESNames) {	$ESNames = array(); 	}
	if (!$ENames) {	$ENames = array(); 	}
	if (!$identifiers) {	$identifiers = array(); 	}
	if (!$secondaryIDs) {	$secondaryIDs = array(); 	}
	if (!$protocol_type_names) {	$protocol_type_names = array(); 	}
	if (!$label_names) {	$label_names = array(); 	}
	if (!$biologicalReplicates) {	$biologicalReplicates = array(); 	}

	//Master Array has the following keys:
	//master_array[exp_set_name][experiment][identifier][secondaryID][protocol_type_name][sp_name][BiologicalReplicateNumber][TechnicalReplicateNumber]
	
	while ($row = $sth->fetchRow()) 
	{
		//sp.exp_set_name, sp.exp_name, i.identifier, i.identifier2, pt.protocol_type_name
		//, sp.sp_name, sp.sp_name_order, nd.replicate, nd.technical_replicate,	nd.normalized_intensity 
		$ESName = $row[0];
		$EName = $row[1];
		$identifier = $row[2];
		$secondaryID = $row[3];
		$protocol_type_name = $row[4];
		$label_name = $row[5];
		$label_order = $row[6];
		$replicate = $row[7];
		$technical_replicate = $row[8];
		$normalized_intensity = $row[9];
		
		$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name][$replicate][$technical_replicate] = $normalized_intensity;
		
		//Check if we have seen this key before
		//if no add it to the array of keys for the respective field.
		$ESNames[$ESName]++;
		$ENames[$EName]++;
		$label_names[$label_order] = $label_name;
			
		$identifiers[$identifier]++;
		$secondaryIDs[$secondaryID]++;
		$protocol_type_names[$protocol_type_name]++;
		$biologicalReplicates[$replicate]++;
		
		//technicalReplicates have to be handled slightly differently.
		//because we are keeping track of keys for technical replicate
		//for EACH of the biological replicates (and not just one
		//set of keys for all biological replicates)
		if (!$technicalReplicates[$replicate])
		{	$technicalReplicates[$replicate] = array();		}
		if (!$SPTechnicalReplicates[$label_order][$replicate])
		{	$SPTechnicalReplicates[$label_order][$replicate] = array();		}
		
		if (!in_array($technical_replicate, $technicalReplicates[$replicate]))
		{	$technicalReplicates[$replicate][] = $technical_replicate;	}
		if (!in_array($technical_replicate, $SPTechnicalReplicates[$label_order][$replicate]))
		{	$SPTechnicalReplicates[$label_order][$replicate][] = $technical_replicate;	}
		
		$counts['Exp Set'][$ESName]++;
		$counts['Experiment'][$EName]++;
		$counts['Identifier'][$identifier]++;
		$counts['Secondary ID'][$secondaryID]++;
		$counts['Protocol Type'][$protocol_type_name]++;
		$counts['Sampling Point'][$label_name]++;
		$counts['Biological Replicate'][$replicate]++;
	}
	//In cases where there may be no data for initial sampling points
	//the $SPTechnicalReplicates will contain sampling points in wrong order.
	//So sort this array's keys to correct the order.
	ksort($SPTechnicalReplicates);
}

function removeNullRows($process_field = "", $removeOnlyIfAllValuesNull = true)
{
	global $searchGeneKey;
	
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['label_names'];
	
	if ($process_field)
	{	$process_fields = array($process_field);	}
	else
	{	$process_fields = &$_SESSION[$searchGeneKey]['FIELDS'];	}
	
	$ESNames = array_keys($master_array);
	foreach ($process_fields as $process_field) 	
	{
		foreach ($ESNames as $ESName) 
		{
			$ENames = array_keys($master_array[$ESName]);
			foreach ($ENames as $EName) 
			{
				$identifiers = array_keys($master_array[$ESName][$EName]);
				foreach ($identifiers as $identifier) 
				{
					$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
					foreach ($secondaryIDs as $secondaryID) 
					{
						$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
						foreach ($protocol_type_names as $protocol_type_name) 
						{
							$nonNullValueFound = false;
							$nullValueFound = false;
							foreach ($label_names as $label_name) 
							{
								$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name];
								if (strlen($value)) 
								{	$nonNullValueFound = true;	}
								else
								{	$nullValueFound = true;	}
							}
							
							if ($removeOnlyIfAllValuesNull)
							{	if (!$nonNullValueFound)
								{	removeRow($ESName, $EName, $identifier, $secondaryID, $protocol_type_name, $process_field);	}
							}
							elseif ($nullValueFound)
							{	removeRow($ESName, $EName, $identifier, $secondaryID, $protocol_type_name, $process_field);		}
								
						}
					}
				}
			}
		}
	}
}

function removeNullRowsReplicate($removeOnlyIfAllValuesNull = true)
{
	global $searchGeneKey;
	
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['Sampling Point'];
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	$sp_name_orders = array_keys($SPTechnicalReplicates);
	
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{
		$ENames = array_keys($master_array[$ESName]);
		foreach ($ENames as $EName) 
		{
			$identifiers = array_keys($master_array[$ESName][$EName]);
			foreach ($identifiers as $identifier) 
			{
				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
				foreach ($secondaryIDs as $secondaryID) 
				{
					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
					foreach ($protocol_type_names as $protocol_type_name) 
					{
						$nonNullValueFound = false;
						$nullValueFound = false;
						foreach ($sp_name_orders as $sp_name_order)
						{
							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
							foreach ($biologicalReplicates as $biologicalReplicate)
							{
								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
			      				foreach ($technicalReplicates as $technicalReplicate) 
		      					{	
			      					$value = $master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];
									if (strlen($value)) 
									{	$nonNullValueFound = true;	}
									else
									{	$nullValueFound = true;	}
								}
							}
						}
						
						if ($removeOnlyIfAllValuesNull)
						{	if (!$nonNullValueFound)
							{	removeRow($ESName, $EName, $identifier, $secondaryID, $protocol_type_name);	}
						}
						elseif ($nullValueFound)
						{	removeRow($ESName, $EName, $identifier, $secondaryID, $protocol_type_name);	}
					}
				}
			}
		}
	}
	
}


function removeRow($ESName, $EName, $identifier, $secondaryID, $protocol_type_name, $process_field = '')
{	
	global $searchGeneKey;

	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$keys = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS'];
	$counts = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_COUNTS'];
	$SPTechnicalReplicates = &$keys['SP Technical Replicate'];
	
	$data_points_removed = 0;

	if ($_SESSION['IS_REPLICATE_TRACK'])
	{
		if (!isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]))
		{	return;	}
		
		$label_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]);
		foreach($label_names as $label_name)
		{
			$biologicalReplicates = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name]);
			foreach ($biologicalReplicates as $biologicalReplicate)
			{
				$technicalReplicates = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name][$biologicalReplicate]);
  				foreach ($technicalReplicates as $technicalReplicate) 
				{
					unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name][$biologicalReplicate][$technicalReplicate]);
					if (0 == count($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name][$biologicalReplicate]))
					{	
						unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name][$biologicalReplicate]);
						if (0 == count($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name]))
						{	unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$label_name]);	}
					}
					$data_points_removed++;
					$counts['Sampling Point'][$label_name]--;
					if (0 == $counts['Sampling Point'][$label_name])
					{	
						$label_order = array_search($label_name, $keys['Sampling Point']);	unset($keys['Sampling Point'][$label_order]);
						unset($keys['SP Technical Replicate'][$label_order]);
					}
					
					$counts['Biological Replicate'][$biologicalReplicate]--;
					
					//If count of a particular Biological replicate is zero (all occurances
					//of this biological replicates from the master_array have been removed) than
					// remove all entries of Biological replicates in array SPTechnicalReplicates.
					//(SPTechnicalReplicates keeps keys by sampling point order and biological replicate).
					if (0 == $counts['Biological Replicate'][$biologicalReplicate])
					{
						$sp_name_orders = array_keys($SPTechnicalReplicates);
						foreach ($sp_name_orders as $sp_name_order)
						{	unset($SPTechnicalReplicates[$sp_name_order][$biologicalReplicate]);		}
					}
				}
			}
		}
	}
	else
	{
		if (!isset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field]))
		{	return;	}
		
		$label_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field]);
		foreach($label_names as $label_name)
		{
			unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field][$label_name]);
			$data_points_removed++;
			$counts['label_names'][$label_name]--;
			if (0 == $counts['label_names'][$label_name])
			{	$key = array_search($label_name, $keys['label_names']);	unset($keys['label_names'][$key]);	}
		}
	}
	
	$counts['Protocol Type'][$protocol_type_name] -= $data_points_removed;
	$counts['Identifier'][$identifier] -= $data_points_removed;
	$counts['Secondary ID'][$secondaryID] -= $data_points_removed;
	$counts['Experiment'][$EName] -= $data_points_removed;
	$counts['Exp Set'][$ESName] -= $data_points_removed;
	
	if (!$_SESSION['IS_REPLICATE_TRACK'])
	{	unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$process_field]);	}
	if (0 == count($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]))
	{	
		unset($master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name]);
		if (0 == count($master_array[$ESName][$EName][$identifier][$secondaryID]))
		{
			unset($master_array[$ESName][$EName][$identifier][$secondaryID]);
			if (0 == count($master_array[$ESName][$EName][$identifier]))
			{
				unset($master_array[$ESName][$EName][$identifier]);
				if (0 == count($master_array[$ESName][$EName]))
				{
					unset($master_array[$ESName][$EName]);
					if (0 == count($master_array[$ESName]))
					{	unset($master_array[$ESName]);	}
				}
			}
		}
	}
	
	if (0 == $counts['Exp Set'][$ESName])
	{	
		$key = array_search($ESName, $keys['Exp Set']);	
		removeKeyAndCompress($keys['Exp Set'], $key);
		unset($counts['Exp Set'][$ESName]);
	}
	if (0 == $counts['Experiment'][$EName])
	{	
		$key = array_search($EName, $keys['Experiment']);	
		removeKeyAndCompress($keys['Experiment'], $key);
		unset($counts['Experiment'][$EName]);	
	}
	if (0 == $counts['Identifier'][$identifier])
	{	
		$key = array_search($identifier, $keys['Identifier']); 
		removeKeyAndCompress($keys['Identifier'], $key);
		unset($counts['Identifier'][$identifier]);	
	}
	if (0 == $counts['Secondary ID'][$secondaryID])
	{	
		$key = array_search($secondaryID, $keys['Secondary ID']); 
		removeKeyAndCompress($keys['Secondary ID'], $key);
		unset($counts['Secondary ID'][$secondaryID]);	
	}
	if (0 == $counts['Protocol Type'][$protocol_type_name])
	{	
		$key = array_search($protocol_type_name, $keys['Protocol Type']);	
		removeKeyAndCompress($keys['Protocol Type'], $key);
		unset($counts['Protocol Type'][$protocol_type_name]);
	}
}




/**Removes the given element at position $key 
* and then restores all keys of the array in serial order.
*/
function removeKeyAndCompress(&$array, $key)
{
	unset($array[$key]);
	$tempArray = array();
	foreach($array as $value)
	{	$tempArray[] = $value;	}
	$array = $tempArray;
}

function doTransformation()
{
	global $searchGeneKey;
	
	$transformation_type = $_SESSION[$searchGeneKey]['transformation'];
	if ($transformation_type == '--none--')
	{	return;	}
	
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$fieldarray = &$_SESSION[$searchGeneKey]['FIELDS'];
	$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['label_names'];
		
	if (!$master_array)
	{	return;	}
	
	//Calculate Mean first
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{
		$ENames = array_keys($master_array[$ESName]);
		foreach ($ENames as $EName) 
		{
			$identifiers = array_keys($master_array[$ESName][$EName]);
			foreach ($identifiers as $identifier) 
			{
				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
		    	foreach ($secondaryIDs as $secondaryID) 
		    	{
					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
					foreach ($protocol_type_names as $protocol_type_name) 
					{
						for ($i=0; $i<count($fieldarray); $i++) 
						{
							$fieldname = str_replace("\"", "", $fieldarray[$i]);
							$row = &$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name][$fieldarray[$i]];
							
							$sum = 0; $N = 0; $mean = 0;
							foreach ($label_names as $label_name) 
							{
								$value = $row[$label_name];
								if (is_numeric($value)) 
								{	$sum += $value; $N++;	} 
								
							}
							if ($N > 0)
							{	$mean = $sum / $N;	}
							
							//Now Calculate Std Dev
							if ($transformation_type == 'Z-Score')
							{
								$sum = 0; $std_dev = 0;
								if ($N > 1)
								{
									foreach ($label_names as $label_name) 
									{
										$value = $row[$label_name];
										if (is_numeric($value))
										{	$sum += ($value - $mean) * ($value - $mean);	}
									}
									$std_dev = sqrt($sum/($N - 1));
									
								}
							}
							$rejectRow = false;
							if (($transformation_type == 'Standardized By Mean' OR $transformation_type == 'Centered') AND $mean == 0)
							{	$rejectRow = true;	}
							elseif ($transformation_type == 'Z-Score' AND $std_dev == 0)
							{	$rejectRow = true;	}
							if ($rejectRow)
							{	continue;	}
							
							//Now finally transform data in master_array.
							foreach ($label_names as $label_name) 
							{
								switch($transformation_type)
								{
								case 'Centered':
									if (is_numeric($row[$label_name]))
									{	$row[$label_name] = $row[$label_name] - $mean;	}
									break;
								case 'Standardized By Mean':
									if (is_numeric($row[$label_name]))
									{	$row[$label_name] = $row[$label_name]/$mean;	}
									break;
								case 'Z-Score':
									if (is_numeric($row[$label_name]))
									{	$row[$label_name] = ($row[$label_name] - $mean) / $std_dev;	}
									break;
								}
							}
						}
					}
				}
			}
		}
	}
	return;
}

function doTransformationReplicate()
{
	global $searchGeneKey;
	
	$transformation_type = $_SESSION[$searchGeneKey]['transformation'];
	if ($transformation_type == '--none--')
	{	return;	}
	
	$master_array = &$_SESSION[$searchGeneKey]['MASTER_ARRAY'];
	$label_names = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['Sampling Point'];
	$SPTechnicalReplicates = &$_SESSION[$searchGeneKey]['MASTER_ARRAY_KEYS']['SP Technical Replicate'];
	$sp_name_orders = array_keys($SPTechnicalReplicates);
		
	if (!$master_array)
	{	return;	}
	
	//Calculate Mean first
	$ESNames = array_keys($master_array);
	foreach ($ESNames as $ESName) 
	{
		$ENames = array_keys($master_array[$ESName]);
		foreach ($ENames as $EName) 
		{
			$identifiers = array_keys($master_array[$ESName][$EName]);
			foreach ($identifiers as $identifier) 
			{
				$secondaryIDs = array_keys($master_array[$ESName][$EName][$identifier]);
		    	foreach ($secondaryIDs as $secondaryID) 
		    	{
					$protocol_type_names = array_keys($master_array[$ESName][$EName][$identifier][$secondaryID]);
					foreach ($protocol_type_names as $protocol_type_name) 
					{
						$row = &$master_array[$ESName][$EName][$identifier][$secondaryID][$protocol_type_name];
						$sum = 0; $N = 0; $mean = 0;
						foreach ($sp_name_orders as $sp_name_order)
						{
							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
							foreach ($biologicalReplicates as $biologicalReplicate)
							{
								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
								foreach ($technicalReplicates as $technicalReplicate)
								{
									$value = $row[$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];
									if (is_numeric($value)) 
									{	$sum += $value; $N++;	} 
								}
							}
								
						}
						if ($N > 0)
						{	$mean = $sum / $N;	}
							
						//Now Calculate Std Dev
						if ($transformation_type == 'Z-Score')
						{
							$sum = 0; $std_dev = 0;
							if ($N > 1)
							{
								foreach ($sp_name_orders as $sp_name_order)
								{
									$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
									foreach ($biologicalReplicates as $biologicalReplicate)
									{
										$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
										foreach ($technicalReplicates as $technicalReplicate)
										{
											$value = $row[$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];
											if (is_numeric($value))
											{	$sum += ($value - $mean) * ($value - $mean);	}
										}
									}
								}
								$std_dev = sqrt($sum/($N - 1));
							}
						}
						$rejectRow = false;
						if (($transformation_type == 'Standardized By Mean' OR $transformation_type == 'Centered') AND $mean == 0)
						{	$rejectRow = true;	}
						elseif ($transformation_type == 'Z-Score' AND $std_dev == 0)
						{	$rejectRow = true;	}
						if ($rejectRow)
						{	continue;	}
							
						//Now finally transform data in master_array.
						foreach ($sp_name_orders as $sp_name_order)
						{
							$biologicalReplicates = array_keys($SPTechnicalReplicates[$sp_name_order]);
							foreach ($biologicalReplicates as $biologicalReplicate)
							{
								$technicalReplicates = $SPTechnicalReplicates[$sp_name_order][$biologicalReplicate];
								foreach ($technicalReplicates as $technicalReplicate)
								{
									$cell = &$row[$label_names[$sp_name_order]][$biologicalReplicate][$technicalReplicate];
									switch($transformation_type)
									{
									case 'Centered':
										if (is_numeric($cell))
										{	$cell = $cell - $mean;	}
										break;
									case 'Standardized By Mean':
										if (is_numeric($cell))
										{	$cell = $cell/$mean;	}
										break;
									case 'Z-Score':
										if (is_numeric($cell))
										{	$cell = ($cell - $mean) / $std_dev;	}
										break;
									}
								}
							}
						}
					}
				}
			}
		}
	}
	return;
}

?>