<?php

/**

* This script is one step for the Wizard Type Front-End for DOME.

* It displays a page containing a number of checkboxes using the 

* data set in the file "workflow.php".

* 

* Date: 3 Sept 2003

* @author Aejaaz Kamal <aekamal@vt.edu>

* updated: X. Jing Li

*/

//session_start();





include_once("common.php");

include_once("workFlow.php");



//Parse Get or Post step number and set the current step number.

setStepNumber();

$_SESSION['STEP_FILE_NAME'] = substr($_SERVER['PHP_SELF'], strrpos($_SERVER['PHP_SELF'], "/") + 1);



//Sets Environment Variable

setVariables($_SESSION['STEP_NUMBER']);



//If there is a submit (Either Next, Previous or StartOver Clicked).

doControlBarRedirection(1); 

?>





<?php 

$stepCount = count(split(':', $_SESSION['STEP_NUMBER']));

$title = "Choose : {$labelNames['PAGE_LABEL']}"; 

include("header.php");

?>



<script type="text/javascript">

function setTechniqueCheckBox(frm, grpNumber)

{

	for (i = 0; i < frm.elements.length; i++)

	{

		if (frm.elements[i].type == "checkbox" && frm.elements[i].name.substring(0, 7) == "chkBox_")

		{

			for (j = 0; j < groups[grpNumber].length; j++)

			{

				Number = groups[grpNumber][j];

				chkBoxName = "chkBox_" + Number;

				if ((frm.elements[i].name == chkBoxName))

				{	    

					frm.elements[i].checked = true;	

				}

			}

		}

	}

}



function setAll(form, val) {

  for (i=0; i<form.elements.length; i++)

  {

    if (form.elements[i].type == "checkbox")

    {

      if ((form.elements[i].name.substring(0, 7) == "chkBox_"))

      {	    form.elements[i].checked = val;	}

      

    }

  }

}



function checkOnlyOneClicked(form, chkBox) 

{

  var noOfChecked = 0;

  for (i=0; i<form.elements.length; i++)

  {

    if (form.elements[i].type == "checkbox")

    {

      if ((form.elements[i].name.substring(0, 7) == "chkBox_") && form.elements[i].checked)

      {	    noOfChecked++;	}

    }

  }

  if (noOfChecked > 1)

  {

	  alert("You can select only one time point while retrieving raw files.\nTo select this one first unselect the other one." );

	  chkBox.checked = false;

  }

}



</script>









<?php

if ($_SESSION['errMsgs'])

{  

	foreach ($_SESSION['errMsgs'] as $msg)

	{	printError($msg);	}

	unset($_SESSION['errMsgs']);

}

if (strtoupper($currPageName) == 'TECHNIQUE' || strtoupper($currPageName) == 'TECHNIQUE_REPLICATE')

{	$isTechniquePage = true;	}

elseif (strtoupper($currPageName) == 'SAMPLING_POINT')

{	$isSamplingPointPage = true;	}

fillForm($_SESSION['STEP_NUMBER'], $labelNames, $errNo);

include("footer.php");





/**Top level function that prints the form.

* @param number $stepNumber The current Step number to print the form for.

* @param string $prevPageName The identifying name of the previous page in the workflow.

* @param string $currPageName The identifying name of the current page in the workflow.

* @param string $nextPageName The identifying name of the next page in the workflow.

* @param stringArray $labelNames The Array containing the names to be displayed

* (in the frame containing all the checkboxes) for each of the tables.

* @param number $errNo Set to a non-zero value if the user input is invalid.

*/



function fillForm($stepNumber, $labelNames, $errNo)

{

	global $prevPageName, $currPageName, $nextPageName, $isTechniquePage, $isSamplingPointPage, $help_tip;

  $currPageNameUpper = strtoupper($currPageName);

  $currPageNameLower = strtolower($currPageName);

  print printPageSelections();

  print "\n<div class=\"step{$stepNumber}-form\">\n";

  print "\n<p class=\"help-tips\">$help_tip</p>\n";

  

    

  if (!$errNo)

  {

    $_SESSION[$currPageNameUpper]['QUERY'] = prepareSQL();

  }

  $self = $_SERVER['PHP_SELF'];

  print "<form name=\"{$currPageNameLower}-form\" method=\"post\" action=\"{$self}\">\n";

  

  if ($isTechniquePage)

  {	



	  printControlBar($stepNumber, 1, 1);

	  print "\n<table width=\"1100\" align=\"left\">\n\t<tr><td width=\"750\">";	

  }

  

  fillCheckboxes($labelNames);

  

	

 	if ($isTechniquePage)

	{	//print the required javascript arrays for grouping in framesets.

		print "\n<script type=\"text/javascript\">";

		for ($i = 0; $i < $_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT']; $i++)

		{

			$groups[$_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE']][] = $i;

		}

		print "\ngroups = new Array(" . count($groups) . ");";

		$i = 0;

		foreach ($groups as $group)

		{

			$groupArrayStr = "\"" . join("\", \"", $group) . "\"";

			print "\ngroups[$i] = Array($groupArrayStr);";

			$i++;

		}

		print "\n</script>";

		

		

		print "</td><td width=\"10%\" align=\"center\">AND/OR</td><td width=\"35%\" valign=\"top\">";

		fillMapSelectionBox(ceil(count($groups)/2));

		print "</td></tr>\n</table>";

	}

	elseif ($isSamplingPointPage)

	{

		//Print Tissue Type Labels. 

		$sql = "SELECT \"label_id\", \"name\" FROM \"label\" 

			WHERE \"kw_table_id\" = '{$_SESSION['TableID']['SAMPLE']}' 

			ORDER BY \"order\"";

		//print $sql;

	    $sth = $_SESSION['dbh']->query($sql);

		if ( DB::isError($sth) ) 

		{	printError("Error retrieving Tissue Types. " . $sth->getMessage());	return;	}

		

		

		print "<p><table>";

		print "<tr><td><label>Tissue Type: </label></td><td>";

		//print "<select name=\"tissue_type_label_id\" size=\"3\">";

		while ($row = $sth->fetchRow()) 

		{

			if (!isset($_SESSION[$currPageNameUpper]['tissue_type_label_id']))

			{	$_SESSION[$currPageNameUpper]['tissue_type_label_id'] = $row[0];	}

			

			print "\n\t<input type=\"radio\" name=\"tissue_type_label_id\" value=\"$row[0]\"";

			if ($_SESSION[$currPageNameUpper]['tissue_type_label_id'] == $row[0])

			{	print " checked";	}

			print ">$row[1]</input></td></tr>";

			print "\n<tr><td></td><td>";

		}

		//print "</select>";

		print "</td></tr></table>";

	}

  //prints the previous, next and other buttons.

  if (2 == $_SESSION['IS_REPLICATE_TRACK'])

  {	printControlBar($stepNumber, 1, 0);	}

  else

  {	printControlBar($stepNumber, 1, 1);	}

  print "</form>";

  print "</div>";

}



/**Function that constructs the SQL statement for the current page using

* data from the workflow file.

* @param string $prevPageName The identifying name of the previous page in the workflow.

* @param string $currPageName The identifying name of the current page in the workflow.

*/

function prepareSQL()

{

	global $prevPageName, $currPageName, $isTechniquePage;

  $prevPageNameUpper = strtoupper($prevPageName);

  $currPageNameUpper = strtoupper($currPageName);

  $TableData = $_SESSION[$currPageNameUpper]['TABLE_DATA'];

  //make $TableData point to the data (in workflow file) for the first table of this page.



  if (!isset($TableData))

  {

	  printError("TableData For page '$currPageName' not set.");

	  unset($_SESSION[$currPageNameUpper]['QUERY']);

	  return;

  }



  $firstTable = 1;



  for ($i = 0; $i < count($TableData); $i++)

  {

    if ($firstTable)

    {  $firstTable = 0;  }

    else

    {

      $strSQLCurr .= " UNION ";

    }



    $TableNameUpper = strtoupper($TableData[$i]['TABLE_NAME']);



    $strPreviousSQLFilteredByUserInput = filterByUserInput($prevPageName);

        

    $strSQLCurr .= "SELECT r.kw_table AS table_name

      , n.{$TableData[$i]['RECORD_ID_FIELD']} AS record_id

      , n.{$TableData[$i]['NAME_FIELD']} AS name";

      if ($isTechniquePage)

      {	$strSQLCurr .= ", n.technique_type";	}

      

      $strSQLCurr .= " FROM ref_kw_table r";

    if (strlen($TableData[$i]['TABLE_QUERY']) > 0)

    {

      $strSQLCurr .= ", ({$TableData[$i]['TABLE_QUERY']}) n";

    }

    else

    {

      $strSQLCurr .= ", {$TableData[$i]['TABLE_NAME']} n";

    }

    if (strlen($strPreviousSQLFilteredByUserInput) > 0)

    {

      $strSQLCurr .= ", ($strPreviousSQLFilteredByUserInput) o";

    }

    $strSQLCurr .= " WHERE r.kw_table_id = '{$_SESSION['TableID'][$TableNameUpper]}'";

    if (strlen($strPreviousSQLFilteredByUserInput) > 0)

    {

      $strSQLCurr .= " AND n.{$TableData[$i]['PREVIOUS_RECORD_ID_FIELD']} = o.record_id";

    }

    if ($isTechniquePage)

    {	$strSQLCurr .= " AND n.\"label_id\" = {$_SESSION['SAMPLING_POINT']['tissue_type_label_id']}";	}

    

  }



  //$strSQLCurr .= " ORDER BY table_name ASC";

  return $strSQLCurr;

 }





/**Function prints the checkboxes for this page. Checkboxes will be grouped by their

 * table name while displaying, if there are checkboxes from more than one table.

 * @param number $stepNumber The current Step number to print the form for.

 * @param string $currPageName The identifying name of the current page in the workflow.

 * @param string $nextPageName The identifying name of the next page in the workflow.

 * @param stringArray $labelNames The Array containing the names to be displayed

 * (in the frame containing all the checkboxes) for each of the tables.

*/



function fillCheckboxes($labelNames)

{

	global $currPageName, $nextPageName, $isTechniquePage;

  	$currPageNameLower = strtolower($currPageName);

  $currPageNameUpper = strtoupper($currPageName);

  $nextPageNameLower = strtolower($nextPageName);



  /*The CHECKBOX_INFO session variable contains an array of records. 

  Each record consists of 

  1) $_SESSION['CHECKBOX_INFO'][$chkBoxNo]['TABLE_NAME'] - The group (of table) which this

  checkbox belongs to and 

  2) $_SESSION['CHECKBOX_INFO'][$chkBoxNo]['NAME'] - The name to display on the front-end

  for this checkbox.

  3) $_SESSION['CHECKBOX_INFO'][$chkBoxNo]['TECHNIQUE_TYPE'] - ONLY ON THE TECHNIQUE page

  The name of the frame in which to display on the front-end for this checkbox.

  Finally, $_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT'] maintains the total count of all

  checkboxes

  */

  unset($_SESSION['CHECKBOX_INFO']);



	$strSQL = "SELECT table_name, record_id, name";

	if ($isTechniquePage)

	{

		$strSQL .= ", technique_type";

	}

	$strSQL .= " FROM ({$_SESSION[$currPageNameUpper]['QUERY']}) a" ;	

	if ($currPageNameUpper == 'SAMPLING_POINT')

	{	//do Nothing

	}

	elseif ($isTechniquePage)

	{	$strSQL .= " ORDER BY table_name, technique_type, name";	}

	else

	{	$strSQL .= " ORDER BY table_name, name";	}

	

  //print "Checkbox: $strSQL";

  $rst = $_SESSION['dbh']->query($strSQL);

  if (DB::isError($rst)) {

    printError("Error filling checkboxes. [" . $rst->getMessage() . "]" ); return;}

    

  if ($rst->numRows() == 0)

  {

		printMessage("No data available or No result from metadata query for $currPageName.");

	  	return;

  }



  $i = 0;

  $chkBoxNo = 0;

  $firstTable = 1;

     

  if ($isTechniquePage)

  {	print "<div class=\"technique-main-fieldset\">";	}

  else

  {	print "<div class=\"main-fieldset\">";	}

  

  $index = 0;

    while ($row = $rst->fetchRow())

    {

      if ($lastTableName != $row[0])

      {

        if (!$firstTable)

        {

          print "</p></div>";

          print "\n</fieldset>";

        }

        $i++;

        $key = "TABLE{$i}_LABEL";

        print "<fieldset>\n<legend><b>Select {$labelNames[$key]}(s)</b></legend>\n";

        print "\n<div class=\"selection-checkboxes\" align=\"center\"><p>";

        $firstTable = 0;

      }



      if ($lastTableName != $row[0] || $lastName != $row[2])

      {

        $_SESSION['CHECKBOX_INFO'][$chkBoxNo]['TABLE_NAME'] = $row[0];

        $_SESSION['CHECKBOX_INFO'][$chkBoxNo]['NAME'] = $row[2];

        if ($isTechniquePage)

        {	$_SESSION['CHECKBOX_INFO'][$chkBoxNo]['TECHNIQUE_TYPE'] = $row[3];	}

        

        if ($index == 0) 

        {	print "\n<table>\n\t<tr>";	} 

        

		$chkboxHTML[$index] .= "\n<input type=\"checkbox\" name=\"chkBox_{$chkBoxNo}\"";

        if (findIfChecked($currPageName, $row[0], $row[2]))

        {

          $chkboxHTML[$index] .= " checked";

        }

        if ('SAMPLING_POINT'== $currPageNameUpper AND 2 == $_SESSION['IS_REPLICATE_TRACK'])

        {	$chkboxHTML[$index] .= " onclick=\"checkOnlyOneClicked(this.form, this)\"";	}

        $chkboxHTML[$index] .= ">";

        if ('EXPERIMENT_SET'== $currPageNameUpper)

        {	

	        $chkboxHTML[$index] .= "<a href=\"queryMetadata.php?exp_set_id=" 

        		. urlencode($row[1]) . '&dontPrintFooter=1&windowSize=' . urlencode("800,600") 

        		. "\" target=\"_queryMetadata\">$row[2]</a>";	

        }

        elseif('EXPERIMENT'== $currPageNameUpper)

        {	

	        $chkboxHTML[$index] .= "<a href=\"queryMetadata.php?experiment_id=" 

	        	. urlencode($row[1]) . '&dontPrintFooter=1&windowSize=' . urlencode("800,600") 

	        	. "\" target=\"_queryMetadata\">$row[2]</a>";	

	    }

        else

        {	$chkboxHTML[$index] .= $row[2];	}

        $chkboxHTML[$index] .= "</input>";

        

        $lastTableName = $row[0];

        $lastName = $row[2];

        $chkBoxNo++;

        $index++;

        

      

     }

    }

    if ($isTechniquePage)

    {	

	    //if no of checkboxes is less than this number, they get placed one below 

	    //the other (vertically). Else they get placed horizontally. Also, if 

	    //$horizontalOnly is set to true, they always get placed horizontally.

	    $checkBoxFramesPerRow = 2;	

	    $horizontalOnly = true;

    }

    else

    {	$checkBoxesPerRow = 7;	}

    

    for ($i = 0, $chkBoxFrameNo = 0; $i < $index; $i++)

    {

	    if ($isTechniquePage)

	    {

	    	if ($_SESSION['CHECKBOX_INFO'][$i-1]['TECHNIQUE_TYPE'] != $_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'])

	    	//last technique_type is not same as the current technique_type - Means a new group is starting

	        {	

		        print "<td>";

		        printSearchByTechniqueTop($_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE']);	

		    }

			

		    print "$chkboxHTML[$i]<br/>";	

			

			if ($_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'] != $_SESSION['CHECKBOX_INFO'][$i+1]['TECHNIQUE_TYPE'])

			{

				printSearchByTechniqueBottom($_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'], $chkBoxFrameNo);

				print "</td>";	

				$chkBoxFrameNo++;

				if (fmod($chkBoxFrameNo, $checkBoxFramesPerRow) == 0)

		    	{	print "</tr>\n\t<tr>"; 	}

			}

	    }

	    else

	    {	

		    print "<td>$chkboxHTML[$i]</td>";	

		    if (!$horizontalOnly AND $index < $checkBoxesPerRow)

			{	print "</tr>\n\t<tr>";	}

	    	if (fmod(($i + 1), $checkBoxesPerRow) == 0)

	    	{  	print "</tr>\n\t<tr>"; 	}

		}

    }

	print "</tr>\n</table>";

	print "</p></div>";

	print "\n<div class=\"select-clear-bar\">";

	if (!('SAMPLING_POINT'== $currPageNameUpper AND 2 == $_SESSION['IS_REPLICATE_TRACK']))

	{

		print "\n\n<input type=\"button\" onClick=\"setAll(this.form, true)\" value=\"Select All\">";

		print "\n<input type=\"button\" onClick=\"setAll(this.form, false)\" value=\"Clear All\"><br />\n";

	}

	print "</div>";

	print "\n</fieldset>";

	

	$_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT'] = $chkBoxNo;

	print "</div><br />";

 }

 

function fillMapSelectionBox($selectionBoxSizeMultiplier)

{

  global $currPageName, $isTechniquePage;

  $currPageNameUpper = strtoupper($currPageName);

  

  if ($isTechniquePage)

  {

	if (!isset($_SESSION[$currPageNameUpper]['map_ids']))

	{	$_SESSION[$currPageNameUpper]['map_ids'] = array(0);	}

	  

	//Print Maps. 

/*	$sql = "SELECT DISTINCT m.\"map_id\", m.\"map_name\", m.\"map_type_id\"

		, mt.\"map_type_name\", UPPER(m.\"map_name\")

		FROM \"map\" m, \"map_component\" mc, map_type mt

		WHERE mc.map_id = m.map_id

		AND m.\"map_type_id\" = mt.map_type_id";

	if ($_SESSION['CurrentSpecieID'] > 0)

	{	$sql .= " AND mc.specie_id = {$_SESSION['CurrentSpecieID']}";	}

	$sql .= " ORDER BY m.\"map_type_id\", UPPER(m.\"map_name\")";

*/

  $sql = "SELECT DISTINCT m.\"map_id\", m.\"map_name\", m.\"map_type_id\", mt.\"map_type_name\", UPPER(m.\"map_name\")

		FROM \"map\" m, \"map_component\" mc, \"map_type\" mt, \"pathway_info\" pi

		WHERE mc.map_id = m.map_id

    AND m.\"map_type_id\" = mt.\"map_type_id\"

    AND mc.\"map_component_id\" = pi.\"map_component_id\"

    ORDER BY m.\"map_type_id\", UPPER(m.\"map_name\")";

	//print $sql;

	

	$sth = $_SESSION['dbh']->query($sql);

	if ( DB::isError($sth) ) 

	{	printError("Error retrieving Maps. " . $sth->getMessage());	return;	}

	print "\n<p><label>Maps: </label>";

	print "<select name=\"map_ids[]\"";

	print " size=\"" . 19 *$selectionBoxSizeMultiplier . "\" \"multiple\">";

	print "\n\t<option value=\"0\"";

	if (in_array('0', $_SESSION[$currPageNameUpper]['map_ids']))

	{	print " selected";	}

	print ">--Select One--</option>";

	while ($row = $sth->fetchRow()) 

	{

		if ($last_map_type_id != $row[2])

		{	

			if ($last_map_type_id > 0)

			{	print "\n</optgroup>";	}

			print "\n<optgroup label=\"$row[3]\">";

			$last_map_type_id = $row[2];

		}

		

		print "\n\t<option value=\"$row[0]\"";

		if (in_array($row[0], $_SESSION[$currPageNameUpper]['map_ids']))

		{	print " selected";	}

		print ">$row[1]</option>";

	}

	print "\n</optgroup>";

	print "\n</select></p>";

  }

}



/**Function that processes the user input (when the user hits Next> button).

* @param string $currPageName The identifying name of the current page in the workflow.

* @return boolean True if the user clicked at least one checkbox in each of

* the table frames.

*/

function processForm($currPageName)

{

	global $labelNames;

	$currPageNameUpper = strtoupper($currPageName);

	

	if (isset($_REQUEST['map_ids']))

	{	$_SESSION[$currPageNameUpper]['map_ids'] = $_REQUEST['map_ids'];	}

	if (isset($_REQUEST['tissue_type_label_id']))

	{	$_SESSION[$currPageNameUpper]['tissue_type_label_id'] = $_REQUEST['tissue_type_label_id'];	}

  //Set $_SESSION[$currPageNameUpper] variables

  $NoOfAtLeastOneCheckTables = 0;

  for ($i = 0; $i < $_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT']; $i++)

  {

    $key = "chkBox_{$i}";



    if ($_REQUEST[$key])

    {

      if ($lastTable != $_SESSION['CHECKBOX_INFO'][$i]['TABLE_NAME'])

      {

        $lastTable = $_SESSION['CHECKBOX_INFO'][$i]['TABLE_NAME'];

        $NoOfAtLeastOneCheckTables++;

        //Incremented when at least one checkbox is checked in a table.

      }

    }

    if (!setChecked($currPageName, $_SESSION['CHECKBOX_INFO'][$i]['TABLE_NAME'], $_SESSION['CHECKBOX_INFO'][$i]['NAME'], $_REQUEST[$key]))

    {

      printError("Error setting checks for CheckBox '{$_SESSION['CHECKBOX_INFO'][$i]['TABLE_NAME']}' and Name '{$_SESSION['CHECKBOX_INFO'][$i]['NAME']}'");

    }

  }



  $inputValid = !($NoOfAtLeastOneCheckTables < count($_SESSION[$currPageNameUpper]['TABLE_DATA']));

  

	if (!$inputValid)

	{

		$errMsg = "Please select at least one ";

		$firstLabel = 1;

		for ($i = 1; $i <= count($_SESSION[$currPageNameUpper]['TABLE_DATA']); $i++)

		{

			$key = "TABLE{$i}_LABEL";

			if (!$firstLabel)

			{	$errMsg .= "or ";	}

			$errMsg .= $labelNames[$key];

			$firstLabel = 0;

		}

		$_SESSION['errMsgs'][] = $errMsg;

		return 0;

	}

	if (strtoupper($currPageName) == 'TECHNIQUE' || strtoupper($currPageName) == 'TECHNIQUE_REPLICATE')

	{	

  		$TechniqueInputValid = processFormTechnique($currPageName);

  		return $TechniqueInputValid;

	}

	else

	{	return 1;	}



}





/**Unchecks all the checkboxes for the current page.

* @param string $currPageName The identifying name of the current page in the workflow.

*/

function setAllUnchecked($currPageName)

{

	$currPageNameUpper = strtoupper($currPageName);

	for ($i = 0; $i < $_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT']; $i++)

	{

		setChecked($currPageName, $_SESSION['CHECKBOX_INFO'][$i]['TABLE_NAME'], $_SESSION['CHECKBOX_INFO'][$i]['NAME'], "");

	}

}



/**Checks to see if at least one of the Record IDs corresponding to a checkbox with name $name

* has been set (in the frame for $TableName).

* @param string $currPageName The identifying name of the current page in the workflow.

* @param string $TableName The identifying name of one of the tables in the current page.

* @param string $name The name to check for.

* @return boolean 1 if found 0 if not found.

*/

function findIfChecked($currPageName, $TableName, $name)

{

  $currPageNameUpper = strtoupper($currPageName);

  $strSQL = "SELECT table_name, record_id, name FROM ({$_SESSION[$currPageNameUpper]['QUERY']}) a WHERE table_name = '$TableName' AND name = '$name'";

  $rst = $_SESSION['dbh']->query($strSQL);

  if (DB::isError($rst)) {printError("Error getting $currPageName. [" . $rst->getMessage() . "]" ); return;}

  while ($row = $rst->fetchRow())

  {

    if ($_SESSION[$currPageNameUpper][$TableName][$row[1]])

    {

      return 1;

    }

  }

  return 0;

}





/**Sets all the Record IDs corresponding to the checkbox (with name $name and belonging to the Table Frame $TableName) to the value in $value

* @param string $currPageName The identifying name of the current page in the workflow.

* @param string $TableName The Table name (or frame) the checkbox belongs to.

* @param string $name The name (label) of the checkbox.

* @param boolean $value The value to set the corresponding session varaible to.

*/

function setChecked($currPageName, $TableName, $name, $value = 1)

{

  $currPageNameUpper = strtoupper($currPageName);

  $strSQL = "SELECT table_name, record_id, name FROM ({$_SESSION[$currPageNameUpper]['QUERY']}) a WHERE table_name = '$TableName' AND name = '$name'";

  //print $strSQL;

  $rst = $_SESSION['dbh']->query($strSQL);

  if (DB::isError($rst)) {printError("Error getting $currPageName. [" . $rst->getMessage() . "]" ); return 0;}

  while ($row = $rst->fetchRow())

  {

    $_SESSION[$currPageNameUpper][$TableName][$row[1]] = $value;

    //printMessage("Setting :{$TableName}:{$name}:{$row[1]} to '{$value}'");

  }

  return 1;

}



/**This function is called only for the 'Technique' page. It prints the

* the HTML for displaying the front-end before the usual checkbox is dispalayed.

* @param string $chkboxName The identifying name of the checkbox around which the

* HTML needs to be output.

*/

function printSearchByTechniqueTop($chkboxName)

{

	echo "<fieldset>\n";

	echo "<legend>\n";

	echo "&nbsp;&nbsp;{$chkboxName}&nbsp;&nbsp;\n";

	echo "</legend>\n";

	echo "<br />\n";



}



/**This function is called only for the 'Technique' page. It prints the

* the HTML for displaying the front-end after the usual checkbox is dispalayed.

* @param string $chkboxGroup The identifying name of the checkbox group 

* for which the HTML needs to be output.

* @param number $chkboxNumber The index of this checkbox.

*/

function printSearchByTechniqueBottom($chkboxGroup, $chkboxNumber = 0)

{

	echo "<br />\n";

	switch (strtoupper($chkboxGroup))

	{

		case 'MRNA':

			$label = "Search by TC or Gene Name:";

			break;	

		

		case 'METABOLITE':

			$label = "Search by Compound Name:";

			break;	

			

		case 'PROTEIN':

			$label = "Search by Protein State or Spot No:";

			break;	

		default:

			$label = "Search:";

			break;	

  	}

  	printTechniqueSearchPage($chkboxGroup, $chkboxNumber, $label);

  	echo "<br />\n";

	echo "</fieldset>";

}



function printTechniqueSearchPage($chkboxGroup, $grpNumber, $label = "")

{

	global $currPageName;

	$currPageNameUpper = strtoupper($currPageName);

	

	if (strlen($_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT']) == 0)

	{

		$_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] = "like";

	}

	echo "\n<label>$label</label><br />";

	//echo "\n&nbsp;&nbsp;<textarea name=\"{$chkboxGroup}[NAMES]\" col=\"25\" rows=\"5\" onchange=\"setTechniqueCheckBox(this.form, $grpNumber)\">\n";

	echo "\n&nbsp;&nbsp;<textarea name=\"{$chkboxGroup}[NAMES]\" col=\"25\" rows=\"5\" >\n";

	if ($_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['NAMES']) 

	{

		echo "{$_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['NAMES']}";

	}   

	echo "</textarea></p>\n";

	 

	 //Now the radio buttons.

	echo "<br /><input type=\"radio\" name=\"{$chkboxGroup}[ISEXACT]\" value=\"like\"";

	if ($_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] && $_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] == "like") 

	{

		echo " checked";

	}

	echo " /> Approx match<br />\n";

	

	echo "<input type=\"radio\" name=\"{$chkboxGroup}[ISEXACT]\" value=\"exact\"";

	if ( $_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] == "exact") 

	{

	    echo " checked";

	} 

	echo " /> Exact match<br />\n";

	

	echo "<input type=\"radio\" name=\"{$chkboxGroup}[ISEXACT]\" value=\"browse\"";

	if ( $_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] == "browse") 

	{

	    echo " checked";

	} 

	echo " /> All Data<br />\n";

}





/**This function is called only for the 'Technique' page. It prints the

* the HTML for displaying the front-end after the usual checkbox is dispalayed.

* @param string $currPageName The identifying name of the current page in the workflow.

* @return number Returns 0 if there was an error and 1 if there was no error.

*/

function processFormTechnique($currPageName)

{

	$currPageNameUpper = strtoupper($currPageName);

	

	$map_ids = join(', ', $_SESSION[$currPageNameUpper]['map_ids']);



	$ret = -2;

	$atLeastOneSearchBoxFilled = false;

	for ($i = 0; $i < $_SESSION['CHECKBOX_INFO']['CHECKBOX_COUNT']; $i++)

	{

		$key = "chkBox_{$i}";

		if ($chkboxGroup != $_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'])

		{	//New Group Starts

			$chkboxGroup = $_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'];

			$atLeastOneInGroupClicked = false;

		}

		

		if ($_REQUEST[$key])

		{

			$atLeastOneInGroupClicked = true;

			$_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup] = $_REQUEST[$chkboxGroup];

			if (strlen($_REQUEST[$chkboxGroup]['NAMES']) > 0)

			{	$atLeastOneSearchBoxFilled = true;	}

		}

		if ($_SESSION['CHECKBOX_INFO'][$i]['TECHNIQUE_TYPE'] != $_SESSION['CHECKBOX_INFO'][$i+1]['TECHNIQUE_TYPE'])

		{	//Last element of this group.

			if (!$atLeastOneInGroupClicked)

			{

				unset($_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]);	

			}

		}

	}

	

	$atLeastOneBrowse = false;

	$chkboxGroups = array_keys($_SESSION[$currPageNameUpper]['DATA']);

	foreach ($chkboxGroups as $chkboxGroup)

	{

		if ($_SESSION[$currPageNameUpper]['DATA'][$chkboxGroup]['ISEXACT'] == 'browse')

		{	$atLeastOneBrowse = true;	}

	}

	if (!($atLeastOneSearchBoxFilled OR $atLeastOneBrowse OR '0' != $map_ids))

	{	$_SESSION['errMsgs'][] ="All search boxes empty and no 'All Data' or maps selected.";	}



	if ($_SESSION['errMsgs'])

	{	return 0;	}

	else

	{	return 1;	}

}

?>

