#!/usr/local/bin/perl

use DBI;
use DOMELIB;
use strict "vars";

#===============================================================================
# This script will update all search_names in allnames if the search_name do not
# satisfy our searc_name criteria. i.e. space, comma, dash are not taken out
# from aname.
#
# X. Jing Li
# 11/03/2006.
#==============================================================================
my ($database, $username, $password, $bnet_DB, $specieDB, $logfile, $dbh, $sql, $sth, $rc, $sth1, $rc1, $name_id, $kwid, $rid, $name, $sname, $search_name);

#== connect to the database:
($database, $username, $password, $bnet_DB, $specieDB) = database_login2();
$dbh = DBI->connect($database,$username,$password) or die " Can't connect to $database:$DBI::errstr.";
$dbh->begin_work;
$sql = "set search_path to \"$bnet_DB\"";
$sth = $dbh-> prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";

#== open output file:
$logfile = "./tmp-plots/updateSearchNamesInAllnames.log";
open (OUT, ">$logfile") or die "Can not open log file $logfile. $!";
print OUT "kw_table_id\trecord_id\taname\told search_name\tnew search_name\n";

#== get aname, search_name from allnames:
$sql = "select name_id, kw_table_id, record_id, aname, search_name from allnames order by kw_table_id";
$sth = $dbh-> prepare($sql) or die "Can't prepare: $DBI::errstr.";
$rc = $sth->execute or die "Can't execute: $DBI::errstr.";
while (($name_id, $kwid, $rid, $name, $sname) = $sth->fetchrow()) {
    $sname =~ s/\,//g;
    $search_name = getSearchName($name);
    if ($sname ne $search_name) {
        #print OUT "$kwid\t$rid\t$name\t$sname\t$search_name\n";
        $search_name =~ s/\'/\'\'/g;
        $sql = "update allnames set search_name = \'$search_name\' where name_id = $name_id";
        print OUT "$sql\n";
        $sth1 = $dbh-> prepare($sql) or die "Can't prepare: $DBI::errstr.";
        $rc1 = $sth1->execute or die "Can't execute: $DBI::errstr.";
    }
}
close OUT;
$sth1->finish;
$sth->finish;
#$dbh->rollback;
$dbh->commit;
$dbh->disconnect;
exit;
