<?php
/**
* This script is a Front-End for deleting Metadata for ANY table
* directly to the DOME database. It uses a data structure called $fieldsInfo.
* $fieldsInfo is an array of an array with each row consisting of 
* name, type, size, maxsize, required. This information is stored in dataForTables.php file.
* Date: 26 Apr 2005
* @author Aejaaz Kamal <aekamal@vt.edu>
*/

include_once("common.php");
include_once("paging.php");
if ($_REQUEST['currPageName'])
{	$_SESSION['currPageName'] = $_REQUEST['currPageName'];	}
if (!$_SESSION['currPageName'])
{	printError("currPageName not set.");	}
else
{	$currPageName = $_SESSION['currPageName'];	}
$currPageNameUpper = strtoupper($currPageName);
if (isset($_REQUEST['callingPage']))
{	$_SESSION[$currPageNameUpper]['callingPage'] = $_REQUEST['callingPage'];	}
else
{	unset($_SESSION[$currPageNameUpper]['callingPage']);	}

include_once("dataForTables.php");

?>

<?php

include("header.php");
if (strtoupper($_SESSION['role']) != 'MANAGER')
{	printError("You are not authorized to view this page. Your role level should be 'manager' to view this page.");	exit();}
?>
<script type="text/javascript">
function confirmSubmit()
{
var agree=confirm("Are you sure you wish to continue deleting?");
if (agree)
	return true ;
else
	return false ;
}
</script>
<?php
if ($_REQUEST['submit'])
{	processForm();	}
if ($errMsgs)
{  
	foreach ($errMsgs as $msg)
	{	printError($msg);	}
}
if ($_SESSION['Message'])
{  
	foreach ($_SESSION['Message'] as $msg)
	{	printMessage($msg);	}
	unset($_SESSION['Message']);
}

switch(strtoupper($currPageName))
{
case 'REFERENCE':
	$results_per_page = 100;
	break;
case 'SAMPLING_REPLICATE':
case 'ADD_SAMPLING_POINT':
	$results_per_page = 50;
	break;
default:
	$results_per_page = 10;
	break;
}
if ($_REQUEST['page_no'] > 0)
{   $page_no = $_REQUEST['page_no'];    }
else
{   $page_no = 1;   }
$offset = ($page_no - 1) * $results_per_page;

fillForm($offset, $page_no, $results_per_page);

include_once("footer.php");
?>

<?php
//Functions
function fillForm($offset, $page_no, $results_per_page = 50)
{
	global $currPageName, $fieldsInfo, 
		$nameOfTable, $nameOfIDField, $nameOfDisplayedField, $tableLabel, $sortField;
	$currPageNameUpper = strtoupper($currPageName);
	$self = $_SERVER[PHP_SELF];
	
	$sql = "SELECT \"$nameOfIDField\"";
	if ($currPageNameUpper == 'SAMPLING_REPLICATE' OR $currPageNameUpper == 'ADD_SAMPLING_POINT')
	{	
		$sql .= ", \"experiment_set\".\"exp_set_name\", \"experiment\".\"exp_name\", \"label\".\"name\"";	
		if ($currPageNameUpper == 'ADD_SAMPLING_POINT')
		{	$sql .= ", \"label\".\"order\"";	}
	}
	
	foreach($fieldsInfo as $key=>$fieldRow)
	{
		$type = $fieldRow['type'];
		if ($type == 'id')
		{
			if (!$fieldRow['table'])
			{	
				$fieldsInfo[$key]['table'] = "t_{$key}";	
				$fieldRow['table'] = "t_{$key}";
			}
			if (!$fieldRow['IDField'])
			{	
				$fieldsInfo[$key]['IDField'] = 'id_field';	
				$fieldRow['IDField'] = 'id_field';	
			}
			if (!$fieldRow['displayField'])
			{	
				$fieldsInfo[$key]['displayField'] = 'display_field';	
				$fieldRow['displayField'] = 'display_field';	
			}
			
			$ForeignKeyRows[] = $fieldRow;
			$sql .= ", \"{$fieldRow['table']}\".\"{$fieldRow['displayField']}\"";

		}
		else
		{
			$name = $fieldRow['name'];
			$sql .= ", \"$name\"";
		}
	}
	$sql .= " FROM \"$nameOfTable\"";
	if ($currPageNameUpper == 'SAMPLING_REPLICATE' OR $currPageNameUpper == 'ADD_SAMPLING_POINT')
	{	
		$sql .= ", \"experiment_set\", \"experiment\", \"label\"";	
		if ($currPageNameUpper == 'SAMPLING_REPLICATE')
		{	$sql .= ", \"sampling_point\""; 	}
	}
	if ($ForeignKeyRows)
	{
		//tables
		foreach($ForeignKeyRows as $ForeignKeyRow)
		{	
			if ($ForeignKeyRow['sql'])
			{	$sql .= ", ({$ForeignKeyRow['sql']}) {$ForeignKeyRow['table']}";	}
			else
			{	$sql .= ", {$ForeignKeyRow['table']}";		}
		}
		//joins
		foreach($fieldsInfo as $fieldRow)
		{
			if ($fieldRow['type'] == 'id')
			{
				if (!$whereDone)
				{	$sql .= " WHERE";	$whereDone = true;	}
				else
				{	$sql .= " AND";	}
				
				$sql .= " \"$nameOfTable\".\"{$fieldRow['name']}\" = \"{$fieldRow['table']}\".\"{$fieldRow['IDField']}\"";	
			}
		}
	}
	
	if ('TISSUE_TYPE' == $currPageNameUpper)
	{	
		if (!$whereDone)
		{	$sql .= " WHERE";	$whereDone = true;	}
		else
		{	$sql .= " AND";	}
		$sql .= " \"$nameOfTable\".\"kw_table_id\" = {$_SESSION['TableID']['SAMPLE']}";	
	}
	elseif ('SPOTTED_ARRAY_DESIGN' == $currPageNameUpper)
	{	$sql .= " WHERE UPPER(\"platform_technology\") IN ('SPOTTED DNA/CDNA', 'SPOTTED OLIGONUCLEOTIDE')";	}
	elseif ('AFFYMETRIX_ARRAY_DESIGN' == $currPageNameUpper)
	{	$sql .= " WHERE UPPER(\"platform_technology\") = 'IN SITU OLIGONUCLEOTIDE'";	}
	elseif ('SAMPLING_REPLICATE' == $currPageNameUpper OR 'ADD_SAMPLING_POINT' == $currPageNameUpper)
	{	
		if (!$whereDone)
		{	$sql .= " WHERE";	$whereDone = true;	}
		else
		{	$sql .= " AND";	}
		$sql .= " \"experiment_set\".\"exp_set_id\" = \"experiment\".\"exp_set_id\" 
			AND \"experiment\".\"experiment_id\" = \"sampling_point\".\"experiment_id\" 
			AND \"sampling_point\".\"label_id\" = \"label\".label_id";
		if ($currPageNameUpper == 'SAMPLING_REPLICATE')
		{	$sql .= " AND \"sampling_point\".\"sampling_point_id\" = \"sampling_replicate\".\"sampling_point_id\"";	}
	}
	
	if ($sortField)
	{	$sql .= " ORDER BY $sortField";	}	
	elseif ($nameOfDisplayedField)
	{	$sql .= " ORDER BY UPPER(\"$nameOfDisplayedField\")";	}
	else
	{	$sql .= " ORDER BY \"$nameOfIDField\"";	}
	
	$sqlExec .= $sql . " LIMIT $results_per_page OFFSET $offset";
	//print $sqlExec;
	$sth = $_SESSION['dbh']->query($sqlExec);
	if ( DB::isError($sth) ) 
	{	
		printError("Error reading from $nameOfTable. " . $sth->getMessage());	
		return 0;	
	}
	
	//Print Table
	print "\n<p><label>$tableLabel: </label></p>";
	print "\n<table><tr><th>Operation</th>";
	if ($currPageNameUpper == 'SAMPLING_REPLICATE' OR $currPageNameUpper == 'ADD_SAMPLING_POINT')
	{	
		print "<th>Experiment Set</th><th>Experiment</th><th>Sampling Point</th>";	
		if ($currPageNameUpper == 'ADD_SAMPLING_POINT')
		{	print"<th>Order</th>";	}
	}
	foreach($fieldsInfo as $fieldRow)
	{
		if ($fieldRow['type'] != 'hidden')
		{
			$label = $fieldRow['label'];
			print "<th>$label</th>";
		}
	}
	print "</tr>\n";
	$cl = 'dark-row';
	while($row = $sth->fetchRow())
	{
		if ($cl == 'dark-row')
		{	$cl = 'light-row';	}
		else
		{	$cl = 'dark-row';	}
		$i = 0;
		
		print "<tr class=\"$cl\"><td>";
		print "<form name=\"{$row[0]}_operation\" method=\"post\" action=\"$self\">\n";
		print "<input type=\"hidden\" name=\"id\" value=\"$row[0]\" />";
		print "<input type=\"submit\" name=\"submit\" value=\"Delete\" onclick=\"return confirmSubmit()\" />";
		if ($currPageNameUpper != 'ADD_SAMPLING_POINT')
		{	print "<input type=\"submit\" name=\"submit\" value=\"Edit\" />";	}
		print "</form>";
		print "</td>";
		
		
		if ($currPageNameUpper == 'SAMPLING_REPLICATE' OR $currPageNameUpper == 'ADD_SAMPLING_POINT')
		{	
			$i++; print "<td>$row[$i]</td>";
			$i++; print "<td>$row[$i]</td>";
			$i++; print "<td>$row[$i]</td>";
			if ($currPageNameUpper == 'ADD_SAMPLING_POINT')
			{	$i++; print "<td>$row[$i]</td>";	}
		}
		foreach($fieldsInfo as $fieldRow)
		{
			$i++;
			$type = $fieldRow['type'];
			
			if ($type == 'password')
			{	
				print "<td>";
				$len = strlen($row[$i]);
				for ($j = 0; $j < $len; $j++)
				{	print "*";		}
				print "</td>";
			}
			elseif ($type == 'hidden')
			{	//skip field
			}
			else
			{	
				print "<td>$row[$i]</td>";	
			}
		}
		print "</tr>\n";
	}
	print "</table>";	
	
	
	//Getting Total count.
	$sqlCount = "SELECT count(*) FROM ($sql) a";
	$sth = $_SESSION['dbh']->query($sqlCount);
	if ( DB::isError($sth) ) 
	{	
		printError("Error getting count from $nameOfTable. " . $sth->getMessage());	
		return 0;	
	}
	$row = $sth->fetchRow();
	$totCount = $row[0];
	//Printing Paging links.
	$self = $_SERVER['PHP_SELF'];
	$pre_href = "$self?currPageName=$currPageNameUpper&page_no=";
	$post_href = "";
	print navigation($pre_href, $post_href, $totCount, $results_per_page,  $page_no);
	if ('BNetMenu.php' == $_SESSION[$currPageNameUpper]['callingPage'])
	{	print "<p><a href=\"./{$_SESSION[$currPageNameUpper]['callingPage']}\">< Back to BNet Menu</a></p>";	} 
	else
	{	print "<p><a href=\"./viewEditMetaDataMenu.php\">< Back to View/Edit Metadata Menu</a></p>";	} 

}

/**============================
* Request Functions
*============================*/
function processForm()
{
	global $errMsgs, $currPageName, $fieldsInfo;
	$currPageNameUpper = strtoupper($currPageName);
	
	$operation = $_REQUEST['submit'];
	$id = $_REQUEST['id'];
	if (strtoupper($operation) == 'DELETE')
	{	deleteFromTable($id);	}
	elseif (strtoupper($operation) == 'EDIT')
	{	editFromTable($id);	}
	
	if ($errMsgs)
	{	return 0;	}
	return 1;
}


function deleteFromTable($id)
{
	global $errMsgs, $currPageName, $fieldsInfo, $nameOfTable, $nameOfIDField;
	$currPageNameUpper = strtoupper($currPageName);
	
	//Begin Tranx
	$sth = $_SESSION['dbh']->query("BEGIN TRANSACTION");
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error starting transaction. " . $sth->getMessage();	
		return 0;	
	}
	if ($currPageNameUpper == 'ADD_SAMPLING_POINT')
	{
		//check for any rows pointing to label.
		$sql = "SELECT * FROM \"sampling_point\" 
			WHERE \"label_id\" = (SELECT \"label_id\" FROM \"sampling_point\"
				WHERE \"sampling_point_id\" = $id)
			AND \"sampling_point_id\" != $id";
		//print $sql;

		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error checking for label_ids for  $nameOfTable. " . $sth->getMessage();	
			$sth = $_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		if ($sth->numRows() == 0)
		{
			$sql = "DELETE FROM \"label\" WHERE \"label_id\" = (SELECT \"label_id\" FROM \"sampling_point\" WHERE \"sampling_point_id\" = $id)";
			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	
				$errMsgs[] = "Error deleting label_id for this $nameOfTable. " . $sth->getMessage();
				$sth = $_SESSION['dbh']->query("ROLLBACK");
				return 0;	
			}
		}
	}
	elseif ($currPageNameUpper == 'PROTOCOL_TYPE')
	{
		$sql = "SELECT \"method\" FROM \"$nameOfTable\" WHERE \"$nameOfIDField\" = $id";
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			$errMsgs[] = "Error checking for method type while deleting from $nameOfTable. " . $sth->getMessage();	
			$sth = $_SESSION['dbh']->query("ROLLBACK");
			return 0;	
		}
		$row = $sth->fetchRow();
		if (strtoupper($row[0]) == 'STATISTICAL')
		//Delete the corresponding "mean" row from "protocol" table which was 
		//added during new protocol_type addition.
		{
			$sql = "DELETE FROM \"protocol\" WHERE \"protocol_type_id\" = $id AND UPPER(\"protocol_name\") = 'MEAN'";
			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	
				$errMsgs[] = "Error deleting 'mean' protocol while deleting from $nameOfTable for protocol_type_id '$id'. " . $sth->getMessage();	
				$sth = $_SESSION['dbh']->query("ROLLBACK");
				return 0;	
			}
			
			//Check for other protocol_names if Statistical protocol_type.
			$sql = "SELECT * FROM \"protocol\" WHERE \"protocol_type_id\" = $id AND UPPER(\"protocol_name\") != 'MEAN'";
			$sth = $_SESSION['dbh']->query($sql);
			if ( DB::isError($sth) ) 
			{	
				$errMsgs[] = "Error checking for other protocols while deleting from $nameOfTable for protocol_type_id '$id'. " . $sth->getMessage();	
				$sth = $_SESSION['dbh']->query("ROLLBACK");
				return 0;	
			}
			if ($sth->numRows() > 0)
			{
				$errMsgs[] = "There are 'Statistical Test' related to this protocol in the database. Please delete them first.";
				$sth = $_SESSION['dbh']->query("ROLLBACK");
				return 0;	
			}
		}
	}
	
	//Delete the row from the table with the given id.
	$sql = "DELETE FROM \"$nameOfTable\" WHERE \"$nameOfIDField\" = $id"; 
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		$errMsgs[] = "Error Deleting from $nameOfTable. " . $sth->getMessage();	
		$sth = $_SESSION['dbh']->query("ROLLBACK");
		return 0;	
	}
	$sth = $_SESSION['dbh']->query("COMMIT");
	printMessage("Record with ID '$id' successfully deleted from $nameOfTable.");
	//unset($_SESSION[$currPageNameUpper]);
	
	if ($errMsgs)
	{	return 0;	}
	return 1;
}

function editFromTable($id)
{
	global $errMsgs, $currPageName, 
	$fieldsInfo, $nameOfTable, $nameOfIDField;
	$currPageNameUpper = strtoupper($currPageName);	
	if ($currPageNameUpper == 'SAMPLING_REPLICATE')
	{
		$sql = "SELECT es.\"exp_set_id\", e.\"exp_name\", l.\"name\" 
			FROM \"experiment_set\" es, \"experiment\" e, \"sampling_point\" sp, \"sampling_replicate\" sr, \"label\" l
			WHERE sr.\"sampling_replicate_id\" = $id
			AND sp.\"sampling_point_id\" = sr.\"sampling_point_id\"
			AND e.\"experiment_id\" = sp.\"experiment_id\"
			AND es.\"exp_set_id\" = e.\"exp_set_id\"
			AND sp.\"label_id\" = l.\"label_id\"";	
		//print $sql;
		$sth = $_SESSION['dbh']->query($sql);
		if ( DB::isError($sth) ) 
		{	
			printError("Error reading from extra tables for $nameOfTable. " . $sth->getMessage());	
			return 0;	
		}
		if ($sth->numRows() == 0)
		{	
			$errMsgs[] = "$nameOfIDField '$id' not found in extra tables for '$nameOfTable'";	
			return 0;
		}
		else
		{	
			$row = $sth->fetchRow();
			$_SESSION[$currPageNameUpper]['experiment_set_id'] = $row[0];
			$_SESSION[$currPageNameUpper]['exp_name'] = $row[1];
			$_SESSION[$currPageNameUpper]['sampling_point_label'] = $row[2];
		}
	}
	
	
	$sql = "SELECT \"$nameOfIDField\"";
	foreach($fieldsInfo as $fieldRow)
	{
		$name = $fieldRow['name'];
		$sql .= ", \"$name\"";
	}
	$sql .= " FROM \"$nameOfTable\" WHERE \"$nameOfIDField\" = $id";
	//print $sql;
	$sth = $_SESSION['dbh']->query($sql);
	if ( DB::isError($sth) ) 
	{	
		printError("Error reading from $nameOfTable. " . $sth->getMessage());	
		return 0;	
	}
	if ($sth->numRows() == 0)
	{	
		$errMsgs[] = "$nameOfIDField '$id' not found in table '$nameOfTable'";	
		return 0;
	}
	else
	{	
		$row = $sth->fetchRow();
		$_SESSION[$currPageNameUpper][$nameOfIDField] = $id;
		$i = 1;
		foreach($fieldsInfo as $fieldRow)
		{
			$name = $fieldRow['name'];
			$_SESSION[$currPageNameUpper][$name] = $row[$i];
			$i++;
		}
	}
	print "<meta http-equiv=\"refresh\" content=\"0; URL=addTable.php?currPageName=$currPageNameUpper&mode=EDIT\">";
	exit();
}

?>
