<?php
/**
* This file contains the workflow which the front-end will follow.
* Changing this changes the steps the front-end will go through.
* Date: 3 Sept 2003
* @author Aejaaz Kamal <aekamal@vt.edu>
* @updated: Dec. 12, 2003, X. Jing Li
*/



/**Sets the "environment" variables for the step number specified by
* $stepNumber variable.
* @param number $stepNumber The number of the step to set the environment
* variables to.
*/
function setVariables($stepNumber)
{
  global $prevPageName, $currPageName, $nextPageName, $labelNames, $help_tip, 
  	$searchGeneKey, $techniqueKey, $fields, $currPageFile;
  

  $help_tip = '';
  
  switch($stepNumber)
  {
    
	case '1':
	  $prevPageName = "";
      $currPageName = "intro";
	  $currPageFile = "intro.php";
      $_SESSION['TOTAL_STEPS'] = 7;	
	  break;
	  
	case '1:1': //Following are the environment variables for step number 2.
    case '1:2': 
    case '1:13': 
      $help_tip = "Please select the experiment_set. You can choose more than one experiment_set if they exist.";
      $prevPageName = "intro"; //The unique string associated with the previous page.
                          //(Note that all caps will be used for all identifying strings.)
      $currPageName = "experiment_set"; //The unique string associated with the current page.
      $nextPageName = "experiment"; //The unique string associated with the page going to.
      $currPageFile = $_SESSION['STEP_FILE_NAME'];
        //The filename of the page coming from
        //$_SESSION['STEP_FILE_NAME'] variable contains the file name of the step.php file.
        //(The filename is set dynamically so that even if the step.php filename is renamed
        //the system works).
      $labelNames['PAGE_LABEL'] = "Experiment Set";
        //String to be displayed in the header section of this step page.
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
        //String to be displayed as the title of the frame for first table.
      $labelNames['TABLE2_LABEL'] = "Experiment Set";
        //String to be displayed as the title of the frame for second table
        //(In case there is more than one table in a single page).
        //Set this variable to the total number of steps in the workflow.
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
      
    case '1:3':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_METABOLOMICS";
	  $currPageFile = "addDataMetabolomics.php";
      $_SESSION['TOTAL_STEPS'] = 3;	
	  break;
	
	case '1:4':
      $prevPageName = "intro";
      $currPageName = "merge_compounds";
	  $currPageFile = "mergeCompounds.php";
      $_SESSION['TOTAL_STEPS'] = 3;	
	  break;
	
	case '1:5':
      $prevPageName = "intro";
      $currPageName = "send_updates";
	  $currPageFile = "sendUpdates.php";
      $_SESSION['TOTAL_STEPS'] = 2;	
	  break;
	
	case '1:6':
      $prevPageName = "intro";
      $currPageName = "process_updates";
	  $currPageFile = "processUpdates.php";
      $_SESSION['TOTAL_STEPS'] = 3;	
	  break;

	case '1:7':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_METABOLOMICS";
	  $currPageFile = "addDataMetabolomics.php";
      $_SESSION['TOTAL_STEPS'] = 3;	
	  break;
	case '1:8':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_MICROARRAY";
	  $currPageFile = "addDataMicroarray.php";
      $_SESSION['TOTAL_STEPS'] = 3;	
	  break;
	case '1:9':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_METABOLOMICS";
	  $currPageFile = "addDataMetabolomics.php";
      $_SESSION['TOTAL_STEPS'] = 3;		  
      break;
      
	case '1:10':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_METABOLOMICS";
	  $currPageFile = "addDataMetabolomics.php";
      $_SESSION['TOTAL_STEPS'] = 3;		  
      break;
      
   case '1:12':
      $prevPageName = "intro";
      $currPageName = "ADD_DATA_AFFY";
	  $currPageFile = "addDataAffy.php";
      $_SESSION['TOTAL_STEPS'] = 3;		  
      break;
	  
	case '1:1:1': 
    case '1:2:1': 
    case '1:13:1': 
    	$help_tip = "Please select the experiments. The experiment list is based on the set of experiment_sets you had selected in the previous page. You can choose more than one experiments if they exist.";
      $prevPageName = "experiment_set"; //The unique string associated with the previous page.
                          //(Note that all caps will be used for all identifying strings.)
      $currPageName = "experiment"; //The unique string associated with the current page.
      $nextPageName = "sampling_point"; //The unique string associated with the page going to.
      $currPageFile = $_SESSION['STEP_FILE_NAME'];
        //The filename of the page coming from
        //$_SESSION['STEP_FILE_NAME'] variable contains the file name of the step.php file.
        //(The filename is set dynamically so that even if the step.php filename is renamed
        //the system works).
      $labelNames['PAGE_LABEL'] = "Experiment";
        //String to be displayed in the header section of this step page.
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
        //String to be displayed as the title of the frame for first table.
      
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;  
      
	case '1:6:1':
      $prevPageName = "process_updates";
      $currPageName = "process_updates_top";
	  $currPageFile = "processUpdatesTop.php";
      $_SESSION['TOTAL_STEPS'] = 4;	
	  break;

    case '1:1:1:1':
    case '1:2:1:1':
      $help_tip = "Please select the sampling_points. These sampling_points are for the corresponding experiments you chose in the previous page. You can choose more than one sampling_points if they exist.";
      $prevPageName = "experiment";
      $currPageName = "sampling_point";
      $nextPageName = "technique";
	  $currPageFile = $_SESSION['STEP_FILE_NAME'];
      $labelNames['PAGE_LABEL'] = "Sampling Point";
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
      $_SESSION['TOTAL_STEPS'] = 7;	
      break;
      
	case '1:13:1:1':
      $help_tip = "Please select the sampling_points. These sampling_points are for the corresponding experiments you chose in the previous page. You can choose more than one sampling_points if they exist.";
      $prevPageName = "experiment";
      $currPageName = "sampling_point";
      $nextPageName = "raw_data_files";
	  $currPageFile = $_SESSION['STEP_FILE_NAME'];
      $labelNames['PAGE_LABEL'] = "Sampling Point";
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
      $_SESSION['TOTAL_STEPS'] = 6;	
      break;

    case '1:1:1:1:1':
      $prevPageName = "sampling_point";
      $currPageName = "technique";
	  $currPageFile = $_SESSION['STEP_FILE_NAME'];
      $labelNames['PAGE_LABEL'] = "Technique";
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
      $_SESSION['TOTAL_STEPS'] = 7;	
      break;

	case '1:2:1:1:1':
      $prevPageName = "sampling_point";
      $currPageName = "technique_replicate";
	  $currPageFile = $_SESSION['STEP_FILE_NAME'];
      $labelNames['PAGE_LABEL'] = "Technique";
      $labelNames['TABLE1_LABEL'] = $labelNames['PAGE_LABEL'];
      $_SESSION['TOTAL_STEPS'] = 7;	
      break;
    
	case '1:6:1:1':
      $prevPageName = "process_updates_top";
      $currPageName = "process_updates_right";
	  $currPageFile = "processUpdatesRight.php";
      $_SESSION['TOTAL_STEPS'] = 4;	
	  break;  
	
	case '1:13:1:1:1':
      
      $prevPageName = "sampling_point";
      $currPageName = "raw_data_files";
	  $currPageFile = "rawDataFiles.php";
      $_SESSION['TOTAL_STEPS'] = 6;	
      break;
     
	case '1:1:1:1:1:1': 
		$prevPageName = "technique"; 
      $currPageName = "searchgene"; 
      $currPageFile = "searchGene.php";
      $_SESSION['TOTAL_STEPS'] = 7;	
	  break;
	  
	case '1:2:1:1:1:1':
      $prevPageName = "technique_replicate"; 
      $currPageName = "searchgene_replicate"; 
      $currPageFile = "searchGene.php";
      $_SESSION['TOTAL_STEPS'] = 7;	
	  break;
	
	case '1:13:1:1:1:1':
      
      $prevPageName = "raw_data_files";
      $currPageName = "PRODUCE_ZIP_FILE";
	  $currPageFile = "produceZipFile.php";
      $_SESSION['TOTAL_STEPS'] = 6;	
      break;

	case '1:1:1:1:1:1:1':
      $prevPageName = "searchgene";
      $currPageName = "searchGeneResults";
	  $currPageFile = "doTableOutput.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
	case '1:2:1:1:1:1:1':
      $prevPageName = "searchgene_replicate";
      $currPageName = "searchGeneResults_replicate";
	  $currPageFile = "doTableOutput.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
   case '1:1:1:1:1:1:2':
      $prevPageName = "searchgene";
      $currPageName = "searchGeneResults";
	  $currPageFile = "doFileOutput.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
	case '1:2:1:1:1:1:2':
      $prevPageName = "searchgene_replicate";
      $currPageName = "searchGeneResults_replicate";
	  $currPageFile = "doFileOutput.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
	case '1:1:1:1:1:1:3':
      $prevPageName = "searchgene";
      $currPageName = "dognuplot";
	  $currPageFile = "doGNUPlot.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;
	case '1:2:1:1:1:1:3':
      $prevPageName = "searchgene_replicate";
      $currPageName = "dognuplot_replicate";
	  $currPageFile = "doGNUPlot.php";
	  $_SESSION['TOTAL_STEPS'] = 7;	
      break;    
	case '1:1:1:1:1:1:4':
	  $prevPageName = "searchgene";
      $currPageName = "KMEANS";
	  $currPageFile = "doKMeansClustering.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
	case '1:2:1:1:1:1:4':
      $prevPageName = "searchgene_replicate";
      $currPageName = "KMEANS_REPLICATE";
	  $currPageFile = "doKMeansClustering.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
  	case '1:1:1:1:1:1:5':
  	case '1:2:1:1:1:1:5':
      $prevPageName = "searchgene";
      $currPageName = "doMaps";
	  $currPageFile = "doMaps.php";
	  $_SESSION['TOTAL_STEPS'] = 9;	
      break;
	case '1:1:1:1:1:1:6':
	  $prevPageName = "searchgene";
      $currPageName = "PCA";
	  $currPageFile = "doPCA.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
	  break;
	case '1:2:1:1:1:1:6':
	  $prevPageName = "searchgene_replicate";
      $currPageName = "PCA_REPLICATE";
	  $currPageFile = "doPCA.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
	  break;
	case '1:1:1:1:1:1:7':
          $prevPageName = "searchgene";
		$currPageName = "FA";
          $currPageFile = "doFA.php";
          $_SESSION['TOTAL_STEPS'] = 8;
          break;
	case '1:2:1:1:1:1:7':
          $prevPageName = "searchgene_replicate";
		$currPageName = "FA_REPLICATE";
          $currPageFile = "doFA.php";
          $_SESSION['TOTAL_STEPS'] = 8;
          break;
	case '1:1:1:1:1:1:8':
          $prevPageName = "searchgene";
		$currPageName = "NMF";
          $currPageFile = "doNMF.php";
          $_SESSION['TOTAL_STEPS'] = 8;
          break;
	case '1:2:1:1:1:1:8':
          $prevPageName = "searchgene_replicate";
		$currPageName = "NMF_REPLICATE";
          $currPageFile = "doNMF.php";
          $_SESSION['TOTAL_STEPS'] = 8;
          break;
	case '1:1:1:1:1:1:9':
	  $prevPageName = "searchgene";
      $currPageName = "BIPLOT";
	  $currPageFile = "doBiplot.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
	  break;
	case '1:2:1:1:1:1:9':
	  $prevPageName = "searchgene_replicate";
      $currPageName = "BIPLOT_REPLICATE";
	  $currPageFile = "doBiplot.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
	  break;
   case '1:1:1:1:1:1:4:1':
     $prevPageName = "KMEANS";
      $currPageName = "KMEANS_RESULTS";
	  $currPageFile = "KMeansClusteringResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
   case '1:2:1:1:1:1:4:1':
      $prevPageName = "KMEANS_REPLICATE";
      $currPageName = "KMEANS_RESULTS_REPLICATE";
	  $currPageFile = "KMeansClusteringResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
	
    case '1:1:1:1:1:1:5:1':
	case '1:2:1:1:1:1:5:1':   
		$prevPageName = "doMaps";
		$currPageName = "Map_Parameters";
		$currPageFile = "mapParameters.php";
		$_SESSION['TOTAL_STEPS'] = 9;
		break;
	
   case '1:1:1:1:1:1:6:1':
     $prevPageName = "PCA";
      $currPageName = "PCA_RESULTS";
	  $currPageFile = "PCAResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
   case '1:2:1:1:1:1:6:1':
      $prevPageName = "PCA_REPLICATE";
      $currPageName = "PCA_RESULTS_REPLICATE";
	  $currPageFile = "PCAResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;

   case '1:1:1:1:1:1:7:1':
     $prevPageName = "FA";
      $currPageName = "FA_RESULTS";
          $currPageFile = "FAResults.php";
          $_SESSION['TOTAL_STEPS'] = 8;
      break;
   case '1:2:1:1:1:1:7:1':
      $prevPageName = "FA_REPLICATE";
      $currPageName = "FA_RESULTS_REPLICATE";
          $currPageFile = "FAResults.php";
          $_SESSION['TOTAL_STEPS'] = 8;
      break;
   case '1:1:1:1:1:1:8:1':
     $prevPageName = "NMF";
      $currPageName = "NMF_RESULTS";
          $currPageFile = "NMFResults.php";
          $_SESSION['TOTAL_STEPS'] = 8;
      break;
   case '1:2:1:1:1:1:8:1':
      $prevPageName = "NMF_REPLICATE";
      $currPageName = "NMF_RESULTS_REPLICATE";
          $currPageFile = "NMFResults.php";
          $_SESSION['TOTAL_STEPS'] = 8;
      break;
	case '1:1:1:1:1:1:9:1':
     $prevPageName = "BIPLOT";
      $currPageName = "BIPLOT_RESULTS";
	  $currPageFile = "BiplotResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
	case '1:2:1:1:1:1:9:1':
      $prevPageName = "BIPLOT_REPLICATE";
      $currPageName = "BIPLOT_RESULTS_REPLICATE";
	  $currPageFile = "BiplotResults.php";
	  $_SESSION['TOTAL_STEPS'] = 8;
      break;
    case '1:1:1:1:1:1:5:1:1':
	case '1:2:1:1:1:1:5:1:1':   
		$prevPageName = "Map_Parameters";
		$currPageName = "Map_Results";
		$currPageFile = "MapResults.php";
		$_SESSION['TOTAL_STEPS'] = 9;
		break;
  }
  
  	
  	$steps = split(':', $stepNumber);
	$steps_count = count($steps) - 1;
	if (1 == $steps[1])
	{	$_SESSION['IS_REPLICATE_TRACK'] = 0;}
	elseif (2 == $steps[1])
	{	$_SESSION['IS_REPLICATE_TRACK'] = 1;	}
	elseif (13 == $steps[1])
	{	$_SESSION['IS_REPLICATE_TRACK'] = 2;	}
	
	if ($_SESSION['IS_REPLICATE_TRACK'])
	{	
		$searchGeneKey = 'SEARCHGENE_REPLICATE';
		$techniqueKey = 'TECHNIQUE_REPLICATE';
	}
	else
	{	
		$searchGeneKey = 'SEARCHGENE';	
		$techniqueKey = 'TECHNIQUE';
		$fields = array("mean"=>"Mean", "median"=>"Median", "std_dev"=>"Standard Deviation", 
		    	"N_data"=>"Number of Points", "ratio_of_means"=>"Ratio of Means", "ratio_of_medians"=>"Ratio of Medians", 
		    	"p_value"=>"P-Value of Diff of Means", "difference_of_means"=>"Difference of Means", "difference_of_medians"=>"Difference of Medians",
		    	"mean_l"=>"Mean of Log", "median_l"=>"Median of Log", "std_dev_l"=> "Std Dev of Log", 
		    	"ratio_of_means_l"=>"Ratio of Means of Log", "ratio_of_medians_l"=>"Ratio of Medians of Log", "p_value_l"=> "P-Value of Diff of Means of Log", 
		    	"difference_of_means_l"=>"Difference of Means of Log", "difference_of_medians_l"=>"Difference of Medians of Log");
	}  
}

/**Contains data for the individual pages. Note that all the data is stored
* in session varaibles in Associative arrays. The Keys of the arrays are as follows:
* 1) First key (in caps) for the unique string associated with the page.
* 2) Second key identifies what kind of data it is (as in data for the table
*    or for the page.
* 3) For table data (second key being 'TABLE_DATA') the data for different
*    tables will be identified by the index (third key) assigned to that table.
* 4) And finally the fourth key is the description of the data.
*/

function fillTableInfo()
{
  $_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['TABLE_NAME'] = "experiment_set";
    //The table to query for showing the checkboxes on the front-end.
    //This is also the name that will be searched in kw_table for finding the
    //ID of the table.
    //Note that if there is a query associated with key named 'TABLE_QUERY',
    //then this query is given a higher precedence for retrieving data than
    //just retrieving from the table with name stored in 'TABLE_NAME'

	if (strtoupper($_SESSION['role']) == 'GUEST')
	{
		$_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['TABLE_QUERY'] =
		"SELECT es.\"exp_set_id\", es.\"exp_set_name\" FROM \"experiment_set\" es
		WHERE es.\"public_access\" = 'true' ORDER BY es.\"exp_set_name\"";
	}
    //This query is given a higher precedence for retrieving data than
    //just retrieving from the table with name stored in 'TABLE_NAME'

  $_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['TABLE_NAME_FIELD'] = "kw_table";
    //The name of the field containing Names in reference table containing IDs and names for all tables
  $_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['RECORD_ID_FIELD'] = "exp_set_id";
    //The name of the record_id field containing IDs associated with individual
    //checkboxes displayed in the front-end.
  $_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['NAME_FIELD'] = "exp_set_name";
    //The field which contains the label for individual checkboxes.
  $_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['PREVIOUS_RECORD_ID_FIELD'] = "";
    //The field which contains the record IDs of the previous page.

    //Also, if there are more than one tables per page, repeat the data
    //with the next index.
	
	
  $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['TABLE_NAME'] = "experiment";
    //The table to query for showing the checkboxes on the front-end.
    //This is also the name that will be searched in kw_table for finding the
    //ID of the table.
    //Note that if there is a query associated with key named 'TABLE_QUERY',
    //then this query is given a higher precedence for retrieving data than
    //just retrieving from the table with name stored in 'TABLE_NAME'

  //$_SESSION['EXPERIMENT']['TABLE_DATA'][0]['TABLE_QUERY'] =
   // "SELECT e.experiment_id, es.exp_set_name FROM experiment e, experiment_set es
    //WHERE e.exp_set_id = es.exp_set_id ORDER BY es.exp_set_name";
    //This query is given a higher precedence for retrieving data than
    //just retrieving from the table with name stored in 'TABLE_NAME'

  $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['TABLE_NAME_FIELD'] = "kw_table";
    //The name of the field containing Names in reference table containing IDs and names for all tables
  $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['RECORD_ID_FIELD'] = "experiment_id";
    //The name of the record_id field containing IDs associated with individual
    //checkboxes displayed in the front-end.
  $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['NAME_FIELD'] = "exp_name";
    //The field which contains the label for individual checkboxes.
  $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['PREVIOUS_RECORD_ID_FIELD'] = 
  	$_SESSION['EXPERIMENT_SET']['TABLE_DATA'][0]['RECORD_ID_FIELD'];
    //The field which contains the record IDs of the previous page.
  
    //Also, if there are more than one tables per page, repeat the data
    //with the next index.

  
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['TABLE_NAME'] = "SAMPLING_POINT";
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['TABLE_QUERY'] =
    "SELECT s.\"sampling_point_id\", l.\"name\", s.\"experiment_id\" FROM \"sampling_point\" s,".
    " \"label\" l WHERE s.\"label_id\" = l.\"label_id\" ORDER BY l.\"order\"";
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['TABLE_NAME_FIELD'] = "kw_table";
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['RECORD_ID_FIELD'] = "sampling_point_id";
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['NAME_FIELD'] = "name";
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['PREVIOUS_RECORD_ID_FIELD'] =
    $_SESSION['EXPERIMENT']['TABLE_DATA'][0]['RECORD_ID_FIELD'];
  

  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['TABLE_NAME'] = "TECHNIQUE";
  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['TABLE_QUERY'] =
    "SELECT DISTINCT t.\"technique_id\", t.\"technique_name\", sp.\"sampling_point_id\", 
    t.\"technique_type\", s.\"label_id\"
    FROM \"sampling_point\" sp, \"sampling_replicate\" sr, \"sample\" s, \"sample_extract\" se,
    	 \"extract\" e, \"technique\" t
    WHERE sp.\"sampling_point_id\"  = sr.\"sampling_point_id\" AND
          sr.\"sampling_replicate_id\" = s.\"sampling_replicate_id\" AND
          s.\"sample_id\" = se.\"sample_id\" AND
          se.\"extract_id\" = e.\"extract_id\" AND
          e.\"technique_id\" = t.\"technique_id\"";
          
	if (strtoupper($_SESSION['role']) == 'GUEST')
	{
		//Get all Experiment Set IDs in a string
		if (isset($_SESSION['EXPERIMENT_SET']['EXPERIMENT_SET']))
		{
			$ESIDs = $_SESSION['EXPERIMENT_SET']['EXPERIMENT_SET'];
			$firstKey = 1;
			$ESIDs_str = "";
			foreach($ESIDs as $key=>$value)
			{
				if ($value)
				{
					if (!$firstKey)
					{ $ESIDs_str .= ", "; }
					$ESIDs_str .= $key;
					$firstKey = 0;
				}
			}
			$_SESSION['TECHNIQUE']['TABLE_DATA'][0]['TABLE_QUERY'] = 
			"SELECT t.\"technique_id\", t.\"technique_name\", t.\"sampling_point_id\", 
    			t.\"technique_type\", t.\"label_id\"
    			FROM ({$_SESSION['TECHNIQUE']['TABLE_DATA'][0]['TABLE_QUERY']}) t
				, \"technique_acl\" tacl
			WHERE tacl.\"exp_set_id\" IN ($ESIDs_str)
			AND tacl.\"technique_id\" = t.\"technique_id\"";
		}
	}
  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['TABLE_NAME_FIELD'] = "kw_table";
  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['RECORD_ID_FIELD'] = "technique_id";
  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['NAME_FIELD'] = "technique_name";
  $_SESSION['TECHNIQUE']['TABLE_DATA'][0]['PREVIOUS_RECORD_ID_FIELD'] =
  $_SESSION['SAMPLING_POINT']['TABLE_DATA'][0]['RECORD_ID_FIELD'];
  
  $_SESSION['TECHNIQUE_REPLICATE']['TABLE_DATA'] = $_SESSION['TECHNIQUE']['TABLE_DATA'];

}

?>
